#include <bits/stdc++.h>
#include "sqsort.h"

using namespace std;

struct Linked
{
    pair<int,int>val;
    Linked* next;
    Linked* prev;

    Linked(pair<int,int>v)
    {
        next=NULL;
        prev=NULL;
        val=v;
    }
};
void addLeft(Linked*& cur,pair<int,int>v)
{
    Linked* tmp = new Linked(v);
    if(cur==NULL)
    {
        cur=tmp;
    }
    else
    {
        tmp->prev=cur->prev;
        if(cur->prev!=NULL)cur->prev->next=tmp;
        tmp->next=cur;
        cur->prev=tmp;
    }
}
void addRight(Linked*& cur,pair<int,int>v)
{
    Linked* tmp=new Linked(v);
    if(cur==NULL)
    {
        cur=tmp;
    }
    else
    {
        tmp->prev=cur;
        tmp->next=cur->next;
        if(cur->next!=NULL)cur->next->prev=tmp;
        cur->next=tmp;
    }
}
vector<pair<int,int> >solve(int n)
{
    Linked* list=NULL;
    int size=0;
    addRight(list,make_pair(0,0));
    size++;
    for(int i=0;i<n;i++)
    {
        for(int j=i;j<n;j++)
        {
            if(i==0&&j==0)continue;
            if(cmp(list->val.first,list->val.second,i,j))
            {
               Linked* tmp=list->next;
               if(tmp==NULL)
               {
                   addRight(list,make_pair(i,j));
                   size++;
               }
               else
               {
                    while(tmp!=NULL&&cmp(tmp->val.first,tmp->val.second,i,j))
                    {
                        if(tmp->next==NULL)
                        {
                            addRight(tmp,make_pair(i,j));
                            size++;
                            tmp=NULL;
                            break;
                        }
                        tmp=tmp->next;
                    }
                    if(tmp!=NULL)
                    {
                        addLeft(tmp,make_pair(i,j));
                        size++;

                    }
               } 
            }
            else
            {
                Linked* tmp=list->prev;
                if(tmp==NULL)
                {
                    addLeft(list,make_pair(i,j));
                    size++;
                }
                else
                {
                    while(tmp!=NULL&&!cmp(tmp->val.first,tmp->val.second,i,j))
                    {
                        if(tmp->prev==NULL)
                        {
                            addLeft(tmp,make_pair(i,j));
                            size++;
                            tmp=NULL;
                            break;
                        }
                        tmp=tmp->prev;
                    }
                    if(tmp!=NULL)
                    {
                        addRight(tmp,make_pair(i,j));
                        size++;
                    }
                }
            }
        }
    }
    while(list->prev!=NULL)
    {
        list=list->prev;
    }
    vector<pair<int,int> >result;
    while(list!=NULL)
    {
        if(list!=NULL)
        {
            result.push_back(list->val);
        }
        list=list->next;
    }
    return result;
}