#include <bits/stdc++.h>

#define int ll
#define endl '\n'
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
#define dbg(x) cerr << #x << " : " << x << endl
#define mp make_pair
#define pb emplace_back

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;
using pld = pair <ld, ld>;

template <class T>
istream& operator>> (istream &in, vector <T> &a)
{
    for (auto &i : a)
        in >> i;
    return in;
}
template <class T>
ostream& operator<< (ostream &out, const vector <T> &a)
{
    for (auto &i : a)
        out << i << " ";
    return out;
}
template <class T, class U>
istream& operator>> (istream &in, pair <T, U> &a)
{
    in >> a.first >> a.second;
    return in;
}
template <class T, class U>
ostream& operator<< (ostream &out, const pair <T, U> &a)
{
    out << a.first << " " << a.second;
    return out;
}

inline void Start()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen(".in", "r", stdin);
    //freopen(".out", "w", stdout);
}
const int INF = 1e9;
int ans = 0, n, k;
vector <int> t, l;
vector <vector <int>> komu;

void rec(vector <int> skolko, vector <int> used, int i)
{
    if (i == n)
    {
        int rem = 0;
        for (int i = 0; i < n; ++i)
            if (!used[i])
                ++rem;
        vector <vector <int>> dp(n, vector <int> (rem + 1));
        for (int i = 0; i < n; ++i)
        {
            for (int r = 0; r <= rem; ++r)
            {
                dp[i][r] = max(dp[i][r], i ? dp[i - 1][r] : 0ll);
                if (r - (2 * k - skolko[i]) >= 0)
                    dp[i][r] = max(dp[i][r], (i ? dp[i - 1][r - (2*k - skolko[i])] : 0ll) + l[i]);
            }
        }
        ans = max(ans, *max_element(all(dp.back())));
        return;
    }
    for (auto var : komu[i])
    {
        if (var == -1)
            rec(skolko, used, i + 1);
        else
        {
            skolko[var] += k;
            used[i] = true;
            rec(skolko, used, i + 1);
            skolko[var] -= k;
            used[i] = false;
        }
    }
}

void rel(int &a, int b)
{
    a = max(a, b);
}

signed main()
{
    Start();
    cin >> n >> k;
    t.resize(n), l.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> t[i] >> l[i];
    komu.resize(n);
    for (int i = 0; i < n; ++i)
        komu[i].pb(i), komu[i].pb(-1), komu[t[i]].pb(i);
    vector <int> skolko(n), used(n);
    if (n <= 10)
    {
        rec(skolko, used, 0);
        cout << ans;
    }
    vector <int> v;
    for (int i = 0;;)
    {
        v.pb(i);
        i = t[i];
        if (i == 0)
            break;
    }
    // a) first one is used so we can easily do for lst
    {
        vector <vector <vector <int>>> dp(n + 1, vector <vector <int>> (2, vector <int> (n + 1)));
        dp[0][1] = vector<int>(n + 1, -INF);
        for (int i = 0; i < n; ++i)
        {
            for (int can = 0; can < 2; ++can)
            {
                for (int rem = 0; rem <= n; ++rem)
                {
                    int ver = i, nxt = i + 1;
                    if (can)
                    {
                        if (rem - k - 1 >= 0)
                            dp[nxt][can][rem - k - 1] = max(dp[nxt][can][rem - k - 1], dp[ver][can][rem] + l[v[i]]);
                        if (rem - 2 >= 0)
                            dp[nxt][!can][rem - 2] = max(dp[nxt][!can][rem - 2], dp[ver][can][rem] + l[v[i]]);
                    }
                    rel(dp[nxt][true][rem], dp[ver][can][rem]);
                    if (rem - k - 1 >= 0)
                        rel(dp[nxt][false][rem - k - 1], dp[ver][can][rem] + l[v[i]]);
                    if (rem - 2 * k >= 0)
                        rel(dp[nxt][true][rem - 2 * k], dp[ver][can][rem] + l[v[i]]);
                }
            }
        }
        ans = max(ans, *max_element(all(dp[n][0])));
    }
    {
        vector <vector <vector <int>>> dp(n + 1, vector <vector <int>> (2, vector <int> (n + 1)));
        dp[0][0] = vector<int>(n + 1, -INF);
        for (int i = 0; i < n; ++i)
        {
            for (int can = 0; can < 2; ++can)
            {
                for (int rem = 0; rem <= n; ++rem)
                {
                    int ver = i, nxt = i + 1;
                    if (can)
                    {
                        if (rem - k - 1 >= 0)
                            dp[nxt][can][rem - k - 1] = max(dp[nxt][can][rem - k - 1], dp[ver][can][rem] + l[v[i]]);
                        if (rem - 2 >= 0)
                            dp[nxt][!can][rem - 2] = max(dp[nxt][!can][rem - 2], dp[ver][can][rem] + l[v[i]]);
                    }
                    rel(dp[nxt][true][rem], dp[ver][can][rem]);
                    if (rem - k - 1 >= 0)
                        rel(dp[nxt][false][rem - k - 1], dp[ver][can][rem] + l[v[i]]);
                    if (rem - 2 * k >= 0)
                        rel(dp[nxt][true][rem - 2 * k], dp[ver][can][rem] + l[v[i]]);
                }
            }
        }
        ans = max(ans, *max_element(all(dp[n][1])));
    }
    cout << ans;
    return 0;
}


