
//#include <bits/stdc++.h>
#include <algorithm>
#include "sqsort.h"
using namespace std;
void mergesorti(vector <int> &a)
{
    if (a.size() <= 1)
        return;
    vector <int> l(a.size() / 2), r(a.size() - a.size() / 2);
    for (int i = 0; i < a.size() / 2; ++i)
        l[i] = a[i];
    for (int i = 0; i < a.size() - a.size() / 2; ++i)
        r[i] = a[i + a.size() / 2];
    mergesorti(l);
    mergesorti(r);
    int i = 0, j = 0;
    while (i < l.size() && j < r.size())
    {
        if (cmp(l[i], l[i], r[j], r[j]))
        {
            a[i + j] = l[i];
            ++i;
        }
        else
        {
            a[i + j] = r[j];
            ++j;
        }
    }
    while (i < l.size())
    {
        a[i + j] = l[i];
        ++i;
    }
    while (j < r.size())
    {
        a[i + j] = r[j];
        ++j;
    }
}
vector <int> where;
bool cmpr(int a, int b, int c, int d)
{
    if (min(where[a], where[b]) <= min(where[c], where[d]) && max(where[a], where[b]) <= max(where[c], where[d]))
        return true;
    if (min(where[a], where[b]) >= min(where[c], where[d]) && max(where[a], where[b]) >= max(where[c], where[d]))
        return false;
    return cmp(a, b, c, d);
}
void mergesortp(vector <pair<int,int>> &a)
{
    if (a.size() <= 1)
        return;
    vector <pair<int,int>> l(a.size() / 2), r(a.size() - a.size() / 2);
    for (int i = 0; i < a.size() / 2; ++i)
        l[i] = a[i];
    for (int i = 0; i < a.size() - a.size() / 2; ++i)
        r[i] = a[i + a.size() / 2];
    mergesortp(l);
    mergesortp(r);
    int i = 0, j = 0;
    while (i < l.size() && j < r.size())
    {
        if (cmpr(l[i].first, l[i].second, r[j].first, r[j].second))
        {
            a[i + j] = l[i];
            ++i;
        }
        else
        {
            a[i + j] = r[j];
            ++j;
        }
    }
    while (i < l.size())
    {
        a[i + j] = l[i];
        ++i;
    }
    while (j < r.size())
    {
        a[i + j] = r[j];
        ++j;
    }
}
std::vector <std::pair <int, int>> solve(int n)
{
    vector <int> inds(n);
    for (int i = 0; i < n; ++i)
        inds[i] = i;
    mergesorti(inds);
    where.resize(n);
    for (int i = 0; i < n; ++i)
        where[inds[i]] = i;
    vector <pair <int, int>> prs;
    for (int i = 0; i < n; ++i)
        for (int j = i; j < n; ++j)
            prs.emplace_back(i, j);
    mergesortp(prs);
    return prs;
}

