#include<bits/stdc++.h>
#include "sqsort.h"
using namespace std;

#define ll long long
#define F first
#define S second

#define FORi(i,a,b) for(ll i=a;i<b;i++)
#define FOR(i,n) FORi(i,0,n)
#define FOA(v,a) for(auto v : a)

#define bit(t,s) ((i>>((t)*m+s))&(1LL))
#define MOD 1000000007

typedef vector<int> vi;
typedef pair<int, int> ii;
#define len(qq) ((int) qq.size())
#define MID ((l+r)/2)
#define oii(a,b) ii(min(a,b), max(a,b))

#define mp make_pair

map<pair<ii, ii>, bool> cache;

bool CMP(int a, int b, int c, int d){
	if(cache[mp(oii(a,b), oii(c,d))]) return cache[mp(oii(a,b), oii(c,d))];
	cache[mp(oii(a,b), oii(c,d))] = cmp(a,b,c,d);
	cache[mp(oii(c,d), oii(a,b))] = 1-cache[mp(oii(a,b), oii(c,d))];
	return cache[mp(oii(a,b), oii(c,d))];
}

vector<pair<int, int>> solve(int n){
	vi order;

	FOR(i,n){
		bool inserted=false;
		FOR(j, len(order)){
			if(cmp(i,i, order[j], order[j])){
				order.insert(order.begin()+j, i);
				inserted = true;
				break;
			}
		}
		if(!inserted) order.push_back(i);
	}
	queue<ii> s;
	s.push(ii(0,1));
	s.push(ii(-1,-1));
	vector<ii> ans;
	int lay=0;
	map<ii, bool> vis;
	vis[ii(0,1)] = true;
	vector<vector<ii> > layers(1);
	while(s.size()>1){
		ii t = s.front();
		s.pop();
		if(t==ii(-1,-1)){
			s.push(ii(-1,-1));
			lay++;
			layers.push_back(vector<ii>());
			continue;
		}
		layers[lay].push_back(t);
		if(t.S+1<n && !vis[ii(t.F, t.S+1)]) s.push(ii(t.F, t.S+1)), vis[ii(t.F, t.S+1)] = true;
		if(t.F+1<t.S && !vis[ii(t.F+1, t.S)]) s.push(ii(t.F+1, t.S)), vis[ii(t.F+1, t.S)] = true;
	}
	FOA(v, layers){
		//FOA(j,v) cout<<j.F<<" "<<j.S<<"    ";
		//cout<<endl;

		vector<ii> sorted_lay;

		FOA(i,v){
			bool inserted=false;
			FOR(j, len(sorted_lay)){
				if(cmp(order[i.F],order[i.S], order[sorted_lay[j].F], order[sorted_lay[j].S])){
					sorted_lay.insert(sorted_lay.begin()+j, i);
					inserted = true;
					break;
				}
			}
			if(!inserted) sorted_lay.push_back(i);
		}

		FOA(i,sorted_lay){
			ans.push_back(oii(order[i.F], order[i.S]));
			//cout<<order[i.F]<<" "<<order[i.S]<<endl;
		}
	}
	FOR(i,n){
		int l=0, r=ans.size()-1;
		int work=-1;
		while(l<=r){
			if(cmp(ans[MID].F, ans[MID].S, order[i],order[i])){
				l = MID+1;
			}
			else work=MID, r = MID-1;
		}
		if(work==-1) ans.push_back(ii(order[i], order[i]));
		else ans.insert(ans.begin()+work, oii(order[i],order[i]));
		//cout<<i<<" "<<MID<<endl;
	}
	//FOA(v,ans) cout<<v.F<<" "<<v.S<<endl;
	return ans;

}

