// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

typedef long long int ll;
typedef unsigned long long ull;
typedef long double ld;

#define P pair
typedef P<int, int> Pii;
typedef P<ll, ll> Pll;
typedef P<string, string> Pss;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()


#define add_fill(a, c) setw(a) << setfill(c)
// #define endl '\n'

#define slimming(a) a.shrink_to_fit()
#define len(a) (ll)a.size()

#define f first
#define s second

const ll INF = (ll) (1e9);
#define MOD 1000000009

#define yes "YES"
#define no "NO"
#define imp "impossible"

#define pb push_back
#define eb emplace_back

#pragma GCC optimize "-O3"
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("no-stack-protector")
#pragma comment(linker, "/stack:200000000")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

// mt19937 rnd(time(0));

ll get_rand() {
   return (rand() << 16) ^ rand();
}

bool get(ll mask, ll id){
   return ((mask>>id)&1);
}
void solve() {
   ll n, k;
   cin >> n >> k;
   vector < Pll > a(n);
   for(int i = 0; i < n; ++i)
      cin >> a[i].f >> a[i].s;
   
   vector < Pll > b(n);
   for(int i = 0; i < n; ++i){
      b[i] = {a[i].s, i};
   }

   sort(all(b));
   ll ans = 0;
   for(ll mask = 0; mask < (1<<n); ++mask){
      vector < ll > id;
      for(int i = 0; i < n; ++i){
         if(get(mask, i))
            id.pb(i);
      }

      vector < bool > used(n, false);
      ll q = 0;
      for(int i = 0; i < len(id); ++i){
         if(binary_search(all(id), a[b[id[i]].s].f)){
            ++q;
            continue;
         }
         used[a[b[id[i]].s].f] = true;
         used[b[id[i]].s] = true;
      }
      for(auto i : id)
         used[i] = true;
      ll cnt = 0;
      for(auto i : used)
         cnt += (!i);
      if((ll)(cnt / k) >= q){
         ll tmp = 0;
         for(auto i : id)
            tmp += b[i].f;
         ans = max(tmp, ans);
      }
   }
   cout << ans;
   return;
}

int main() {
   ios_base::sync_with_stdio(false);
   cin.tie(nullptr);
   cout.tie(nullptr);
   // freopen("input.txt", "r", stdin);
   // freopen("output.txt", "w", stdout);

   ll t = 1;
   // cin >> t;
   while (t--) {
      solve();
      cout << endl;
   }
   return 0;
}