// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

typedef long long int ll;
typedef unsigned long long ull;
typedef long double ld;

#define P pair
typedef P<int, int> Pii;
typedef P<ll, ll> Pll;
typedef P<string, string> Pss;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()


#define add_fill(a, c) setw(a) << setfill(c)
// #define endl '\n'

#define slimming(a) a.shrink_to_fit()
#define len(a) (ll)a.size()

#define f first
#define s second

const ll INF = (ll)((ll) (1e9) + 7);
#define MOD 1000000009

#define yes "YES"
#define no "NO"
#define imp "impossible"

#define pb push_back
#define eb emplace_back

#pragma GCC optimize "-O3"
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("no-stack-protector")
#pragma comment(linker, "/stack:200000000")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

// mt19937 rnd(time(0));

ll get_rand() {
   return (rand() << 16) ^ rand();
}

bool GetId(ll mask, ll id){
   return ((mask>>id)&1);
}

ll GetOne(ll mask, ll n){
   ll cnt = 0;
   for(int i = 0; i < n; ++i)
      cnt += GetId(mask, i);
   return cnt;
}

ll rec(vector < ll > a, ll n, ll m){
   if(len(a) == m){
      bool flag = true;
      vector < ll > h(m, 0), w(n);
      for(int i = 0; i < m; ++i){
         for(int j = 0; j < n; ++j){
            if(GetId(a[i], j)){
               h[i] += 1;
               w[j] += 1;
            }
         }
      }
      for(int i = 0; i < m and flag; ++i){
         for(int j = 0; j < n; ++j){
            if(GetId(a[i], j) and (h[i] <= 1 and w[j] <= 1)){
               flag = false;
               break;
            }else if(!GetId(a[i], j) and ((n-h[i]) <= 1 and (m-w[j]) <= 1)){
               flag = false;
               break;
            }
         }
      }

      // for(int i = 0; i < m; ++i){
      //    for(int j = 0; j < n; ++j){
      //       cout << GetId(a[i], j);
      //    }
      //    cout << endl;
      // }
      // cout << flag << endl << endl;
      return flag;
   }

   ll cnt = 0;
   for(ll mask = 0; mask < (1<<n); ++mask){
      a.pb(mask);
      cnt = (cnt + rec(a, n, m) + INF)%INF;
      a.pop_back();
   }
   return cnt;
}
void solve() {
   ll n, m;
   cin >> n >> m;
   
   if(n > m)
      swap(n, m);

   cout << rec({}, n, m);
   return;
}

int main() {
   ios_base::sync_with_stdio(false);
   cin.tie(nullptr);
   cout.tie(nullptr);
   // freopen("input.txt", "r", stdin);
   // freopen("output.txt", "w", stdout);

   ll t = 1;
   // cin >> t;
   while (t--) {
      solve();
      cout << endl;
   }
   return 0;
}