#include <bits/stdc++.h>
#include "sqsort.h"

using namespace std;


vector<pair<int, int>> vec;

vector<pair<int, int>> mergesort(int l, int r) {
    if (l == r - 1) {
        vector<pair<int, int>> one;
        one.push_back(vec[l]);
        return one;
    }
    int m = l + (r - l) / 2;
    auto a = mergesort(l, m);
    auto b = mergesort(m, r);
    vector<pair<int, int>> res;
    int p1 = 0, p2 = 0;
    while (p1 < a.size() || p2 < b.size()) {
        if (p1 == a.size())
            res.push_back(b[p2++]);
        else if (p2 == b.size())
            res.push_back(a[p1++]);
        else{
            if(cmp(a[p1].first, a[p1].second, b[p2].first, b[p2].second))
                res.push_back(b[p2++]);
            else
                res.push_back(a[p1++]);
        }
    }
    return res;
}

vector<pair<int, int>> solve(int n) {
    for (int i = 0; i < n; ++i)
        for (int j = i; j < n; ++j)
            vec.push_back({i, j});
    vector<pair<int, int>> sorted = mergesort(0, vec.size());
    vector<pair<int, int>> ans;
    for (int i = sorted.size() - 1; i >= 0; i--)
        ans.push_back(sorted[i]);
    return ans;
}