#include <bits/stdc++.h>
#include "sqsort.h"
using namespace std;
typedef long long ll;
typedef pair<int,int> pi;
typedef pair<ll,ll> pl;
#define F first
#define S second
//#define endl '\n'
#define sz(x) (int)(x).size()
#define all(x) (x).begin(),(x).end()
#ifdef dremix
    #define p(x) cerr<<#x<<" = "<<x<<endl;
    #define p2(x,y) cerr<<"("<<#x<<","<<#y<<") = "<<x<<", "<<y<<endl;
    #define pv(x) cerr<<#x<<" = {";for(auto v : x)cout<<v<<", ";cout<<"}"<<endl;
#else
    #define p(x)
    #define p2(x,y)
    #define pv(x)
#endif
#define fastio ios_base::sync_with_stdio(false);cin.tie(nullptr);
const ll INF = 2e18;
const int MOD = 1e9+7;


#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
gp_hash_table<ll,bool> memo;

const int maxn = 2000;

int hash1(const pi &x){
    return maxn*x.F + x.S;
}
const int maxmaxn = 4000000;

ll hash2(int x, int y){
    return 1ll*maxmaxn*x + y;
}

int total = 0;
const int maxdp = 7e5;


bool _cmp(int a, int b, int c, int d){
    ll num = hash2(hash1({a,b}),hash1({c,d}));
    if(memo.find(num) == memo.end()){
        if(total < maxdp){
            bool res = cmp(a,b,c,d);
            memo[num] = res;
            total++;
            return res;
        }
        else
            return cmp(a,b,c,d);
    }
    return memo[num];
}



bool comp(const int &x, const int &y){
    return _cmp(x,x,y,y);
}

struct ano{
    int x,y;
    bool operator<(const ano &a)const{
        return !_cmp(x,y,a.x,a.y);
    }
};



vector<pi> solve(int n){
    vector<int> idx(n,0);
    iota(all(idx),0);
    sort(all(idx),comp);

    //pv(idx)

    int i,j;
    vector<int> pos(n,0);
    iota(all(pos),0);
    vector<pi> ans;

    int tot = n*(n+1)/2;

    priority_queue<ano> q;

    int curr = 0;
    for(auto x : idx){
        pos[x] = curr++;
        q.push({x,x});
    }

    while(!q.empty()){
        pi temp = {q.top().x,q.top().y};
        q.pop();
        //p2(temp.F,temp.S)
        ans.push_back(temp);
        pos[temp.F]++;
        //p2(pos[temp.F],idx[pos[temp.F]])
        if(pos[temp.F] < n){
            q.push({temp.F,idx[pos[temp.F]]});
        }
    }

    return ans;
}






