#include <bits/stdc++.h>
#include "sqsort.h"
#define ll long long
#define mp make_pair
#define pb push_back
#define fi first
#define se second
#define pll pair<ll,ll>
#define pii pair<int,int>
#define all(v) v.begin(),v.end()
#define ld long double
#define y1 Enkognit

using namespace std;

//mt19937_64 rnd(time(0));

const ll MOD=1e9+7;

int n, m, T;
bool a[2001][2001];
int ps[2001];
vector<pii> v;
vector<int> q;

ll binpow(ll h,ll r,ll md=MOD)
{
    ll l=1;
    while (r)
    {
        if (r&1) l*=h, l%=md;
        h*=h;
        h%=md;
        r/=2;
    }
    return l;
}

bool comp1(int x,int y)
{
    return a[x][y];
}

bool comp2(pii x,pii y)
{
    if (min(ps[x.fi],ps[x.se])<min(ps[y.fi],ps[y.se]) && max(ps[x.fi],ps[x.se])<max(ps[y.fi],ps[y.se])) return 1;
    if (min(ps[x.fi],ps[x.se])>min(ps[y.fi],ps[y.se]) && max(ps[x.fi],ps[x.se])>max(ps[y.fi],ps[y.se])) return 0;
    if (x.fi==y.fi)
    {
        return a[x.se][y.se];
    }
    if (x.fi==y.se)
    {
        return a[x.se][y.fi];
    }
    if (x.se==y.fi)
    {
        return a[x.fi][y.se];
    }
    if (x.se==y.se)
    {
        return a[x.fi][y.fi];
    }
    return cmp(x.fi, x.se, y.fi, y.se);
}

vector<pii> solve(int n)
{
    for (int i = 1; i < n; i++)
        for (int j = i+1; j < n; j++)
        {
            bool t=cmp(0,i,0,j);
            if (t) a[i][j]=1, a[j][i]=0; else a[i][j]=0, a[j][i]=1;
        }
    for (int i = 0; i < n; i++)
        for (int j = i; j < n; j++) v.pb(mp(i, j));
    for (int i = 0; i < n; i++) q.pb(i);
    for (int i = 1; i < n; i++)
    {
        ll j=2;
        if (i==j) j++;
        bool t=cmp(0,j,i,j);
        a[0][i]=t;a[i][0]=(!t);
    }
    sort(all(q), comp1);
    for (int i = 0; i < q.size(); i++) ps[q[i]]=i;
    sort(all(v), comp2);
    return v;
}

/*int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    vector<pii> v=solve(n);
    return 0;
}*/
/*
8 3
5 12
6 111
4 101
0 13
1 105
7 14
2 108
3 9
*/
