#include "sqsort.h"
#include <algorithm>
using namespace std;
#define ii pair<int,int>
#define x first
#define y second

bool mycmp(const ii &x, const ii &y){
    return cmp(x.x,x.y,y.x,y.y);
}
void merge_sort(vector<ii> &v, int i,int n){
    if(n<=1){
        return;
    }
    int mid=n/2;
    merge_sort(v,i,mid);
    merge_sort(v,i+mid,n-mid);
    vector<ii> c;
    int il=0,ir=0;
    while(il<mid&&ir<n-mid){
        if(mycmp(v[i+il],v[i+mid+ir])){
            c.push_back(v[i+il]);
            il++;
        }
        else{
            c.push_back(v[i+mid+ir]);
            ir++;
        }
    }
    while(il<mid){
        c.push_back(v[i+il]);
        il++;
    }
    while(ir<n-mid){
        c.push_back(v[i+mid+ir]);
        ir++;
    }
    for(int j=0; j<n; j++){
        v[i+j]=c[j];
    }
}
std::vector<std::pair<int, int>> solve(int n){
    vector<ii> sol;
    for(int i=0; i<n; i++){
        for(int j=i; j<n; j++){
            sol.emplace_back(i,j);
        }
    }
    //sort(sol.begin(),sol.end(),mycmp);
    merge_sort(sol,0,sol.size());

    return sol;
}