#include <bits/stdc++.h>

using namespace std;

const int MOD = 1000000007;

int p2[2505];
int dp[55];
int fact[2505];

int lgput(int a, int b) {
  int ans = 1;
  for (; b; b >>= 1) {
    if (b & 1)
      ans = 1LL * ans * a % MOD;
    a = 1LL * a * a % MOD;
  }
  return ans;
}

int inv(int a) {
  return lgput(a, MOD - 2);
}

int comb(int n, int k) {
  return 1LL * fact[n] * inv(fact[n - k]) % MOD * inv(fact[k]) % MOD;
}

int ways(int n, int k) {
  return 1LL * fact[n] * inv(fact[n - k]) % MOD;
}

int main() {

  int n, m;
  scanf("%d%d", &n, &m);
  p2[0] = 1;
  fact[0] = 1;
  for (int i = 1; i <= n * m; ++i) {
    p2[i] = 2LL * p2[i - 1] % MOD;
    fact[i] = 1LL * i * fact[i - 1] % MOD;
  }

  if (n > m)
    swap(n, m);

  if (n == 1 && m == 1) {
    printf("%d\n", 0);
    return 0;
  }
  if (n == 1 && m == 2) {
    printf("%d\n", 2);
    return 0;
  }
  if (n == 1) {
    printf("%d\n", 2 * m);
    return 0;
  }

  for (int i = 1; i <= n; ++i)
    dp[i] = 1LL * comb(n, i) * comb(m, i) % MOD * fact[i] % MOD * p2[n * m - i * n - i * m + i * i] % MOD;

  int ans = 0;
  for (int i = n; i > 1; --i) {
    for (int j = i - 1; j >= 1; --j)
      dp[j] = (dp[j] - 1LL * dp[i] * comb(i, j) % MOD + MOD) % MOD;
    ans = (ans + dp[i]) % MOD;
  }
  ans = (ans + dp[1]) % MOD;

  printf("%d\n", (p2[n * m] - 2LL * ans + MOD) % MOD);

  return 0;
}
