#include <bits/stdc++.h>

using namespace std;

const long long MOD = 1000000007;

long long p2[2505];
long long dp[55];
long long fact[2505];

long long lgput(long long a, long long b) {
  long long ans = 1;
  for (; b; b >>= 1) {
    if (b & 1)
      ans = 1LL * ans * a % MOD;
    a = 1LL * a * a % MOD;
  }
  return ans;
}

long long inv(long long a) {
  return lgput(a, MOD - 2);
}

long long comb(long long n, long long k) {
  return 1LL * fact[n] * inv(fact[n - k]) % MOD * inv(fact[k]) % MOD;
}

long long ways(long long n, long long k) {
  return 1LL * fact[n] * inv(fact[n - k]) % MOD;
}

int main() {


  long long n, m;
  scanf("%lld%lld", &n, &m);
  p2[0] = 1;
  fact[0] = 1;
  for (long long i = 1; i <= 2500; ++i) {
    p2[i] = 2LL * p2[i - 1] % MOD;
    fact[i] = 1LL * i * fact[i - 1] % MOD;
  }

  if (n > m)
    swap(n, m);

  if (n == 1 && m == 1) {
    printf("0\n");
    return 0;
  }
  if (n == 1 && m == 2) {
    printf("2\n");
    return 0;
  }
  if (n == 1) {
    printf("%d\n", (p2[m] - 2 * m % MOD + MOD) % MOD);
    return 0;
  }

  for (long long i = 1; i <= n; ++i)
    dp[i] = 1LL * comb(n, i) * comb(m, i) % MOD * fact[i] % MOD * p2[n * m - i * n - i * m + i * i] % MOD;

  long long ans = 0;
  for (long long i = n; i > 1; --i) {
    for (long long j = i - 1; j >= 1; --j)
      dp[j] = (dp[j] - 1LL * dp[i] * comb(i, j) % MOD + MOD) % MOD;
    ans = (ans + dp[i]) % MOD;
  }
  ans = (ans + dp[1]) % MOD;
  ans = (1LL * p2[n * m] - 2LL * ans % MOD + MOD) % MOD;


  printf("%lld\n", ans);

  return 0;
}
