#include <bits/stdc++.h>
#include "sqsort.h"

using namespace std;

const int MAXN = 2005;

int a[MAXN];
int p[MAXN];
int valori[MAXN];
vector<pair<int, int> >G[MAXN];

int qry;

struct Aux {
  int a, b;
  bool operator <(const Aux& other) const {
    if (min(p[a], p[b]) <= min(p[other.a], p[other.b]) && max(p[a], p[b]) <= max(p[other.a], p[other.b]))
      return 1;
    if (min(p[a], p[b]) >= min(p[other.a], p[other.b]) && max(p[a], p[b]) >= max(p[other.a], p[other.b]))
      return 0;
    if (cmp(a, b, other.a, other.b))
      return 1;
    return 0;
  }
};

int bs(int l, int r, int pos) {
  int last = pos;
  while (l <= r) {
    int mid = (l + r) / 2;
    if (cmp(a[mid], a[mid], pos, pos)) {
      l = mid + 1;
    } else {
      last = mid;
      r = mid - 1;
    }
  }
  return last;
}

vector<pair<int, int> >solve(int n) {
  a[0] = 0;
  for (int i = 1; i < n; ++i) {
    int pos = bs(0, i - 1, i);
    for (int j = i; j > pos; --j)
      a[j] = a[j - 1];
    a[pos] = i;
  }
  for (int i = 0; i < n; ++i)
    p[a[i]] = i;
  //for (int i = 0; i < n; ++i)
    //printf("%d ", a[i]);
  priority_queue<pair<int, int> >pq;
  set<Aux>s;
  for (int i = 0; i < n; ++i)
    for (int j = i; j < n; ++j)
      s.insert({min(a[i], a[j]), max(a[i], a[j])});
  vector<pair<int, int> >sol;
  for (auto it:s)
sol.push_back({it.a, it.b});
  return sol;
}