#include <bits/stdc++.h>
#include "sqsort.h"

using namespace std;

const int MAXN = 2005;

int a[MAXN];
int p[MAXN];
int valori[MAXN];

int qry;


bool check(int a, int b, int c, int d) {
  if (min(p[a], p[b]) <= min(p[c], p[d]) && max(p[a], p[b]) <= max(p[c], p[d]))
    return 1;
  return 0;
}

struct Aux {
  int a, b;
  bool operator <(const Aux& b1) const {
    if (check(a, b, b1.a, b1.b))
      return 1;
    if (check(b1.a, b1.b, a, b))
      return 0;
    if (cmp(p[a], p[b], p[b1.a], p[b1.b]))
      return 1;
    return 0;

  }
};

int bs(int l, int r, int pos) {
  int last = pos;
  while (l <= r) {
    int mid = (l + r) / 2;
    if (cmp(a[mid], a[mid], pos, pos)) {
      l = mid + 1;
    } else {
      last = mid;
      r = mid - 1;
    }
  }
  return last;
}

bool cp(Aux a, Aux b) {
  if (check(a.a, a.b, b.a, b.b))
    return 1;
  if (check(b.a, b.b, a.a, a.b))
    return 0;
  if (cmp(p[a.a], p[a.b], p[b.a], p[b.b]))
    return 1;
  return 0;
}

vector<pair<int, int> >solve(int n) {
  a[0] = 0;
  for (int i = 1; i < n; ++i) {
    int pos = bs(0, i - 1, i);
    for (int j = i; j > pos; --j)
      a[j] = a[j - 1];
    a[pos] = i;
  }
  for (int i = 0; i < n; ++i)
    p[a[i]] = i;
  //for (int i = 0; i < n; ++i)
    //printf("%d ", a[i]);
  vector<Aux>ax;
  for (int i = 0; i < n; ++i) {
    for (int j = i; j < n; ++j)
      ax.push_back({a[i], a[j]});
  }
  sort(ax.begin(), ax.end());
  vector<pair<int, int> >sol;
  for (auto it:ax) {
    if (it.a > it.b)
      swap(it.a, it.b);
    sol.push_back({it.a, it.b});
  }
  return sol;
}
