#include <bits/stdc++.h>
#include "sqsort.h"

using namespace std;

const int MAXN = 2005;

int a[MAXN];
int p[MAXN];
int valori[MAXN];

int qry;

bool check(int a, int b, int c, int d) {
  if (min(p[a], p[b]) <= min(p[c], p[d]) && max(p[a], p[b]) <= max(p[c], p[d]))
    return 1;
  return 0;
}

int bs(int l, int r, int pos) {
  int last = pos;
  while (l <= r) {
    int mid = (l + r) / 2;
    if (cmp(a[mid], a[mid], pos, pos)) {
      l = mid + 1;
    } else {
      last = mid;
      r = mid - 1;
    }
  }
  return last;
}

bool cp(pair<int, int>a, pair<int, int> b) {
  if (check(a.first, a.second, b.first, b.second))
    return 1;

  if (check(b.first, b.second, a.first, a.second))
    return 0;

  if (cmp(p[a.first], p[a.second], p[b.first], p[b.second]))
    return 1;
  return 0;
}

vector<pair<int, int> >solve(int n) {
  a[0] = 0;
  for (int i = 1; i < n; ++i) {
    int pos = bs(0, i - 1, i);
    for (int j = i; j > pos; --j)
      a[j] = a[j - 1];
    a[pos] = i;
  }
  for (int i = 0; i < n; ++i)
    p[a[i]] = i;
  //for (int i = 0; i < n; ++i)
    //printf("%d ", a[i]);
  vector<pair<int, int> >sol;
  for (int i = 0; i < n; ++i) {
    for (int j = i; j < n; ++j)
      sol.push_back({min(a[i], a[j]), max(a[i], a[j])});
  }
  sort(sol.begin(), sol.end(), cp);
  return sol;
}

