#include <iostream>
#include <fstream>
#include <algorithm>
#include <cstring>
#include <iomanip>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) (a).begin() (a).end()
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pil = pair<int, ll>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
using ld = long double;
template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; }
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; }
void debug_out() { cerr << endl; }
template<typename T1, typename... T2> void debug_out(T1 A, T2... B) { cerr << ' ' << A; debug_out(B...); }
#ifdef DEBUG
    #define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
    #define debug(...) 1337
#endif

const int INF = 1e9 + 1337;
const int maxN = 10004;
int N, K;
int W[maxN], T[maxN];

bool used[maxN];
int ord[maxN], L;
int dp[2][2][2][maxN];

int dq[2][maxN];

signed main()
{
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> N >> K;
    for (int i = 0; i < N; ++i)
        cin >> T[i] >> W[i];
    int cyc = 0;
    for (int i = 0; i < N; ++i)
    {
        if (!used[i])
        {
            ++cyc;
            L = 0;
            for (int j = i; !used[j]; j = T[j])
            {
                ord[L++] = j;
                used[j] = true;
            }
            int maxS = N;
            for (int t = 0; t < 2; ++t)
                for (int fst = 0; fst < 2; ++fst)
                    for (int last = 0; last < 2; ++last)
                        for (int S = 0; S <= maxS; ++S)
                            dp[t][fst][last][S] = -INF;
            dp[0][0][0][0] = 0;
            dp[0][1][1][K + 1] = W[ord[0]];
            for (int i = 0; i + 1 <= L; ++i)
            {
                for (int fst = 0; fst < 2; ++fst)
                    for (int last = 0; last < 2; ++last)
                        for (int S = 0; S <= maxS; ++S)
                            dp[~i & 1][fst][last][S] = -INF;
                for (int fst = 0; fst < 2; ++fst)
                {
                    for (int last = 0; last < 2; ++last)
                    {
                        for (int S = 0; S <= maxS; ++S)
                        {
                            if (dp[i & 1][fst][last][S] <= -INF) continue;
                            if (i + 1 == L) continue;
                            if (S + K <= maxS)
                                chkmax(dp[~i & 1][fst][1][S + K + 1], dp[i & 1][fst][last][S] + W[ord[i + 1]]);
                            if (last == 0)
                            {
                                chkmax(dp[~i & 1][fst][0][S], dp[i & 1][fst][last][S]);
                            }
                            else
                            {
                                chkmax(dp[~i & 1][fst][0][S + 1 - K], dp[i & 1][fst][last][S]);
                            }
                        }
                    }
                }
            }
            for (int S = K; S <= maxS; ++S)
                dp[~L & 1][0][1][S - K + 1] = dp[~L & 1][0][1][S];
            for (int S = 0; S <= N; ++S)
                dq[cyc & 1][S] = dq[~cyc & 1][S];
            for (int S = 0; S <= N && S <= maxS; ++S)
            {
                int mx = -INF;
                for (int fst = 0; fst < 2; ++fst)
                    for (int last = 0; last < 2; ++last)
                        chkmax(mx, dp[~L & 1][fst][last][S]);
                if (mx <= -INF) continue;
                for (int x = N; x >= S; --x)
                    chkmax(dq[cyc & 1][x], dq[~cyc & 1][x - S] + mx);
            }
        }
    }
    cout << *max_element(dq[cyc & 1], dq[cyc & 1] + N + 1) << '\n';

    return 0;
}