#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) (a).begin() (a).end()
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pil = pair<int, ll>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
using ld = long double;
template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; }
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; }
void debug_out() { cerr << endl; }
template<typename T1, typename... T2> void debug_out(T1 A, T2... B) { cerr << ' ' << A; debug_out(B...); }
#ifdef DEBUG
    #define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
    #define debug(...) 1337
#endif

const int MOD = 1000000007;
const int maxN = 60005;
int add(int a, int b)
{
    a += b;
    if (a >= MOD)
        a -= MOD;
    return a;
}
void vadd(int &a, int b)
{
    a += b;
    if (a >= MOD)
        a -= MOD;
}
int sub(int a, int b)
{
    a -= b;
    if (a < 0)
        a += MOD;
    return a;
}
int mult(int a, int b)
{
    return a * (ll)b % MOD;
}
int bpow(int a, ll b)
{
    int res = 1;
    for (; b; b >>= 1)
    {
        if (b & 1)
            res = mult(res, a);
        a = mult(a, a);
    }
    return res;
}
int rev(int a)
{
    return bpow(a, MOD - 2);
}
int p2[maxN], fact[maxN], rfact[maxN];
int cnk(int n, int k)
{
    if (k < 0 || k > n)
        return 0;
    return mult(mult(fact[n], rfact[k]), rfact[n - k]);
}

signed main()
{
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    p2[0] = 1;
    for (int i = 1; i < maxN; ++i)
        p2[i] = mult(p2[i - 1], 2);
    fact[0] = rfact[0] = fact[1] = rfact[1] = 1;
    for (int i = 2; i < maxN; ++i)
    {
        fact[i] = mult(fact[i - 1], i);
        rfact[i] = rev(fact[i]);
    }

    int n, m;
    cin >> n >> m;
    if (n > m) swap(n, m);
    if (n == 1)
    {
        if (m == 2)
        {
            cout << "2\n";
            exit(0);
        }
        cout << sub(p2[m], mult(2, m)) << '\n';
        exit(0);
    }
    if (n == 2)
    {
        if (m == 2)
        {
            cout << "6\n";
            exit(0);
        }
        int alone = mult(mult(4, n), sub(p2[m - 1], m));
        cout << sub(p2[n * m], add(add(alone, mult(mult(n, n - 1), 2)), mult(2, n))) << '\n';
        exit(0);
    }
    int ans = p2[n * m];
    for (int k = 1; k <= min(n, m); ++k)
    {
        int fr = n * m - k * (n + m - 1) + k * (k - 1);
        int sgn = (k & 1 ? MOD - 1 : 1);
        int pos_pick = mult(mult(cnk(n, k), cnk(m, k)), fact[k]);
        vadd(ans, mult(sgn, mult(pos_pick, p2[fr + 1])));
    }
    cout << ans << '\n';

    return 0;
}