#include <bits/stdc++.h>
#ifndef DEBUG
    #include "sqsort.h"
#endif

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pil = pair<int, ll>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
using ld = long double;
template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; }
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; }
void debug_out() { cerr << endl; }
template<typename T1, typename... T2> void debug_out(T1 A, T2... B) { cerr << ' ' << A; debug_out(B...); }
#ifdef DEBUG
    #define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
    #define debug(...) 1337
#endif

mt19937 rng(time(0));

#ifdef DEBUG
int A[2003];
int queries;
bool cmp(int a, int b, int c, int d)
{
    ++queries;
    return A[a] + A[b] < A[c] + A[d];
}
#endif

vector<pii> solve(int n)
{
    vector<int> ord(n);
    iota(all(ord), 0);
    shuffle(all(ord), rng);
    sort(all(ord), [&](int i, int j) -> bool
    {
        return cmp(i, i, j, j);
    });
    vector<int> where(n);
    for (int i = 0; i < n; ++i)
        where[ord[i]] = i;
    vector<pii> ans;
    for (int i = 0; i < n; ++i)
        for (int j = i; j < n; ++j)
            ans.emplace_back(i, j);
    shuffle(all(ans), rng);
    sort(all(ans), [&](pii A, pii B) -> bool
    {
        if (where[B.fi] <= where[A.fi] && where[B.se] <= where[A.se])
            return false;
        return cmp(A.fi, A.se, B.fi, B.se);
    });
    return ans;
}

#ifdef DEBUG
signed main()
{
    int N = 2000;
    for (int i = 0; i < N; ++i)
        A[i] = rng() % 10000000;
    solve(N);
    debug(queries);
    return 0;
}
#endif