#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#include "sqsort.h"


#define ll int
#define vll vector<ll>
#define vvll vector<vll>
#define pll pair<ll, ll>
#define vpll vector<pll>
#define vb vector<bool>
#define vvb vector<vb>
#define mod (ll)1000000007
using namespace std;

ll n;
vpll dif; //keeps the difference of second - first



bool cmp(int a, int b, int c, int d);
std::vector<std::pair<int, int>> solve(int n);

/*
void print_vll(vll& arr, const string name)
{
	cout << name << ": " << endl;
	for (ll i = 0; i < arr.size(); i++)
	{
		cout << arr[i] << " ";
	}
	cout << endl;
}
*/

/*
bool cmp(int a, int b, int c, int d)
{
	ll type; cin >> type;
	if (type == 1) return true;
	return false;
}
*/



/*
we can sort dif by using bubble sort:
*/
/*
void handle_dif()
{
	ll sz = dif.size();
	for (ll start = sz - 2; start >= 0; start--)
	{
		for (ll cur = start; cur < sz - 1; cur++)
		{
			ll ai = dif[cur].first;
			ll aj = dif[cur].second;
			ll ak = dif[cur+1].first;
			ll am = dif[cur+1].second;

			/* 
			we wanna check if cur > cur+1
			so we have to check if:
			am - ak < aj - ai
			am + ai < aj + ak
			*/
/*
			bool curans = cmp(am, ai, aj, ak);
			if (curans == false) break;
			ll curf = dif[cur].first;
			ll curs = dif[cur].second;
			dif[cur].first = dif[cur + 1].first;
			dif[cur].second = dif[cur + 1].second;
			dif[cur + 1].first = curf;
			dif[cur + 1].second = curs;
		}
	}
}
*/
void print_ans(vpll& ans1)
{
	for (ll i = 0; i < ans1.size(); i++)
	{
		cout << "(" << ans1[i].first << ", " << ans1[i].second << ")" << ", ";
	}
	cout << endl;
}


/*

improve:
find with binary seaarch the place of the current one.

*/
std::vector<std::pair<int, int>> solve(int n)
{
	vector<std::pair<int, int>> ans;
	for (ll len = 0; len < n; len++)
	{
		for (ll start = 0; start + len < n; start++)
		{
			ans.push_back({ start, start + len });
		}
	}


	ll sz = ans.size();
	for (ll start = sz - 2; start >= 0; start--)
	{
		//print_ans(ans);
		ll curind = sz-1;

		// let's find its index by lower bound:
		// we will find the last index that start is smaller than him.
		//cout << "start: " << start << endl;
		ll low = start+1, high = sz - 1, mid;

		while (low <= high)
		{
			mid = (low + high) / 2;
			//cout << "mid: " << mid << endl;
			ll ai = ans[start].first;
			ll aj = ans[start].second;
			ll ak = ans[mid].first;
			ll am = ans[mid].second;

			//cout << ai << ", " << aj << ", " << ak << ", " << am << endl;
			bool curans = cmp(ai, aj, ak, am);
			if (curans == true)
			{
				curind = min(curind-1, mid - 1);
				high = mid - 1;
			}
			else
			{
				low = mid + 1;
			}
		}
		//cout << "curind: " << curind << endl;
		// now, swap all elements from start to curind-1:
		//ll curindf = ans[curind].first;
		//ll curinds = ans[curind].second;
		ll curstartf = ans[start].first;
		ll curstarts = ans[start].second;
		for (ll i = start; i < curind; i++)
		{
			//ll curf = ans[i].first;
			//ll curs = ans[i].second;
			ans[i].first = ans[i + 1].first;
			ans[i].second = ans[i + 1].second;
			//ans[i - 1].first = curf;
			//ans[i + 1].second = curs;
		}
		ans[curind].first = curstartf;
		ans[curind].second = curstarts;
		//ans[start]
		/*
		for (ll cur = start; cur < sz - 1; cur++)
		{
			ll ai = ans[cur].first;
			ll aj = ans[cur].second;
			ll ak = ans[cur + 1].first;
			ll am = ans[cur + 1].second;

			/*
			we wanna check if cur > cur+1
			so we have to check if:
			ai + aj < ak + am
			*/
			
			//cout << ai << ", " << aj << ", " << ak << ", " << am << endl;
		/*
			bool curans = cmp(ai, aj, ak, am);
			if (curans == true) break;
			ll curf = ans[cur].first;
			ll curs = ans[cur].second;
			ans[cur].first = ans[cur + 1].first;
			ans[cur].second = ans[cur + 1].second;
			ans[cur + 1].first = curf;
			ans[cur + 1].second = curs;
		}*/
	}

	//print_ans(ans);
	return ans;
}


/*
int main()
{
	cin >> n;
	solve(n);
	return 0;

}
*/
