﻿//#pragma GCC optimize("Ofast,unroll-loops")

#ifdef LOCAL
#include "headers.h"
#else
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
//#include "sqsort.h"
#endif
 
using namespace std;
 
//#define int ll
 
typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;
#define sz(x) int((x).size())

template <typename T>
using ordered_set = __gnu_pbds::tree <T, __gnu_pbds::null_type, less<T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

#ifdef ONLINE_JUDGE
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
#else
mt19937 rng(1000 - 7);
#endif
 
const int N = 11;
//const ll MOD = 998244353;
const ll MOD = 1e9 + 7;
const ld eps = 5e-8;
const pii dir[] = { { 0, 1 }, { 0, -1 }, { 1, 0 }, { -1, 0 } };

int n, k, v[N], c[N], a[N];

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin >> n >> k;
    for (int i = 0; i < n; i++) {
        cin >> v[i] >> c[i];
    }

    int ans = 0;
    for (int i = 0; i < (1 << n); i++) {
        fill(a, a + N, 1);

        for (int j = 0; j < n; j++) {
            if (i >> j & 1) {
                a[v[j]]--; 
                a[j]++; 
            }
        }

        int cur = 0, cnt = 0;
        vector <int> s;
        for (int j = 0; j < n; j++) {
            if (a[j] == 2) {
                cur += c[j];
            }
            if (a[j] == 1) {
                s.push_back(c[j]);
            }
        }

        sort(s.rbegin(), s.rend());
        while (!s.empty()) {
            if (cnt >= k) {
                cur += s.front();
                s.erase(s.begin());
                cnt = 0;
            }
            else {
                while (!s.empty() && cnt < k) {
                    s.pop_back();
                    cnt++;
                }
            }
        }

        //cout << i << " " << cur << endl;
        ans = max(ans, cur);
    }

    cout << ans << endl;

    return 0;
}
