﻿//#pragma GCC optimize("Ofast,unroll-loops")

#ifdef LOCAL
#include "headers.h"
#else
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
//#include "sqsort.h"
#endif
 
using namespace std;
 
//#define int ll
 
typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;
#define sz(x) int((x).size())

template <typename T>
using ordered_set = __gnu_pbds::tree <T, __gnu_pbds::null_type, less<T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

#ifdef ONLINE_JUDGE
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
#else
mt19937 rng(1000 - 7);
#endif
 
const int N = 2e5 + 10;
//const ll MOD = 998244353;
const ll MOD = 1e9 + 7;
const ld eps = 5e-8;
const pii dir[] = { { 0, 1 }, { 0, -1 }, { 1, 0 }, { -1, 0 } };

int n, m, a[5][5], cntr[5][2], cntc[5][2];

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin >> n >> m;

    int ans = 0;
    for (int i = 0; i < (1 << (n * m)); i++) {
        memset(cntr, 0, sizeof cntr);
        memset(cntc, 0, sizeof cntc);

        for (int j = 0; j < n * m; j++) {
            int x = i >> j & 1;

            int r = j / m;
            int c = j % m;

            a[r][c] = x;
        }

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                cntr[i][a[i][j]]++;
                cntc[j][a[i][j]]++;
            }
        }

        bool flag = true;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (cntr[i][a[i][j]] == 1 && cntc[j][a[i][j]] == 1) {
                    flag = false;
                    break;
                } 
            }
        } 

        ans += flag;
    } 

    cout << ans << endl;

    return 0;
}
