﻿//#pragma GCC optimize("Ofast,unroll-loops")

#ifdef LOCAL
#include "headers.h"
#else
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include "sqsort.h"
#endif
 
using namespace std;
 
//#define int ll
 
typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;
#define sz(x) int((x).size())

template <typename T>
using ordered_set = __gnu_pbds::tree <T, __gnu_pbds::null_type, less<T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

#ifdef ONLINE_JUDGE
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
#else
mt19937 rng(1000 - 7);
#endif
 
const int N = 2e5 + 10;
//const ll MOD = 998244353;
const ll MOD = 1e9 + 7;
const ld eps = 5e-8;
const pii dir[] = { { 0, 1 }, { 0, -1 }, { 1, 0 }, { -1, 0 } };

/*
int seq[] = { 5, 2, 13, 7, 1 };

bool cmp(int a, int b, int c, int d) {
    return seq[a] + seq[b] < seq[c] + seq[d];
}
*/

vector <pair <int, int>> solve(int n) {
    vector <pii> res;
    vector <int> a(n);

    iota(a.begin(), a.end(), 0);

    sort(a.begin(), a.end(), [&] (int i, int j) {
        return cmp(i, i, j, j);
    });

    vector <int> b(n);
    for (int i = 0; i < n; i++) {
        b[a[i]] = i;
    }

    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) {
            res.push_back({ i, j });
        }
    }

    sort(res.begin(), res.end(), [&] (pii x, pii y) {
        int l1 = b[x.first], r1 = b[x.second];
        int l2 = b[y.first], r2 = b[y.second];

        if (r1 < l1) {
            swap(l1, r1);
        }
        if (r2 < l2) {
            swap(l2, r2);
        }

        if (!((l1 >= l2 && l1 <= r2 && r1 >= l2 && r1 <= r2) || 
            (l2 >= l1 && l2 <= r1 && r2 >= l1 && r2 <= r1))) {
            
            /* 
            cout << x.first << " " << x.second << " " << y.first << " " << y.second << endl;
            cout << l1 << " " << r1 << " " << l2 << " " << r2 << endl;
            cout << (l1 + r1 < l2 + r2) << cmp(x.first, x.second, y.first, y.second) << endl;
            */ 

            return l1 + r1 < l2 + r2;
        }
        else {
            return cmp(x.first, x.second, y.first, y.second);
        }
    });

    return res;
}

/*
signed main() {
    freopen("output.txt", "w", stdout);

    auto res = solve(5);

    for (auto [x, y] : res) {
        cout << x << " " << y << " " << seq[x] + seq[y] << endl;
    }

    return 0;
}
*/
