#include <iostream>
#include <vector>
#include <utility>
#include <algorithm>
#include <bits/stdc++.h>

#define fi first
#define se second

#include "sqsort.h"
//#include "sqsort.cpp"

using namespace std;
/*
static const int HARD_LIMIT = 50000000;

static int n;
static std::vector<int> a;

static bool valid_pos(int i) {
	return 0 <= i && i < n;
}

static int Q;
bool cmp(int a_, int b, int c, int d) {
	if(!valid_pos(a_) || !valid_pos(b) || !valid_pos(c) || !valid_pos(d)) {
		std::cerr << "Invalid query." << std::endl;
		std::cout << -1 << std::endl;
		exit(0);
	}

	Q++;
	if(Q > HARD_LIMIT) {
		std::cerr << "Too many queries." << std::endl;
		std::cout << -1 << std::endl;
		exit(0);
	}

	return a[a_] + a[b] < a[c] + a[d];
}

static bool check_valid(const std::vector<std::pair<int, int>> &a) {
	if(n * (n + 1) / 2 != (int)a.size()) {
		return false;
	}

	std::vector<std::vector<bool>> used(n, std::vector<bool>(n, false));
	for(int i = 0; i < (int)a.size(); i++) {
		if(!valid_pos(a[i].first) || !valid_pos(a[i].second) || used[a[i].first][a[i].second]) {
			return false;
		}

		used[a[i].first][a[i].second] = true;
		used[a[i].second][a[i].first] = true;
	}

	return true;
}*/

long long pos[2009];

long long cnt[2009][2009];

bool can(int a,int b,int c,int d){

    if(max(pos[a],pos[b])<=min(pos[c],pos[d]))return true;
    if(cnt[max(pos[c],pos[d])][min(pos[a],pos[b])]>=max(pos[a],pos[b]))return true;

    return cmp(a,b,c,d);
}

void merge_(vector<pair<int,int> > &a,vector<pair<int,int> > &b,vector<pair<int,int> > &ans){
    long long i1=0,i2=0;
    while(i1<a.size() || i2<b.size()){
        if(i2==b.size())ans.push_back(a[i1]),i1++;
        else{
            if(i1==a.size()){
                ans.push_back(b[i2]);
                i2++;
            }
            else{
                if(can(a[i1].fi,a[i1].se,b[i2].fi,b[i2].se)){
                    ans.push_back(a[i1]);
                    i1++;
                }
                else{
                    ans.push_back(b[i2]);
                    i2++;
                }
            }
        }
    }
}

void merge_sort(vector<pair<int,int> > &a){
    if(a.size()<2)return;
    vector<pair<int,int> >a1,a2;

    long long k=rand()%a.size();

    for(int i=0;i<a.size()/2;i++)a1.push_back(a[i]);
    for(int i=a.size()/2;i<a.size();i++)a2.push_back(a[i]);

    merge_sort(a1);
    merge_sort(a2);

    a.clear();

    merge_(a1,a2,a);
}

vector<pair<int, int> >solve(int n){
    vector<pair<int,int> >ans;

    vector<pair<int,int> >nums;
    for(int i=0;i<n;i++)nums.push_back({i,i}),pos[i]=n-i;

    merge_sort(nums);

    for(int i=0;i<nums.size();i++)pos[nums[i].fi]=i;

    for(int i=1;i<nums.size();i++){
        cnt[i][i]=-1;
        for(int l=1;l<i;l++){
            cnt[i][l]=cnt[i-1][l];

            while(cnt[i][l]+1<=i && cmp(nums[l].fi,nums[cnt[i][l]+1].fi,nums[0].fi,nums[i].fi))cnt[i][l]++;
           // cout<<cnt[i][l]<<' ';
        }
       // cout<<endl;
    }

    for(int i=0;i<n;i++){
        for(int j=i;j<n;j++){
            ans.push_back({i,j});
        }
    }

    merge_sort(ans);
    return ans;
}/*

int main() {
	std::cin >> n;
	a.resize(n);
	for(int i = 0; i < n; i++) {
		a[i] = 3 * i % n;
		//cout<<a[i]<<' ';
	}
	//cout<<endl;

	Q = 0;
	std::vector<std::pair<int, int>> ret = solve(n);

	if(!check_valid(ret)) {
		std::cerr << "Invalid output." << std::endl;
		std::cout << -1 << std::endl;
		return 0;
	}

	for(int i = 1; i < (int) ret.size(); i++) {
		if(a[ret[i].first] + a[ret[i].second] < a[ret[i - 1].first] + a[ret[i - 1].second]) {
			std::cerr << "Output not sorted." << std::endl;
			std::cout << -1 << std::endl;
			return 0;
		}
	}

	std::cerr << "Correct!" << std::endl;
	std::cout << Q << std::endl;
	return 0;
}
*/
