#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define pb push_back
#define pll pair<ll, ll>

const ll maxn = ll(1e2) + 5;
const ll mod = ll(1e9) + 7;

ll n, k;
vector<ll> tar;
vector<ll> lv;

void solve() {
    cin >> n >> k;
    for(ll i = 0; i < n; i++) {
        ll t, l;
        cin >> t >> l;
        tar.pb(t);
        lv.pb(l);
    }

    ll ans = 0;
    for(ll msk = 0; msk < (1 << n); msk++) { /// K + K
        ll cur = 0;
        bool ok = true;
        ll used = msk;
        for(ll i = 0; i < n; i++) {
            if((msk & (1 << i)) == 0) continue;
            cur += lv[i];
            if(msk & (1 << tar[i])) {
                ok = false;
                break;
            }
            used += (1 << tar[i]);
        }
        if(!ok) continue;

        for(ll sec = 0; sec < (1 << n); sec++) {
            if(sec & msk) continue;
            ll need = 0;
            ll cur_ans = cur;
            for(ll i = 0; i < n; i++) {
                if(sec & (1 << i)) {
                    if(used & (1 << i)) {
                        need += 2 * k;
                    } else {
                        need += k;
                    }
                    cur_ans += lv[i];
                }
            }

            ll cnt = 0;
            for(ll i = 0; i < n; i++) {
                if((sec & (1 << i)) == 0 && (used & (1 << i)) == 0) {
                    cnt++;
                }
            }

            if(cnt >= need) {
                ans = max(ans, cur_ans);
            }
        }
    }
    cout << ans << endl;
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
