#include <bits/stdc++.h>
#include "sqsort.h"

using namespace std;

typedef int ll;
typedef long double ld;
#define pb push_back
#define pll pair<ll, ll>

const ll maxn = ll(1e2) + 5;
const ll mod = ll(1e9) + 7;

vector<pll> start;
vector<ll> order;

/*vector<ll> ar = {5, 1, 3};
bool cmp(ll a, ll b, ll c, ll d) {
    return ar[a] + ar[b] < ar[c] + ar[d];
}*/

vector<ll> ps;

vector<pll> srt(ll l, ll r) {
    if(l == r) {
        return {start[l]};
    } else {
        ll mid = (l + r) / 2;
        vector<pll> first = srt(l, mid);
        vector<pll> sec = srt(mid + 1, r);

        vector<pll> res;
        ll i = 0, j = 0;
        while(i < first.size() || j < sec.size()) {
            if(j == sec.size()) {
                res.pb(first[i]);
                i++;
            } else if(i == first.size()) {
                res.pb(sec[j]);
                j++;
            } else if(max(ps[first[i].first], ps[first[i].second]) < min(ps[sec[j].first], ps[sec[j].second])) {
                res.pb(first[i]);
                i++;
            } else if(max(ps[sec[j].first], ps[sec[j].second]) < min(ps[first[i].first], ps[first[i].second])) {
                res.pb(sec[j]);
                j++;
            } else if(cmp(first[i].first, first[i].second, sec[j].first, sec[j].second)) {
                res.pb(first[i]);
                i++;
            } else {
                res.pb(sec[j]);
                j++;
            }
        }

        return res;
    }
}

vector<ll> srt_vals(ll l, ll r) {
    if(l == r) {
        return {order[l]};
    } else {
        ll mid = (l + r) / 2;
        vector<ll> first = srt_vals(l, mid);
        vector<ll> sec = srt_vals(mid + 1, r);

        vector<ll> res;

        ll i = 0, j = 0;
        while(i < first.size() || j < sec.size()) {
            if(j == sec.size()) {
                res.pb(first[i]);
                i++;
            } else if(i == first.size()) {
                res.pb(sec[j]);
                j++;
            } else if(cmp(first[i], first[i], sec[j], sec[j])) {
                res.pb(first[i]);
                i++;
            } else {
                res.pb(sec[j]);
                j++;
            }
        }
        return res;
    }
}

vector<pll> solve(ll n) {
    for(ll i = 0; i < n; i++) {
        for(ll j = i; j < n; j++) {
            start.pb({i, j});
        }
    }

    for(ll i = 0; i < n; i++) {
        order.pb(i);
    }

    vector<ll> tmp = srt_vals(0, order.size() - 1);
    ps.assign(n, 0);
    for(ll i = 0; i < n; i++) {
        ps[tmp[i]] = i;
    }

    return srt(0, start.size() - 1);
}


/*int main()
{
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    for(auto el : solve(3)) {
        cout << "{" << el.first << ", " << el.second << "}, ";
    }

    return 0;
}*/
