#include "sqsort.h"
#include <bits/stdc++.h>

#define Tree int h,int l,int r
#define Left (h<<1),l,((l+r)>>1)
#define Right ((h<<1)|1),((l+r)>>1)+1,r
#define ll long long
#define pb push_back
#define F first
#define S second

using namespace std;

int v[500005];

struct comp {
  bool operator()(pair < int , int > a, pair < int , int > b) {
    return cmp(v[a.F],v[a.S],v[b.F],v[b.S]);
  }
};
	
vector < pair < int , int > > solve(int nn) {
	for (int i=0; i<nn; i++) 
		v[i]=i;
	
	bool s=true;
	while (s) {
		s=false;
		for (int i=1; i<nn; i++) {
			// true if v[i]<v[i-1]
			if (cmp(0,v[i],0,v[i-1]))
				swap(v[i],v[i-1]),s=true;
		}
	}
	
	set < pair < int , int > > st;
	set < pair < int , int > , comp > St;
	set < pair < int , int > > :: iterator it;
	
	vector < pair < int , int > > S;
	for (int i=0; i<nn; i++) 
		for (int j=i; j<nn; j++) 
			st.insert({i,j});
	
	while (st.size()) {
		int l=(*st.begin()).F;
		int r=(*st.begin()).S;
		
		St.insert({l,r});
		while (1) {
			it=(st.upper_bound({l+1,-1}));
			if (it==st.end()) break;
			if ((*it).S>=r) break;
			l=(*it).F,r=(*it).S;
			St.insert({l,r});
		}
		
		S.pb({ v[(*St.begin()).F],v[(*St.begin()).S]  });
		st.erase(st.find({(*St.begin()).F,(*St.begin()).S}));
		
		St.clear();
	}
	
	for (int i=0; i<S.size(); i++) 
		if (S[i].F>S[i].S) swap(S[i].F,S[i].S);
	
	return S;
}

/*

5
2 0 1 4 3

*/
