#include<bits/stdc++.h>
#pragma GCC optimize("Ofast")
// #define int long long
#define ii pair <int, int>
#define app push_back
#define all(a) a.begin(), a.end()
#define bp __builtin_popcountll
#define ll long long
#define mp make_pair
#define f first
#define pb push_back
#define s second
#define Time (double)clock()/CLOCKS_PER_SEC
#define FOR(i, n) for (int i = 0; i < (int)(n); ++i)
#define debug(x) std::cout << #x << ": " << x << '\n';
const int N = 2e4, mod = 1e9 + 7;
int used[N], sz[N];
int n, m;
struct smart_map
{
    std::vector<int> x;
    std::bitset<N> nxt;

    smart_map() {
        x.resize(2 * n);
        nxt &= 0;

        clear();
    }

    int get(int i) {
        if (i + n < 0 || i + n >= 2 * n) return -1e9;
        return x[i + n];
    }
    void set(int i, int y) {
        if (i + n < 0) return;
        if (i + n >= 2 * n) return;
        nxt[i + n] = 1;
        // debug(i + n)
        x[i + n] = std::max(x[i + n], y);
    }
    std::vector<std::pair<int,int>> getAll() {
        std::vector<int> index;
        int cur = findFirst();
        while (cur < 2 * n) {
            index.pb(cur);
            cur = findNext(cur);
        }
        std::vector<std::pair<int,int>> v(index.size());

        FOR(i, index.size()) {
            v[i] = {index[i] - n, x[index[i]]};
        }
        return v;
    }
    void doAdd(int cnt, int much) {
        std::vector<int> index;
        int cur = findFirst();
        while (cur < 2 * n) {
            index.pb(cur);
            cur = findNext(cur);
            // debug(cur)
        } 
        // debug(cnt)
        if (cnt > 0) {
            for (int i = (int)index.size() - 1; i >= 0; --i) {
                int where = index[i];
                // debug(where - n << ' ' << x[where])
                // debug(where + cnt - n << ' ' << x[where] + much)
                if (where + cnt >= 0 && where + cnt < 2 * n) {
                    // debug("SET")
                    set(where + cnt - n, std::max(x[where] + much, x[where + cnt]));
                }
            }
        }
        if (cnt < 0) {
            FOR(i, (int)index.size()) {
                int where = index[i];
                // debug(where - n << ' ' << x[where])
                // debug(where + cnt - n << ' ' << x[where] + much)
                if (where + cnt >= 0 && where + cnt < 2 * n) {
                    // debug("SET")
                    set(where + cnt - n, std::max(x[where] + much, x[where + cnt]));
                }
            }
        }
    }
    void clear() {
        // memset(x, 0, sizeof(x));
        FOR(i, 2 * n) x[i] = 0;

        nxt &= 0;
    }
    int findFirst() {
        return nxt._Find_first();
    }
    int findNext(int t) {
        return nxt._Find_next(t);
    }
    void relax(smart_map &other) {
        FOR(i, 2 * n) {
            x[i] = std::max(x[i], other.x[i]);
        }
        nxt |= other.nxt;
    }
};
signed main() {
    #ifndef LOCAL
    std::ios_base::sync_with_stdio(0); std::cin.tie(0);
    #endif
    std::cin >> n >> m;
    std::vector<std::pair<int,int>> a(n);
    FOR(i, n) {
        std::cin >> a[i].first >> a[i].second;
    }
    std::vector<smart_map> knap;
    smart_map bal[2][2]; //ind1, last
    smart_map best;

    best.set(0, 0);
    FOR(i, n) {
        if (used[i]) continue;
        std::vector<int> ind;
        int now = i;
        while (!used[now]) {
            used[now] = 1;
            ind.pb(now);
            now = a[now].first;
        }
        // debug(i)
        sz[knap.size()] = ind.size();
        smart_map temp_best[2];
        FOR(START, 2) {
            bal[0][0] = best;
            bal[0][1] = best;
            if (START == 0) {
                bal[0][0].doAdd(1, 0);
                // bal[0][0].set(1, 0);
            }
            if (START == 1) {
                bal[0][1].doAdd(-m, a[ind[0]].second);
                // bal[0][1].set(-m, a[ind[0]].second);
            }
            for (int j = 1; j < (int)ind.size(); ++j) {
                bal[1][0].clear();
                bal[1][1].clear();
                for (int last = 0; last < 2; ++last) {
                    for (int now = 0; now < 2; ++now) {
                        for (auto q : bal[0][last].getAll()) {
                            int curBal = q.first;
                            int answ = q.second;


                            if (last == 1 && now == 0) {
                                curBal += m;
                            }
                            if (now == 1) {
                                curBal -= m;
                                answ += a[ind[j]].second;
                            }
                            if (last == 0 && now == 0) {
                                curBal++;
                            }
                            if (curBal < -n) continue;
                            // if (START == 1) {
                            //     // debug(q.first)
                            //     debug(j << ' ' << now << ' ' << curBal)
                            // }
                            bal[1][now].set(curBal, std::max(bal[1][now].get(curBal), answ));
                        }
                    }
                }
                std::swap(bal[0], bal[1]);
            }

            FOR(last, 2) {
                for (auto e : bal[0][last].getAll()) {
                    int curBal = e.first;
                    int answ = e.second;

                    // if (START == 1) {
                    //     debug(curBal << ' ' << answ)
                    // }

                    if (last == 1 && START == 0) {
                        curBal += m - 1;
                    }

                    bal[1][last].set(curBal, answ);
                }
            }

            FOR(last, 2) {
                for (auto e : bal[1][last].getAll()) {
                    temp_best[START].set(e.first, e.second);
                }
            }
        }
        FOR(last, 2) {
            for (auto e : temp_best[last].getAll()) {
                best.set(e.first, e.second);
            }
        }
    }
    int answ = 0;
    for (auto e : best.getAll()) {
        if (e.first >= 0) answ = std::max(answ, e.second); 
    }
    std::cout << answ << '\n';
}