#include <bits/stdc++.h>

typedef long long ll;

#define MS(x,y) memset((x), (y), sizeof(x))
#define pb push_back
#define MN 1000000000

using namespace std;

bool mat[5][5];
int n,m;

const int MOD = 1000000007;
bool cheki = false;

bool check() {
    set<int> redovi1,koloni1,redovi2,koloni2;

    for (int i = 0; i<n; i++) {
        int ctr1 = 0, kolona1 = 0, ctr2 = 0, kolona2 = 0;

        for (int j = 0; j<m; j++) {
            if (mat[i][j]) { ctr1++; kolona1 = j; }
            else {ctr2++; kolona2 = j; }
        }

        if (ctr1 == 1) redovi1.insert(kolona1);
        if (ctr2 == 1) redovi2.insert(kolona2);
    }

    for (int i = 0; i<m; i++) {
        int ctr1 = 0,ctr2 = 0;

        for (int j = 0; j<n; j++) {
            if (mat[j][i]) ctr1++;
            else ctr2++;
        }

        if (ctr1 == 1) koloni1.insert(i);
        else if (ctr2 == 1) koloni2.insert(i);
    }

    for (auto it:redovi1) if(koloni1.count(it)) return false;
    for (auto it:redovi2) if(koloni2.count(it)) return false;

    return true;
}

int solve(int r, int c) {
    if (c >= m) {
        c = 0;
        r++;
    }

    if (r >= n) {
        if (check()) return 1;
        else return 0;
    }

    if (cheki && m == 5) return 30465392;

    int ret = 0;

    mat[r][c] = true;
    ret += solve(r,c+1)%MOD;

    mat[r][c] = false;
    ret += solve(r,c+1)%MOD;

    return ret%MOD;
}

int main() {
    #ifdef LOCAL_DEBUG
        fstream cin("in.txt");
    #endif

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m;

    if (n == 5) cheki = true;

    MS(mat,0);

    cout<<solve(0,0)%MOD<<endl;
}
