#include <bits/stdc++.h>
#include "sqsort.h"

typedef long long ll;

#define MS(x,y) memset((x), (y), sizeof(x))
#define pb push_back
#define MN 1000000

using namespace std;

//int niza[3] = {5,1,3};
//
//bool cmp(int a, int b, int c, int d) {
//    if (niza[a]+niza[b] < niza[c]+niza[d]) return true;
//    else return false;
//}

vector<int> resRed;
int n;
vector<int> pat[2001];
bool vis[2001];
int vrednosti[2001];

void dfs(int curr, vector<int> order) {
    if (order.size() == n) {
        resRed = order;
        return;
    }

    if (!resRed.empty()) return;

    for (auto it:pat[curr]) {
        if (vis[it]) continue;

        vis[it] = true;
        order.pb(it);

        dfs(it,order);

        order.pop_back();
        vis[it] = false;
    }
}

vector<pair<int,int>> solve(int n2) {
    n = n2;

    bool tiGoStaile[n];
    MS(tiGoStaile,false);

    for (int i = 0; i<n; i++) {
        for (int j = i+1; j<n; j++) {
            auto know = cmp(i,i,i,j);

            ///TRUE = j>i
            ///FALSE = j<i

            if (know) { pat[j].pb(i); tiGoStaile[i] = true; }
            else { pat[i].pb(j); tiGoStaile[j] = true; }
        }
    }

    MS(vis,0);

    for (int i = 0; i<n; i++) if (!tiGoStaile[i]) dfs(i,{i});
    for (int i = 0; i<n; i++) vrednosti[resRed[i]] = n-i;

    vector<pair<int, pair<int,int>>> sortir;

    for (int i = 0; i<n; i++) {
        for (int j = i; j<n; j++) {
            sortir.pb({vrednosti[i]+vrednosti[j], {i,j}});
        }
    }

    sort(sortir.begin(), sortir.end());

    vector<pair<int,int>> a;

    for (auto it:sortir) a.pb({it.second});

    return a;
}

//int main() {
//    #ifdef LOCAL_DEBUG
//        fstream cin("in.txt");
//    #endif
//
//    ios_base::sync_with_stdio(false);
//    cin.tie(0);
//    cout.tie(0);
//
//    auto res = solve(3);
//
//    for (auto it:res) cout<<it.first<<" "<<it.second<<endl;
//}
