#include <iostream>
#include <vector>
#include <unordered_map>
#include <string>
#include <map>
#include <string>
#include <algorithm>
#include <iomanip>
#include <set>
#include <unordered_set>
#include <deque>
#include <functional>
#include <queue>
#include <cmath>
#include <array>
#include “sqsort.h”
//#include <ext/pb_ds/assoc_container.hpp>
//using namespace __gnu_pbds;
#define endl '\n'
//#define int long long
using namespace std;
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("fast-math")
const int INF = 1'000'000'000;
const int MAXN = 3e5;
//gp_hash_table<long long, bool> map1;
//unordered_map<long long, bool> map1;
int n, k;
int t[MAXN], l[MAXN];
bool used[MAXN];
int row[100], col[100], rk[100][100];
vector<pair<int,int>> ans;
deque<pair<int, int>> act, nact;
vector<int> ones, nones;
int amount;
bool bigger(int i, int j, int i2, int j2) {
	if (i >= i2 && j <= j2) {
		return true;
	}
	return false;
}
void push(int i, int j) {
	if (i >= amount || j >= amount || i > j) {
		return;
	}
	for (auto k : act) {
		if (bigger(i, j, k.first, k.second)) {
			return;
		}
	}
	int l = -1, r = act.size();
	while (r - l > 1) {
		int res = (r + l) / 2;
		if (cmp(ones[act[res].first], ones[act[res].second], ones[i], ones[j])) {
			l = res;
		}
		else {
			r = res;
		}
	}
	nact.clear();
	for (int i = 0; i <= act.size(); i++) {
		if (j == r) {
			nact.push_back({ i, j });
		}
		if (i != act.size()) {
			nact.push_back(act[i]);
		}
	}
	return;
}
vector<pair<int, int>> solve(int n) {
	amount = n;
	ones.push_back(0);
	for (int i = 1; i < n; i++) {
		int l = -1, r = ones.size();
		while (r - l > 1) {
			int res = (r + l) / 2;
			if (cmp(ones[res], ones[res], i, i)) {
				l = res;
			}
			else {
				r = res;
			}
		}
		nones.clear();
		for (int j = 0; j < i + 1; j++) {
			if (j == r) {
				nones.push_back(i);
			}
			if (j != i) {
				nones.push_back(ones[j]);
			}
		}
		ones = nones;
		push(0, 0);
		while (act.size() > 0) {
			auto pa = act[0];
			ans.push_back(pa);
			act.pop_front();
			push(pa.first + 1, pa.second);
			push(pa.first, pa.second + 1);
		}
	}
	return ans;
}
