#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <iomanip>

#define endl '\n'
#define mp make_pair
#define pb push_back
#define sqr(x) ((x) * (x))
//#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<pii> vii;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)1e9 + 10;
const int MOD = (int)1e9 + 7;

int rec(int i, vc& p, vi& t, vi& w, int n, int k) {
	if (i == n) {
		int ans = 0;
		int r = 0;
		vc used(n);
		for (int j = 0; j < n; ++j) {
			if (p[j]) {
				if (!used[t[j]] && !p[t[j]]) {
					used[t[j]] = 1;
					ans += w[j];
					used[j] = 1;
				}
			}
		}
		for (int j = 0; j < n; ++j) {
			if (p[j] && !used[j]) {
				int cnt = 0;
				while (r < n && cnt < k) {
					if (used[r] || p[r]) {
						++r;
						continue;
					}
					used[r] = 1;
					++cnt;
					++r;
				}
				if (cnt == k)
					ans += w[j];
			}
		}
		vi v;
		for (int j = 0; j < n; ++j) {
			if (!p[j] && !used[j])
				v.push_back(w[j]);
		}
		sort(v.rbegin(), v.rend());
		for (int j = 0; j < (int)v.size() / (2 * k); ++j)
			ans += v[j];
		return ans;
	}
	int ans = rec(i + 1, p, t, w, n, k);
	p[i] = 1;
	ans = max(ans, rec(i + 1, p, t, w, n, k));
	p[i] = 0;
	return ans;
}

signed main() {
#ifdef LOCALFILE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n, k;
	cin >> n >> k;
	vi t(n), w(n);
	for (int i = 0; i < n; ++i)
		cin >> t[i] >> w[i];
	if (n <= 10) {
		vc p(n);
		cout << rec(0, p, t, w, n, k);
	}


	return 0;
}