#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <iomanip>

#define endl '\n'
#define mp make_pair
#define pb push_back
#define sqr(x) ((x) * (x))
//#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<pii> vii;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)1e9 + 10;
const int MOD = (int)1e9 + 7;

int solve(int n, int k, vii& w, vi& t, vi& id) {
	int sumk = 0, sum2k = 0, r1 = n - 1, r2 = n - 1, r = n - 1, cnt1 = 0, cnt2 = 0;
	vc used(n);
	while (cnt1 < k && r1 >= 0) {
		if (r1 >= 0) {
			if (!used[r1]) {
				sumk += w[r1].first;
				++cnt1;
			}
			--r1;
		}
	}
	while (cnt2 < 2 * k && r2 >= 0) {
		if (r2 >= 0) {
			if (!used[r2]) {
				sum2k += w[r2].first;
				++cnt2;
			}
			--r2;
		}
	}
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		if (i > r)
			used[i] = 1;
		int next = id[t[w[i].second]];
		if (next > r)
			used[next] = 1;
		int minn = INF, c = -1;
		if (!used[next] && !used[i] && minn > w[i].first + w[next].first) {
			minn = w[i].first + w[next].first;
			c = 0;
		}
		if (!used[i] && r1 >= 0 && minn > w[i].first + sumk) {
			minn = w[i].first + sumk;
			c = 1;
		}
		if (r2 >= 0 && minn > sum2k) {
			minn = sum2k;
			c = 2;
		}
		if (c == -1)
			continue;
		if (c == 0) {
			used[i] = 1;
			used[next] = 1;
			if (i > r1) --cnt1;
			if (i > r2) --cnt2;
			if (next > r1) --cnt1;
			if (next > r2) --cnt2;
		}
		else if (c == 1) {
			if (i > r1) --cnt1;
			while (cnt1 < k && r1 >= 0) {
				if (r1 >= 0) {
					if (!used[r1]) {
						sumk += w[r1].first;
						++cnt1;
					}
					--r1;
				}
			}
			if (r1 < 0)
				continue;
			r = r1;
			cnt1 = 0; cnt2 -= k;
			used[i] = 1;
		}
		else if (c == 2) {
			r1 = r = r2;
			cnt1 = cnt2 = 0;
		}
		ans += w[i].first;
		while (cnt1 < k && r1 >= 0) {
			if (r1 >= 0) {
				if (!used[r1]) {
					sumk += w[r1].first;
					++cnt1;
				}
				--r1;
			}
		}
		while (cnt2 < 2 * k && r2 >= 0) {
			if (r2 >= 0) {
				if (!used[r2]) {
					sum2k += w[r2].first;
					++cnt2;
				}
				--r2;
			}
		}
	}
	return ans;
}

signed main() {
#ifdef LOCALFILE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n, k;
	cin >> n >> k;
	vi t(n);
	vii w(n);
	for (int i = 0; i < n; ++i) {
		cin >> t[i] >> w[i].first;
		w[i].second = i;
	}
	sort(w.rbegin(), w.rend());
	vi id(n);
	for (int i = 0; i < n; ++i)
		id[w[i].second] = i;
	int ans = solve(n, k, w, t, id);
	w[0].first = 0;
	sort(w.rbegin(), w.rend());
	for (int i = 0; i < n; ++i)
		id[w[i].second] = i;
	ans = max(ans, solve(n, k, w, t, id));
	cout << ans;

	return 0;
}