#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <iomanip>

#define endl '\n'
#define mp make_pair
#define pb push_back
#define sqr(x) ((x) * (x))
#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<pii> vii;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)1e9 + 10;
const int MOD = (int)1e9 + 7;

signed main() {
#ifdef LOCALFILE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n, m;
	cin >> n >> m;
	int ans = 0;
	for (int mask = 0; mask < ((ll)1 << (n * m)); ++mask) {
		vi a(n), b(m);
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				int x = 0;
				if (mask & ((ll)1 << (i * m + j)))
					x = 1;
				a[i] += x;
				b[j] += x;
			}
		}
		bool flag = 1;
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				int x = 0;
				if (mask & ((ll)1 << (i * m + j)))
					x = 1;
				if ((x && a[i] < 2 && b[j] < 2) || (!x && a[i] > m - 2 && b[j] > n - 2)) {
					flag = 0;
					break;
				}
			}
			if (!flag)
				break;
		}
		if (flag)
			++ans;
	}
	cout << ans;

	return 0;
}