#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

//#define int long long
#define INF 1000000000
map<int, int> dp[2];

void init() {
    dp[0][0] = 0;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, k;
    cin >> n >> k;
    vector<int> nxt(n);
    vector<int> L(n);
    for (int i = 0; i < n; ++i) {
        cin >> nxt[i];
        cin >> L[i];
    }
    init();
    int cur = 0;
    for (int i = 0; i < n; ++i) {
        map<int, int> dpn[2];
        for (int l = 0; l < 2; l++) {
            for (pair<int, int> p:dp[l]) {
                int x = p.first;
                int v = p.second;
                //printf("l=%d, x=%d:%d\n",l,x,v);
                if (l == 1) {
                    dpn[0][x] = max(dp[0][x], v);
                } else {
                    dpn[1][x] = max(dpn[1][x], v + L[i]);
                    dpn[0][x + 1] = max(dpn[0][x + 1], v);
                    if (x >= k) {
                        dpn[0][x - k] = max(dp[0][x - k], v + L[i]);
                    }
                }
            }
        }
        dp[0].swap(dpn[0]);
        dp[1].swap(dpn[1]);
        //cout<<"------\n";

        cur = nxt[cur];
    }
    int ans = 0;

    int l = 0;
    for (pair<int, int> p:dp[l]) {
        int x = p.first;
        int v = p.second;
        //printf("l=%d, x=%d:%d\n",l,x,v);
        ans = max(ans, v);

    }
    cout << ans;

    return 0;
}/*
4 1
1 99
2 100
3 99
4 0
*/