#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

//#define int long long
#define INF 1000000000
#define MAX_DST 1000

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, k;
    cin >> n >> k;
    vector<int> L(n);
    vector<int> nxt(n);
    for (int i = 0; i < n; ++i) {
        cin >> nxt[i];
        cin >> L[i];
    }
    int dp[n + 1][2][2 * MAX_DST];
    for (int j = 0; j <= n; ++j) {
        for (int i = 0; i < 2; ++i) {
            for (int l = 0; l < 2 * MAX_DST; ++l) {
                dp[j][i][l] = -INF;
            }
        }
    }
    dp[0][0][MAX_DST + 0] = 0;
    int cur = 0;
    for (int i = 1; i <= n; ++i) {
        for (int j = -n; j <= n; ++j) {
            dp[i][1][j + MAX_DST] = dp[i - 1][0][j + MAX_DST] + L[cur];
            dp[i][0][j + MAX_DST] = max(dp[i][0][j + MAX_DST], dp[i - 1][0][j - 1 + MAX_DST]);
            dp[i][0][j + MAX_DST] = max(dp[i][0][j + MAX_DST], dp[i - 1][0][j + k + MAX_DST] + L[cur]);
            dp[i][0][j + MAX_DST] = max(dp[i][0][j + MAX_DST], dp[i - 1][1][j + MAX_DST]);
        }
        cur = nxt[cur];
    }
    int ans = -INF;
    for (int i = 0; i < n; ++i) {
        ans = max(ans, dp[n][0][i + MAX_DST]);
    }
    cout << ans;
    return 0;
}/*
4 1
1 99
2 100
3 99
0 0

 6 1
 1 100
 2 100
 3 0
 4 0
 5 0
 0 0

 8 2
 5 12
 6 111
 4 101
 0 13
 1 105
 7 14
 2 108
 3 9
*/