#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

//#define int long long
#define INF 1000000000
#define MAX_DST 1000

vector<int> L;
vector<int> nxt;


int n, k;
vector<int> cur;

int res = -INF;

void check() {
    int s = 0;
    int need = 0;
    int sum = 0;
    for (int i = 0; i < n; ++i) {
        s += 1 - cur[i];
        sum += cur[i] * L[i];
        if (cur[i]) {
            if (cur[nxt[i]]) {
                need += k;
            } else {
                s -= 1;
            }
        }
    }
    if (need <= s) {
        res = max(res, sum);
    }
}

void gen(int k) {
    if (k == n) {
        check();
    } else {
        for (int i = 0; i < 2; ++i) {
            cur[k] = i;
            gen(k + 1);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> k;
    L.resize(n);
    nxt.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> nxt[i];
        cin >> L[i];
    }
    if (n <= 1) {
        cur.resize(n);
        gen(0);
        cout << res;
        return 0;

    }

    int dp[n + 1][2][2 * MAX_DST][2];
    for (int j = 0; j <= n; ++j) {
        for (int i = 0; i < 2; ++i) {
            for (int l = 0; l < 2 * MAX_DST; ++l) {
                for (int m = 0; m < 2; ++m) {
                    dp[j][i][l][m] = -INF;
                }
            }
        }
    }
    dp[1][0][MAX_DST + 0][1] = 0;
    dp[1][1][MAX_DST + 0][0] = L[0];
    dp[1][0][MAX_DST + 1][0] = 0;
    dp[1][0][MAX_DST - k][0] = L[0];
    int cur = nxt[0];
    for (int i = 2; i <= n; ++i) {
        for (int j = -n; j <= n; ++j) {
            for (int l = 0; l < 2; ++l) {
                if (i == 1) {
                    dp[i][1][j + MAX_DST][1] = dp[i - 1][0][j + MAX_DST][0] + L[cur];
                    dp[i][0][j + MAX_DST][0] = max(dp[i][0][j + MAX_DST][0], dp[i - 1][0][j - 1 + MAX_DST][0]);
                    dp[i][0][j + MAX_DST][1] = max(dp[i][0][j + MAX_DST][1], dp[i - 1][0][j + k + MAX_DST][0] + L[cur]);
                    dp[i][0][j + MAX_DST][0] = max(dp[i][0][j + MAX_DST][0], dp[i - 1][1][j + MAX_DST][0]);
                } else {
                    dp[i][1][j + MAX_DST][l] = dp[i - 1][0][j + MAX_DST][l] + L[cur];
                    dp[i][0][j + MAX_DST][l] = max(dp[i][0][j + MAX_DST][l], dp[i - 1][0][j - 1 + MAX_DST][l]);
                    dp[i][0][j + MAX_DST][l] = max(dp[i][0][j + MAX_DST][l], dp[i - 1][0][j + k + MAX_DST][l] + L[cur]);
                    dp[i][0][j + MAX_DST][l] = max(dp[i][0][j + MAX_DST][l], dp[i - 1][1][j + MAX_DST][l]);
                }
            }
        }
        cur = nxt[cur];
    }
    int ans = -INF;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < 2; ++j) {
            for (int l = 0; l < 2; ++l) {
                if (j !=l) {
                    continue;
                }
                ans = max(ans, dp[n][j][i + MAX_DST][l]);
            }
        }
    }
    cout << ans;
    return 0;
}/*
4 1
1 99
2 0
3 99
0 100

 6 2
 1 100
 2 0
 3 100
 4 0
 5 0
 0 100

 8 2
 5 12
 6 111
 4 101
 0 13
 1 105
 7 14
 2 108
 3 9
*/