#include <bits/stdc++.h>
using namespace std;

#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
#define x first
#define y second

typedef long long ll;
typedef long double ld;

const int N = 51, MASK = 1 << 14, MOD = 1e9 + 7;

int dp[N][MASK];
int dp2[N][16][16];

int recount2x(int j, int h) {
	if (__builtin_popcount(h) == 1) {
		int nmask = 0;
		for (int k = 0; k < 2; ++k) {
			if (h >> k & 1) {
				if (j >> (2 * k) & 3) {
					nmask |= 3 << (2 * k);
				} else {
					nmask |= 1 << (2 * k);
				}
			} else {
				nmask |= j & (3 << (2 * k));
			}
		}
		return nmask;
	} else {
		int nmask = 0;
		for (int k = 0; k < 2; ++k) {
			if (h >> k & 1) {
				if (j >> (2 * k) & 3) {
					nmask |= 3 << (2 * k);
				} else {
					nmask |= 2 << (2 * k);
				}
			} else {
				nmask |= j & (3 << (2 * k));
			}
		}
		return nmask;
	}
}

pair<int, int> recount2(pair<int, int> p, int c) {
	return {recount2x(p.x, c), recount2x(p.x, (~c) & 3)};
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	if (n > m)
		swap(n, m);
	if (n == 1) {
		if (m == 1)
			cout << "0";
		else if (m == 2)
			cout << "2";
		else
			cout << (1 << m) - 2 * m;
		return 0;
	}
	if (n == 2) {
		dp2[0][0][0] = 1;
		for (int i = 0; i < m; ++i) {
			for (int j = 0; j < 16; ++j) {
				for (int h = 0; h < 16; ++h) {
					for (int k = 0; k < 4; ++k) {
						pair<int, int> ns = recount2({j, h}, k);
						(dp2[i + 1][ns.x][ns.y] += dp2[i][j][h]) %= MOD;
					}
				}
			}
		}
		ll result = 0;
		for (int i = 0; i < 16; ++i) {
			for (int h = 0; h < 16; ++h) {
				for (int j = 0; j < n; ++j) 
					if ((i >> (2 * j) & 3) == 1 || (h >> (2 * j) & 3) == 1)
						goto bad2;
				result += dp2[m][i][h];
				bad2:;
			}
		}
		cout << result;
		return 0;
	}
	assert(n <= 7);
	dp[0][0] = 1;
	int max_mask = 1 << (2 * n);
	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < max_mask; ++j) {
			for (int h = 0; h < (1 << n); ++h) {
				if (__builtin_popcount(h) == 1) {
					int nmask = 0;
					for (int k = 0; k < n; ++k) {
						if (h >> k & 1) {
							if (j >> (2 * k) & 3) {
								nmask |= 3 << (2 * k);
							} else {
								nmask |= 1 << (2 * k);
							}
						} else {
							nmask |= j & (3 << (2 * k));
						}
					}
					(dp[i + 1][nmask] += dp[i][j]) %= MOD;
				} else {
					int nmask = 0;
					for (int k = 0; k < n; ++k) {
						if (h >> k & 1) {
							if (j >> (2 * k) & 3) {
								nmask |= 3 << (2 * k);
							} else {
								nmask |= 2 << (2 * k);
							}
						} else {
							nmask |= j & (3 << (2 * k));
						}
					}
					(dp[i + 1][nmask] += dp[i][j]) %= MOD;
				}
			}
		}
	}
	// for (int i = 0; i <= m; ++i) {
	// 	for (int j = 0; j < max_mask; ++j)
	// 		cout << dp[i][j] << " ";
	// 	cout << "\n";
	// }
	ll result = 0;
	for (int i = 0; i < max_mask; ++i) {
		for (int j = 0; j < n; ++j) 
			if ((i >> (2 * j) & 3) == 1)
				goto bad;
		result += dp[m][i];
		bad:;
	}
	result %= MOD;
	ll cnt2 = 1;
	for (int i = 0; i < n * m; ++i)
		(cnt2 *= 2) %= MOD;
	// cout << result << endl;
	cout << ((2 * result - cnt2) % MOD + MOD) % MOD;
	return 0;
}