#include <bits/stdc++.h>
#include "sqsort.h"
using namespace std;
#define app push_back
#define ii pair <int, int> 
#define f first
#define s second

const int N = 2007;
bool used[N][N];
int ord[N];

vector <ii> solve(int n) {
    vector <ii> ans;
    for (int i = 0; i < n; ++i)
        ord[i] = i;

    auto comp1 = [&] (int i, int j) {
        return cmp(i, i, j, j);
    };  
    sort(ord, ord + n, comp1);
    vector <int> num(n);
    for (int i = 0; i < n; ++i)
        num[ord[i]] = i;

    struct Pair {
        int i, j;
        bool operator < (Pair p) const {
            if (i <= p.i && j <= p.j && (i != p.i || j != p.j))
                return 0;
            if (i >= p.i && j >= p.j && (i != p.i || j != p.j))
                return 1;
            return cmp(ord[p.i], ord[p.j], ord[i], ord[j]);            
        }   
    };

    priority_queue <Pair> q;
    auto add = [&] (int i, int j) {
        if (i <= j && i < n && j < n && !used[i][j]) {
            used[i][j] = 1;
            q.push({i, j});
        }   
    };  

    add(0, 0);
    while (q.size()) {
        auto c = q.top(); q.pop();
        int i = c.i, j = c.j;
        ans.app({ord[i], ord[j]});
        add(i + 1, j);
        add(i, j + 1);
    }                           

    return ans;
}   