#include <bits/stdc++.h>
#include "sqsort.h"
using namespace std;
#define app push_back
#define ii pair <int, int> 
#define f first
#define s second

const int N = 2007;
int ord[N];

struct Pair {
    int i, j;
    bool operator < (Pair p) const {
        if (i <= p.i && j <= p.j && (i != p.i || j != p.j))
            return 1;
        if (i >= p.i && j >= p.j && (i != p.i || j != p.j))
            return 0;
        return cmp(ord[i], ord[j], ord[p.i], ord[p.j]);            
    }   
};

/*
int r[N * N];
Pair who[N * N];
int pos[N][N];
int ptr = 0;
*/

vector <ii> solve(int n) {
    for (int i = 0; i < n; ++i)
        ord[i] = i;

    auto comp1 = [&] (int i, int j) {
        return cmp(i, i, j, j);
    };  
    sort(ord, ord + n, comp1);

    vector <Pair> add;
    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            add.app({i, j});
        }   
    }   

    auto comp_add = [&] (Pair a, Pair b) {
        return a.i - a.j < b.i - b.j;
    };  

    sort(add.begin(), add.end(), comp_add);

    vector <Pair> ans;
    for (auto p : add) {
        int i = p.i, j = p.j;
        int s = -1;
        for (int p = 0; p < ans.size(); ++p) {
            if (make_pair(ans[p].i, ans[p].j) == make_pair(i - 1, j)) {
                s = p;
                break;
            }   
        }   
        ans.insert(ans.begin() + s + 1, p);
        int u = s + 1;
        while (u + 1 < ans.size() && ans[u + 1] < ans[u]) {
            swap(ans[u], ans[u + 1]);
            u++;
        }   
    }   
    vector <ii> t;
    for (auto e : ans)
        t.app({ord[e.i], ord[e.j]});
    return t;
}   