#include <bits/stdc++.h>
#define x first
#define y second
#define all(x) x.begin(), x.end()
using namespace std;
using ll = long long;
#define int ll

const int N = 2000;
const int INF = 1e18;

void umax(int &x, int y) {
	x = max(x, y);
}

int n, k;
int go[N];
int mul[N];
int dp[N][2 * N][2];
int a[N];
int old_bal[2 * N];
int new_bal[2 * N];

void solve(vector<int> p, bool take_last) {
	fill_n(dp[0][0], 4 * N * N, -INF);
	for (int i = 0; i < 2 * N; ++i) {
		if (take_last) {
			dp[0][i][0] = old_bal[i];
		} else {
			dp[0][i][1] = old_bal[i];
		}
	}
	int len = (int)p.size();
	for (int i = 0; i < len; ++i) {
		a[i] = mul[p[i]];
	}
	for (int i = 0; i < len; ++i) {
		for (int f = N - len; f <= N + len; ++f) {
			int v = dp[i][f][1];
			if (v >= 0) {
				if (f >= 1) {
					umax(dp[i + 1][f - 1][0], v + a[i]);
				}
				umax(dp[i + 1][f + 1][1], v);
			}
			v = dp[i][f][0];
			if (v >= 0) {
				if (f >= k) {
					umax(dp[i + 1][f - k][0], v + a[i]);
				}
				umax(dp[i + 1][f + 1][1], v);
			}
		}
	}
	// for (int i = 0; i < len; ++i) {
	// 	cout << a[i] << " ";
	// }
	// cout << endl;
	// for (int i = -len; i <= len; ++i) {
	// 	cout << i << "\t" << dp[len][N + i][!take_last] << endl;
	// }
	for (int i = 0; i < 2 * N; ++i) {
		new_bal[i] = max(new_bal[i], dp[len][i][!take_last]);
	}
}

bool used[N];

signed main() {
	ios::sync_with_stdio(0); cin.tie(0);
	fill_n(dp[0][0], 4 * N * N, -INF);
	cin >> n >> k;
	set<int> gos;
	for (int i = 0; i < n; ++i) {
		cin >> go[i] >> mul[i];
		assert(0 <= go[i] && go[i] < n);
		gos.insert(go[i]);
	}
	assert((int)gos.size() == n);
	fill_n(old_bal, 2 * N, -INF);
	old_bal[N] = 0;

	for (int i = 0; i < n; ++i) {
		if (used[i]) {
			continue;
		}
		vector<int> p;
		int v = i;
		while (!used[v]) {
			p.push_back(v);
			used[v] = true;
			v = go[v];
		}
		assert(v == i);
		reverse(all(p));

		fill_n(new_bal, 2 * N, -INF);
		solve(p, false);
		solve(p, true);
		copy_n(new_bal, 2 * N, old_bal);
	}

	int answer = -1;
	for (int i = N; i <= N + n; ++i) {
		answer = max(answer, old_bal[i]);
	}
	assert(answer >= 0);
	cout << answer << "\n";
	return 0;
}