#include <bits/stdc++.h>
#define x first
#define y second
#define all(x) x.begin(), x.end()
using namespace std;
using ll = long long;
#define int ll

const int N = 55;
const int T = 2187;
const int M = 1e9 + 7;

int n, m;
int dp[N][N][N][N];
int cnk[N][N];

int fp(int a, int p) {
	int x = 1;
	for (; p > 0; p >>= 1) {
		if (p & 1) {
			(x *= a) %= M;
		}
		(a *= a) %= M;
	}
	return x;
}

signed main() {
	ios::sync_with_stdio(0); cin.tie(0);
	for (int i = 0; i < N; ++i) {
		cnk[i][0] = 1;
		cnk[i][i] = 1;
	}
	for (int i = 1; i < N; ++i) {
		for (int j = 1; j < i; ++j) {
			cnk[i][j] = (cnk[i - 1][j] + cnk[i - 1][j - 1]) % M;
		}
	}
	cin >> n >> m;
	if (n > m) {
		swap(n, m);
	}
	assert(n <= m && m <= N);
	assert(min(n, m) >= 3);
	--n, --m;
	dp[0][n][0][0] = 1;
	for (int i = 0; i < m; ++i) {
		for (int a = 0; a <= n; ++a) {
			for (int b = 0; a + b <= n; ++b) {
				for (int c = 0; a + b + c <= n; ++c) {
					int v = dp[i][a][b][c];
					if (!v) {
						continue;
					} 
					if (a > 0) {
						(dp[i + 1][a - 1][b + 1][c] += v * a) %= M;
					}
					if (b > 0) {
						(dp[i + 1][a][b - 1][c + 1] += v * b) %= M;
					}
					if (c > 0) {
						(dp[i + 1][a][b][c] += v * c) %= M;
					}
					for (int ka = 0; ka <= a; ++ka) {
						for (int kb = 0; kb <= b; ++kb) {
							for (int kc = 0; kc <= c; ++kc) {
								if (ka + kb + kc == 1) {
									continue;
								}
								int add = cnk[a][ka];
								(add *= cnk[b][kb]) %= M;
								(add *= cnk[c][kc]) %= M;
								(add *= v) %= M;
								(dp[i + 1][a - ka][b - kb][c + ka + kb] += add) %= M;
							}
						}
					}
				}
			}
		}
	}
	static int bad[N];
	fill_n(bad, N, 0);
	for (int a = 0; a <= n; ++a) {
		for (int b = 0; a + b <= n; ++b) {
			for (int c = 0; a + b + c <= n; ++c) {
				(bad[b + 1] += dp[m][a][b][c]) %= M;
			}
		}
	}
	int s = 0;
	for (int i = 1; i < N; ++i) {
		int up = bad[i] * ((n + 1) * (m + 1));
		up %= M;
		int dn = fp(i, M - 2);
		// assert(up % i == 0);
		(s += up * dn) %= M;
		// cout << bad[i] << " ";
	}
	// cout << endl;
	// cout << s << endl;
	int full = 1;
	for (int i = 0; i < (n + 1) * (m + 1); ++i) {
		(full *= 2) %= M;
	}
	int ans = (full - 2 * s) % M;
	ans += M;
	ans %= M;
	cout << ans << endl;
	return 0;
}