#include <bits/stdc++.h>
#define pb push_back
#define lb lower_bound
#define ub upper_bound
#pragma GCC optimize("O3")
#pragma GCC optimize("O2")
//#define int ll
//#define endl '\n'
#include "sqsort.h"

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

vector<pair<int, int>> solve(int n)
{
    vector<int> v(n);
    for(int i = 0; i < n; i++) v[i] = i;
    for(int i = 0; i < n; i++)
    {
        bool swaps = 0;
        for(int j = 0; j < n - 1; j++)
        {
            if (cmp(v[j + 1], v[j + 1], v[j], v[j]))
            {
                swap(v[j], v[j + 1]);
                swaps = 1;
            }
        }
        if (!swaps) break;
    }

    vector<pii> line1, line2, line3;
    line3 = {{n - 1, n - 1}};
    int order = 2;
    while(order != n + 1)
    {
        line1.clear();
        line1 = line3;
        line3.clear();
        line2.clear();
        for(int i = n - order; i < n; i++)
        {
            line2.pb({n - order, i});
        }
        int point1, point2 = point1 = 0;
        while(point1 < line1.size() && point2 < line2.size())
        {
            if (max(line2[point2].first, line2[point2].second) <= min(line1[point1].first, line1[point1].second))
            {
                line3.pb(line2[point2]);
                point2++;
                continue;
            }
            if (cmp(v[line1[point1].first], v[line1[point1].second], v[line2[point2].first], v[line2[point2].second]))
            {
                line3.pb(line1[point1]);
                point1++;
            }
            else
            {
                line3.pb(line2[point2]);
                point2++;
            }
        }
        while(point1 < line1.size())
        {
            line3.pb(line1[point1]);
            point1++;
        }
        while(point2 < line2.size());
        {
            line3.pb(line2[point2]);
            point2++;
        }
        order++;
    }

    vector<pii> ans;
    for(int i = 0; i < n * (n + 1) / 2; i++)
    {
        ans.pb({v[line3[i].first], v[line3[i].second]);
    }

    return ans;
}

/*
main()
{
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    solve(5);
    //vector<pii> sol = solve(3);
    //for(auto i : sol)
    //{
    //    cout << i.first << " " << i.second << endl;
    //}
}
*/
