#include<bits/stdc++.h>
#include "sqsort.h"
using namespace std;

bool cmpSort( int a, int b ){
    return cmp( a, a, b, b );
}

vector < pair<int,int> > rv;

int findIdx( int x ){

    int idx = -1;
    for( auto i : rv ){ idx++;
        if( i == pair <int, int> ( x, x ) ) return idx;
    }
    return -1;

}

vector < pair<int, int> > solve( int N ){

    int IDX[N];
    int A[N]; for(int i=0;i<N;i++) A[i] = i;

    sort( A, A+N, cmpSort );

    for(int i=0;i<N;i++) cout << A[i] << ' '; cout << endl;

    for(int i=0;i<N-1;i++){
        IDX[i] = rv.size();
        rv.push_back( { A[i], A[i] } );
        rv.push_back( { A[i], A[i+1] } );
    }
    IDX[N-1] = rv.size();
    rv.push_back( { A[N-1], A[N-1] } );

    // for(int i=0;i<N;i++) cout << i << "  " << IDX[i] << endl;

    for(int i=0;i<N;i++) {
        for(int j=i+2;j<N;j++){

            int L = findIdx( A[i] );
            int R = findIdx( A[j] );
            int mid;
            int target = -1;

            //cout << i << " " << L << endl;
            //cout << j << " " << R << endl;
            //cout << endl;

            while( L <= R ){

                mid = (L+R) / 2;

                if( cmp( A[i], A[j], rv[mid].first, rv[mid].second ) ){
                    target = mid;
                    R = mid-1;
                }else L = mid+1;

            }

            rv.insert( rv.begin()+target,  pair <int, int> ( A[i], A[j] ) );

        }
    }

    vector < pair<int,int> > _rv;
    for( auto it : rv ){
        _rv.push_back( it );
    }

    return _rv;

}
