#include<bits/stdc++.h>
#include "sqsort.h"
using namespace std;

bool cmpSort( int a, int b ){
    return cmp( a, a, b, b );
}

vector < pair<int,int> > rv;

int findIdx( int x, int y ){

    for(int i=0;i<rv.size();i++) if( rv[i] == pair<int,int>(x,y) ) return i;
    return 0;

}

vector <int> findOrdering( int N ){

    vector <int> rv;
    rv.push_back(0);

    for(int i=1;i<N;i++){

        int L = 0, R = i-1, mid;
        int pos = 0;
        //cout << i << endl;
        //for(int k : rv) cout << k << ' '; cout << endl;
        while( L <= R ){

            mid = (L+R) / 2;

            //cout << "cmp( " << rv[mid] << " , " << i << ") ";

            if( cmp( i, i, rv[mid], rv[mid] ) ){
                //cout << "true" << endl;
                pos = mid+1;
                L = mid+1;
            }else {R = mid-1; }

        }

        rv.insert( rv.begin()+pos, i );

    }

    reverse( rv.begin(), rv.end() );
    //for( int i : rv ) cout << i << ' '; cout << endl;
    return rv;

}

vector < pair<int, int> > solve( int N ){

    int IDX[N];
    int A[N]; for(int i=0;i<N;i++) A[i] = i;

    vector <int> _A = findOrdering(N);
    for(int i=0;i<N;i++) A[i] = _A[i];

    // for(int i=0;i<N;i++) cout << A[i] << ' '; cout << endl;

    for(int i=0;i<N-1;i++){
        IDX[i] = rv.size();
        rv.push_back( { A[i], A[i] } );
        rv.push_back( { A[i], A[i+1] } );
    }
    IDX[N-1] = rv.size();
    rv.push_back( { A[N-1], A[N-1] } );

    for(int i=0;i<N;i++) {

        if( i+2 >= N ) break;

        int lastL;
        if( i == 0 ) lastL = 0;
        else         lastL = max( findIdx( A[i], A[i] ), findIdx( A[i-1], A[i+2] ) );
        for(int j=i+2;j<N;j++){

            int L = lastL;
            int R = findIdx( A[j], A[j] );
            int mid;
            int target = L;

            while( L <= R ){

                mid = (L+R) / 2;

                if( cmp( A[i], A[j], rv[mid].first, rv[mid].second ) ){
                    target = mid;
                    R = mid-1;
                }else L = mid+1;

            }

            rv.insert( rv.begin()+target, pair <int, int> ( A[i], A[j] ) );
            lastL = target;

        }
    }

    return rv;

}