#include<bits/stdc++.h>

using namespace std;

#define int long long
#define fi first
#define se second
#define pii pair<int, int>
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define eb emplace_back
#define ld long double

const int mod = 1e9 + 7;

int binpow(int x, int n) {
    if (n == 0) return 1;
    if (n % 2 == 0) return binpow((x * x) % mod, n / 2);
    return (x * binpow((x * x) % mod, n / 2)) % mod;
}

vector<int> fact(100, 1);

int C(int n, int k) {
    if (k > n) return 0;
    int res = (fact[n] * binpow(fact[k], mod - 2)) % mod;
    return (res * binpow(fact[n - k], mod - 2)) % mod;
}

int dp[100][100];
int dp2[100][100];

int solve2(int n, int m) {
    if (n > m) swap(n, m);
    if (dp2[n][m] != -1) return dp2[n][m];
    int ans = binpow(2, n * m);
    int res = 0;
    for (int c = 1; c <= n; c++) {
        int z = C(n, c);
        for (int i = 1; i <= c; i++) z = (z * (m - i + 1)) % mod;
        z = (z * solve2(n - c, m - c));
        res = (res + z) % mod;
    }
    dp2[n][m] = (ans - res + mod * 2) % mod;
    return dp2[n][m];
}

int solve(int n, int m) {
    if (n > m) swap(n, m);
    if (dp[n][m] != -1) return dp[n][m];
    int ans = binpow(2, n * m);
    int res = 0;
    for (int c = 1; c <= n; c++) {
        int z = C(n, c);
        for (int i = 1; i <= c; i++) z = (z * (m - i + 1)) % mod;
        z = (z * solve2(n - c, m - c));
        res = (res + z) % mod;
    }
    dp[n][m] = (ans - 2 * res + mod * 2) % mod;
    return dp[n][m];
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    if (n > m) swap(n, m);
    if (n == 1) {
        int ans = binpow(2, m);
        cout << (ans - m - m + mod) % mod;
        return 0;
    }
    if (n == 2) {
        if (m == 2) {
            cout << 6;
            return 0;
        }
        for (int i = 1; i < 100; i++) {
            fact[i] = (fact[i - 1] * i) % mod;
        }
        for (int i = 0; i < 100; i++) for (int j = 0; j < 100; j++) {
            dp[i][j] = dp2[i][j] = -1;
        }
        int res = solve(n, m);
        cout << (res - m + mod) % mod;
        return 0;
    }
    for (int i = 1; i < 100; i++) {
        fact[i] = (fact[i - 1] * i) % mod;
    }
    for (int i = 0; i < 100; i++) for (int j = 0; j < 100; j++) {
        dp[i][j] = dp2[i][j] = -1;
    }
    cout << solve(n, m);
}
