#include <bits/stdc++.h>

using namespace std;
const int N = 1e5 + 1;
inline bool bit(int x, int n) {
    return (x&(1<<n));
}
vector <int> gr[N];
int cost[N];
int in[N];
inline bool cmp(int x, int y) {
    return in[x] < in[y];
}

bool used[N];
int all = 0;
int cur = 0;
void dfs(int v, int col = 0) {
    all += cost[v];
    if (!col) cur += cost[v];
    used[v] = 1;
    for (auto it : gr[v]) {
        if (!used[it]) {
            dfs(it, col ^ 1);
        }
    }
}

signed main () {
    int n, k;
    cin >> n >> k;
    vector <pair <int, int> > v;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        v.push_back({x, y});
    }
    int ans = 0;
    if (n <= 10) {
        int fmask = (1<<n);
        for (int i = 0; i < fmask; i++) {
            int curans = 0;
            int need = 0;
            for (int j = 0; j < n; j++) {
                if (bit(i, j)) {
                    need++;
                    if (bit(i, v[j].first)) {
                        need += k;
                    }
                    else {
                        need++;
                    }
                    curans += v[j].second;
                }
            }
            if (need <= n) {
                ans = max(ans, curans);
            }
        }
    }
    else {
        for (int i = 0; i < n; i++) {
            gr[i].push_back(v[i].first);
            in[v[i].first]++;
            cost[i] = v[i].second;
        }
        vector <int> ord(n);
        iota(ord.begin(), ord.end(), 0);
        sort(ord.begin(), ord.end(), cmp);
        for (auto v : ord) {
            if (!used[v]) {
                cur = all = 0;
                dfs(v);
                ans += max(cur, all - cur);
            }
        }

    }
    cout << ans << '\n';
}
