#include <bits/stdc++.h>
using namespace std;

const int MOD = 1e9 + 7;

int n, m;
int sc, ans;
int p2[2505];

int cnt[2505];
int fact[2505];

int lgput(int x, int p) {
	int ans = 1, aux = x;
	for (int i = 1; i <= p ; i = i << 1) {
		if (i & p) ans = 1LL * ans * aux % MOD;
		aux = 1LL * aux * aux % MOD;
	}
	return ans;
}

int invmod(int x) {
	return lgput(x, MOD - 2);
}

int C(int n, int k) {
	int ans = fact[n];
	ans = 1LL * ans * invmod(fact[n - k]) % MOD;
	ans = 1LL * ans * invmod(fact[k]) % MOD;
	return ans;
}

void solve() {
	fact[0] = 1;
	for (int i = 1; i <= m ; ++i) fact[i] = 1LL * fact[i - 1] * i % MOD;

	for (int nr = 1; nr <= n ; ++nr) {
		cnt[nr] = n * m;
		for (int i = 1; i <= nr ; ++i)
			cnt[nr] = cnt[nr] - (m - i) - (n - i) - 1;
	}
	for (int i = 1, sgn = -1; i <= n ; ++i, sgn = -sgn) { 
		sc = (sc + 1LL * C(n, i) * C(m, i) % MOD * 1LL * fact[i] % MOD * 1LL * p2[cnt[i]] % MOD * sgn) % MOD; 		
		if (sc < 0) sc += MOD;	
	}
}

int main() {
	scanf("%d%d", &n, &m);
	if (n > m) swap(n, m);

	if (n == 1) {
		int ans = m * 2LL;
		printf("%d", ans);
		return 0;
	}

	p2[0] = 1;
	for (int i = 1; i <= n * m ; ++i) 
		p2[i] = p2[i - 1] * 2LL % MOD;
	
	ans = p2[n * m];
	
	solve();

	ans = (ans * 1LL + sc * 2LL) % MOD;
	if (ans < 0) ans += MOD;

	printf("%d", ans);

	return 0;
}
