#include "sqsort.h"
#include <bits/stdc++.h>
using namespace std;

const int DIM = 2e3;

bool mycmp(int a, int b) {
	return !(cmp(0, b, 0, a));
}

vector <pair <int, int>> ans;
vector <int> elem;
int fsBig[DIM + 5][DIM + 5];

void solve(int ls, int ld, vector <int> &st, vector <int> &dr) {
	if (ls > ld) return ;
	if (ls == ld) {
		for (int i = st[0]; i <= dr[0] ; ++i) ans.push_back({elem[ls], elem[i]});
//		cerr << ls << " " << st[0] << " " << dr[0] << endl;
		return ;
	}

	int lin = ls, col = dr[0], nr = 0;
	vector <int> pct; pct.push_back(col);
	while (lin < ld && col >= st[nr] && col <= dr[nr]) {
		col = fsBig[lin][col];
		pct.push_back(col);
		++lin; ++nr;
	}

	vector <int> lst, ldr, rst, rdr;

	int lls = ls, lld = ls;
	for (int i = 0; i < (int)pct.size() ; ++i) {
		if (st[i] > pct[i] - 1) break ;
		else {
			lst.push_back(st[i]);
			ldr.push_back(min(pct[i] - 1, dr[i]));
			++lld;
		}
	}

    --lld;
	if (!lst.empty()) solve(lls, lld, lst, ldr);

	ans.push_back({elem[ls], elem[dr[0]]});

    for (int i = 1; i < (int)pct.size() ; ++i) st[i] = max(pct[i], st[i]);
	int rls = ls + 1, rld = ls + 1;
    int le = ld - ls + 1;
	for (int i = 1; i < le ; ++i) {
		rst.push_back(st[i]);
		rdr.push_back(dr[i]);
		++rld;
	}

    --rld;
	if (!rst.empty())solve(rls, rld, rst, rdr);
}

vector <pair <int, int>> solve(int n) {
	///vad ordinea elementelor prima oara
	elem.clear();
	for (int i = 0; i < n ; ++i) elem.push_back(i);

//	sort(elem.begin(), elem.end(), mycmp);
//	for (auto it : elem) cout << it << " ";
//	cout << endl;

//	for (int i = 0; i < n - 1 ; ++i) {
//		fsBig[i][i] = i;
//		for (int j = i; j < n ; ++j) {
//			fsBig[i][j] = fsBig[i][j - 1];
//			while (cmp(elem[i + 1], elem[fsBig[i][j]], elem[i], elem[j])) ++fsBig[i][j];
//		}
//	}

//	for (int i = 0; i < n ; ++i) {
//        for (int j = 0; j < n ; ++j) {
//            cout << fsBig[i][j] << " ";
//        }
//        cout << endl;
//	}

	vector <int> st(n);
	vector <int> dr(n);

	for (int i = 0; i < n ; ++i) st[i] = i, dr[i] = n - 1;
//	solve(0, n - 1, st, dr);

	for (auto &it : ans) if (it.first > it.second) swap(it.first, it.second);

//	for (auto it : ans) cerr << it.first << " " << it.second << endl;
	return ans;
}
