#include <iostream>
#include <cstdio>
#include <vector>
#include <utility>
#include <algorithm>

#include "sqsort.h"
//#include "sqsort.cpp"
using namespace std;

//bool cmp(int a, int b, int c, int d);

vector<pair<int, int>> v , w;
int poz[2010];



int fct (pair <int , int> x , pair <int , int> y){
    if (poz[x.first] <= poz[y.first] && poz[x.second] <= poz[y.second])
        return 1;
    else if (poz[x.first] >= poz[y.first] && poz[x.second] >= poz[y.second])
        return 0;
    return cmp(x.first , x.second , y.first , y.second);
}

int fct2 (pair <int , int> x , pair <int , int> y){
    return cmp(x.first , x.second , y.first , y.second);
}

void sortare (int st , int dr){
   int mid = (st + dr)/2 , i , j , poz;

   //printf ("%d %d\n",st , dr);

   if (st == dr)
        return;

   sortare(st , mid);
   sortare(mid + 1 , dr);

   for (i = st ; i <= dr ; i++)
        w[i] = v[i];

   i = st;
   j = mid + 1;

   poz = st;
   while (i <= mid && j <= dr){
        if (fct (w[i] , w[j])){
            v[poz] = w[i];
            i++;
            poz++;
        }
        else {
            v[poz] = w[j];
            j++;
            poz++;
        }
   }

   while (i <= mid){
        v[poz] = w[i];
        poz++;
        i++;
   }

   while (j <= dr){
        v[poz] = w[j];
        poz++;
        j++;
   }



}

vector<pair<int, int>> solve(int n){
    int l , r , i;


    l = r = 0;
    for (i = 1 ; i <= n * (n + 1) / 2 ; i++){
        v.push_back(make_pair(l , r));
        r++;
        if (r == n){
            l++;
            r = l;
        }
    }

    for (i = 0 ; i < n ; i++)
        w.push_back(make_pair(i , i));
    sort (w.begin() , w.end() , fct2);

    for (i = 0 ; i < n ; i++){
        //printf ("%d ",w[i].first);
        poz[w[i].first] = i;
    }

    w.resize(v.size());

    sortare (0 , v.size() - 1);

    //for (i = 0 ; i < v.size() ; i++){
      //  printf ("%d %d\n",v[i].first , v[i].second);
    //}

    return v;

}