#include <bits/stdc++.h>
#include "sqsort.h"

using namespace std;

vector<pair<int, int>> v;

vector<pair<int, int>> merge(vector<pair<int, int>> x, vector<pair<int, int>> y) {
    int p1 = 0;
    int p2 = 0;
    vector<pair<int, int>> res;
    while (p1 < x.size() && p2 < y.size()) {
        if (cmp(x[p1].first, x[p1].second, y[p2].first, y[p2].second)) {
            res.push_back(x[p1++]);
        } else res.push_back(y[p2++]);
    }
    while (p1 < x.size())res.push_back(x[p1++]);
    while (p2 < y.size())res.push_back(y[p2++]);
    return res;
}

vector<pair<int, int>> msort(int l, int r) {
    if (l == r)return {v[l]};
    else {
        int m = (l + r) / 2;
        auto v1 = msort(l, m);
        auto v2 = msort(m + 1, r);
        return merge(v1, v2);
    }
}


vector<pair<int, int>> solve(int n) {
    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            v.push_back({i, j});
        }
    }
    return msort(0, (int) v.size() - 1);
}
