#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>
#include "sqsort.h"
//#define ll long long
//#define F first
//#define S second
//#define pb push_back
//#define int ll


using namespace std;
using namespace __gnu_pbds;

const int mod=1e9+7;

template <typename T> using ordered_set = tree<T,null_type,less<T>,rb_tree_tag,tree_order_statistics_node_update>;

vector<pair<int,int> > solve(int n){
    vector<pair<int,int> ans;
    ans.resize(n*(n+1)/2);
    int kol=0;
    for(int i=0;i<n-1;i++){
        for(int j=i;j<n;j++){
            if(i==0 && j==0){
                ans.pb({i,j});
                kol++;
            }
            else{
                int l=0,r=kol-1;
                ans=-1;
                while(l<=r){
                    int mid=(l+r)/2;
                    if(cmp(i,j,ans[mid].F,ans[mid].S)){
                        r=mid-1;
                    }
                    else{
                        ans=mid;
                        l=mid+1;
                    }
                }
                for(int e=kol;e>=mid+1;e--){
                    ans[e+1]=ans[e];
                }
                ans[mid+1]={i,j};
            }
        }
    }

    return ans;
}

// main(){
//    ios_base::sync_with_stdio(0);
//    cout.tie(0);cin.tie(0);
//    #ifdef LOCAL
//        freopen("input.txt","r",stdin);
//        freopen("output.txt","w",stdout);
//    #else
//        //freopen("input.txt","r",stdin);
//        //freopen("output.txt","w",stdout);
//    #endif
//
//
//    //cout<<700*700*700<<endl;
//
//    return 0;
//
//
//
//}
