#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>
#include "sqsort.h"
//#define ll long long
//#define F first
//#define S second
//#define pb push_back
//#define int ll


using namespace std;
using namespace __gnu_pbds;

const int mod=1e9+7;

template <typename T> using ordered_set = tree<T,null_type,less<T>,rb_tree_tag,tree_order_statistics_node_update>;

//vector<int> a;
//
//bool cmp(int i,int j,int a1,int b1){
//if(a[i]+a[j]<a[a1]+a[b1]){
//    return 1;
//}
//else{
//    return 0;
//}
//}

vector<pair<int,int> > solve(int n){
    vector<pair<int,int>> ans;
    ans.resize(n*(n+1)/2);
    int kol=0;
    for(int i=0;i<n;i++){
        for(int j=i;j<n;j++){
            if(i==0 && j==0){
                ans.push_back({i,j});
                kol++;
            }
            else{
                int l=0,r=kol-1;
                int ans1=-1;
                while(l<=r){
                    int mid=(l+r)/2;
                    if(cmp(i,j,ans[mid].first,ans[mid].second)){
                        r=mid-1;
                    }
                    else{
                        ans1=mid;
                        l=mid+1;
                    }
                }
                for(int e=kol;e>=ans1+1;e--){
                    ans[e+1]=ans[e];
                }
                ans[ans1+1]={i,j};
                kol++;
            }
        }
    }

    ans.pop_back();

    return ans;
}

// main(){
//    ios_base::sync_with_stdio(0);
//    cout.tie(0);cin.tie(0);
//    #ifdef LOCAL
//        freopen("input.txt","r",stdin);
//        freopen("output.txt","w",stdout);
//    #else
//        freopen("input.txt","r",stdin);
//        freopen("output.txt","w",stdout);
//    #endif
//
//    int n;
//
//    cin>>n;
//
//    a.resize(n);
//
//    for(int i=0;i<n;i++){
//        cin>>a[i];
//    }
//
//    vector<pair<int,int> > an;
//
//    an=solve(n);
//
//    for(int i=0;i<an.size();i++){
//        cout<<an[i].F<<' '<<an[i].S<<endl;
//    }
//
//
//    return 0;
//
//
//
//}
