#include <bits/stdc++.h>
using namespace std;

const int N = (int)(1e5 + 500);

int n, K;
int T[N], L[N];
vector <int> vec;

bool cmp(int x, int y) {
    return L[x] > L[y];
}

int solve(int msk) {
    vec.clear();
    for (int i = 0; i < n; ++i) {
        if (msk & (1 << i)) {
            vec.push_back(i);
        }
    }
    sort(vec.begin(), vec.end(), cmp);

    int ost = n - __builtin_popcount(msk);

    int cur = 0;
    for (int i = 0; i < (int)(vec.size()); ++i) {
        int x = vec[i];

        if (!(msk & (1 << T[x]))) {
            if (ost < 1) {
                cur = -1e9;
                break;
            }
            --ost;
            cur += L[x];
            continue;
        }

        if (ost < K) {
            cur = -1e9;
            break;
        }

        ost -= K;
        cur += L[x];
    }

    return cur;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> n >> K;
    for (int i = 0; i < n; ++i) {
        cin >> T[i] >> L[i];
    }

    int ans = 0, ps = -1;
    for (int msk = 0; msk < (1 << n); ++msk) {
        int vl = solve(msk);
        if (vl > ans) {
            ps = msk;
            ans = vl;
        }
    }

//    solve(102);

    cerr << "ps = " << ps << "\n";
    cout << ans << "\n";
}
