#include <bits/stdc++.h>
using namespace std;

const int N = (int)(1e3 + 500);

int n, K;
int T[N], L[N];
int dp[N][N][3];
vector <int> vec, ord;

bool cmp(int x, int y) {
    return L[x] > L[y];
}

int solve(int msk) {
    vec.clear();
    for (int i = 0; i < n; ++i) {
        if (msk & (1 << i)) {
            vec.push_back(i);
        }
    }
    sort(vec.begin(), vec.end(), cmp);

    int ost = n - __builtin_popcount(msk);

    int cur = 0;
    for (int i = 0; i < (int)(vec.size()); ++i) {
        int x = vec[i];

        if (!(msk & (1 << T[x]))) {
            if (ost < 1) {
                cur = -1e9;
                break;
            }
            --ost;
            cur += L[x];
            continue;
        }

        if (ost < K) {
            cur = -1e9;
            break;
        }

        ost -= K;
        cur += L[x];
    }

    return cur;
}

void dfs(int v) {
    ord.push_back(v);
    if (v == n - 1) {
        return;
    }

    dfs(T[v]);
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> n >> K;
    for (int i = 0; i < n; ++i) {
        cin >> T[i] >> L[i];
    }

    if (n <= 20) {
        int ans = 0, ps = -1;
        for (int msk = 0; msk < (1 << n); ++msk) {
            int vl = solve(msk);
            if (vl > ans) {
                ps = msk;
                ans = vl;
            }
        }
        cerr << "ps = " << ps << "\n";
        cout << ans << "\n";
    } else {
        dfs(T[n - 1]);

        for (int i = 0; i <= n; ++i) {
            for (int j = 0; j <= n; ++j) {
                for (int k = 0; k < 3; ++k) {
                    dp[i][j][k] = -1;
                }
            }
        }

        dp[0][n][0] = 0;
        for (int i = 1; i <= n; ++i) {
            for (int j = 0; j <= n; ++j) {
                for (int k = 0; k < 3; ++k) {
                    if (dp[i - 1][j][k] != -1) {
                        dp[i][j][0] = max(dp[i][j][0], dp[i - 1][j][k]);
                    }
                }
                if (j - K - 1 >= 0) {
                    if (dp[i - 1][j][0] != -1) {
                        dp[i][j - K - 1][1] = max(dp[i][j - K - 1][1], dp[i - 1][j][0] + L[ord[i - 1]]);
                    }
                    if (dp[i - 1][j][1] != -1) {
                        dp[i][j - K - 1][1] = max(dp[i][j - K - 1][1], dp[i - 1][j][1] + L[ord[i - 1]]);
                    }
                    if (dp[i - 1][j][2] != -1) {
                        dp[i][j - K - 1][1] = max(dp[i][j - K - 1][1], dp[i - 1][j][2] + L[ord[i - 1]]);
                    }
                }
                if (j - 2 >= 0) {
                    if (dp[i - 1][j][0] != -1) {
                        dp[i][j - 2][2] = max(dp[i][j - 2][2], dp[i - 1][j][0] + L[ord[i - 1]]);
                    }
                    if (dp[i - 1][j][1] != -1) {
                        dp[i][j - 2][2] = max(dp[i][j - 2][2], dp[i - 1][j][1] + L[ord[i - 1]]);
                    }
                }
            }
        }

        int ans = 0;
        for (int j = 0; j <= n; ++j) {
            for (int k = 0; k < 3; ++k) {
                ans = max(ans, dp[n][j][k]);
            }
        }

        cout << ans << "\n";
    }
}
