#include <bits/stdc++.h>
#include "sqsort.h"

using namespace std;

int alcomp[2005][2005];

vector<int> indices;

bool tmpc(pair<int,int> x, pair<int,int> y)
{
    x.first = indices[x.first];
    y.first = indices[y.first];
    y.second = indices[y.second];
    x.second = indices[x.second];
    if(alcomp[x.first][y.first] == alcomp[x.second][y.second]) return alcomp[x.first][y.first];
    if(alcomp[x.first][y.second] == alcomp[x.second][y.first]) return alcomp[x.first][y.second];
    return cmp(x.first, x.second, y.first, y.second);
}

bool compare_indices(int x, int y)
{
    return !cmp(0, x, 0, y);
}

vector<pair<int, int>> eq_pool;

bool check_in_pool(vector<pair<int,int>> pool, pair<int, int> pr)
{
    for(auto _pr : pool) if(pr == _pr) return 1;
    return 0;
}

int splits = 0;

void split_in_pool(vector<pair<int,int>>& pool, int n)
{
    //cout << splits++ << "\n";
    pair<int, int> spliter = pool[0];
    eq_pool.push_back(spliter);
    //for(auto e : pool)
    //    cerr << e.first << " " << e.second << endl;
    //cerr << endl;
    pool.erase(pool.begin());
    int step = (1<<20);
    int index = -1;

    pair<int,int> re1 = spliter;

    re1.first++;

    if(re1.first <= re1.second && re1.second < n && check_in_pool(pool, re1) == false && check_in_pool(eq_pool, re1) == false) {
        for(; step > 0; step /= 2)
        {
            if(index + step >= pool.size()) continue;

            if(tmpc(pool[index + step], re1) == true)
                index += step;
        }

        //if(index >= 0) index++;
        //cout << index << endl;

        pool.push_back(re1);
        for(int i = pool.size() - 1; i >= index + 2; i--)
            pool[i] = pool[i-1];

        pool[index + 1] = re1;
    }

    re1.first--;
    re1.second++;

    if(re1.first <= re1.second && re1.second < n && check_in_pool(pool, re1) == false && check_in_pool(eq_pool, re1) == false) {
        step = (1<<20);
        index = -1;
        for(; step > 0; step /= 2)
        {
            if(index + step >= pool.size()) continue;

            if(tmpc(pool[index + step], re1) == true)
                index += step;
        }

        //if(index >= 0) index++;
        //cout << index << endl;

        pool.push_back(re1);
        for(int i = pool.size() - 1; i >= index + 2; i--)
            pool[i] = pool[i-1];

        pool[index + 1] = re1;
    }

    /*for(int i = 0; i < (int)pool.size()-1; i++)
    {
        cout << pool[i].first << " " << pool[i].second << endl;
        cout << pool[i+1].first << " " << pool[1+i].second << endl;
        cout << endl;
        //assert(!tmpc(pool[i+1], pool[i]));
        //assert(!cmp(pool[i+1].first, pool[i+1].second, pool[i].first, pool[i].second));
    }*/
}

std::vector<std::pair<int, int>> solve(int n)
{
    for(int i = 0; i < n; i++)
        indices.push_back(i);

    sort(indices.begin(), indices.end(), compare_indices);
    reverse(indices.begin(), indices.end());

    vector<int> reverse_indices(n);
    for(int i = 0; i < n; i++)
    {
        reverse_indices[indices[i]] = i;
    }

    for(int i = 0; i < n; i++)
    for(int j = i+1; j < n; j++) {
        alcomp[i][j] = (reverse_indices[i] < reverse_indices[j]);
        alcomp[j][i] = !alcomp[i][j];
    }

    vector<pair<int, int>> ret;
    /*for(int i = 0; i < n; i++)
    for(int j = i; j < n; j++)
        ret.push_back(make_pair(i, j));
    */

    vector<pair<int, int>> pair_pool;

    pair_pool.push_back(make_pair(0, 0));

    ret.clear();

    while(pair_pool.size() > 0)
    {
        //cout << pair_pool.size() << endl;
        ret.push_back(pair_pool[0]);
        split_in_pool(pair_pool, n);
    }

    //sort(ret.begin(), ret.end(), tmpc);

    for(int i = 0; i < ret.size(); i++)
    {
        auto& e = ret[i];
        e.first = indices[e.first];
        e.second = indices[e.second];

        if(e.first > e.second) swap(e.first, e.second);

        //cerr << e.first << " " << e.second << endl;
    }
    //cerr << endl;

    return ret;
}
