#include <bits/stdc++.h>

const int MAX_N = 5;
const int MOD = 1000000007;

int res = 0;
std::vector<int> seq;

void bkt(int cnt, int last, int sum, int n) {
	if(sum + cnt - 1 == n) {
		res++;
		for(auto it: seq)
			printf("%d ", it);
		printf("\n");
	} else if(sum + cnt - 1 < n) {
		for(int i = last; i <= n && (cnt + 1 - 1) + i + sum <= n; ++i) {
			seq.push_back(i);
			bkt(cnt + 1, i, sum + i, n);
			seq.pop_back();
		}
	}
}

int lgput(int b, int e) {
	int ac = 1;
	while(e > 0) {
		if(e % 2 == 1)
			ac = (long long)ac * b % MOD;
		b = (long long)b * b % MOD;
		e /= 2;
	}
	return ac;
}

int invmod(int x) {
	return lgput(x, MOD - 2);
}

int dp[1+MAX_N][1+MAX_N];
int comb[1+MAX_N][1+MAX_N], fact[1+MAX_N];

int fr1[1+MAX_N], fr2[1+MAX_N];

int brut(int n, int m) {
	int res = 0;
	for(int mask = 0; mask < (1 << (n * m)); ++mask) {
		for(int i = 0; i <= MAX_N; ++i)
			fr1[i] = fr2[i] = 0;

		for(int l = 0; l < n; ++l)
			for(int c = 0; c < m; ++c) {
				int cell = l * m + c;
				if((1 << cell) & mask) {
					++fr1[l];
					++fr2[c];
				}
			}
	
		bool ok = true;
		for(int l = 0; l < n; ++l)
			for(int c = 0; c < m; ++c) {
				int cell = l * m + c;
				if(((1 << cell) & mask) && (fr1[l] == 1 && fr2[c] == 1))
					ok = false;
				else if(((1 << cell) & mask) == 0 && (fr1[l] == m - 1 && fr2[c] == n - 1))
					ok = false;
			}

		res = res + ok;
	}
	return res;
}

int main() {
	/*
	int n, m;

	comb[0][0] = 1;
	for(int i = 1; i <= MAX_N; ++i)
		for(int j = 0; j <= i; ++j) {
			comb[i][j] = comb[i - 1][j];
			if(j > 0)
				comb[i][j] = (comb[i][j] + comb[i - 1][j - 1]) % MOD;
		}
	
	fact[0] = 1;
	for(int i = 1; i <= MAX_N; ++i)
		fact[i] = (long long)fact[i - 1] * i % MOD;

	for(int i = 0; i <= MAX_N; ++i)
		dp[i][0] = dp[0][i] = 1;

	for(int l = 1; l <= MAX_N; ++l)
		for(int c = 1; c <= MAX_N; ++c) {
			dp[l][c] = lgput(2, l * c);
			
			if(l == 1 || c == 1) {
				int cells = l * c;
				if(cells == 1)
					dp[l][c] = 0;
				else if(cells == 2 || cells == 3)
					dp[l][c] = 2;
				else
					dp[l][c] = (dp[l][c] + MOD - 2 * cells) % MOD;
			} else if(l == 2 || c == 2) {
				int cells = l * c / 2;
				if(cells == 2)
					dp[l][c] = 6;
				else
					dp[l][c] = (dp[l][c] + MOD - 6 * cells) % MOD;
			} else {
				for(int k = 1; k <= std::min(l, c); ++k) {
					int chestii = (long long)dp[l - k][c - k] * comb[l][k] % MOD * comb[c][k] % MOD * 2 * fact[k] % MOD;
					dp[l][c] = (dp[l][c] + MOD - chestii) % MOD;
				}
			}
		}


	for(int i = 1; i <= MAX_N; ++i) {
		for(int j = 1; j <= MAX_N; ++j)
			printf("%d ", dp[i][j]);
		printf("\n");
	}

	for(int i = 1; i <= MAX_N; ++i) {
		for(int j = 1; j <= MAX_N; ++j)
			printf("%d ", brut(i, j));
		printf("\n");
	}
*/
	
	int n, m;
	scanf("%d%d", &n, &m);
	assert(n <= 5 && m <= 5);
	printf("%d", brut(n, m) % MOD);
	return 0;
}
