#pragma GCC target("avx,avx2,sse3,ssse3,sse4.1,sse4.2,tune=native")
#pragma GCC optimize(3)
#pragma GCC optimize("O3")
#pragma GCC optimize("inline")
#pragma GCC optimize("-fgcse")
#pragma GCC optimize("-fgcse-lm")
#pragma GCC optimize("-fipa-sra")
#pragma GCC optimize("-ftree-pre")
#pragma GCC optimize("-ftree-vrp")
#pragma GCC optimize("-fpeephole2")
#pragma GCC optimize("-fsched-spec")
#pragma GCC optimize("-falign-jumps")
#pragma GCC optimize("-falign-loops")
#pragma GCC optimize("-falign-labels")
#pragma GCC optimize("-fdevirtualize")
#pragma GCC optimize("-fcaller-saves")
#pragma GCC optimize("-fcrossjumping")
#pragma GCC optimize("-fthread-jumps")
#pragma GCC optimize("-freorder-blocks")
#pragma GCC optimize("-fschedule-insns")
#pragma GCC optimize("inline-functions")
#pragma GCC optimize("-ftree-tail-merge")
#pragma GCC optimize("-fschedule-insns2")
#pragma GCC optimize("-fstrict-aliasing")
#pragma GCC optimize("-falign-functions")
#pragma GCC optimize("-fcse-follow-jumps")
#pragma GCC optimize("-fsched-interblock")
#pragma GCC optimize("-fpartial-inlining")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("-freorder-functions")
#pragma GCC optimize("-findirect-inlining")
#pragma GCC optimize("-fhoist-adjacent-loads")
#pragma GCC optimize("-frerun-cse-after-loop")
#pragma GCC optimize("inline-small-functions")
#pragma GCC optimize("-finline-small-functions")
#pragma GCC optimize("-ftree-switch-conversion")
#pragma GCC optimize("-foptimize-sibling-calls")
#pragma GCC optimize("-fexpensive-optimizations")
#pragma GCC optimize("inline-functions-called-once")
#pragma GCC optimize("-fdelete-null-pointer-checks")

#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}

const int N = 1e4 + 10, MOD = 1e9 + 7, base = 131, INF = 1e9;

bool bit(int a, int n) {
    return (a >> n) & 1;
}

int n, m, ans, cnth[51], cntv[51];

string f(int mask) {
    string res = "";
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            res.push_back(bit(mask, i * m + j) + '0');
        }
        res.push_back('\n');
    }
    return res;
}

void solve() {
    cin >> n >> m;
    for (int mask = 0; mask < (1 << (n * m)); mask++) {

        for (int i = 0; i < n; i++) {
            cnth[i] = 0;
        }
        for (int i = 0; i < m; i++) {
            cntv[i] = 0;
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (bit(mask, i * m + j)) {
                    cnth[i]++;
                    cntv[j]++;
                }
            }
        }
        bool ok = true;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if ((cnth[i] == 1 && cntv[j] == 1 && bit(mask, i * m + j)) || (m - cnth[i] == 1 && n - cntv[j] == 1 && !bit(mask, i * m + j))) {
                    ok = false;
                    break;
                }
            }
        }
//        cout << f(mask) << " " << ok << endl;
        if (ok) ans++;
    }
    cout << ans;
}