#include <bits/stdc++.h>
#include "sqsort.h"

using namespace std;

const int N = 2e3 + 100;

int pos[N];

bool cm(pair < int, int > a, pair < int, int > b) {
    return cmp(a.first, a.second, b.first, b.second);
}

bool cm1(pair < int, int > a, pair < int, int > b) {
    pair < int, int > pa = a, pb = b;
    if (pos[pa.first] > pos[pa.second]) swap(pa.first, pa.second);
    if (pos[pb.first] > pos[pb.second]) swap(pb.first, pb.second);
    if (pos[pa.first] <= pos[pb.first] && pos[pa.second] <= pos[pb.second]) return true;
    if (pos[pa.first] > pos[pb.first] && pos[pa.second] > pos[pb.second]) return false;
    return cmp(a.first, a.second, b.first, b.second);
}

bool cm2(pair < int, int > a, pair < int, int > b) {
    return max(pos[a.first], pos[a.second]) < min(pos[b.first], pos[b.second]);
}

vector < pair < int, int > > solve(int n) {
    vector < pair < int, int > > a, b;
    for (int i = 0; i < n; i++) {
        a.push_back({i, i});
    }
    sort(a.begin(), a.end(), cm);
    for (int i = 0; i < a.size(); i++) {
        pos[a[i].first] = i;
    }
    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) {
            b.push_back({i, j});
        }
    }
    random_shuffle(b.begin(), b.end());
    sort(b.begin(), b.end(), cm2);
    sort(b.begin(), b.end(), cm1);
    return b;
}
