#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define eb emplace_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)(x).size())

using namespace std;
using ll = long long;
using vi = vector<int>;
using pi = pair<int, int>;
using vpi = vector<pi>;

template<class T> bool ckmin(T& a, T b) { return b < a ? a = b, true : false; }
template<class T> bool ckmax(T& a, T b) { return b > a ? a = b, true : false; }

int n, k;

vpi nrm(const vpi& res) {
    vpi ans;
    for (pi x : res) {
        if (x.S + n < 0) continue;
        if (ans.empty()) ans.pb(x);
        else {
            if (ans.back().F == x.F) x.S = max(ans.back().S, x.S), ans.pop_back();
            while(!ans.empty() && ans.back().S <= x.S) ans.pop_back();
            ans.pb(x);
        }
    }
    return ans;
}

vpi mrg(const vpi& a, const vpi& b) {
    vpi res(a.size() + b.size());
    merge(all(a), all(b), res.begin());
    return nrm(res);
}

vpi mrg_sum(vpi& a, const vpi& b) {
    vpi ans;
    for (pi d : b) for(pi x : a)
        if(x.S + d.S + n >= 0) ans.eb(x.F+d.F, x.S+d.S);
    sort(ans.begin(), ans.end());
    return nrm(ans);
}

mt19937 rng(1337228);

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    cin >> n >> k;
    vi t(n), a(n), used(n);
    for (int i = 0; i < n; ++i) {
        //t[i] = (i + 1) % n;
        //a[i] = rng()%(int)1e4;
        cin >> t[i] >> a[i];
    }
    vector<pi> res { {0, 0} };
    for (int i = 0; i < n; ++i) {
        if(used[i]) continue;
        vpi A, B { {0, 0} }, C { {0, 0} }, D;
        for (int j = i; !used[j]; j = t[j]) {
            used[j] = 1;
            vpi nA, nB, nC, nD;

            // cout << j << ' ';

            nA = mrg(mrg_sum(B, {{a[j], -1}}), mrg_sum(A, {{a[j], -k}}));
            nB = mrg(mrg_sum(A, {{0, +1}}),    mrg_sum(B, {{0, +1}}));
            nC = mrg(mrg_sum(D, {{a[j], -1}}), mrg_sum(C, {{a[j], -k}}));
            nD = mrg(mrg_sum(C, {{0, +1}}),    mrg_sum(D, {{0, +1}}));

            A.swap(nA), B.swap(nB), C.swap(nC), D.swap(nD);
        }

        res = mrg_sum(res, mrg(B,C));
    }

    int L = 0;
    for (pi x : res) if(x.S >= 0) ckmax(L, x.F);
    cout << L << endl;
}
