#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define eb emplace_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)(x).size())

using namespace std;
using ll = long long;
using vi = vector<int>;
using pi = pair<int, int>;
using vpi = vector<pi>;

template<class T> bool ckmin(T& a, T b) { return b < a ? a = b, true : false; }
template<class T> bool ckmax(T& a, T b) { return b > a ? a = b, true : false; }

const int N = 51, C = 5000, MOD = 1e9+7;

int c[N][N], p[C], n, m, ans, col[N][N], fact[C], rev[C], rfct[C];

int frev(int a, int m = MOD) {
    return a == 1 ? 1 : m - (ll)m*frev(m%a,a)/a;
}

void solve(int i = 0, int j = 0) {
    if (j == m) ++i, j = 0;
    if (i == n) {
        int k = 0;
        for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j) {
            int x = col[i][j], cnt = 0;
            for (int k = 0; k < m; ++k) cnt += x == col[i][k];
            for (int k = 0; k < n; ++k) cnt += x == col[k][j];
            if (cnt == 2) ++k;
        }
        if (k == 0) ans++;
    } else {
        col[i][j] = 0;
        solve(i, j + 1);
        col[i][j] = 1;
        solve(i, j + 1);
    }
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    for (int i = 0; i < N; ++i) c[i][0] = 1;
    for (int i = 1; i < N; ++i) {
        for (int j = 1; j < N; ++j)
            c[i][j] = (c[i][j-1] + c[i][j]) % MOD;
    }
    p[0] = 1;
    for (int i = 1; i < C; ++i) p[i] = (ll)p[i-1]*2%MOD;
    fact[1] = rfct[1] = rev[1] = fact[0] = rfct[0] = 1;
    for (int i = 2; i < C; ++i) {
        fact[i] = (ll) fact[i-1] * i % MOD;
        rev[i] = frev(i);
        rfct[i] = (ll) rfct[i-1] * rev[i] % MOD;
    }

    cin >> n >> m;
    if (n > m) swap(n, m);
    if (n >= 3) {
        ans = p[n*m];
        for(int k = 1; k <= n; ++k) {
            int kek = 2 * rfct[k]; if (kek >= MOD) kek -= MOD;
            kek = (ll)kek * fact[n] % MOD;
            kek = (ll)kek * rfct[n-k] % MOD;
            kek = (ll)kek * fact[m] % MOD;
            kek = (ll)kek * rfct[m-k] % MOD;
            kek = (ll)kek * p[(n-k)*(m-k)] % MOD;

            if(k % 2) {
                ans -= kek;
                if (ans < 0) ans += MOD;
            } else {
                ans += kek;
                if (ans >= MOD) ans -= MOD;
            }
        }
    }
    else {
        if (m <= 3) solve();
        else {
            if (n == 1) {
                ans = (p[m] - 2*m + MOD) % MOD;
                if (m == 2) ans = 2;
            } else {
                ans = p[2*m];
                ans -= 6*m; if(ans < 0) ans += MOD;
                ans -= (ll)2*m*(m-1)%MOD; if (ans < 0) ans += MOD;
            }
        }
    }
    cout << ans << endl;
}
