#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>

#define ll int
#define ld double
#define pb push_back
#define eb emplace_back
#define ft first
#define sd second

using namespace std;
using namespace __gnu_pbds;

template <typename T1>
using myset = tree<T1,null_type,less<>,rb_tree_tag,tree_order_statistics_node_update>;
template <typename T1, typename T2>
using mymap = tree<T1,T2,less<>,rb_tree_tag,tree_order_statistics_node_update>;

const ll mod = (ll)1e9+7;

ll pw(ll ch, ll st) {
    if (st == 0)
        return 1;
    ll tmp = pw(ch,st/2);
    tmp *= tmp;
    if (st%2)
        tmp *= ch;
    return tmp;
}

int main() {
#ifdef FREOPEN
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
#endif

    ll n, m;

    cin >> n >> m;
    if (n > m)
        swap(n,m);
    vector <ll> dpprev(pw(9,n),0),dpcur(pw(9,n),0);
    vector <ll> all(m+2),base(m+2);
    ll mat1[2][9] = {{0,3,2,0,4,4,2,5,6},{0,1,4,3,0,3,5,1,7}};
    ll mat2[2][9] = {{0,0,2,0,4,4,2,4,2},{0,1,0,3,0,3,3,1,1}};
    all[1] = pw(9,n);
    base[1] = 9;
    all[2] = pw(8,n);
    base[2] = 8;
    all[3] = pw(6,n);
    base[3] = 6;
    for (ll j = 4; j <= m+1; ++j) {
        all[j] = pw(5, j);
        base[j] = 5;
    }
    ll all2 = 1<<n;
    dpprev[all[1]-1] = 1;
    ll ones,zeros,ch1,ch2,nmsk,nch,mem,st;

    for (ll j = 1; j <= m; ++j) {
        for (ll pmsk = 0; pmsk < all[j]; ++pmsk) {

            for (ll msk = 0; msk < all2; ++msk) {
                ones = __builtin_popcount(msk);
                mem = pmsk;
                zeros = n-ones;
                nmsk = 0;
                st = 1;
                for (ll i = n-1; i >= 0; --i) {
                    ch1 = mem%base[j];
                    mem /= base[j];
                    ch2 = (msk>>i)&1;
                    if (ch2) {
                        if (ones == 1)
                            nch = mat1[1][ch1];
                        else
                            nch = mat2[1][ch1];
                    }
                    else {
                        if (zeros == 1)
                            nch = mat1[0][ch1];
                        else
                            nch = mat2[0][ch1];
                    }
                    nmsk += st*nch;
                    st *= base[j+1];
                }
                dpcur[nmsk] += dpprev[pmsk];
                if (dpcur[nmsk] >= mod)
                    dpcur[nmsk] -= mod;
            }
        }
        dpprev = dpcur;
        fill(dpcur.begin(),dpcur.end(),0);
    }
    ll allans = pw(3,n);
    ll ans = 0;
    for (ll msk = 0; msk < allans; ++msk) {
        mem = msk;
        ll cmsk = 0;
        for (ll i = n-1; i >= 0; --i) {
            cmsk*= base[m+1];
            cmsk += mem%3;
            mem /= 3;
        }
        ans += dpprev[cmsk];
        if (ans >= mod)
            ans -= mod;
    }
    cout << ans;
    return 0;
}
