#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = 701;
const int INF = 1e9;

int N, k;
int dp[2][MAXN][2][2];

vector<int> solve(vector<int> a)
{
    for (int i = 0; i < MAXN; i++)
        for (int j = 0; j < 2; j++)
            for (int k = 0; k < 2; k++)
                for (int l = 0; l < 2; l++)
                    dp[j][i][k][l] = -INF;
    int n = a.size();
    dp[(n - 1) & 1][0][0][0] = 0;
    if (k + 1 <= N)
    {
        dp[(n - 1) & 1][k + 1][1][0] = a[n - 1];
        dp[(n - 1) & 1][k + 2][0][1] = a[n - 1];
    }
    if (2 <= N)
    {
        dp[(n - 1) & 1][2][1][1] = a[n - 1];
    }
    for (int person = n - 2; person >= 0; person--)
    {
        for (int badges = 0; badges <= N; badges++)
        {
            // do not take
            dp[person & 1][badges][0][0] = max(dp[person & 1][badges][0][0], dp[(person + 1) & 1][badges][0][0]);
            dp[person & 1][badges][0][0] = max(dp[person & 1][badges][0][0], dp[(person + 1) & 1][badges][1][0]);
            // take with i-th
            if (badges + k + 1 <= N)
            {
                dp[person & 1][badges + k + 1][1][0] = max(dp[person & 1][badges + k + 1][1][0], dp[(person + 1) & 1][badges][0][0] + a[person]);
                dp[person & 1][badges + k + 1][1][0] = max(dp[person & 1][badges + k + 1][1][0], dp[(person + 1) & 1][badges][1][0] + a[person]);
            }
            // take with (i+1)-th
            if (badges + k + 1 <= N)
            {
                dp[person & 1][badges + k + 1][0][0] = max(dp[person & 1][badges + k + 1][0][0], dp[(person + 1) & 1][badges][0][0] + a[person]);
            }
            // take both
            if (badges + 2 <= N)
            {
                dp[person & 1][badges + 2][1][0] = max(dp[person & 1][badges + 2][1][0], dp[(person + 1) & 1][badges][0][0] + a[person]);
            }

            // do not take
            dp[person & 1][badges][0][1] = max(dp[person & 1][badges][0][1], dp[(person + 1) & 1][badges][0][1]);
            dp[person & 1][badges][0][1] = max(dp[person & 1][badges][0][1], dp[(person + 1) & 1][badges][1][1]);
            // take with i-th
            if (badges + k + 1 <= N && person > 0)
            {
                dp[person & 1][badges + k + 1][1][1] = max(dp[person & 1][badges + k + 1][1][1], dp[(person + 1) & 1][badges][0][1] + a[person]);
                dp[person & 1][badges + k + 1][1][1] = max(dp[person & 1][badges + k + 1][1][1], dp[(person + 1) & 1][badges][1][1] + a[person]);
            }
            // take with (i+1)-th
            if (badges + k + 1 <= N)
            {
                dp[person & 1][badges + k + 1][0][1] = max(dp[person & 1][badges + k + 1][0][1], dp[(person + 1) & 1][badges][0][1] + a[person]);
            }
            // take both
            if (badges + 2 <= N && person > 0)
            {
                dp[person & 1][badges + 2][1][1] = max(dp[person & 1][badges + 2][1][1], dp[(person + 1) & 1][badges][0][1] + a[person]);
            }
        }
    }
    vector<int> ans(N + 1);
    for (int i = 0; i < N + 1; i++)
    {
        ans[i] = max(ans[i], dp[0][i][0][0]);
        ans[i] = max(ans[i], dp[0][i][0][1]);
        ans[i] = max(ans[i], dp[0][i][1][0]);
        ans[i] = max(ans[i], dp[0][i][1][1]);
    }
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n >> k, N = n;
    vector<int> t(n), l(n);
    for (int i = 0; i < n; i++)
    {
        cin >> t[i] >> l[i];
    }
    if (n <= 10)
    {
        int ans = 0;
        for (int mask1 = 0; mask1 < (1 << n); mask1++)
        {
            for (int mask2 = mask1; ; mask2 = (mask2 - 1) & mask1)
            {
                for (int mask3 = mask2; ; mask3 = (mask3 - 1) & mask2)
                {
                    int res = 0, T = 1;
                    int take_2 = mask1 - mask2;
                    int take_i = mask2 - mask3;
                    int take_ti = mask3;
                    vector<int> took(n);
                    for (int i = 0; i < n; i++)
                    {
                        if (take_2 & (1 << i))
                            took[i]++, took[t[i]]++;
                        if (take_i & (1 << i))
                            took[i]++;
                        if (take_ti & (1 << i))
                            took[t[i]]++;
                    }
                    int free = 0;
                    for (int i = 0; i < n; i++)
                    {
                        if (took[i] > 1)
                            T = 0;
                        free += took[i] == 0;
                    }
                    int cnt = __builtin_popcount(mask2);
                    if (free < cnt * k)
                        T = 0;
                    free -= cnt * k;
                    vector<int> d;
                    for (int i = 0; i < n; i++)
                    {
                        if (mask1 & (1 << i))
                        {
                            res += l[i];
                        }
                        else
                        {
                            d.push_back(l[i]);
                        }
                    }
                    sort(d.rbegin(), d.rend());
                    for (int i = 0; i < d.size() && free >= 2 * k; i++, free -= 2 * k)
                        res += d[i];
                    if (T)
                        ans = max(ans, res);
                    if (mask3 == 0)
                        break;
                }
                if (mask2 == 0)
                    break;
            }
        }
        cout << ans << endl;
        #ifdef LOCAL
        #else
        return 0;
        #endif
    }
    vector<int> a;
    int fl = 0;
    while (a.size() < n)
    {
        a.push_back(l[fl]);
        fl = t[fl];
    }
    vector<int> b = solve(a);
    cout << *max_element(b.begin(), b.end());
}
