#include <iostream>

using namespace std;

const int MOD = 1e9 + 7;
const int N = 500;

long long inq(long long x, long long y)
{
    if (y == 0) return 1;
    long long l = inq(x, y / 2);
    l = l * l % MOD;
    if (y % 2) return l * x % MOD;
    return l % MOD;
}

long long cnk[N][N];
long long fact[N];
long long rfact[N];

int main()
{
    for (int i = 0; i < N; i++)
    {
        cnk[i][0] = cnk[i][i] = 1;
        for (int j = 1; j < i; j++)
        {
            cnk[i][j] = (cnk[i - 1][j - 1] + cnk[i - 1][j]) % MOD;
        }
    }
    fact[0] = 1;
    rfact[0] = 1;
    for (int i = 1; i < N; i++)
    {
        fact[i] = fact[i - 1] * i % MOD;
        rfact[i] = inq(fact[i], MOD - 2);
    }
    int n, m;
    cin >> n >> m;

    long long all = inq(2, n * m);
    if (n > m) swap(n, m);

    // n <= m

    if (n == 1 && m == 1)
    {
        cout << 0;
        return 0;
    }
    if (n == 1 && m == 2)
    {
        cout << 2;
        return 0;
    }
    if (n == 2 && m == 2)
    {
        cout << 6;
        return 0;
    }

    long long invalid1 = 0;
    for (int k = 1; k <= n; k++)
    {
        long long color_other = inq(2, (n - k) * (m - k));
        long long select_rows = cnk[n][k];
        long long select_cols = fact[m] * rfact[m - k] % MOD;
        if (k % 2 == 1)
        {
            invalid1 = (invalid1 + color_other * select_rows % MOD * select_cols) % MOD;
        }
        else
        {
            invalid1 = (invalid1 - color_other * select_rows % MOD * select_cols) % MOD;
            invalid1 = (invalid1 + MOD) % MOD;
        }
    }
    if (n == 2)
    {
        cout << ((all - 2 * invalid1 + m) % MOD + MOD) % MOD << endl;
        return 0;
    }
    //cout << invalid1 << endl;
    cout << ((all - 2 * invalid1) % MOD + MOD) % MOD << endl;
}
