#include <iostream>
#include <string>
#include <vector>
#include <queue>
#include <deque>
#include <stack>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cstring>
#include <cmath>
#include <cstdlib>
#include <algorithm>
#include <random>
#include <iomanip>
#include <functional>
#include <cassert>
#include <bitset>
#include <chrono>
 
using namespace std;
 
typedef long long ll;

const int N = 1e4 + 7;
const int Inf = 1e9 + 7;

int dp[3][N + N + 1];
int best[2][N + N + 1];
int cur_best[N + N + 1];

int main() {
  ios_base::sync_with_stdio(false); cin.tie(0);
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif
  int n, k;
  cin >> n >> k;
  vector <int> t(n), l(n);
  for (int i = 0; i < n; ++i) {
    cin >> t[i] >> l[i];
  }
  vector <vector <int>> cycles;
  vector <int> used(n);
  for (int i = 0; i < n; ++i) {
    if (used[i]) continue;
    vector <int> cur;
    int j = i;
    while (!used[j]) {
      used[j] = 1;
      cur.push_back(j);
      j = t[j];
    }
    cycles.push_back(cur);
  }

  for (int i = 0; i <= 2 * n; ++i) {
    if (i == n) best[0][i] = 0;
    else best[0][i] = -Inf;
    best[1][i] = -Inf;
  }

  for (auto c : cycles) {
    int m = c.size();
    for (int i = 0; i <= 2 * n; ++i) cur_best[i] = -Inf;

    for (int tk_first = 0; tk_first <= 1; ++tk_first) {
      for (int i = 0; i < 3; ++i) {
        for (int k = 0; k <= 2 * n; ++k) {
          dp[i][k] = -Inf;
        }
      }
      if (tk_first) {
        dp[0][n + 0] = 0;
      } else {
        dp[0][n + 1] = 0;
        dp[0][n + (-k)] = l[c[0]];
        dp[1][n + 0] = l[c[0]];
      }
      for (int i = 0; i + 1 < m; ++i) {
        for (int bal = 0; bal <= 2 * n; ++bal) {
          if (dp[0][bal] == -Inf) continue;
          if (bal + 1 <= 2 * n) dp[1][bal + 1] = max(dp[1][bal + 1], dp[0][bal]);
          if (bal >= k) dp[1][bal - k] = max(dp[1][bal - k], dp[0][bal] + l[c[i + 1]]);
          if (bal + 1 <= 2 * n && (i + 1 != m - 1 || tk_first)) dp[2][bal] = max(dp[2][bal], dp[0][bal] + l[c[i + 1]]);
        }
        swap(dp[0], dp[1]);
        swap(dp[1], dp[2]);
      }
      for (int i = 0; i < 3; ++i) {
        for (int bal = 0; bal <= 2 * n; ++bal) {
          cur_best[bal] = max(cur_best[bal], dp[i][bal]);
        }
      }
    }  
    vector <int> intr;
    int smax = -Inf;
    for (int bal = 2 * n; bal >= 0; --bal) {
      if (cur_best[bal] > smax) {
        intr.push_back(bal);
      }
    }
    reverse(intr.begin(), intr.end());

    for (int pr = 0; pr <= 2 * n; ++pr) {
      if (best[0][pr] == -Inf) continue;
      for (int cur : intr) {
        int sm = pr + cur - n; 
        if (0 <= sm && sm <= 2 * n) {
          best[1][sm] = max(best[1][sm], best[0][pr] + cur_best[cur]);
        }
      }
    }

    swap(best[0], best[1]);
  }
  int ans = -Inf;
  for (int bal = n; bal <= 2 * n; ++bal) ans = max(ans, best[0][bal]);
  cout << ans << '\n';
}
