#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 1e4 + 44;
const int INF = 1e9 + 99;

int dp[2][MAXN][2];
int w[MAXN];
int cur[MAXN];
int nw[MAXN];
int pr[MAXN];

int n, k;

int res[MAXN];

void solve(vector<int> & a)
{
    for (int i = 0; i <= n; ++i)
    {
        dp[0][i][0] = cur[i];
        dp[0][i][1] = cur[i];
    }
    for (auto el : a)
    {
        for (int j = 0; j <= n; ++j)
        {
            dp[1][j][0] = max(dp[0][j][0], dp[0][j][1]);
            dp[1][j][1] = -INF;
        }
        for (int j = 0; j <= n; ++j)
        {
            if (j >= 2)
            {
                dp[1][j][1] = max(dp[1][j][1], dp[0][j - 2][0] + w[el]);
            }
            if (j >= k + 1)
            {
                dp[1][j][1] = max(dp[1][j][1], dp[0][j - k - 1][1] + w[el]);
            }
        }
        for (int j = 0; j <= n; ++j)
        {
            dp[0][j][0] = dp[1][j][0];
            dp[0][j][1] = dp[1][j][1];
        }
    }
    for (int j = 0; j <= n; ++j)
    {
        nw[j] = dp[0][j][0];
    }
    for (int i = 0; i <= n; ++i)
    {
        dp[0][i][0] = cur[i];
        if (i < 2)
        {
            dp[0][i][1] = -INF;
        }
        else
        {
            dp[0][i][1] = cur[i - 2] + w[a.back()];
        }
    }
    int i = 0;
    for (auto el : a)
    {
        for (int j = 0; j <= n; ++j)
        {
            dp[1][j][0] = max(dp[0][j][0], dp[0][j][1]);
            dp[1][j][1] = -INF;
        }
        for (int j = 0; j <= n; ++j)
        {
            if (i == a.size() - 2)
            {
                if (j >= k + 1)
                {
                    dp[1][j][1] = max(dp[1][j][1], dp[0][j - k - 1][0] + w[el]);
                }
                if (j >= 2 * k)
                {
                    dp[1][j][1] = max(dp[1][j][1], dp[0][j - k - k][1] + w[el]);
                }
                continue;
            }
            if (j >= 2)
            {
                dp[1][j][1] = max(dp[1][j][1], dp[0][j - 2][0] + w[el]);
            }
            if (j >= k + 1)
            {
                dp[1][j][1] = max(dp[1][j][1], dp[0][j - k - 1][1] + w[el]);
            }
        }
        for (int j = 0; j <= n; ++j)
        {
            dp[0][j][0] = dp[1][j][0];
            dp[0][j][1] = dp[1][j][1];
        }
        ++i;
    }
    for (int j = 0; j <= n; ++j)
    {
        nw[j] = max(nw[j], dp[0][j][0]);
    }
    for (int j = 0; j <= n; ++j)
    {
        cur[j] = nw[j];
    }
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> k;
    vector<int> t(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> t[i] >> w[i];
    }
    vector<int> used(n);
    for (int i = 0; i < n; ++i)
    {
        if (!used[i])
        {
            vector<int> a;
            int u = i;
            while (t[u] != i)
            {
                used[u] = true;
                a.push_back(u);
                u = t[u];
            }
            a.push_back(u);
            used[u] = true;
            solve(a);
        }
    }
    int ans = 0;
    for (int i = 0; i <= n; ++i)
    {
        ans = max(ans, cur[i]);
    }
    cout << ans << endl;
    return 0;
}
