#include <bits/stdc++.h>
#include "sqsort.h"

using namespace std;

const int MAXN = 1e5 + 7;

int pos[MAXN];

bool my_cmp(int a, int b)
{
    return cmp(0, a, 0, b);
}

bool my_cmp2(pair<int, int> a, pair<int, int> b)
{
    return cmp(a.first, a.second, b.first, b.second);
}

bool my_cmp3(pair<int, int> a, pair<int, int> b)
{
    return (pos[a.first] + pos[a.second] < pos[b.first] + pos[b.second]);
}

std::vector<std::pair<int, int>> solve(int n)
{
    vector<pair<int, int>> ans;
    vector<int> num;
    for (int i = 0; i < n; ++i)
    {
        num.push_back(i);
    }
    stable_sort(num.begin(), num.end(), my_cmp);
    for (int i = 0; i < n; ++i)
    {
        pos[num[i]] = i;
    }
    vector<set<int>> t(n);
    t[0].insert(0);
    int cnt = 1;
    map<pair<int, int>, int> used;
    used[{0, 0}] = true;
    while (cnt)
    {
        int x = num[n - 1];
        int y = num[n - 1];
        for (int i = 0; i < n; ++i)
        {
            if (!t[i].empty())
            {
                if (cmp(num[i], num[*(t[i].begin())], x, y))
                {
                    x = num[i];
                    y = num[*(t[i].begin())];
                }
            }
        }
        ans.push_back({x, y});
        t[pos[x]].erase(pos[y]);
        if (pos[x] != n - 1 && !used[{pos[x] + 1, pos[y]}] && pos[x] + 1 <= pos[y])
        {
            used[{pos[x] + 1, pos[y]}] = true;
            t[pos[x] + 1].insert(pos[y]);
            ++cnt;
        }
        if (pos[y] != n - 1 && !used[{pos[x], pos[y] + 1}] && pos[x] <= pos[y] + 1)
        {
            used[{pos[x], pos[y] + 1}] = true;
            t[pos[x]].insert(pos[y] + 1);
            ++cnt;
        }
        --cnt;
    }
    return ans;
}
