﻿#include "sqsort.h"
#include <algorithm>
#include <map>

using namespace std;

vector <int> ans1;
vector <int> ans2;

bool comp1(int a, int b) {
	return cmp(a, 0, b, 0);
}

bool comp(pair <int, int> a, pair <int, int> b) {
	if (a.first == b.first)
		return ans2[a.second] < ans2[b.second];
	if (a.second == b.second)
		return ans2[a.first] < ans2[b.first];
	if (a.first == b.second)
		return ans2[a.second] < ans2[b.first];
	if (a.second == b.first)
		return ans2[a.first] < ans2[b.second];
	return cmp(a.first, a.second, b.first, b.second);
}

std::vector<std::pair<int, int>> solve(int n) {
	vector <pair <int, int>> answer;
	ans1.resize(n);
	ans2.resize(n);
	for (int i = 0; i < n; ++i) {
		ans1[i] = i;
		for (int j = i; j < n; ++j) {
			answer.push_back({ i, j });
		}
	}
	sort(ans1.begin(), ans1.end(), comp1);
	for (int i = 0; i < n; ++i)
		ans2[ans1[i]] = i;
	sort(answer.begin(), answer.end(), comp);
	return answer;
}