#include <bits/stdc++.h>
using namespace std;

#define pb push_back
#define F first
#define S second
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define mp make_pair
#ifdef MY
    #define endl '\n'
#endif // MY

typedef long long ll;
typedef long double db;
typedef pair < int, int > pii;

const int N = 700 + 5;
int nxt[N];
int cost[N];
int used[N];
int dp[2][N][N][2];

int cnt(int x, int mask) {
    used[x] = mask;
    int res = 0;
    if (nxt[x] != mask) {
        if (!(mask & (1 << x)) && (mask & (1 << nxt[x]))) {
            res++;
        }

    }
    return res;
}

void solve(int n, int k) {
    int ans = 0;
    for (int i = 1; i < (1 << n); i++) {
//        if (i == 106) {
//            cout << "!!";
//        }
        int sum = 0;
        int seg = 0;
        int m = 0;
        for (int j = 0; j < n; j++) {
            if ((1 << j) & i) {
//                if (i == 208) {
//                    cout << j << ' ';
//                }
                sum += cost[j];
                m++;
            }
            if (used[j] != i) {
                seg += cnt(j, i);
            }
        }

        if (m * k - seg * k <= n - m - seg) {
//            if (sum == 17) {
//                cout << i << endl;
//            }
            ans = max(ans, sum);
        }
    }
    cout << ans << endl;
}

bool bad(int m, int s, int k, int n) {
    return k * (m - s) > n - m - s;
}

signed main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, k;
    cin >> n >> k;
    int p = 0;
    for (int i = 0; i < n; i++) {
        cin >> nxt[i] >> cost[i];
        if (cost[i] == 0) {
            p = nxt[i];
        }
    }
    if (n <= 10) {
        solve(n, k);
        #ifndef MY
            return 0;
        #endif // MY
    }
    dp[0][0][0][0] = 0;
    dp[0][1][1][1] = cost[p];
    for (int i = 1; i < n - 1; i++) {
        int v = nxt[p];
        dp[1][0][0][0] = 0;
        dp[1][1][1][1] = cost[v];
        for (int j = 1; j <= i + 1; j++) {
            for (int s = 1; s <= j; s++) {
                if (bad(j, s, k, n)) {
                    continue;
                }
                //cout << i << ' ' << j << ' ' << s << endl;
                dp[1][j][s][0] = max(dp[0][j][s][0], dp[0][j][s][1]);
                dp[1][j][s][1] = max(dp[0][j - 1][s][1], dp[0][j - 1][s - 1][0]) + cost[v];
            }
        }
        swap(dp[0], dp[1]);
        p = v;
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            ans = max({ans, dp[0][i][j][0], dp[0][i][j][1]});
        }
    }
    cout << ans;
    return 0;
}
