#include <bits/stdc++.h>
#include "sqsort.h"
using namespace std;

#define pb push_back
#define F first
#define S second
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define mp make_pair
//#ifdef MY
//    #define endl '\n'
//#endif // MY

typedef long long ll;
typedef long double db;
typedef pair < int, int > pii;

const int N = 2e3 + 5;
int lst[N][N];
int ind[N];
pii cur[N];
int nxt[N];
pii P = {-1, -1};

int get_min(int n) {
    int st = -1;
    for (int i = 0; i < n; i++) {
        if (cur[i] == P) {
            continue;
        }
        st = i;
        break;
    }
    pii res = cur[st];
    for (int i = 0; i < n; i++) {
        if (cur[i] == P || i == st) {
            continue;
        }
        if (cmp(cur[i].F, cur[i].S, res.F, res.S)) {
            res = cur[i];
            st = i;
        }
    }
    return st;
}

vector < pii > solve(int n) {
    for (int i = 0; i < n; i++) {
        ind[i] = i;
        for (int j = i; j < n; j++) {
            lst[i][j] = cmp(i, i, j, j);
        }
    }
    sort(ind, ind + n, [](int a, int b) {return lst[a][b];});
    for (int i = 0; i < n; i++) {
        nxt[i] = i;
        cur[i] = {ind[i], ind[i]};
    }
    vector < pii > ans;
    int m = n * (n + 1) / 2;
    for (int i = 0; i < m; i++) {
        int j = get_min(n);
        ans.pb(cur[j]);
        if (nxt[j] + 1 == n) {
            cur[j] = P;
        } else {
            nxt[j]++;
            cur[j] = {ind[j], ind[nxt[j]]};
        }
    }
    return ans;
}
