//#include <bits/stdc++.h>
#include "cstdio"
#include "math.h"
#include "vector"
#include "algorithm"
#include "set"
#include "map"
#include "stack"
#include <iostream>
#include <iomanip>
#include <fstream>
#include <cmath>
#include <random>
#include <cstring>
#include <unordered_map>

//#pragma comment(linker, "/stack:200000000")
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

using namespace std;

using ll = long long;

#define pll pair<ll, ll>
#define pii pair<int, int>
#define pli pair<ll, int>
#define pb push_back
#define ld long double
#define pdd pair<double, double>
#define mp make_pair
//#define f first
//#define s second

mt19937 gen(time(0));

void setIO(string name = "") {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.setf(ios::fixed);
//    freopen((name+".in").c_str(), "r", stdin);
//    freopen((name+".out").c_str(), "w", stdout);
}

class cartesian_tree {
    struct node {
        int x, y, size;
        node *L, *R;

        node(int x) : x(x), y(rand()), size(1), L(nullptr), R(nullptr) {};
    } *root;

    int size(node *t) {
        return t != nullptr ? t->size : 0;
    }

    void update(node *t) {
        if (t == nullptr)
            return;
        t->size = size(t->L) + size(t->R) + 1;
    }

    node *merge(node *a, node *b) {
        if (a == nullptr || b == nullptr)
            return b == nullptr ? a : b;
        if (a->y > b->y) {
            a->R = merge(a->R, b);
            update(a);
            return a;
        } else {
            b->L = merge(a, b->L);
            update(b);
            return b;
        }
    }

    pair<node *, node *> split(node *t, int x) {
        if (t == nullptr) {
            return {nullptr, nullptr};
        }
        if (t->x < x) {
            auto r = split(t->R, x);
            t->R = r.first;
            update(t);
            return {t, r.second};
        } else {
            auto l = split(t->L, x);
            t->L = l.second;
            update(t);
            return {l.first, t};
        }
    }

    pair<node *, node *> splitk(node *t, int k) {
        if (t == nullptr) {
            return {nullptr, nullptr};
        }
        if (size(t->L) < k) {
            auto r = splitk(t->R, k - size(t->L) - 1);
            t->R = r.first;
            update(t);
            return {t, r.second};
        } else {
            auto l = splitk(t->L, k);
            t->L = l.second;
            update(t);
            return {l.first, t};
        }
    }

    void add(int x) {
        auto tmp = split(root, x);
        root = merge(tmp.first, merge(new node(x), tmp.second));
    }

    void append(int x) {
        root = merge(root, new node(x));
    }

    void print(node *t) {
        if (t == nullptr) {
            return;
        }
        print(t->L);
        cout << t->x << ' ';
        print(t->R);
    }

    void print() {
        cout << "The tree is:\n";
        print(root);
        cout << endl << endl;
    }
};

int main() {
//    ifstream in;
//    ofstream out;
//    in.open(".in");
//    out.open(".out");
    setIO();
    int n, k;
    cin >> n >> k;
    vector<int> goal(n), l(n);
    for (int i = 0; i < n; i++) {
        cin >> goal[i] >> l[i];
    }
    if (n <= 10) {
        int ans = 0, mask1 = 0;
        vector<bool> loser(n), alive(n);
        vector<int> cnt(n);
        for (int mask = 0; mask < (1 << n); mask++) {
            int loser_num = 0, dead = 0;
            int sum = 0;
            for (int i = 0; i < n; i++) {
                loser[i] = false;
                alive[i] = false;
                cnt[i] = 0;
            }
            for (int i = 0; i < n; i++) {
                if (mask & (1 << i)) {
                    sum += l[i];
                    if (loser[i]) {
                        loser_num++;
                        if (!alive[goal[i]]) {
                            loser[goal[i]] = true;
                            cnt[i] = k;
                        }
                    } else if (alive[goal[i]]) {
                        cnt[i] = k;
                        alive[i] = true;
                    } else {
                        alive[i] = true;
                        loser[goal[i]] = true;
                        cnt[i] = 2 * k;
                        if (mask & (1 << goal[i])) continue;
                        dead--;
                    }
                } else dead++;
            }
            bool ok = true;
            for (int i = 0; i < n; i++) {
                if (mask & (1 << i)) {
                    if (cnt[i] >= 2 * k) continue;
                    if (cnt[i] >= k) {
                        if (dead >= k) {
                            dead -= k;
                            continue;
                        } else {
                            ok = false;
                        }
                    } else {
                        if (dead >= 2 * k) {
                            dead -= 2 * k;
                            continue;
                        } else {
                            ok = false;
                        }
                    }
                }
            }
            if (ok) {
                if (sum > ans) {
                    ans = sum;
                    mask1 = mask;
                }
            }
        }
        cout << ans;
    }
    return 0;
}