//#include <bits/stdc++.h>
#include "cstdio"
#include "math.h"
#include "vector"
#include "algorithm"
#include "set"
#include "map"
#include "stack"
#include <iostream>
#include <iomanip>
#include <fstream>
#include <cmath>
#include <random>
#include <cstring>
#include <unordered_map>

//#pragma comment(linker, "/stack:200000000")
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

using namespace std;

using ll = long long;

#define pll pair<ll, ll>
#define pii pair<int, int>
#define pli pair<ll, int>
#define pb push_back
#define ld long double
#define pdd pair<double, double>
#define mp make_pair
//#define f first
//#define s second

mt19937 gen(time(0));

void setIO(string name = "") {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.setf(ios::fixed);
//    freopen((name+".in").c_str(), "r", stdin);
//    freopen((name+".out").c_str(), "w", stdout);
}

const int MAXN = 1e4 + 5;

vector<int> goal(MAXN);
vector<int> l(MAXN);
vector<int> p(MAXN);
vector<int> previous(MAXN);

void go(int i, int cnt, int j, int n) {
    if (cnt == n) return;
    p[cnt] = i;
    previous[i] = j;
    go(goal[i], cnt + 1, i, n);
}

int main() {
//    ifstream in;
//    ofstream out;
//    in.open(".in");
//    out.open(".out");
    setIO();
    int n, k;
    cin >> n >> k;
    for (int i = 0; i < n; i++) {
        cin >> goal[i] >> l[i];
    }
    if (n <= 10) {
        int ans = 0;
        vector<bool> loser(n), alive(n);
        vector<int> cnt(n);
        for (int mask = 0; mask < (1 << n); mask++) {
            int loser_num = 0, dead = 0;
            int sum = 0;
            for (int i = 0; i < n; i++) {
                loser[i] = false;
                alive[i] = false;
                cnt[i] = 0;
            }
            for (int i = 0; i < n; i++) {
                if (mask & (1 << i)) {
                    sum += l[i];
                    if (loser[i]) {
                        loser_num++;
                        if (!alive[goal[i]]) {
                            loser[goal[i]] = true;
                            cnt[i] = k;
                        }
                    } else if (alive[goal[i]]) {
                        cnt[i] = k;
                        alive[i] = true;
                    } else {
                        alive[i] = true;
                        loser[goal[i]] = true;
                        cnt[i] = 2 * k;
                    }
                }
            }
            for (int i = 0; i < n; i++) {
                if (mask & (1 << i)) {
                    if (cnt[i] >= 2 * k) continue;
                    if (cnt[i] >= k) {
                        dead -= k;
                    } else {
                        dead -= 2 * k;
                    }
                } else if (!alive[i] && !loser[i]) dead++;
            }
            if (dead >= 0) {
                ans = max(ans, sum);
            }
        }
        cout << ans;
    } else {
        vector<bool> get(n);
        for (int i = 0; i < n; i++) {
            if (l[i] == 0) {
                go((i + 1) % n, 0, i, n);
                break;
            }
        }
        int ans = 0, cnt = 0;
        get[n - 1] = true;
        for (int i = n - 2; i >= 0; i--) {
            if (l[p[i]] > l[p[i + 1]] && get[i + 1]) {
                ans -= l[p[i + 1]];
                get[i + 1] = false;
                ans += l[p[i]];
                get[i] = true;
            } else if (!get[i + 1]) {
                get[i] = true;
                ans += l[p[i]];
            } else {
                cnt++;
            }
        }
        vector<int> left_l;
        for (int i = 0; i < n; i++) {
            if (!get[i]) left_l.push_back(l[p[i]]);
        }
        sort(left_l.rbegin(), left_l.rend());
        for (int x : left_l) {
            if (cnt >= 2 * k) {
                ans += x;
                cnt -= 2 * k;
            } else break;
        }
        cout << ans;
    }
    return 0;
}

//11 3
//1 12
//2 12
//3 12
//4 12
//5 12
//6 12
//7 12
//8 12
//9 12
//10 12
//0 0