#include "sqsort.h"

std::vector<std::pair<int, int>> solve(int n) {
    std::vector<std::pair<int, int>> pairs;
    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) {
            pairs.push_back(std::make_pair(i, j));
        }
    }
    int sz = (int) pairs.size();
    for (int i = sz - 1; i >= 1; i--) {
        for (int j = i - 1; j >= 0; j--) {
            if (cmp(pairs[i].first, pairs[i].second,
                    pairs[j].first, pairs[j].second)) {
                std::swap(pairs[i], pairs[j]);
            }
        }
    }
    return pairs;
}