//#include <bits/stdc++.h>
#include "cstdio"
#include "math.h"
#include "vector"
#include "algorithm"
#include "set"
#include "map"
#include "stack"
#include <iostream>
#include <iomanip>
#include <fstream>
#include <cmath>
#include <random>
#include <cstring>
#include <unordered_map>

//#pragma comment(linker, "/stack:200000000")
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

using namespace std;

using ll = long long;

#define pll pair<ll, ll>
#define pii pair<int, int>
#define pli pair<ll, int>
#define pb push_back
#define ld long double
#define pdd pair<double, double>
#define mp make_pair
//#define f first
//#define s second

mt19937 gen(time(0));

void setIO(string name = "") {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.setf(ios::fixed);
//    freopen((name+".in").c_str(), "r", stdin);
//    freopen((name+".out").c_str(), "w", stdout);
}

const int MAXN = 1e4 + 5;

vector<int> A = {5, 1, 3};
std::vector<std::vector<int>> compare(2005, std::vector<int> (2005));

bool cmp(int i, int j, int k, int l) {
    return A[i] + A[j] < A[k] + A[l];
}

void merge(std::vector<std::pair<int, int>> &pairs, int l, int r) {
    if (r - l <= 1) return;
    int m = (l + r) / 2;
    int pos1 = 0, pos2 = 0;
    std::pair<int, int> temp[r - l];
    while (pos1 + l < m && pos2 + m < r) {
        if (compare[pairs[l + pos1].first][pairs[m + pos2].first] && compare[pairs[l + pos1].second][pairs[m + pos2].second]) {
            temp[pos1 + pos2] = std::make_pair(pairs[l + pos1].first, pairs[l + pos1].second);
            pos1++;
            continue;
        }
        if (compare[pairs[l + pos1].first][pairs[m + pos2].second] && compare[pairs[l + pos1].second][pairs[m + pos2].first]) {
            temp[pos1 + pos2] = std::make_pair(pairs[l + pos1].first, pairs[l + pos1].second);
            pos1++;
            continue;
        }
        if (compare[pairs[m + pos2].first][pairs[l + pos1].first] && compare[pairs[m + pos2].second][pairs[l + pos1].second]) {
            temp[pos1 + pos2] = std::make_pair(pairs[m + pos2].first, pairs[m + pos2].second);
            pos2++;
            continue;
        }
        if (compare[pairs[m + pos2].first][pairs[l + pos1].second] && compare[pairs[m + pos2].second][pairs[l + pos1].first]) {
            temp[pos1 + pos2] = std::make_pair(pairs[m + pos2].first, pairs[m + pos2].second);
            pos2++;
            continue;
        }
        if (cmp(pairs[l + pos1].first, pairs[l + pos1].second,pairs[m + pos2].first, pairs[m + pos2].second)) {
            temp[pos1 + pos2] = std::make_pair(pairs[l + pos1].first, pairs[l + pos1].second);
            pos1++;
        } else {
            temp[pos1 + pos2] = std::make_pair(pairs[m + pos2].first, pairs[m + pos2].second);
            pos2++;
        }
    }
    while (pos1 + l < m) {
        temp[pos1 + pos2] = std::make_pair(pairs[l + pos1].first, pairs[l + pos1].second);
        pos1++;
    }
    while (pos2 + m < r) {
        temp[pos1 + pos2] = std::make_pair(pairs[m + pos2].first, pairs[m + pos2].second);
        pos2++;
    }
    for (int i = 0; i < r - l; i++) {
        pairs[i + l] = {temp[i].first, temp[i].second};
    }
}

void merge_sort(std::vector<std::pair<int, int>> &pairs, int l, int r) {
    if (r - l <= 1) return;
    merge_sort(pairs, l, (l + r) / 2);
    merge_sort(pairs, (l + r) / 2, r);
    merge(pairs, l, r);
}

std::vector<std::pair<int, int>> solve(int n) {
    std::vector<std::pair<int, int>> pairs;
    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) {
            pairs.push_back(std::make_pair(i, j));
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            compare[i][j] = cmp(0, i, 0, j);
        }
    }
    merge_sort(pairs, 0, (int) pairs.size());
    return pairs;
}

int main() {
//    ifstream in;
//    ofstream out;
//    in.open(".in");
//    out.open(".out");
    setIO();
    vector<pii> pairs = solve(3);
    for (auto p : pairs) {
        cout << p.first << " " << p.second << "\n";
    }
    return 0;
}
