#include <iostream>
#include <cstdio>
#include <sstream>
#include <iomanip>
#include <cstring>
#include <string.h>
#include <cmath>
#include <math.h>
#include <map>
#include <set>
#include <vector>
#include <unordered_map>
#include <algorithm>
#include <random>
//#include <ext/container/c++.h>


using namespace std;
//using namespace __gnu_pbds;
template<class T1, class T2> inline bool chkmin(T1 &x, const T2 &y) {
	if (x > y) {
		x = y;
		return true;
	}
	return false;
}
template<class T1, class T2> inline bool chkmax(T1 &x, const T2 &y) {
	if (x < y) {
		x = y;
		return true;
	}
	return false;
}
#define rall(c) (c).rbegin(), (c).rend()
#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()
#define mp make_pair
#define pb push_back
using ll = long long;
using ld = long double;
const int MAXN = 10228;


int n, k;
int t[MAXN], L[MAXN];
bool used[MAXN];
int dp[2][2][MAXN * 2];
int curdp[MAXN * 2];
int ndp[MAXN * 2];
int cursum = 0;
int have;

void solve(vector<int> order) {
	int l = -n;
	int r = n;
	for (int f = l; f <= r; f++) {
		ndp[f + n] = -1e9;
	}
	for (int gg = 0; gg < 2; gg++) {
		int id = 0;
		for (int f = l; f <= r; f++) {
			dp[id ^ 1][0][f + n] = -1e9;
			dp[id ^ 1][1][f + n] = -1e9;
			dp[id][gg][f + n] = curdp[f + n];
			dp[id][1 - gg][f + n] = -1e9;
		}
		for (int i = 0; i < sz(order); i++) {
			for (int t = 0; t < 2; t++) {
				if (i == 0 && t != gg) {
					continue;
				}
				//t = 0 - we still have our badge
				//t = 1 - it was taken from us
				for (int bal = l; bal <= r; bal++) {
					//bal - cur balance of taken bages
					if (dp[id][t][bal + n] < 0) {
						if (bal >= 0) {
							break;
						}
						continue;
					}
					int curval = dp[id][t][bal + n];
					dp[id][t][bal + n] = -1e9;
					for (int g = 0; g < 2; g++) {
						//do we want to survive?
						if (g == 0) {
							if (i == sz(order) - 1 && gg != 0) {
								continue;
							}
							chkmax(dp[id ^ 1][0][bal + n + (t == 0 ? 1: 0)], curval);
							continue;
						}
						for (int nt = 0; nt < 2; nt++) {
							if (i == sz(order) - 1 && nt != gg) {
								continue;
							}
							//nt = 1 - we want to steal target's badge
							//nt = 0 - we don't want to do it
							int need = 2 * k - (t == 0 ? k: 0) - (nt == 1 ? k: 0);
							if (bal + n - need >= 0) {
								chkmax(dp[id ^ 1][nt][bal + n - need], curval + L[order[i]]);
							}
						}
					}
				}
			}
			id ^= 1;
		}
		for (int f = l; f <= r; f++) {
			chkmax(ndp[f + n], dp[id][gg][f + n]);
		}
	}
	for (int f = l; f <= r; f++) {
		curdp[f + n] = ndp[f + n];
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//freopen("input.in", "r", stdin);
	cin >> n >> k;
	have = n;
	for (int i = 0; i < n; i++) {
		cin >> t[i] >> L[i];
	}
	for (int i = -n; i <= n; i++) {
		curdp[i + n] = -1e9;
	}
	curdp[n] = 0;
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			int cur = i;
			vector<int> order;
			while (!used[cur]) {
				used[cur] = true;
				order.pb(cur);
				cur = t[cur];
			}
			solve(order);
		}
	}
	int ans = 0;
	for (int i = 0; i <= n; i++) {
		chkmax(ans, curdp[i + n]);
	}
	cout << ans << '\n';
}