#include <iostream>
#include <cstdio>
#include <sstream>
#include <iomanip>
#include <cstring>
#include <string.h>
#include <cmath>
#include <math.h>
#include <map>
#include <set>
#include <vector>
#include <unordered_map>
#include <algorithm>
#include <random>
#include "sqsort.h"
//#include <ext/container/c++.h>


using namespace std;
//using namespace __gnu_pbds;
template<class T1, class T2> inline bool chkmin(T1 &x, const T2 &y) {
	if (x > y) {
		x = y;
		return true;
	}
	return false;
}
template<class T1, class T2> inline bool chkmax(T1 &x, const T2 &y) {
	if (x < y) {
		x = y;
		return true;
	}
	return false;
}
#define rall(c) (c).rbegin(), (c).rend()
#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()
#define mp make_pair
#define pb push_back
using ll = long long;
using ld = long double;



bool query(int a, int b, int c, int d) {
	return cmp(a, b, c, d);
}


bool comp(int a, int b) {
	return query(a, a, b, b);
}


bool comp1(pair<int, int> a, pair<int, int> b) {
	return cmp(a.first, a.second, b.first, b.second);
}


vector<pair<int, int> > solve(int n) {
	vector<int> order;
	for (int i = 0; i < n; i++) {
		order.pb(i);
	}
	sort(all(order), comp);
	vector<pair<int, int> > d;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j <= i; j++) {
			d.pb(mp(order[j], order[i]));
		}
	}
	sort(all(d), comp1);
	return d;
}