#include <iostream>
#include <cstdio>
#include <sstream>
#include <iomanip>
#include <cstring>
#include <string.h>
#include <cmath>
#include <math.h>
#include <map>
#include <set>
#include <vector>
#include <unordered_map>
#include <algorithm>
#include <random>
#include "sqsort.h"
//#include <ext/container/c++.h>


using namespace std;
//using namespace __gnu_pbds;
template<class T1, class T2> inline bool chkmin(T1 &x, const T2 &y) {
	if (x > y) {
		x = y;
		return true;
	}
	return false;
}
template<class T1, class T2> inline bool chkmax(T1 &x, const T2 &y) {
	if (x < y) {
		x = y;
		return true;
	}
	return false;
}
#define rall(c) (c).rbegin(), (c).rend()
#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()
#define mp make_pair
#define pb push_back
using ll = long long;
using ld = long double;


int where[2005];

bool query(int a, int b, int c, int d) {
	return cmp(a, b, c, d);
}


bool comp(int a, int b) {
	return query(a, a, b, b);
}


bool comp1(pair<int, int> a, pair<int, int> b) {
	if (where[a.first] > where[a.second]) {
		swap(a.first, a.second);
	}
	if (where[b.first] > where[b.second]) {
		swap(b.first, b.second);
	}
	if (where[a.first] < where[b.first] && where[a.second] < where[b.second]) {
		return true;
	}
	if (where[a.first] > where[b.first] && where[a.second] > where[b.second]) {
		return false;
	}
	return cmp(a.first, a.second, b.first, b.second);
}


vector<pair<int, int> > d[2020];


vector<pair<int, int> > solve(int n) {
	vector<int> order;
	for (int i = 0; i < n; i++) {
		order.pb(i);
	}
	sort(all(order), comp);
	for (int i = 0; i < n; i++) {
		where[order[i]] = i;
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j <= i; j++) {
			d[i].pb(mp(order[j], order[i]));
		}
	}
	set<pair<int, int> > s;
	for (int i = 0; i < n; i++) {
		s.insert(mp(sz(d[i]), i));
	}
	while (sz(s) != 1) {
		auto dd = *s.begin();
		if (dd.first == 0) {
			s.erase(dd);
			continue;
		}
		s.erase(dd);
		auto dd1 = *s.begin();
		s.erase(dd1);
		vector<pair<int, int> > dm;
		dm.resize(sz(d[dd.second]) + sz(d[dd1.second]));
		merge(all(d[dd.second]), all(d[dd1.second]), dm.begin(), comp1);
		d[dd.second] = dm;
		d[dd1.second].clear();
		s.insert(mp(sz(d[dd.second]), dd.second));
	}
	return d[s.begin()->second];
}