#include <iostream>
#include <cstdio>
#include <sstream>
#include <iomanip>
#include <cstring>
#include <string.h>
#include <cmath>
#include <math.h>
#include <map>
#include <set>
#include <vector>
#include <unordered_map>
#include <algorithm>
#include <random>
#include "sqsort.h"
//#include <ext/container/c++.h>


using namespace std;
//using namespace __gnu_pbds;
template<class T1, class T2> inline bool chkmin(T1 &x, const T2 &y) {
	if (x > y) {
		x = y;
		return true;
	}
	return false;
}
template<class T1, class T2> inline bool chkmax(T1 &x, const T2 &y) {
	if (x < y) {
		x = y;
		return true;
	}
	return false;
}
#define rall(c) (c).rbegin(), (c).rend()
#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()
#define mp make_pair
#define pb push_back
using ll = long long;
using ld = long double;


int where[2005];

bool query(int a, int b, int c, int d) {
	return cmp(a, b, c, d);
}


bool comp(int a, int b) {
	return query(a, a, b, b);
}


bool comp1(pair<int, int> a, pair<int, int> b) {
	return cmp(a.first, a.second, b.first, b.second);
}

vector<pair<int, int> > d[2020];
mt19937 as(228);
int n;
	
vector<pair<int, int> > solve(vector<vector<pair<int, int> > > curd) {
	vector<vector<pair<int, int> > > curd1;
	for (auto y: curd) {
		if (y.empty()) {
			continue;
		}
		curd1.pb(y);
	}
	swap(curd, curd1);
	curd1.clear();
	if (sz(curd) == 0) {
		return vector<pair<int, int> > {};
	}
	// for (auto x: curd) {
	// 	for (auto y: x) {
	// 		cout << y.first << ' ' << y.second << ' ';
	// 	}
	// 	cout << '\n';
	// }
	// cout << '\n';
	if (sz(curd) == 1) {
		return curd[0];
	}
	int len = 0;
	for (int i = 0; i < sz(curd); i++) {
		len += sz(curd[i]);
	}
	if (len <= n / 3) {
		vector<pair<int, int> > st;
		for (int i = 0; i < sz(curd); i++) {
			for (auto x: curd[i]) {
				st.pb(x);
			}
		}
		sort(all(st), comp1);
		return st;
	}
	vector<pair<int, int> > all;
	int tp = 0;
	for (int i = 0; i < sz(curd); i++) {
		if (sz(curd[tp]) < sz(curd[i])) {
			tp = i;
		}
	}
	auto mid = curd[tp][sz(curd[tp]) / 2];
	vector<vector<pair<int, int> > > curdl, curdr;
	curdl.resize(sz(curd));
	curdr.resize(sz(curd));
	for (int i = 0; i < sz(curd); i++) {
		bool was = false;
		for (int j = 0; j < sz(curd[i]); j++) {
			if (curd[i][j] == mid) {
				was = true;
				for (int t = 0; t < j; t++) {
					curdl[i].pb(curd[i][t]);
				}
				for (int t = j + 1; t < sz(curd[i]); t++) {
					curdr[i].pb(curd[i][t]);
				}
				break;
			}
		}
		if (was) {
			continue;
		}
		int l =0;
		int r = sz(curd[i]);
		while (l < r) {
			int pk = (l + r) >> 1;
			if (comp1(curd[i][pk], mid)) {
				l = pk + 1;
			} else {
				r = pk;
			}
		}
		for (int j = 0; j < l; j++) {
			curdl[i].pb(curd[i][j]);
		}
		for (int j = l; j < sz(curd[i]); j++) {
			curdr[i].pb(curd[i][j]);
		}
	}
	//cout << "divide " << mid.first << ' ' << mid.second << '\n';
	auto k = solve(curdl);
	k.pb(mid);

	auto k1 = solve(curdr);
	for (auto y: k1) {
		k.pb(y);
	} 
	return k;
}

vector<pair<int, int> > solve(int _n) {
	n = _n;
	vector<int> order;
	for (int i = 0; i < n; i++) {
		order.pb(i);
	}
	sort(all(order), comp);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j <= i; j++) {
			d[i].pb(mp(order[j], order[i]));
		}
	}
	vector<vector<pair<int, int> > > curd;
	for (int i = 0; i < n; i++) {
		curd.pb(d[i]);
	}
	auto res = solve(curd);
	// for (auto x: res) {
	// 	cout << x.first << ' ' << x.second << '\n';
	// }
	return res;
}