#include <iostream>
#include <cstdio>
#include <sstream>
#include <iomanip>
#include <cstring>
#include <string.h>
#include <cmath>
#include <math.h>
#include <map>
#include <set>
#include <vector>
#include <unordered_map>
#include <algorithm>
#include <random>
#include "sqsort.h"
//#include <ext/container/c++.h>


using namespace std;
//using namespace __gnu_pbds;
template<class T1, class T2> inline bool chkmin(T1 &x, const T2 &y) {
	if (x > y) {
		x = y;
		return true;
	}
	return false;
}
template<class T1, class T2> inline bool chkmax(T1 &x, const T2 &y) {
	if (x < y) {
		x = y;
		return true;
	}
	return false;
}
#define rall(c) (c).rbegin(), (c).rend()
#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()
#define mp make_pair
#define pb push_back
using ll = long long;
using ld = long double;


int where[2020];

bool query(int a, int b, int c, int d) {
	return cmp(a, b, c, d);
}


bool comp(int a, int b) {
	return query(a, a, b, b);
}


bool comp1(pair<int, int> a, pair<int, int> b) {
	if (where[a.first] > where[a.second]) {
		swap(a.first, a.second);
	}
	if (where[b.first] > where[b.second]) {
		swap(b.first, b.second);
	}
	if (a == b) {
		return false;
	}
	if (where[a.first] <= where[b.first] && where[a.second] <= where[b.second]) {
		return true;
	}
	if (where[b.first] <= where[a.first] && where[b.second] <= where[a.second]) {
		return false;
	}
	return cmp(a.first, a.second, b.first, b.second);
}




vector<pair<int, int> > d[2020];


vector<pair<int, int> > mergenubas(int l, int r) {
	if (l == r) {
		return d[l];
	}
	set<pair<int, int> > s;
	for (int i = l; i <= r; i++) {
		s.insert(mp(sz(d[i]), i));
	}
	while (sz(s) > 1) {
		auto x = *s.begin();
		s.erase(x);
		auto y = *s.begin();
		s.erase(y);
		auto e = d[x.second];
		auto f = d[y.second];
		d[y.second].clear();
		d[x.second].resize(sz(e) + sz(f));
		merge(all(e), all(f), d[x.second].begin(), comp1);
		s.insert(mp(sz(d[x.second]), x.second));
	}
	return d[s.begin()->second];
}

int n;
vector<int> order;


vector<pair<int, int> > solve(int l, int r) {
	if (l == r) {
		return vector<pair<int, int> >{mp(order[l], order[l])};
	}
	if (l + 1 == r) {
		return vector<pair<int, int> >{mp(order[l], order[l]), mp(order[l], order[r]), mp(order[r], order[r])};
	}
	if (r - l + 1 <= 6) {
		for (int i = l; i <= r; i++) {
			d[i].clear();
			for (int j = i; j <= r; j++) {
				d[i].pb(mp(order[i], order[j]));
			}
		}
		return mergenubas(l, r);
	}
	int mid = l + (r - l) / 5 * 4;
	auto z1 = solve(mid + 1, r);
	for (int i = l; i <= mid; i++) {
		d[i].clear();
		for (int k = i; k <= r; k++) {
			d[i].pb(mp(order[i], order[k]));
		}
	}
	d[mid + 1] = z1;
	return mergenubas(l, mid + 1);
}
 


vector<pair<int, int> > solve(int _n) {
	n = _n;
	for (int i = 0; i < n; i++) {
		order.pb(i);
	}
	sort(all(order), comp);
	vector<pair<int, int> > porder;
	for (int i = 0; i < n; i++) {
		where[order[i]] = i;
		for (int j = 0; j <= i; j++) {
			porder.pb(mp(order[j], order[i]));
		}
	}
	return solve(0, n - 1);
}