#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long
#define mp make_pair
#define pii pair<int, int>
#define pip pair<int, pii>
#define sz(a) (int) (a.size())
#define all(a) a.begin(), a.end()
#define chkmin(a, b) a = min(a, b)
#define chkmax(a, b) a = max(a, b)

mt19937 rnd(time(0));


const int max_n = 51;
const int mod = 1e9 + 7;

int fact[max_n * max_n];
int dp0[max_n][max_n], dp1[max_n][max_n];

int binpow(int a, int b) {
	int res = 1;
	for(;b > 0;b /= 2, a = a * a % mod)
		if (b & 1) res = res * a % mod;
	return res;
}

int inv(int a) {
	return binpow(a, mod - 2);
}

int num[4][4];

void rec(int id1, int id2, int& n, int& m) {
	if (id1 == n) {
		bool good = false;
		for(int i = 0;i < n;i++) {
			for(int j = 0;j < m;j++) {
				if (num[i][j] == 1) {
					bool bad = false;
					for(int i1 = 0;i1 < n;i1++) {
						if (i1 != i && num[i1][j] == 1) bad = true;
					}
					for(int j1 = 0;j1 < m;j1++) {
						if (j1 != j && num[i][j1] == 1) bad = true;
					}
					if (!bad) good = true;
				}
				if (good) break;
			}
			if (good) break;
		}
		if (good) dp0[n][m]++;
		return;
	}

	for(int i = 1;i <= 2;i++) {
		num[id1][id2] = i;
		rec(id1 + (id2 == m - 1 ? 1 : 0), (id2 + 1) % m, n, m);
	}
}

void f(int n, int m) {
	int res = 0;
	for(int i = 1;i <= min(n, m);i++) {
		int r = 1;
		for(int j = 0;j < i;j++)
			r = r * (n - j) * (m - j) % mod;
		r = r * inv(fact[i]) % mod * dp1[n - i][m - i] % mod;

		res += r;
	}
	dp0[n][m] = res % mod;
	dp1[n][m] = (binpow(2, n * m) - dp0[n][m] + mod) % mod;
}

void solve() {
	fact[0] = 1;
	for(int i = 1;i < max_n * max_n;i++) 
		fact[i] = (fact[i - 1] * i) % mod;

	int n, m;
	cin >> n >> m;

	if (n > m) swap(n, m);

	for(int i = 0;i < max_n;i++) {
		dp1[0][i] = dp1[i][0] = 1;
	}

	for(int i = 1;i <= 2;i++) {
		for(int j = 1;j <= m - 1;j++) {
			//cout << j << endl;
			rec(0, 0, i, j);
			dp1[i][j] = binpow(2, i * j) - dp0[i][j];
			//cout << i << " " << j << " " << dp0[i][j] << endl;
		}
	}
	for(int i = 3;i <= n;i++) {
		for(int j = i;j <= m;j++) {
			f(i, j);
		}
	}

	cout << (binpow(2, n * m) - 2 * dp0[n][m] + 2 * mod) % mod << endl;
}


signed main() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);

	solve();
}