//#include <bits/stdc++.h>
#include "sqsort.h"

using namespace std;

#define ll long long
#define fi first
#define se second
#define mp make_pair
#define pii pair<int, int>
#define pip pair<int, pii>
#define sz(a) (int) (a.size())
#define all(a) a.begin(), a.end()
#define chkmin(a, b) a = min(a, b)
#define chkmax(a, b) a = max(a, b)


void merge_sort(vector<pii>& a, int l, int r) {
	if (l == r) return;
	int m = (l + r) / 2;
	merge_sort(a, l, m);
	merge_sort(a, m + 1, r);

	vector<pii> b;
	int id1 = l, id2 = m + 1;

	while(id1 <= m || id2 <= r) {
		if (id1 > m) b.emplace_back(a[id2++]);
		else if (id2 > r) b.emplace_back(a[id1++]);
		else {
			if (cmp(a[id1].fi, a[id1].se, a[id2].fi, a[id2].se)) b.emplace_back(a[id1++]);
			else b.emplace_back(a[id2++]);
		}
	}
	for(int i = 0;i < sz(b);i++)
		a[l + i] = b[i];
}


vector<pii> solve(int n) {
	vector<pii> a;
	for(int i = 0;i < n;i++) {
		for(int j = i;j < n;j++) a.emplace_back(i, j);
	}
	
	merge_sort(a, 0, (int) a.size() - 1);
	return a;
}