#include <bits/stdc++.h>
#include "sqsort.h"

using namespace std;

map<vector<int>, int> ret;

int ask(int a, int b, int c, int d) {
  if (a > b) swap(a, b);
  if (c > d) swap(c, d);
  if (ret.count({a, b, c, d})) {
    return ret[{a, b, c, d}];
  }
  int x = cmp(a, b, c, d);
  ret[{a, b, c, d}] = ret[{c, d, a, b}] = x;
  return x;
}

const int N = 2000 + 7;
int pos[N];

bool coco(pair<int, int> a, pair<int, int> b) {
  if (pos[a.first] < pos[a.second] && pos[b.first] < pos[b.second]) {
    return 1;
  }
  if (pos[a.first] > pos[a.second] && pos[b.first] > pos[b.second]) {
    return 0;
  }
  return ask(a.first, a.second, b.first, b.second);
}

bool single(int i, int j) {
  return ask(i, i, j, j);
}

vector<pair<int, int>> solve(int n) {
  vector<pair<int, int>> ret;
  for (int i = 0; i < n; i++) {
    for (int j = i; j < n; j++) {
      ret.push_back({i, j});
    }
  }
  vector<int> ord;
  for (int i = 0; i < n; i++) {
    ord.push_back(i);
  }
  sort(ord.begin(), ord.end(), single);
  for (int i = 0; i < n; i++) {
    pos[ord[i]] = i;
  }
  sort(ret.begin(), ret.end(), coco);
  return ret;
}


