#include "sqsort.h"
#include <bits/stdc++.h>
#define pii pair<int,int>
#define all(x) x.begin(),x.end()
#define ft first
#define sd second
#define PB push_back
#define MP make_pair
using namespace std;
const int N = 2010;
vector<pii> vc;
pii empt = MP(-1, -1), st[4 * N];
int nm[N], ptr[N], wh[N], pre[N];

int get(int x) { return (pre[x] == x ? x : pre[x] = get(pre[x])); }

bool CMP(int _x, int _y){
    return cmp(_x, _x, _y, _y);
}

bool CMP2(pii _x, pii _y){
    return cmp(_x.ft, _x.sd, _y.ft, _y.sd);
}

bool chk(int a, int b, int c, int d){
    if (wh[get(a)] <= wh[get(c)] && wh[get(b)] <= wh[get(d)])
        return 1;
    if (wh[get(a)] >= wh[get(c)] && wh[get(b)] >= wh[get(d)])
        return 0;
    return cmp(a, b, c, d);
}

void pull(int v){
    if (st[v + v] == empt)
        st[v] = st[v + v + 1];
    else if (st[v + v + 1] == empt)
        st[v] = st[v + v];
    else if (chk(st[v + v].ft, st[v + v].sd, st[v + v + 1].ft, st[v + v + 1].sd))
        st[v] = st[v + v];
    else st[v] = st[v + v + 1];
}

void build(int v, int l, int r){
    if (l == r){
        st[v] = MP(nm[l], nm[ptr[l]]);
        return;
    }

    int md = (l + r) >> 1;

    build(v + v, l, md);
    build(v + v + 1, md + 1, r);

    pull(v);
}

void update(int v, int l, int r, int ps, pii nw){
    if (l == r){
        st[v] = nw;
        return;
    }

    int md = (l + r) >> 1;

    if (ps <= md)
        update(v + v, l, md, ps, nw);
    else update(v + v + 1, md + 1, r, ps, nw);

    pull(v);
}

vector<pii> solve(int n){
    for (int i = 0; i < n; i++)
        nm[i] = i;

    sort(nm, nm + n, CMP);

//    for (int i = 0; i < n; i++)
//    for (int j = i; j < n; j++)
//        vc.PB({i, j});
//
//    sort(all(vc), CMP2);

    vc.clear();

    // if ptr[i] == n don't add to seg

    for (int i = 0; i < n; i++){
        ptr[i] = i;
        wh[nm[i]] = i;
        pre[i] = i;
    }

    for (int i = 1; i < n; i++)
        if (!cmp(nm[i - 1], nm[i - 1], nm[i], nm[i])){
            pre[get(i)] = get(i - 1);
        }

    build(1, 0, n - 1);

    int need = n * (n + 1) / 2;

    for (int it = 0; it < need; it++){
        pii cur = st[1];
        vc.PB(cur);

//        cerr << cur.ft << " " << cur.sd << '\n';

        int id = wh[cur.ft];

        ptr[id]++;

        if (ptr[id] == n)
            update(1, 0, n - 1, id, empt);
        else update(1, 0, n - 1, id, MP(nm[id], nm[ptr[id]]));
    }

    return vc;
}
