#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define ld long double
#define F first
#define S second
#define pb push_back

const int N = 1e4 + 10;
const int INF = 1e9;
const int MOD = 1e9 + 7;
const int rx[4] = {-1, 0, 1, 0};
const int ry[4] = {0, 1, 0, -1};
const int dx[8] = {-1, -1, -1, 0, 1, 1, 1, 0};
const int dy[8] = {-1, 0, 1, 1, 1, 0, -1, -1};

mt19937 gen(time(0));

int n, k;
int t[N], l[N], pr[N];
bool used[N];

void solve1() {
    ll res = 0;
    for (int mask = 0; mask < (1 << n); mask ++) {
        ll sum = 0;
        for (int i = 0; i < n; i++) {
            if (((mask >> i) & 1) == 1) sum += l[i];
        }
        int kol = n;
        for (int i = 0; i < n; i++) {
            if (((mask >> i) & 1) == 1) {
                if (((mask >> t[i]) & 1) == 1) {
                    kol -= 1 + k;
                } else kol -= 2;
            }
        }
        if (kol >= 0) res = max(res, sum);
    }
    cout << res << endl;
    return;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> k;
    for (int i = 0; i < n; i++) {
        cin >> t[i] >> l[i];
        pr[t[i]] = i;
    }
//    if (n <= 10) {
//        solve1();
//        return 0;
//    }
    int dp[3][n + 1], mx[3][n + 1];
    int res[n + 1];
    vector <int> vec[n + 1];
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            int v = i;
            int nom = i;
            do {
                used[v] = true;
                v = t[v];
                if (l[v] < l[nom]) nom = v;
            } while (v != i);
            for (int i = 0; i < 3; i++) {
                for (int j = 0; j <= n; j++) {
                    dp[i][j] = 0;
                    mx[i][j] = 0;
                    if (!i) res[j] = 0;
                }
            }
            v = nom;
            v = pr[v];
            int h = 2;
            while (v != nom) {
                int prh = h - 1;
                if (prh == -1) prh = 2;
                int prprh = prh - 1;
                if (prprh == -1) prprh = 2;
                for (int i = 0; i <= n; i++) {
                    if (i - 1 - k >= 0) {
                        mx[h][i - 1 - k] = mx[prh][i - 1 - k];
                        dp[h][i - 1 - k] = max(dp[h][i - 1 - k], dp[prh][i] + l[v]);
                        res[i - 1 - k] = max(res[i - 1 - k], dp[h][i - 1 - k]);
                        mx[h][i - 1 - k] = max(mx[h][i - 1 - k], dp[h][i - 1 - k]);
                    }
                    if (i - 2 >= 0) {
                        mx[h][i - 2] = mx[prh][i - 2];
                        dp[h][i - 2] = max(dp[h][i - 2], mx[prprh][i] + l[v]);
                        res[i - 2] = max(res[i - 2], dp[h][i - 2]);
                        mx[h][i - 2] = max(mx[h][i - 2], dp[h][i - 2]);
                    }
                }
                v = pr[v];
                h ++;
                if (h == 3) h = 0;
            }
            for (int i = 0; i < 3; i++) {
                for (int j = 0; j <= n; j++) {
                    dp[i][j] = 0;
                    mx[i][j] = 0;
                }
            }
            nom = pr[nom];
            v = nom;
            v = pr[v];
            h = 2;
            while (v != nom) {
                int prh = h - 1;
                if (prh == -1) prh = 2;
                int prprh = prh - 1;
                if (prprh == -1) prprh = 2;
                for (int i = 0; i <= n; i++) {
                    if (i - 1 - k >= 0) {
                        mx[h][i - 1 - k] = mx[prh][i - 1 - k];
                        dp[h][i - 1 - k] = max(dp[h][i - 1 - k], dp[prh][i] + l[v]);
                        res[i - 1 - k] = max(res[i - 1 - k], dp[h][i - 1 - k]);
                        mx[h][i - 1 - k] = max(mx[h][i - 1 - k], dp[h][i - 1 - k]);
                    }
                    if (i - 2 >= 0) {
                        mx[h][i - 2] = mx[prh][i - 2];
                        dp[h][i - 2] = max(dp[h][i - 2], mx[prprh][i] + l[v]);
                        res[i - 2] = max(res[i - 2], dp[h][i - 2]);
                        mx[h][i - 2] = max(mx[h][i - 2], dp[h][i - 2]);
                    }
                }
                v = pr[v];
                h ++;
                if (h == 3) h = 0;
            }
            for (int i = 0; i <= n; i++) {
                vec[n - i].pb(res[i]);
            }
        }
    }
    if (vec[0].size() == 1) {
        cout << vec[n][0] << endl;
        return 0;
    }
    int ans = 0;
    vector <vector <int> > dp2(2, vector <int> (n + 1, 0));
    for (int i = 0; i < vec[0].size(); i++) {
        for (int j = 0; j <= n; j++) {
            dp2[(i % 2)][j] = dp2[(i - 1) % 2][j];
            for (int h = 1; h <= n && j - h >= 0; h++) {
                dp2[(i % 2)][j] = max(dp2[(i % 2)][j], dp2[(i - 1) % 2][j - h] + vec[h][i]);
            }
            ans = max(ans, dp2[(i % 2)][j]);
        }
    }
    cout << ans << endl;
    return 0;
}
