#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <map>
#include <set>
#include <unordered_set>
#include <unordered_map>



using namespace std;


template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}
template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

#define left left228
#define right right228
#define move move228
#define prev prev228
#define next next228

const int N = 777;
const int INF = 1e9 + 228;

int n, k;
int t[N], L[N];
int dp[N][N * 2][2];

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> k;
	for (int i = 1; i <= n; ++i) {
		cin >> t[i] >> L[i];
		++t[i];
	}

	vector<int> kek;
	kek.emplace_back(0);

	kek.emplace_back(1);
	for (int iter = 0; iter < n - 1; ++iter) {
		int x = kek.back();
		kek.emplace_back(t[x]);
	}

	int shift = n;

	{
		// init dp
		for (int i = 0; i <= n; ++i) {
			for (int j = 0; j <= 2 * n; ++j) {
				dp[i][j][0] = dp[i][j][1] = -INF;
			}
		}

		dp[1][0 + shift][1] = 0;
	}

	for (int i = 1; i < n; ++i) {
		int X = kek[i];
		int Y = kek[i + 1];

		for (int j = -n; j <= n; ++j) {
			for (int alive = 0; alive < 2; ++alive) {
				if (dp[i][j][alive] != -INF) {

					{
						// invade
						// kill Y and praise X
						uax( dp[i + 1][j + shift][0], dp[i][j][alive] + L[X] );
					}

					{
						// die

						uax(dp[i + 1][j + 1 + shift][1], dp[i][j][alive]);
					}

					{
						// not invade not die
						// get from fine

						int lack = 2 * k;

						if (alive) lack -= k;

						uax(dp[i + 1][j - lack + shift][1], dp[i][j][alive] + L[X]);
					}

				}
			}
		}
	}

	int answer = -INF;

	for (int fine = 0; fine <= n; ++fine) {
		uax(answer, dp[n][fine + shift][0]);
		uax(answer, dp[n][fine + shift][1]);

		// cout << "dp[" << n << "][" << fine << "][0]=" << dp[n][fine + shift][0] << endl;
	}

	cout << answer << '\n';



	return 0;
}



/*

8 2
5 12
6 111
4 101
0 13
1 105
7 14
2 108
3 9





*/
