#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <map>
#include <set>
#include <unordered_set>
#include <unordered_map>



using namespace std;


template<typename T> void uin(T &a, T b) {
    if (b < a) a = b;
}
template<typename T> void uax(T &a, T b) {
    if (b > a) a = b;
}

#define int long long
#define left left228
#define right right228
#define move move228
#define prev prev228
#define next next228

const int MOD = 1e9 + 7;

int mod(int x) {
    x %= MOD;
    if (x < 0) x += MOD;
    return x;
}

void add(int &x, int y) {
    x += y;
    if (x >= MOD) x -= MOD;
    if (x < 0) x += MOD;
}

int fp(int a, int b) {
    int res = 1;
    while (b) {
        if (b & 1) {
            res = mod(res * a);
        }
        a = mod(a * a);
        b >>= 1;
    }
    return res;
}

const int N = 55;

int n, m;
int dp[N][N][N][N];
int good[N][N];

void prep() {
    good[1][1] = 0;
    dp[1][1][1][1] = 1;

    good[1][2] = 2;
    dp[1][2][1][1] = 1;

    good[2][1] = 2;
    dp[2][1][1][1] = 1;

    for (int j = 3; j <= m; ++j) {
        // dp[1][j];
        good[1][j] = fp(2, j);
        for (int x = 1; x <= j; ++x) {
            dp[1][j][1][x] = 1;
            good[1][j] = mod(good[1][j] - dp[1][j][1][x] * 2);
        }
    }
    for (int i = 3; i <= n; ++i) {
        // dp[i][1]
        good[i][1] = fp(2, i);
        for (int x = 1; x <= i; ++x) {
            dp[i][1][x][1] = 1;
            good[i][1] = mod(good[i][1] - dp[i][1][x][1] * 2);
        }
    }
    // for (int X = 1; X <= n; ++X) {
    //     for (int Y = X; Y <= m; ++Y) {

    //         if (X == 2 && Y > 1) {
    //             good[X][Y] = fp(2, X * Y);
    //             for (int i = 1; i <= X; ++i) {
    //                 for (int j = 1; j <= Y; ++j) {
    //                     int all = fp(2, (X - 1) * (Y - 1));

    //                     // if (X == 2 && Y == 3 && i == 1 && j == 2) {
    //                     //     cout << "all = " << all << endl;
    //                     // }

    //                     for (int ii = 1; ii < i; ++ii) {
    //                         for (int jj = 1; jj <= Y - 1; ++jj) {
    //                             all = mod(all - dp[X - 1][Y - 1][ii][jj]);
    //                             // if (X == 2 && Y == 3 && i == 1 && j == 2) {
    //                             //     cout << "all -= " << dp[X - 1][Y - 1][ii][jj] << endl;
    //                             // }
    //                             // dp[X][Y][i][j] = mod(dp[X][Y][i][j] + dp[X - 1][Y - 1][ii][jj]);
    //                         }
    //                     }

    //                     dp[X][Y][i][j] = all;

    //                     // if (i == 1 && j == 2 && Y == 2) {
    //                     //     dp[X][Y][i][j] -= 1;
    //                     // }

    //                     good[X][Y] = mod(good[X][Y] - dp[X][Y][i][j] * 2);
    //                 }
    //             }
    //         }
    //     }
    // }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n >> m;

    if (n > m) swap(n, m);


    prep();

    for (int X = 2; X <= n; ++X) {
        for (int Y = X; Y <= m; ++Y) {
            if (Y - X != m - n) continue;

            if (X == 2) {
                if (Y == 2) {
                    dp[X][Y][1][1] = 2;
                    dp[X][Y][1][2] = 2;
                    dp[X][Y][2][1] = 1;
                    dp[X][Y][2][2] = 1;
                } else {
                    good[X][Y] = fp(2, X * Y);
                    for (int j = 1; j <= Y; ++j) {
                        dp[X][Y][1][j] = fp(2, Y - 1);
                        dp[X][Y][2][j] = mod(fp(2, Y - 1) - Y + 1);
                        good[X][Y] = mod(good[X][Y] - 2 * dp[X][Y][1][j] - 2 * dp[X][Y][2][j]);
                    }
                }
            } else {

                good[X][Y] = fp(2, X * Y);
                for (int i = 1; i <= X; ++i) {
                    for (int j = 1; j <= Y; ++j) {
                        int all = fp(2, (X - 1) * (Y - 1));

                        for (int ii = 1; ii < i; ++ii) {
                            for (int jj = 1; jj <= Y - 1; ++jj) {
                                all = mod(all - dp[X - 1][Y - 1][ii][jj]);
                                // dp[X][Y][i][j] = mod(dp[X][Y][i][j] + dp[X - 1][Y - 1][ii][jj]);
                            }
                        }

                        dp[X][Y][i][j] = mod(dp[X][Y][i][j] + all);

                        good[X][Y] = mod(good[X][Y] - dp[X][Y][i][j] * 2);
                    }
                }
            }
        }
    }
    cout << good[n][m] << endl;
    // for (int i = 1; i <= n; ++i) {
    //     for (int j = 1; j <= m; ++j) {
    //         cout << dp[n][m][i][j] << ' ';
    //     }
    //     cout << endl;
    // }
    return 0;
}





/*
my login = A10180
my password = NJSTLGIT
*/