#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <map>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include "sqsort.h"



using namespace std;


template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}
template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

#define left left228
#define right right228
#define move move228
#define prev prev228
#define next next228




vector< pair<int, int> > solve(int n) {
	vector< pair<int, int> > v;
	for (int i = 1; i <= n; ++i) {
		for (int j = i; j <= n; ++j) {
			v.emplace_back(i, j);
		}
	}

	int sz = (int)v.size();

	for (int it = 0; it < sz - 1; ++it) {
		bool sorted = true;
		for (int i = 0; i < sz - 1; ++i) {
			if (!cmp(v[i].first, v[i].second, v[i + 1].first, v[i + 1].second)) {
				swap(v[i], v[i + 1]);
				sorted = false;
			}
		}
		if (sorted) {
			break;
		}
	}
	return v;
}






// signed main() {
// 	ios_base::sync_with_stdio(false);
// 	cin.tie(0);
// 	return 0;
// }



/*

8 2
5 12
6 111
4 101
0 13
1 105
7 14
2 108
3 9


6 2
1 10
2 20
3 20
4 30
5 30
0 0






*/
