#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("Ofast")

#define ff first
#define ss second
#define pb push_back
#define all(x) x.begin(), x.end()

using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef pair <int, int> pii;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

int get(int mask, int x, int y, int m){
    int s = x * m + y;
    return 1&(mask>>s);
}

int cntr[5], cntc[5];
bool check(int mask, int n, int m){
    fill(cntr, cntr + 5, 0);
    fill(cntc, cntc + 5, 0);
    for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            cntr[i] += get(mask, i, j, m);
            cntc[j] += get(mask, i, j, m);
        }
    }
    for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
//            int can = 0;
//            for (int k = 0; k < m; k++){
//                if (k == j) continue;
//                if (get(mask, i, j, m) == get(mask, i, k, m))
//                    can = 1;
//            }
//            for (int k = 0; k < n; k++){
//                if (k == i) continue;
//                if (get(mask, i, j, m) == get(mask, k, j, m))
//                    can = 1;
//            }
//            if (!can)
//                return false;
            if (get(mask, i, j, m)){
                if (cntr[i] == cntc[j] && cntr[i] == 1)
                    return false;
            }else{
                if (n - 1 == cntc[j] && cntr[i] == m - 1)
                    return false;
            }
        }
    }
    return true;
}

int solve(int n, int m){
    int ans = 0;
    int len = n * m;
    for (int mask = 0; mask < (1<<len); mask++){
        if (check(mask, n, m)){
            ans++;
        }
    }
    return ans;
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int x, y;
    cin >> x >> y;
    cout << solve(x, y);
    return 0;
}
