#include <bits/stdc++.h>
#include "sqsort.h"
#define ff first
#define ss second
#define pb push_back
#define all(x) x.begin(), x.end()

using namespace std;
typedef long long ll;
typedef pair <int, int> pii;

const int N = 2000 + 3;
int pos[N], H;
vector <int> v[N];
//
bool can(int x, int y){
    if (x == y) return true;
    for (auto u: v[x])
        if (can(u, y)) return true;
    return false;
}

bool comp(pii a, pii b){
    if (max(pos[a.ff], pos[a.ss]) <= min(pos[b.ff], pos[b.ss])) return true;
    if (min(pos[a.ff], pos[a.ss]) >= max(pos[b.ff], pos[b.ss])) return false;
    return cmp(a.ff, a.ss, b.ff, b.ss);
}

bool comp3(pii a, pii b){
    int ans = cmp(a.ff, a.ss, b.ff, b.ss);
    return ans;
}

bool comp2(int x, int y){
    int ans = -1;
    if (can(x, y)) ans = 1;
    else if (can(y, x)) ans = 0;
    if (ans == -1){
        ans = cmp(x, x, y, y);
        if (ans) v[x].pb(y);
    }
    return ans;
}

vector <pii> solve1(int n){
    vector <pii> ans;
    vector <int> v;

    for (int i = 0; i < n; i++) v.pb(i);
    sort(all(v), comp2);
    for (int i = 0; i < v.size(); i++)
        pos[v[i]] = i;

    for (int i = 0; i < n; i++){
        for (int j = i; j < n; j++){
            ans.pb({i, j});
        }
    }
    sort(all(ans), comp);

    return ans;///9732997
    ///57175
}


vector <pii> solve2(int n){
    vector <pii> ans;
    for (int i = 0; i < n; i++){
        for (int j = i; j < n; j++){
            ans.pb({i, j});
        }
    }
    H = n;
    sort(all(ans), comp3);
    return ans;
}

vector <pii> solve(int n){
    if (n <= 150) return solve1(n);
    return solve2(n);
}
