
/*######  /##   /## /######## /######## /######## /######## /######## /########  /######
| ##__  ##| ##  | ##|_____ ## |_____ ## |_____ ## |_____ ## |_____ ## |_____ ##  /##__  ##
| ##  \ ##| ##  | ##     /##/      /##/      /##/      /##/      /##/      /##/ | ##  \ ##
| #######/| ##  | ##    /##/      /##/      /##/      /##/      /##/      /##/  | ########
| ##__  ##| ##  | ##   /##/      /##/      /##/      /##/      /##/      /##/   | ##__  ##
| ##  \ ##| ##  | ##  /##/      /##/      /##/      /##/      /##/      /##/    | ##  | ##
| ##  | ##|  ######/ /######## /######## /######## /######## /######## /########| ##  | ##
|__/  |__/ \______/ |________/|________/|________/|________/|________/|________/|__/  |_*/

#include <bits/stdc++.h>

#define pb push_back
#define f first
#define s second
#define ios ios_base::sync_with_stdio(0); cin.tie(0);
#define open(name1, name2) freopen(name1, "r", stdin); freopen(name2, "w", stdout);
using namespace std;
typedef long long ll;
typedef long double ld;
mt19937_64 rnd(time(nullptr));

#define int ll

//#pragma comment(linker, "/stack:200000000")
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

const int N = 1e4;
int n, k, l[N], t[N];

void input() {
    cin >> n >> k;
    for (int i = 0; i < n; i++)
        cin >> t[i] >> l[i];
}

void generate() {
    n = rnd() % 10 + 1;
    k = rnd() % n + 1;
    int pos = rnd() % n;
    for (int i = 0; i < n; i++) {
        t[i] = (i - 1 + n) % n;
        if (i == pos)
            l[i] = 0;
        else
            l[i] = rnd() % 100 + 1;
    }
}

int solve_1() {
    int ans = 0;
    for (int mask = 0; mask < (1 << n); mask++) {
        int sum = 0, kolvo = 0;
        for (int i = 0; i < n; i++) {
            if ((1 << i) & mask) {
                sum += l[i];
                kolvo++;
            }
        }
        int cnt = 0;
        for (int i = 0; i < n; i++) {
            if (!((1 << t[i]) & mask) && ((1 << i) & mask))
                cnt++;
        }
        if (int(kolvo - cnt) * k <= n - int(kolvo) - cnt) {
            ans = max(ans, sum);
        }
    }
    return ans;
}

vector<int> por, g[N];

void dfs(int v, int p) {
    por.pb(v);
    for (auto u : g[v]) {
        if (u == p)
            continue;
        dfs(u, p);
    }
}

int solve_2_3() {
    for (int i = 0; i < n; i++)
        g[t[i]].pb(i);
    for (int i = 0; i < n; i++) {
        if (l[i] == 0) {
            dfs(i, i);
            break;
        }
    }
    int dp[n][n + 1][2];
    for (int i = 0; i < n; i++)
        for (int j = 0; j <= n; j++)
            for (int k = 0; k < 2; k++)
                dp[i][j][k] = 0;
    for (int i = 1; i < n; i++) {
        for (int j = 0; j <= i + 1; j++) {
            if (j)
                dp[i][j][0] = max(dp[i - 1][j - 1][0], dp[i - 1][j - 1][1]);
            dp[i][j][1] = dp[i - 1][j + 1][0] + l[por[i]];
            if (j >= k + 1) {
                dp[i][j][1] = max(dp[i][j][1], dp[i - 1][j - 1 - k][0] + l[por[i]]);
            }
        }
    }
    int ans = 0;
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j < 2; j++)
            ans = max(ans, dp[n - 1][i][j]);
    }
    return ans;
}

void solve() {
    input();
    if (n <= 10)
        cout << solve_1() << endl;
    else
        cout << solve_2_3() << endl;
//    while (true) {
//        generate();
//        int f = solve_1();
//        int s = solve_2_3();
//        if (f != s) {
//            cout << f << ' ' << s << endl;
//            cout << n << ' ' << k << endl;
//            for (int i = 0; i < n; i++) {
//                cout << t[i] << ' ' << l[i] << endl;
//            }
//            return;
//        }
}

}

signed main() {
    ios;
//    open("anime.in", "anime.out");
    int attempts = 1;
//    cin >> attempts;
    cout.precision(16);
    while (attempts--) {
        solve();
    }
    return 0;
}