
/*######  /##   /## /######## /######## /######## /######## /######## /########  /######
| ##__  ##| ##  | ##|_____ ## |_____ ## |_____ ## |_____ ## |_____ ## |_____ ##  /##__  ##
| ##  \ ##| ##  | ##     /##/      /##/      /##/      /##/      /##/      /##/ | ##  \ ##
| #######/| ##  | ##    /##/      /##/      /##/      /##/      /##/      /##/  | ########
| ##__  ##| ##  | ##   /##/      /##/      /##/      /##/      /##/      /##/   | ##__  ##
| ##  \ ##| ##  | ##  /##/      /##/      /##/      /##/      /##/      /##/    | ##  | ##
| ##  | ##|  ######/ /######## /######## /######## /######## /######## /########| ##  | ##
|__/  |__/ \______/ |________/|________/|________/|________/|________/|________/|__/  |_*/

#include <bits/stdc++.h>

#define pb push_back
#define f first
#define s second
#define ios ios_base::sync_with_stdio(0); cin.tie(0);
#define open(name1, name2) freopen(name1, "r", stdin); freopen(name2, "w", stdout);
using namespace std;
typedef long long ll;
typedef long double ld;
mt19937_64 rnd(time(nullptr));

#define int ll

//#pragma comment(linker, "/stack:200000000")
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

const int mod = 1e9 + 7;

int fact(int kolvo) {
    int ans = 1;
    for (int i = 1; i <= kolvo; i++) {
        ans *= i;
        ans %= mod;
    }
    return ans;
}

int fastpow(int a, int b) {
    if (b == 0)
        return 1;
    int ans = fastpow(a, b / 2);
    ans *= ans;
    ans %= mod;
    if (b % 2)
        ans *= a;
    ans %= mod;
    return ans;
}

int kso(int kolvo, int n, int m) {
    int ans = 1;
    int cnt = 0;
    for (int i = 1; i <= kolvo; i++) {
        if (n * m - (i - 1) * (n + m - 1) + cnt <= 0)
            return 0;
        ans *= n * m - (i - 1) * (n + m - 1) + cnt;
        ans %= mod;
        if (i >= 2)
            cnt += 2 * (i - 1);
    }
    ans *= fastpow(fact(kolvo), mod - 2);
    ans %= mod;
    return ans;
}

int sv(int kolvo, int n, int m) {
    int ans = n * m;
    for (int i = 1; i <= kolvo; i++) {
        ans -= n + m - 1 - (i - 1) * 2;
    }
    return ans;
}

void solve() {
    int n, m;
    cin >> n >> m;
    if (n == 2 && m == 2) {
        cout << 6 << endl;
        return;
    }
    int answer = 0;
    for (int kolvo = 1; kolvo <= n * m; kolvo++) {
        int kolvo_sp_once = kso(kolvo, n, m);
        int svobod = sv(kolvo, n, m);
        if (kolvo_sp_once == 0)
            break;
        if (kolvo % 2)
            answer += kolvo_sp_once * fastpow(2, svobod) % mod;
        else
            answer -= kolvo_sp_once * fastpow(2, svobod) % mod;
        answer += mod;
        answer %= mod;
    }
    int last = answer * 2;
    last %= mod;
    if (m == 2) {
        last -= n * 2;
        last += mod;
        last %= mod;
    }
    if (n == 2) {
        last -= m * 2;
        last += mod;
        last %= mod;
    }
    last = (fastpow(2, n * m) - last + mod) % mod;
    cout << last << endl;
}

signed main() {
    ios;
//    open("anime.in", "anime.out");
    int attempts = 1;
//    cin >> attempts;
    cout.precision(16);
    while (attempts--) {
        solve();
    }
    return 0;
}