#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,abm,mmx,popcnt")
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ldb;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, k;
    cin >> n >> k;
    vector<int> t(n), l(n);
    for (int i = 0; i < n; i++) {
        cin >> t[i] >> l[i];
    }
    vector<int> revt(n);
    for (int i = 0; i < n; i++) {
        revt[t[i]] = i;
    }
    int ans = 0;
    for (int mask = 0; mask < (1 << n); mask++) {
        bool bad = false;
        int cur_cost = 0;
        int nott = 0;
        int need = 0;
        for (int i = 0; i < n; i++) {
            if (mask & (1 << i)) {
                cur_cost += l[i];
                if (mask & (1 << revt[i])) {
                    need += k;
                }
                if ((mask & (1 << t[i]))==0)
                    nott--;
            } else {
                nott++;
            }
        }
        if (bad)
            continue;

        if (need <= nott)
            ans = max(ans, cur_cost);
    }
    cout << ans << endl;
}


/*
8 2
5 12
6 111
4 101
0 13
1 105
7 14
2 108
3 9
*/
