#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,abm,mmx,popcnt")
#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;
typedef long double ldb;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    int ans = 0;
    for (int mask = 0; mask < (1 << (n * m)); mask++) {
        vector<vector<int>> arr(n, vector<int> (m));
        for (int i = 0; i < n * m; i++) {
            if (mask & (1 << i)) {
                arr[i / m][i % m] = 1;
            }
        }
        bool bad = false;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                int cnt1 = 0;
                for (int i1 = 0; i1 < n; i1++) {
                    if (i1 == i)
                        continue;
                    if (arr[i][j] == arr[i1][j])
                        cnt1++;
                }
                for (int j1 = 0; j1 < m; j1++) {
                    if (j1 == j)
                        continue;
                    if (arr[i][j] == arr[i][j1]) {
                        cnt1++;
                    }
                }
                if (!cnt1) {
                    bad = true;
                    break;
                }
            }
            if (bad)
                break;
        }
        if (!bad)
            ans++;
    }
    cout << ans << endl;
}
