#include <bits/stdc++.h>
using namespace std;

const int MAXN = 3e4, INF = 1e9;
int t[MAXN], l[MAXN];
int n, k;

void slow() {
    int ans = 0;
    for (int mask = 0; mask < (1 << n); ++mask) {
        vector<int> used(n, 0);
        int c = 0, sum = 0;
        for (int i = 0; i < n; ++i) {
            if (mask & (1 << i)) {
                c++;
                sum += l[i];
                used[i] = used[t[i]] = 1;
            }
        }
        int cnt = 0;
        for (int i = 0; i < n; ++i) {
            cnt += used[i];
        }
        if (c * 2 * k - cnt * k <= n - cnt) {
            ans = max(ans, sum);
        }
    }
    cout << ans;
    exit(0);
}

const int MAXS = 1e4 + 10;
int dp[MAXS][MAXS][2][2];
int used[MAXS];

vector<int> get_p(int s) {
    vector<int> p;
    int v = t[s];
    p.push_back(s);
    used[s] = 1;
    while (v != s) {
        used[v] = 1;
        p.push_back(v);
        v = t[v];
    }
    return p;
}

main() {
    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        cin >> t[i] >> l[i];
    }
    /**if (n <= 10) {
        slow();
    }*/
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= n; ++j) {
            for (int st = 0; st < 2; ++st) {
                for (int t = 0; t < 2; ++t) {
                    dp[i][j][st][t] = -INF;
                }
            }
        }
    }
    dp[0][n][0][0] = 0;
    dp[0][n][1][0] = 0;
    vector<int> p;
    vector<int> fns;
    fns.push_back(0);
    for (int s = 0; s < n; ++s) {
        if (!used[s]) {
            auto v = get_p(s);
            for (auto elem : v) {
                p.push_back(elem);
            }
            fns.push_back(p.size());
        }
    }
    int cur = 1;
    for (int i = 1; i <= p.size(); ++i) {
        for (int j = 0; j <= n; ++j) {
            for (int st = 0; st < 2; ++st) {
                if (i > fns[cur]) {
                    cur++;
                }
                if (i == fns[cur]) {
                    int x = max(dp[i - 1][j][st][0], dp[i - 1][j][st][1]);
                    dp[i][j][0][0] = max(dp[i][j][0][0], x);
                    dp[i][j][1][0] = max(dp[i][j][1][0], x);
                    if (j + 2 <= n) {
                        dp[i][j][st][0] = max(dp[i][j][st][0], dp[i - 1][j + 2][0][0] + l[p[i - 1]]);
                    }
                    if (j + k + 1 <= n) {
                        dp[i][j][st][0] = max(dp[i][j][st][0], dp[i - 1][j + k + 1][1][0] + l[p[i - 1]]);
                        dp[i][j][st][0] = max(dp[i][j][st][0], dp[i - 1][j + k + 1][0][1] + l[p[i - 1]]);
                    }
                    if (j + 2 * k <= n) {
                        dp[i][j][st][0] = max(dp[i][j][st][0], dp[i - 1][j + 2 * k][1][1] + l[p[i - 1]]);
                    }
                } else {
                    dp[i][j][st][0] = max(dp[i - 1][j][st][0], dp[i - 1][j][st][1]);
                    if (st == 1 && i == fns[cur - 1] + 1) {
                        dp[i][j][st][0] = -INF;
                    }
                    if (j + 2 <= n) {
                        dp[i][j][st][1] = max(dp[i][j][st][1], dp[i - 1][j + 2][st][0] + l[p[i - 1]]);
                    }
                    if (j + k + 1 <= n) {
                        dp[i][j][st][1] = max(dp[i][j][st][1], dp[i - 1][j + k + 1][st][1] + l[p[i - 1]]);
                    }
                    if (st == 0 && i == fns[cur - 1] + 1) {
                        dp[i][j][st][1] = -INF;
                    }
                }
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int st = 0; st < 2; ++st) {
            for (int t = 0; t < 2; ++t) {
                ans = max(ans, dp[n][i][st][t]);
            }
        }
    }
    cout << ans;
    return 0;
}
/**
4 2
3 111
2 101
0 105
1 108
*/
