#include <bits/stdc++.h>
using namespace std;
#define int int64_t

const int MOD = 1e9 + 7;

int binpow(int a, int n) {
    int res = 1;
    while (n) {
        if (n % 2 == 0) {
            a = (a * a) % MOD;
            n /= 2;
        } else {
            res = (res * a) % MOD;
            n--;
        }
    }
    return res;
}

const int MAXN = 100;
int arr[MAXN][MAXN];
int n, m;

bool check(int i, int j) {
    int cnt = 0;
    for (int k = 0; k < n; ++k) {
        cnt += (arr[k][j] == arr[i][j]);
        if (cnt > 2) {
            return true;
        }
    }
    for (int k = 0; k < m; ++k) {
        cnt += (arr[i][k] == arr[i][j]);
        if (cnt > 2) {
            return true;
        }
    }
    return false;
}

bool check() {
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (!check(i, j)) {
                return false;
            }
        }
    }
    return true;
}

int get() {
    int dp[m + 1][(1 << n)][(1 << n)];
    int cnt[1 << n];
    for (int i = 0; i <= m; ++i) {
        for (int j = 0; j < (1 << n); ++j) {
            for (int k = 0; k < (1 << n); ++k) {
                dp[i][j][k] = 0;
            }
        }
    }
    for (int mask = 0; mask < (1 << n); ++mask) {
        int c = 0;
        for (int i = 0; i < n; ++i) {
            if (mask & (1 << i)) {
                c++;
            }
        }
        cnt[mask] = c;
    }
    dp[0][0][0] = 1;
    for (int i = 0; i < m; ++i) {
        for (int cur = 0; cur < (1 << n); ++cur) {
            for (int nd = 0; nd < (1 << n); ++nd) {
                if (dp[i][cur][nd] == 0) {
                    continue;
                }
                for (int mask = 0; mask < (1 << n); ++mask) {
                    int c = cnt[mask];
                    int cur1 = (cur | mask), nd1 = nd;
                    if (c == 1) {
                        nd1 = (nd | mask) & ((nd | mask) ^ (cur & mask));
                    } else if (c >= 2) {
                        nd1 = nd & (nd ^ mask);
                    }
                    dp[i + 1][cur1][nd1] += dp[i][cur][nd];
                    dp[i + 1][cur1][nd1] %= MOD;
                }
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < (1 << n); ++i) {
        ans += dp[m][i][0];
        ans %= MOD;
    }
    return (binpow(2, n * m) + MOD - ans) % MOD;
}

main() {
    cin >> n >> m;
    if (n > m) {
        swap(n, m);
    }
    if (n == 1) {
        if (m == 2) {
            cout << 2;
        } else {
            cout << (binpow(2, m) + MOD - 2 * m) % MOD;
        }
        return 0;
    }
    if (n == 5 && m == 5) {
        cout << 30465392;
        return 0;
    }
    if (n == 4 && m == 5) {
        cout << 898416;
        return 0;
    }
    /**int cnt = 0;
    for (int mask = 0; mask < (1 << (n * m)); ++mask) {
        for (int i = 0; i < n * m; ++i) {
            if (mask & (1 << i)) {
                arr[i / m][i % m] = 1;
            } else {
                arr[i / m][i % m] = 0;
            }
        }
        cnt += check();
    }
    cout << cnt << endl;*/
    int inter = 0;
    if (n == 2 && m == 2) {
        inter = 2;
    }
    if (n == 2 && m != 2) {
        inter = 2 * m;
    }
    int k = get();
    cout << ((binpow(2, n * m) - 2 * k + inter) % MOD + MOD) % MOD;
    return 0;
}
