#include <bits/stdc++.h>
using namespace std;
#define int int64_t

const int MOD = 1e9 + 7;

int binpow(int a, int n) {
    int res = 1;
    while (n) {
        if (n % 2 == 0) {
            a = (a * a) % MOD;
            n /= 2;
        } else {
            res = (res * a) % MOD;
            n--;
        }
    }
    return res;
}

const int MAXN = 100;
int arr[MAXN][MAXN];
int n, m;

int f(int k) {
    int ans = 1;
    for (int i = 0; i < k; ++i) {
        ans = (ans * (n - i) * (m - i)) % MOD;
    }
    for (int i = 1; i <= k; ++i) {
        ans = (ans * binpow(i, MOD - 2)) % MOD;
    }
    ans *= binpow(2, (n - k) * (m - k));
    return ans % MOD;
}

int get() {
    int ans = 0;
    int k = 1;
    for (int i = 1; i <= min(n, m); ++i) {
        ans += k * f(i);
        k *= -1;
    }
    return ans;
}

main() {
    cin >> n >> m;
    if (n > m) {
        swap(n, m);
    }
    if (n == 1) {
        if (m == 2) {
            cout << 2;
        } else {
            cout << (binpow(2, m) + MOD - 2 * m) % MOD;
        }
        return 0;
    }
    int inter = 0;
    if (n == 2 && m == 2) {
        inter = 2;
    }
    if (n == 2 && m != 2) {
        inter = 2 * m;
    }
    int k = get();
    cout << ((binpow(2, n * m) - 2 * k + inter) % MOD + MOD) % MOD;
    return 0;
}
