#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>
#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,sse4")
//#define int long long
#define pii pair<int, int>
#define x first
#define y second
#define all(a) (a.begin()), (a.end())
#define endl "\n"

using namespace std;

const int N = 1e4 + 10;
const int inf = 1e18 + 10;

int n, k;
int p[N];
int a[N];
int has[N];
int cnt[N];
int type[N];
int pws[N];

void samples()
{
}

int solve()
{
	int res = 0;
	fill(cnt, cnt + n, 1);

	for(int i = 0; i < n; ++i)
		if (type[i] == 2)
		{
			++cnt[i];
			--cnt[has[i]];
		}

	for(int i = 0; i < n; ++i)
		if (type[i] == 1 && !cnt[i])
		{
			++cnt[i];
			--cnt[has[i]];
		}

	for (int i = 0; i < n; ++i)
		if (type[i] == 1 && !cnt[i])
			return 0;

	for (int i = 0; i < n; ++i)
		if (type[i] == 2 && cnt[i] != 2)
			return 0;

	for (int i = 0; i < n; ++i)
		if(type[i] == 2)
			res += a[i];
	
	int freecnt = 0;

	for (int i = 0; i < n; ++i)
		if (type[i] == 0)
			freecnt += cnt[i];

	for(int i = 0; i < n; ++i)
		if (type[i] == 1)
		{
			freecnt -= k;
			res += a[i];
		}

	if (freecnt < 0)
		return 0;

	vector<int> vals;

	for (int i = 0; i < n; ++i)
		if (type[i] == 0)
			vals.push_back(a[i]);

	sort(all(vals), greater<int>());

	for (auto it : vals)
	{
		if (freecnt < k * 2)
			break;

		freecnt -= k * 2;
		res += it;
	}

	return res;
}

int32_t main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	cin >> n >> k;

	for (int i = 0; i < n; ++i)
	{
		int ind, val;
		cin >> ind >> val;

		p[i] = ind;
		has[p[i]] = i;
		a[i] = val;
	}

	pws[0] = 1;

	for (int i = 1; i <= n; ++i)
		pws[i] = pws[i - 1] * 3;

	samples();

	int ans = 0;

	for (int i = 0; i < pws[n]; ++i)
	{
		int val = i;

		for (int i = n - 1; i >= 0; --i)
		{
			type[i] = val / pws[i];
			val %= pws[i];
		}

		ans = max(ans, solve());
	}

	cout << ans << endl;
}

