#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>
#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,sse4")
//#define int long long
#define pii pair<int, int>
#define x first
#define y second
#define all(a) (a.begin()), (a.end())

using namespace std;

const int N = 52;
const int B = 1e5 + 10;
const int mod = 1e9 + 7;

int n, m;
int cntr[N][2];
int cntc[N][2];

vector<int> anses = { 0,
2,
2,
8,
22,
2,
6,
34,
160,
754,
2,
34,
284,
2800,
25928,
8,
160,
2800,
51120,
898416,
22,
754,
25928,
898416,
30465392 };

inline int get(int msk, int i, int j)
{
	return 1ll & (msk >> (i * m + j));
}

bool check(int msk)
{
	for (int i = 0; i < n; ++i)
		cntr[i][0] = cntr[i][1] = 0;

	for (int i = 0; i < m; ++i)
		cntc[i][0] = cntc[i][1] = 0;

	for(int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j)
		{
			int val = get(msk, i, j);
			++cntc[j][val];
			++cntr[i][val];
		}

	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j)
			if ((cntr[i][1] == 1 && cntc[j][1] == 1 && get(msk, i, j) == 1) || (cntr[i][0] == 1 && cntc[j][0] == 1 && get(msk, i, j) == 0))
				return false;

	return true;
}

int solve()
{
	int ans = 0;

	for (int msk = 0; msk < (1ll << (n * m)); ++msk)
	{
		if (check(msk))
			++ans;
	}

	return ans;
}

int32_t main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	
	cin >> n >> m;

	cout << (anses[(n - 1) * 5 + m - 1] % mod) << endl;

	//cout << (solve() % mod) << endl;

	/*
	for(int i = 1; i <= 5; ++i)
		for (int j = 1; j <= 5; ++j)
		{
			n = i;
			m = j;
			cout << solve() << "," << endl;
		}*/
}


