#include <bits/stdc++.h>
#include "sqsort.h"
//#define int long long
#define ll long long
#define fr(i,x,y) for(int i=x;i<y;i++)
#define rfr(i,x,y) for(int i=x;i>=y;i--)
const int N=1e6,M=1e3,INF=2e9;
using namespace std;

/*
static const int HARD_LIMIT = 50000000;

static int n;
static std::vector<int> a;

static bool valid_pos(int i) {
	return 0 <= i && i < n;
}

static int Q;
bool cmp(int a_, int b, int c, int d) {
	if(!valid_pos(a_) || !valid_pos(b) || !valid_pos(c) || !valid_pos(d)) {
		std::cout << "Invalid query." << std::endl;
		std::cout << -1 << std::endl;
		exit(0);
	}

	Q++;
	if(Q > HARD_LIMIT) {
		std::cout << "Too many queries." << std::endl;
		std::cout << -1 << std::endl;
		exit(0);
	}

	return a[a_] + a[b] < a[c] + a[d];
}

static bool check_valid(const std::vector<std::pair<int, int>> &a) {
	if(n * (n + 1) / 2 != (int)a.size()) {
		return false;
	}

	std::vector<std::vector<bool>> used(n, std::vector<bool>(n, false));
	for(int i = 0; i < (int)a.size(); i++) {
		if(!valid_pos(a[i].first) || !valid_pos(a[i].second) || used[a[i].first][a[i].second]) {
			return false;
		}

		used[a[i].first][a[i].second] = true;
		used[a[i].second][a[i].first] = true;
	}

	return true;
}*/



mt19937 rnd(time(0));
struct ver
{
    ver *left=nullptr,*right=nullptr;
    int priority=rnd();
    int size=1;
    pair<int,int> con={0,0};
    void update()
    {
        size=1;
        if(left!=nullptr)size+=left->size;
        if(right!=nullptr)size+=right->size;
    }
};
ver* merge(ver *a,ver *b)
{
    if(a==nullptr)return b;
    if(b==nullptr)return a;
    if(a->priority>b->priority)
    {
        a->right=merge(a->right,b);
        a->update();
        return a;
    }
    else
    {
        b->left=merge(a,b->left);
        b->update();
        return b;
    }
}
pair<ver*,ver*> split(ver *a,int x,int num)
{
    if(a==nullptr)return {nullptr,nullptr};
    //cout<<a->con.first<<' '<<a->con.second<<' '<<num<<'\n';
    if(a->right!=nullptr)num-=a->right->size;
    //cout<<a->con.first<<' '<<a->con.second<<' '<<num<<'\n';
    pair<ver*,ver*> res={nullptr,nullptr};
    if(num<x)
    {
        if(a->right!=nullptr)num+=a->right->size;
        res.first=a;
        auto q=split(a->right,x,num);
        res.first->right=q.first;
        res.second=q.second;
    }
    else
    {
        res.second=a;
        auto q=split(a->left,x,num-1);
        res.second->left=q.second;
        res.first=q.first;
    }
    if(res.first!=nullptr)res.first->update();
    if(res.second!=nullptr)res.second->update();
    return res;
}
/*ver* fnd(ver* a,int x,int num)
{
    if(a->right!=nullptr)num-=a->right->size;
    if(num==x)return a;
    if(num<x)
    {
        if(a->right!=nullptr)num+=a->right->size;
        return fnd(a->right,x,num);
    }
    if(num>x)
    {
        return fnd(a->left,x,num-1);
    }
}*/
int fnd(ver* a,ver* ad,int num)
{
    if(a==nullptr)return -1;
    if(a->right!=nullptr)num-=a->right->size;
    if(cmp(a->con.first,a->con.second,ad->con.first,ad->con.second))
    {
        if(a->right!=nullptr)num+=a->right->size;
        int q=fnd(a->right,ad,num);
        return q;
    }
    else
    {
        int q=fnd(a->left,ad,num-1);
        if(q==-1)return num;
        else return q;
    }
}


/*void vuvod(ver* a)
{
    if(a==nullptr)return;
    vuvod(a->left);
    res.push_back(a->con);
    vuvod(a->right);
}*/
bool comp(pair<int,int> a,pair<int,int> b)
{
    return cmp(a.first,a.second,b.first,b.second);
}
vector<pair<int,int> > solve(int n)
{
    vector<pair<int,int> > res;
    fr(i,0,n)
    {
        fr(j,i,n)
        {
            res.push_back({i,j});
        }
    }
    sort(res.begin(),res.end(),comp);
    return res;
}


/*
int main() {
	std::cin >> n;
	a.resize(n);
	for(int i = 0; i < n; i++) {
		a[i]=rnd()%100;
	}

	Q = 0;
	std::vector<std::pair<int, int>> ret = solve(n);

	if(!check_valid(ret)) {
		std::cout << "Invalid output." << std::endl;
		std::cout << -1 << std::endl;
		return 0;
	}

	for(int i = 1; i < (int) ret.size(); i++) {
		if(a[ret[i].first] + a[ret[i].second] < a[ret[i - 1].first] + a[ret[i - 1].second]) {
			std::cout << "Output not sorted." << std::endl;
			std::cout << -1 << std::endl;
			return 0;
		}
	}

	std::cout << "Correct!" << std::endl;
	std::cout << Q << std::endl;
	return 0;
}
*/
