#include<iostream>
#include<cmath>
#include<map>
#include<algorithm>
#include<set>
#include<iomanip>
#include<vector>
#include "sqsort.h"

#define sz(x) x.size()
#define all(x) (x).begin(), (x).end()
#define pb push_back
#define f first
#define s second
#define vec vector
#define pii pair<int, int>
#define FOR(i, n) for(int (i) = 0; (i) < (n); (i)++)

using namespace std;

const int mod = 1e9 + 7;

vec<pii> solve(int n)
{
    vec<pii> ans;

    FOR(i, n)
    {
        for(int j = i; j < n; j++)
        {
            ans.pb({i, j});
        }
    }

    FOR(i, sz(ans))
    {
        for(int j = i + 1; j < sz(ans); j++)
        {
            bool k = cmp(ans[i].f, ans[i].s, ans[j].f, ans[j].s);

            if(!k)
            {
                swap(ans[i], ans[j]);
            }
        }
    }

    return ans;

}
