#include"sqsort.h"
#include<bits/stdc++.h>
using namespace std;
#define INIT  ios_base :: sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
#define mp make_pair
#define pb push_back
#define ft first
#define sc second
#define ll long long
#define pii pair<int, int>
#define count_bits __builtin_popcount





mt19937 rng(unsigned(time(0)));




//int n;

//bool v[2010];

//int ord[2010];

//int a[2010];




struct it{
    int y, sz;
    pii x;
    it *l, *r;

    it(int y, pii x){
        this->y=y;
        this->x=x;
        this->sz=1;
        this->l=NULL;
        this->r=NULL;
    }


} *R;


int szof(it *t){
    if(!t){return 0;}
    return t->sz;
}


void recalc(it *&t){
if(!t){return;}
    t->sz=szof(t->l)+szof(t->r)+1;
}




void split(it *t, it*&l, it*&r, int pos, int add){
        if(!t){l=r=0; return;}
        recalc(t);
        int cr=szof(t->l)+1+add;
        if(cr<=pos){
            split(t->r, t->r, r, pos, cr); l=t; recalc(l);
        }
        else{
            split(t->l, l, t->l, pos, add); r=t; recalc(r);
        }
}



void merge(it *&t, it*l, it*r){
    if( (!r) || (!l) ){
        t=(l)?(l):(r); recalc(t);return;
    }

    if(l->y>r->y){
        merge(l->r, l->r, r); t=l;
    }
    else{
        merge(r->l, l, r->l); t=r;
    }
    recalc(t);
}



void insert(it *&t, pii x, int pos){
    it *newt=new it(rng(), x);
    it *n1, *n2;
    split(t, t, n1, pos-1, 0);
    merge(t, t, newt);
    merge(t, t, n1);
}



pii access(it *t, int pos){
    it *n1, *n2;
    split(t, t, n1, pos-1, 0);
    split(n1, n1, n2, 1, 0);
    pii res=n1->x;
    merge(n1, n1, n2);
    merge(t, t, n1);
    return res;
}




void get(it *t, std::vector<std::pair<int, int>> &res){
    if(!t){return;}
    get(t->r, res);
    res.pb(t->x);
    get(t->l, res);
}







std::vector<std::pair<int, int>> solve(int n){





//a-sortat




for(int i=1; i<=n; i++){
    for(int j=i; j<=n; j++){
        int l=1, r=szof(R)+1, m=(l+r)/2;

        while(l<r){
            m=(l+r)/2;
            pii pr=access(R, m);
            if( cmp(i-1,j-1, pr.ft, pr.sc ) ){
                l=m+1;
            }
            else{
                r=m;
            }
            m=(l+r)/2;
        }

        insert(R, {i-1, j-1}, m);
        /*vector<pii> b; get(R, b);
        for(int g=0; g<b.size(); g++){
            cout<<b[g].ft<<" "<<b[g].sc<<"||";
        }cout<<"\n";*/
    }
}




std::vector<std::pair<int, int>> res; get(R, res);
return res;

}





























