#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
typedef long long ll;
typedef long double ld;
using namespace std;
const int nax = 10006;
const int MOD = 1000000007;
const int inf = 2e9;
int n, k;
ll tot = 0;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> k;
    ll p[n + 1], l[n + 1];
    for(int i = 1; i <= n; i++) {
        cin >> p[i];
        cin >> l[i];
    }

    int order[n + 1];
    int h = 0;

    int finish = 0, now = 0;
    order[++h] = now;
    while(p[now] != finish) {
        now = p[now];
        order[++h] = now;
    }
    ll dp[n + 1][n + 1];

    for(int i = 0; i <= n; i++) {
        for(int j = 0; j <= n; j++) {
            dp[i][j] = -inf;
        }
    }

    dp[0][0] = 0;

    for(int i = 1; i <= n; i++) {
        if(i > 1) {
            for(int j = n; j >= 0; j++) {
                // take the pred
                if(j + k > n) continue;
                dp[i][j + k] = max(dp[i][j + 1], dp[i - 1][j] + l[order[i]]);
            }
        }
        for(int j = 0; j < n; j++) {
            // don't take the pred
            for(int k = i - 2; k >= 0; k--) {
                dp[i][j + 1] = max(dp[i][j + 1], dp[k][j] + l[order[i]]);
            }
        }
    }

    ll ans = 0;
    for(int i = 0; i <= n; i++) {
        for(int j = 0; j <= n ; j++) {
            ans = max(ans, dp[i][j]);
        }
    }
    cout << ans << '\n';
    return 0;
}
