#include<bits/stdc++.h>
#include “sqsort.h”
using namespace std;
bool cmp(int a, int b, int c, int d);

vector< pair<int, int> > solve(int n)
{
    int s = n * (n + 1) / 2;
    vector< pair<int, int> > order(s);
    int used = 0;
    vector<bool> visited[n];
    for(int i = 0; i < n; i++)
    {
        visited[i].assign(n - i, false);
    }

    while(used != s)
    {
        int pi, pj;
        bool found = false;
        for(int i = 0; i < n; i++)
        {
            for(int j = i; j < n; j++)
            {
                if(!visited[i][j - i])
                {
                    pi = i;
                    pj = j;
                    found = true;
                    break;
                }
            }
            if(found) break;
        }

        for(int i = 0; i < n; i++)
        {
            for(int j = i; j < n; j++)
            {
                if(!visited[i][j - i] && i != p.first && j != p.second)
                {
                    if(cmp(i, j, pi, pj))
                    {
                        pi = i;
                        pj = j;
                    }
                }
            }
        }

        order[used++] = make_pair(pi, pj);
        visited[pi][pj - pi] = true;
    }

    return order;
}