#include <bits/stdc++.h>
#include "sqsort.h"

using namespace std;
 
using ll = long long;
using ld = long double;
using db = double; 
using str = string; 

using pi = pair<int, int>;
using pll = pair<ll, ll>;
using pd = pair<double, double>;

using vpi = vector<pi>;

#define f first
#define s second
#define mp(x, y) make_pair(x, y)

#define sz(X) x.size()
#define pb(x) push_back(x)
#define ins(x) insert(x)

const int MOD = 1e9+7;
const int mxN = 2e5+5;
const ll INF = 1e18; 
const ld PI = acos((ld)-1);
 
int pos[mxN];

bool cmp(int a, int b, int c, int d);

bool to_cmp(pi f, pi s)
{
	return cmp(f.f, f.s, s.f, s.s);
}

bool to_cmp2(pi f, pi s)
{
	int p1 = pos[f.f], p2 = pos[f.s], p3 = pos[s.f], p4 = pos[s.s];
	if(max(p1, p2) > max(p3, p4) && min(p1, p2) > min(p3, p4))
	{
		return 0;
	}
	else if(max(p3, p4) > max(p1, p2) && min(p3, p4) > min(p1, p2))
	{
		return 1;
	}
	if(max(p1, p2) < min(p3, p4))
	{
		return 1;
	}
	else if(max(p3, p4) < min(p1, p2))
	{
		return 0;
	}
	return cmp(f.f, f.s, s.f, s.s);
}

std::vector <std::pair<int, int>> solve(int n)
{
	vpi v, v2;
	for(int j = 0; j < n; j++)
	{
		v.pb(mp(0, j));
	}
	sort(v.begin(), v.end(), to_cmp);
	for(int i = 0; i < n; i++)
	{
		pos[v[i].s] = i;
	}
	for(int i = 0; i < n; i++)
	{
		for(int j = i; j < n; j++)
		{
			v2.pb(mp(i, j));
		}
	}
	sort(v2.begin(), v2.end(), to_cmp2);

	/*for(auto x : v)
	{
		cout << x.f << " " << x.s << "\n";
	}*/
	return v2;
}
 
 /* stuff you should look for
	* int overflow, array bounds
	* special cases (n=1?)
	* do smth instead of nothing and stay organized
	* WRITE STUFF DOWN
	* DON'T GET STUCK ON ONE APPROACH
*/

