#include<bits/stdc++.h>
#define eb push_back
#define pb push_back

using namespace std;

const int MAXN = 50;
const int mod = 1e9 + 7;
long long n, m;
long long perm[MAXN+2];
bool mp[MAXN][MAXN];
int  colr[MAXN], colb[MAXN], rowr[MAXN], rowb[MAXN];
long long ans;

void input() {
    cin>>n>>m;
}

void output() {
    cout<<ans<<endl;
}

void precalc() {
    perm[0] = 1;
    for (int i=1; i<MAXN; i++) {
        perm[i] = perm[i-1]*2;
    }
}

bool check() {
    for (int i=0; i<n; i++) {
        for (int j=0; j<m; j++) {
            if ((mp[i][j] && rowr[i] == 1 && colr[j] == 1) || (!mp[i][j] && rowb[i] == 1 && colb[j] == 1)){
                return 0;
            }
        }
    }
    return 1;
}

void rekursiq(int i, int j) {
    if (j == m) {
        j = 0;
        i++;
    }
    if (i == n) {
        ans += check();
        return;
    }

    mp[i][j] = 1;
    colr[j]++;
    rowr[i]++;
    rekursiq(i, j+1);
    colr[j]--;
    rowr[i]--;

    mp[i][j] = 0;
    colb[j]++;
    rowb[i]++;
    rekursiq(i, j+1);
    colb[j]--;
    rowb[i]--;
}

void solve() {
    precalc();
    rekursiq(0, 0);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    input();
    solve();
    output();
    return 0;
}

