#include<bits/stdc++.h>
#include <ctime>
#include "sqsort.h"

using namespace std;

struct edge
{
    int x, y, val;
    edge() { }
    edge(int x, int y, int val) :x(x), y(y), val(val) { }
    bool operator< (const edge &d) const
    {
        return val>d.val;
    }
};

//const int nmax=1024;
vector< pair<int, int> > ans;
//int t[nmax];

/*bool cmp(int a, int b, int c, int d)
{
    if(t[a]+t[b]<t[c]+t[d]) return true;
    return false;
}*/

void rec(int l, vector< pair<int, int> > v)
{
    int pos=0;
    vector< pair<int, int> > left, right;
    for(int i=1; i<(int)v.size(); ++i)
    {
        int d=cmp(v[0].first, v[0].second, v[i].first, v[i].second);
        if(d==0) left.push_back(v[i]), pos++;
        else right.push_back(v[i]);
    }
    //cout<<v[0].first<<" "<<v[0].second<<" "<<pos<<" "<<pos+l<<endl;
    //cout<<"left"<<endl;
    //for(int i=0; i<(int)left.size(); ++i) cout<<left[i].first<<" "<<left[i].second<<endl;
    //cout<<"right"<<endl;
    //for(int i=0; i<(int)right.size(); ++i) cout<<right[i].first<<" "<<right[i].second<<endl;
    ans[pos+l]=v[0];
    if((int)left.size()) rec(l, left);
    if((int)right.size()) rec(pos+1+l, right);
}

std::vector< std::pair<int, int> > solve(int n)
{
    srand(time(nullptr));
    int k=0;
    vector< edge > v;
    vector< pair<int, int> > g;
    for(int i=0; i<n; ++i)
        for(int j=i; j<n; ++j) v.push_back(edge(i, j, rand())), ans.push_back({0, 0}), k++;
    //cout<<"YES"<<endl;
    sort(v.begin(), v.end());
    for(int i=0; i<k; ++i) g.push_back({v[i].x, v[i].y});
    //for(int i=0; i<k; ++i) cout<<v[i].first<<" "<<v[i].second<<endl;
    //cout<<endl;
    rec(0, g);
    //for(int i=0; i<k; ++i) cout<<ans[i].first<<" "<<ans[i].second<<endl;
    return ans;
}

/*int main()
{
    int n;
    cin>>n;
    for(int i=0; i<n; ++i) cin>>t[i];
    solve(n);
    return 0;
}*/
