#include "sqsort.h"
#include <algorithm>

std::vector<std::pair<int, int>> solve(int n) {
    std::vector<std::pair<int, int>> res;

    /* if (cmp(0, 0, 0, 1)) {
        res.emplace_back(0, 0);
        res.emplace_back(0, 1);
    } else {
        res.emplace_back(0, 1);
        res.emplace_back(0, 0);
    } */

    // Generate result array
    for (auto a = 0; a < n; ++a) {
        for (auto b = a; b < n; ++b) {
            res.emplace_back(a, b);
        }
    }

    // Sort result array
    std::sort(res.begin(), res.end(),
              [&](const auto& x, const auto& y) {
                  return cmp(x.first, x.second, y.first, y.second);
              });

    return res;
}
