#include<iostream>
#include<vector>
#include"sqsort.h"
using namespace std;
vector<pair<int,int> >arr,ans;
vector<int>nums;
int poses[3000];
void quick_sort_nums(vector<int>arr,int pos){
    if(arr.size()==0){
        return;
    }
    int comp=arr[0];
    vector<int>l,r;
    int cnt=0;
    for(int i=1;i<arr.size();i++){
        bool cans=cmp(0,comp,0,arr[i]);
        //cout<<comp.first<<" "<<comp.second<<" "<<arr[i].first<<" "<<arr[i].second<<" - > "<<cans<<endl;
        if(cans){
            r.push_back(arr[i]);
        }else{
            l.push_back(arr[i]);
            cnt++;
        }
    }
    poses[comp]=pos+cnt;
    quick_sort_nums(l,pos);
    quick_sort_nums(r,pos+cnt+1);
}
bool mcmp(int a,int b,int c,int d){
    if(poses[a]>=poses[c] && poses[a]>=poses[d] && poses[b]>=poses[c] && poses[b]>=poses[d]){
        return false;
    }
    if(poses[a]<=poses[c] && poses[a]<=poses[d] && poses[b]<=poses[c] && poses[b]<=poses[d]){
        return true;
    }
    return cmp(a,b,c,d);
}
void quick_sort(vector<pair<int,int> >arr,int pos){
    if(arr.size()==0){
        return;
    }
    pair<int,int>comp=arr[0];
    vector<pair<int,int> >l,r;
    int cnt=0;
    for(int i=1;i<arr.size();i++){
        bool cans=mcmp(comp.first,comp.second,arr[i].first,arr[i].second);
        //cout<<comp.first<<" "<<comp.second<<" "<<arr[i].first<<" "<<arr[i].second<<" - > "<<cans<<endl;
        if(cans){
            r.push_back(arr[i]);
        }else{
            l.push_back(arr[i]);
            cnt++;
        }
    }
    ans[pos+cnt]=comp;
    quick_sort(l,pos);
    quick_sort(r,pos+cnt+1);
}
std::vector<std::pair<int, int>> solve(int n){
    for(int i=0;i<n;i++){
        nums.push_back(i);
        for(int j=i;j<n;j++){
            arr.push_back({i,j});
        }
    }
    ans.resize(arr.size());
    quick_sort_nums(nums,0);
    quick_sort(arr,0);
    return ans;
}
