#include<iostream>
#include<vector>
#include<random>
#include <algorithm>
#include"sqsort.h"
using namespace std;
vector<pair<int,int> >arr,ans;
vector<int>nums;
int poses[3000];
void quick_sort_nums(vector<int>arr,int pos){
    if(arr.size()==0){
        return;
    }
    int comp=arr[0];
    vector<int>l,r;
    int cnt=0;
    for(int i=1;i<arr.size();i++){
        bool cans=cmp(0,comp,0,arr[i]);
        //cout<<comp.first<<" "<<comp.second<<" "<<arr[i].first<<" "<<arr[i].second<<" - > "<<cans<<endl;
        if(cans){
            r.push_back(arr[i]);
        }else{
            l.push_back(arr[i]);
            cnt++;
        }
    }
    poses[comp]=pos+cnt;
    quick_sort_nums(l,pos);
    quick_sort_nums(r,pos+cnt+1);
}
bool mcmp(int a,int b,int c,int d){
    if(poses[a]>=poses[c] && poses[a]>=poses[d] && poses[b]>=poses[c] && poses[b]>=poses[d]){
        return false;
    }
    if(poses[a]<=poses[c] && poses[a]<=poses[d] && poses[b]<=poses[c] && poses[b]<=poses[d]){
        return true;
    }
    return cmp(a,b,c,d);
}
bool scmp(pair<int,int> a, pair<int,int> b){
    return mcmp(a.first,a.second,b.first,b.second);
}
void quick_sort(vector<pair<int,int> >arr,int pos){
    if(arr.size()==0){
        return;
    }
    pair<int,int>comp=arr[0];
    vector<pair<int,int> >l,r;
    int cnt=0;
    for(int i=1;i<arr.size();i++){
        bool cans=mcmp(comp.first,comp.second,arr[i].first,arr[i].second);
        //cout<<comp.first<<" "<<comp.second<<" "<<arr[i].first<<" "<<arr[i].second<<" - > "<<cans<<endl;
        if(cans){
            r.push_back(arr[i]);
        }else{
            l.push_back(arr[i]);
            cnt++;
        }
    }
    ans[pos+cnt]=comp;
    quick_sort(l,pos);
    quick_sort(r,pos+cnt+1);
}
vector<pair<int,int> > merge_sort(vector<pair<int,int> >arr){
    if(arr.size()==1){
        return arr;
    }
    vector<pair<int,int> >l,r,sorted;
    for(int i=0;i<arr.size();i++){
        if(i%2==0){
            l.push_back(arr[i]);
        }else{
            r.push_back(arr[i]);
        }
    }
    l=merge_sort(l);
    r=merge_sort(r);
    int tol=0,tor=0;
    while(tol<l.size() && tor<r.size()){
        bool cans=cmp(l[tol].first,l[tol].second,r[tor].first,r[tor].second);
        if(cans){
            sorted.push_back(l[tol]);
            tol++;
        }else{
            sorted.push_back(r[tor]);
            tor++;
        }
    }
    while(tol<l.size()){
        sorted.push_back(l[tol]);
        tol++;
    }
    while(tor<r.size()){
        sorted.push_back(r[tor]);
        tor++;
    }
    return sorted;
}
std::vector<std::pair<int, int>> solve(int n){
    for(int i=0;i<n;i++){
        nums.push_back(i);
        for(int j=i;j<n;j++){
            arr.push_back({i,j});
        }
    }
    random_shuffle(nums.begin(),nums.end());
    random_shuffle(arr.begin(),arr.end());
    ans.resize(arr.size());
    quick_sort_nums(nums,0);
    //quick_sort(arr,0);
    sort(arr.begin(),arr.end(),scmp);
    return arr;
}
