#include<iostream>
#include<vector>
#include<random>
#include <algorithm>
#include <set>
#include"sqsort.h"
using namespace std;
vector<pair<int,int> >arr,ans;
vector<int>nums;
int poses[3000];
struct result{
    int a,b,c,d;
    bool r;
    bool operator <(result v)const{
        return max(poses[a],poses[b])<max(poses[v.a],poses[v.b]);
    }
};
int tn;
set<result> res;
void quick_sort_nums(vector<int>arr,int pos){
    if(arr.size()==0){
        return;
    }
    int comp=arr[0];
    vector<int>l,r;
    int cnt=0;
    for(int i=1;i<arr.size();i++){
        bool cans=cmp(0,comp,0,arr[i]);
        //cout<<comp.first<<" "<<comp.second<<" "<<arr[i].first<<" "<<arr[i].second<<" - > "<<cans<<endl;
        if(cans){
            r.push_back(arr[i]);
        }else{
            l.push_back(arr[i]);
            cnt++;
        }
    }
    poses[comp]=pos+cnt;
    quick_sort_nums(l,pos);
    quick_sort_nums(r,pos+cnt+1);
}
int cmpres(int a,int b,int c,int d,result i){
    int a1=i.a,b1=i.b,c1=i.c,d1=i.d;
    if(!i.r){
        swap(a1,c1);
        swap(b1,d1);
    }
    if(min(poses[a],poses[b])>max(poses[a],poses[b1])){
        return -1;
    }
    if(poses[a]<=poses[a1] && poses[b]<=poses[b1] && poses[c]>=poses[c1] && poses[d]>=poses[d1]){
        return 1;
    }
    if(poses[a]<=poses[b1] && poses[b]<=poses[a1] && poses[c]>=poses[c1] && poses[d]>=poses[d1]){
        return 1;
    }
    if(poses[a]<=poses[a1] && poses[b]<=poses[b1] && poses[c]>=poses[d1] && poses[d]>=poses[c1]){
        return 1;
    }
    if(poses[a]<=poses[b1] && poses[b]<=poses[a1] && poses[c]>=poses[d1] && poses[d]>=poses[c1]){
        return 1;
    }
    return 0;
}
bool mcmp(int a,int b,int c,int d){
    if(poses[a]>=poses[c] && poses[a]>=poses[d] && poses[b]>=poses[c] && poses[b]>=poses[d]){
        return false;
    }
    if(poses[a]<=poses[c] && poses[a]<=poses[d] && poses[b]<=poses[c] && poses[b]<=poses[d]){
        return true;
    }
    for(auto i:res){
        int r=cmpres(a,b,c,d,i);
        if(r==1){
            return true;
        }
        if(r==-1){
            break;
        }
    }
    for(auto i:res){
        int r=cmpres(c,d,a,b,i);
        if(r==1){
            return false;
        }
        if(r==-1){
            break;
        }
    }
    bool cans=cmp(a,b,c,d);
    if((a+b+c+d)%(tn*6)==0){
        res.insert({a,b,c,d,cans});
    }

    return cans;
}
bool scmp(pair<int,int> a, pair<int,int> b){
    return mcmp(a.first,a.second,b.first,b.second);
}
void quick_sort(vector<pair<int,int> >arr,int pos){
    if(arr.size()==0){
        return;
    }
    pair<int,int>comp=arr[0];
    vector<pair<int,int> >l,r;
    int cnt=0;
    for(int i=1;i<arr.size();i++){
        bool cans=mcmp(comp.first,comp.second,arr[i].first,arr[i].second);
        //cout<<comp.first<<" "<<comp.second<<" "<<arr[i].first<<" "<<arr[i].second<<" - > "<<cans<<endl;
        if(cans){
            r.push_back(arr[i]);
        }else{
            l.push_back(arr[i]);
            cnt++;
        }
    }
    ans[pos+cnt]=comp;
    quick_sort(l,pos);
    quick_sort(r,pos+cnt+1);
}
vector<pair<int,int> > merge_sort(vector<pair<int,int> >arr){
    if(arr.size()==1){
        return arr;
    }
    vector<pair<int,int> >l,r,sorted;
    for(int i=0;i<arr.size();i++){
        if(i%2==0){
            l.push_back(arr[i]);
        }else{
            r.push_back(arr[i]);
        }
    }
    l=merge_sort(l);
    r=merge_sort(r);
    int tol=0,tor=0;
    while(tol<l.size() && tor<r.size()){
        bool cans=mcmp(l[tol].first,l[tol].second,r[tor].first,r[tor].second);
        if(cans){
            sorted.push_back(l[tol]);
            tol++;
        }else{
            sorted.push_back(r[tor]);
            tor++;
        }
    }
    while(tol<l.size()){
        sorted.push_back(l[tol]);
        tol++;
    }
    while(tor<r.size()){
        sorted.push_back(r[tor]);
        tor++;
    }
    return sorted;
}
std::vector<std::pair<int, int>> solve(int n){
    tn=n;
    for(int i=0;i<n;i++){
        nums.push_back(i);
        for(int j=i;j<n;j++){
            arr.push_back({i,j});
        }
    }
    random_shuffle(nums.begin(),nums.end());
    random_shuffle(arr.begin(),arr.end());
    ans.resize(arr.size());
    quick_sort_nums(nums,0);
    //quick_sort(arr,0);
    ans=merge_sort(arr);
    //sort(arr.begin(),arr.end(),scmp);
    return ans;
}
