#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 52
#define MOD 1000000007
using namespace std;
int n, m;

void input()
{
    cin >> n >> m;
}

bool table[MAXN][MAXN];
int cnt = 0;

bool check_cell(int x, int y)
{
    bool b = 0;
    for (int i = 0; i < m; ++i)
    {
        if (i == y)
            continue;
        if (table[x][y] == table[x][i])
        {
            b = 1;
            break;
        }
    }

    if (b)
        return true;

    b = 0;

    for (int i = 0; i < n; ++i)
    {
        if (x == i)
            continue;
        if (table[x][y] == table[i][y])
        {
            b = 1;
            break;
        }
    }

    return b;

}

bool check(vector <bool> clrs)
{
    int sz = clrs.size();

    for (int i = 0; i < sz; ++i)
    {
        int x = i / n;
        int y = i % n;
        table[x][y] = clrs[i];
    }

    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            if (!check_cell(i, j))
                return false;
    return true;
}

void rec(int idx, vector <bool> d)
{
    if (idx == n * m)
    {
        if (check(d))
        {
            ++cnt;
            cnt %= MOD;
        }
        return;
    }

    vector <bool> curr = d;
    curr.push_back(1);
    rec(idx + 1, curr);
    vector <bool> curr1 = d;
    curr1.push_back(0);
    rec(idx + 1, curr1);
}

void solve()
{
    vector <bool> em;
    rec(0, em);
    cout << cnt << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    solve();

    return 0;
}
