#ifndef SQSORT_H
#define SQSORT_H

#include <bits/stdc++.h>
typedef long long ll;
const ll mod = 1e9 + 7;
/*
Chicka chicka slim shady
Hotter than a set of twin babies
in a mercedez benz with the windows up
when the temp goes up to the mid 80s
*/

bool cmp(int a, int b, int c, int d);
std::vector<std::pair<int, int>> solve(int n);

const int MAX_N = 2e3 + 10;
int ind[MAX_N];

bool goodCmp(const std::pair<int, int> &a, const std::pair<int, int> &b) {
    if(std::max(ind[a.first], ind[a.second]) < std::min(ind[b.first], ind[b.second])) {
        return true;
    } else if(std::min(ind[a.first], ind[a.second]) > std::max(ind[b.first], ind[b.second])) {
        return false;
    }
}

std::vector<std::pair<int, int> > solve(int n) {
    std::vector<int> sorted;
    std::vector<bool> blocked;
    for(int i = 0; i < n; i ++) {
        blocked.push_back(0);
    }
    for(int i = 0; i < n; i ++) {
        int best = -1;
        for(int j = 0; j < n; j ++) {
            if(blocked[j]) {continue;}
            if(best == -1) {
                best = j;
            } else if(cmp(0, j, 0, best)) {
                best = j;
            }
        }
        blocked[best] = true;
        sorted.push_back(best);
        ind[best] = i;
    }
    std::vector<std::pair<int, int> > ret;
    for(int i = 0; i < n; i ++) {
        for(int j = i; j < n; j ++) {
            ret.push_back({i, j});
        }
    }
    std::sort(ret.begin(), ret.end(), goodCmp);
    std::random_shuffle(ret.begin(), ret.end(), goodCmp);
    return ret;
}

#endif
