#ifndef SQSORT_H
#define SQSORT_H

#include <bits/stdc++.h>
typedef long long ll;
const ll mod = 1e9 + 7;
/*
Chicka chicka slim shady
Hotter than a set of twin babies
in a mercedez benz with the windows up
when the temp goes up to the mid 80s
*/

bool cmp(int a, int b, int c, int d);
std::vector<std::pair<int, int>> solve(int n);

const int MAX_N = 2e3 + 10;
int ind[MAX_N];

using namespace std;

map<pair<std::pair<int, int>, std::pair<int, int>>, bool> remember;

int N;

bool goodCmp(const std::pair<int, int> &a, const std::pair<int, int> &b) {
    if(N < 500) remember.find({a, b}) != remember.end()) {return remember[{a, b}];}
    if(std::max(ind[a.first], ind[a.second]) <= std::min(ind[b.first], ind[b.second])) {
        return true;
    } else if(std::min(ind[a.first], ind[a.second]) >= std::max(ind[b.first], ind[b.second])) {
        return false;
    } else if(a == b) {
        return true;
    }
    if(N < 500) {
        return remember[{a, b}] = cmp(a.first, a.second, b.first, b.second);
    } else {
        return cmp(a.first, a.second, b.first, b.second);
    }
}

std::vector<int> sorted;

using namespace std;

std::vector<std::pair<int, int> > divcon(int l, int r, std::vector<std::pair<int, int> > &now) {
    std::vector<std::pair<int, int> > lft, rght, retlft, retrght;
    int m = (l + r) / 2ll;
    if(l == r) {
        sort(now.begin(), now.end(), goodCmp);
        return now;
    }
    for(auto it : now) {
        if(goodCmp(it, {sorted[m], sorted[m]})) {
            lft.push_back(it);
        } else {
            rght.push_back(it);
        }
    }
    if(l == r) {
        retlft = lft;
        retrght = rght;
    } else {
        retlft = divcon(l, m, lft);
        retrght = divcon(m + 1, r, rght);
    }
    for(auto it : retrght) {
        retlft.push_back(it);
    }
    return retlft;
}

std::vector<std::pair<int, int> > solve(int n) {
    N = n;
    std::vector<bool> blocked;
    for(int i = 0; i < n; i ++) {
        blocked.push_back(0);
    }
    std::vector<std::pair<int, int> > ret;
    for(int i = 0; i < n; i ++) {
        int best = -1;
        for(int j = 0; j < n; j ++) {
            if(blocked[j]) {continue;}
            if(best == -1) {
                best = j;
            } else if(cmp(0, j, 0, best)) {
                best = j;
            }
        }
        blocked[best] = true;
        sorted.push_back(best);
        ind[best] = i;
    }
    for(int i = 0; i < n; i ++) {
        for(int j = i; j < n; j ++) {
            ret.push_back({i, j});
        }
    }
    auto toRet = divcon(0, n - 1, ret);
    return toRet;
}

#endif
