#include<iostream>
#include<vector>
#include<cstdio>
#include<climits>
using namespace std;

const long long DEL = 1000000007;

long long ans = 0;
long long a = 0;
long long n, m;

long long multiplyByPower(long long x, long long pow)
{
    while (pow > 0)
    {
        if (pow > 24)
        {
            x = x<<24;
        }
        else
        {
            x = x<<pow;
        }
        pow -= 24;
        x = x%DEL;
    }
    return x;
}

int main ()
{
    scanf("%d%d", &n, &m);
    if (n > m) swap(n, m);
    if (n == 2 && m == 2) {cout<<6<<endl; return 0;}

    if (n == 2)
    {
        ans =  multiplyByPower(1, 2*m) - (2*((m*multiplyByPower(1, m) - m*(m-1))%DEL) - 2*m);
        cout<<ans<<endl;
        return 0;
    }

    for (long long i=1; i<=n; i++)
    {
        a = 1;
        long long qdel = 1;
        for (long long j=n; j>n-i; j--)
        {
            a*=j;
            qdel *= (n-j+1);
            if (a%qdel == 0)
            {
                a/=qdel;
                qdel = 1;
            }
            //a = a%DEL;
        }
        a = a%DEL;
        qdel = 1;
        long long aa = 1;
        for (long long j=m; j>m-i; j--)
        {
            aa*=j;
            qdel *= (m-j+1);
            if (aa%qdel == 0)
            {
                aa/=qdel;
                qdel = 1;
            }
            //a = a%DEL;
        }
        aa = aa%DEL;
        a = (a*aa)%DEL;
        for (long long j=1; j<=i; j++)
        {
            a*=j;
            a = a%DEL;
        }
        a = multiplyByPower(a, (n-i)*(m-i) + 1);
        a = a%DEL;
        if (i%2 == 0) ans = (ans%DEL + a)%DEL;
        else ans = (ans%DEL - a + DEL)%DEL;
    }
    int bonus = multiplyByPower(1, n*m);
    ans = (ans + bonus%DEL)%DEL;
    if (ans < 0) ans += DEL;

    cout<<ans<<endl;
}
