#include <bits/stdc++.h>

using namespace std;

const int N = 1e4 + 3;
const int INF = 1e9;

pair<int, bool> dp[2][2][2][N];
int n, k, t[N], l[N];
int perm[N];

inline int max(int a, int b){
    return (a > b) ? a : b;
}

inline int min(int a, int b){
    return (a < b) ? a : b;
}

int solve(int pos, int add, bool rem, bool l_rem){
    if(add + n - pos < 0 || add + n - pos > n) return -INF;
    if(pos == n) return 0;
    int &ans = dp[pos & 1][rem][l_rem][add + n - pos].first;
    bool &solved = dp[pos & 1][rem][l_rem][add + n - pos].second;
    if(solved) return ans;

    solved = true;
    ans = -INF;

    int curr = (!rem) * k;
    if(pos == n - 1){
        if(l_rem) curr += k;

        ans = max(ans, solve(pos + 1, min(add, add - 2 * k + curr), false, l_rem) + l[perm[pos]]);
        if(!rem)
            ans = max(ans, solve(pos + 1, add + 1, false, l_rem));
        else
            ans = max(ans, solve(pos + 1, add, false, l_rem));
        return ans;
    }

    ans = max(ans, solve(pos + 1, min(add, add - 2 * k + curr), false, l_rem) + l[perm[pos]]);
    ans = max(ans, solve(pos + 1, min(add, add - k + curr), true, l_rem) + l[perm[pos]]);

    if(!rem)
        ans = max(ans, solve(pos + 1, add + 1, false, l_rem));
    else
        ans = max(ans, solve(pos + 1, add, false, l_rem));

    return ans;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> k;
    for(int i = 0; i < n; ++i)
        cin >> t[i] >> l[i];

    {
        int node = 0, i =0;
        while(t[node]){
            perm[i] = node;
            node = t[node];
            i++;
        }
        perm[i] = node;
    }

    int ans = solve(0, 0, false, false);
    if(perm[n - 1]) ans = max(ans, solve(0, 0, true, true));
    cout << ans << "\n";
}
