#include "sqsort.h"
#include <bits/stdc++.h>

using namespace std;

bool cmp(int a, int b, int c, int d);

const int N = 2000 + 3;
int v[N], order[N];

bool cmp3(int lvalue, int rvalue){
    return cmp(lvalue, lvalue, rvalue, rvalue);
}

bool cmp2(pair<int, int> p1, pair<int, int> p2){
    int a = p1.first, b = p1.second, c = p2.first, d = p2.second;
    if(order[a] <= order[c] && order[b] <= order[d]) return true;
    if(order[a] >= order[c] && order[b] >= order[d]) return false;
    return cmp(p1.first, p1.second, p2.first, p2.second);
}

vector<pair<int, int>> solve(int n){
    for(int i = 0; i < n; ++i)
        v[i] = i;

    sort(v, v + n, cmp3);

    for(int i = 0; i < n; ++i)
        order[v[i]] = i;

    vector<pair<int, int>> ans;
    for(int i = 0; i < n; ++i){
        for(int j = i; j < n; ++j){
            ans.push_back({v[i], v[j]});
        }
    }
    sort(ans.begin(), ans.end(), cmp2);

    /*for(auto &p: ans)
        if(p.first > p.second)
            swap(p.first, p.second);*/

    return ans;
}
