#include <iostream>
#include <functional>

#include "sqsort.h"
//#include "Lgrader.cpp"

using namespace std;

struct MyPair
{
    int i, j;

    MyPair(){}
    MyPair(int i, int j)
    {
        this->i = i;
        this->j = j;
    }
};

vector<pair<int, int>> solve(int n)
{
    vector <MyPair> v;
    for(int i = 0;i<n;i++)
        for(int j = i;j<n;j++)
            v.push_back(MyPair(i, j));

    sort(v.begin(), v.end(),
    [](MyPair A, MyPair B)
    {
        return cmp(A.i, A.j, B.i, B.j);
    });

    vector <pair <int, int>> ans;
    for(MyPair mp: v) ans.push_back({mp.i, mp.j});

    return ans;
}

