#include <bits/stdc++.h>
#include "sqsort.h"
using namespace std;
bool cmp(int a, int b, int c, int d);

vector <int> sorted, pos;

vector <int> merge1 (vector <int> a, vector <int> b){
    vector <int> ans;
    int sza = a.size (), szb = b.size (), la = 0, lb = 0;
    while (la < sza || lb < szb){
        if (la == sza) ans.push_back (b [lb ++]);
        else if (lb == szb) ans.push_back (a [la ++]);
        else{
            bool dali = cmp (a [la], a [la], a [la], b [lb]);
            if (dali) ans.push_back (a [la ++]);
            else ans.push_back (b [lb ++]);
        }
    }
    return ans;
}

vector <int> sort1 (int l, int r){
    if (l == r) return {l};
    int mid = l + r >> 1;
    return merge1 (sort1 (l, mid), sort1 (mid + 1, r));
}

vector <pair <int, int> > merge2 (vector <pair <int, int> > a, vector <pair <int, int> > b){
    vector <pair <int, int> > ans;
    int sza = a.size (), szb = b.size (), la = 0, lb = 0;
    while (a [la] != make_pair (sorted [pos [b [0].first] - 1], b [0].second)) ans.push_back (a [la ++]);
    ans.push_back (a [la ++]);
    while (la < sza || lb < szb){
        if (la == sza) ans.push_back (b [lb ++]);
        else if (lb == szb) ans.push_back (a [la ++]);
        else{
            bool dali = cmp (a [la].first, a [la].second, b [lb].first, b [lb].second);
            if (dali) ans.push_back (a [la ++]);
            else ans.push_back (b [lb ++]);
        }
    }
    return ans;
}

vector <pair <int, int> > sort2 (int l, int r, int n){
    if (l == r){
        vector <pair <int, int> > ans;
        for (int i = l; i < n; i ++){
            ans.push_back (make_pair (sorted [l], sorted [i]));
        }
        return ans;
    }
    int mid = l + r >> 1;
    return merge2 (sort2 (l, mid, n), sort2 (mid + 1, r, n));
}

std::vector<std::pair<int, int>> solve(int n){
    sorted = sort1 (0, n - 1);
    pos.resize (n);
    for (int i = 0; i < n; i ++) pos [sorted [i]] = i;
    return sort2 (0, n - 1, n);
}
/*
int main (){

    int n;
    cin >> n;
    for (int i = 0; i < n; i ++) cin >> seq [i];
    vector <pair <int, int> > res = solve (n);
    for (auto p : res) cout << p.first << ' ' << p.second << '\n';

}
*/
