#include <bits/stdc++.h>
#include "sqsort.h"

#pragma GCC optimize "-O3"

#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

vector<pair<int, int>> solve(int n) {
    vector<pair<int, int>> pairs;

    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) {
            pairs.emplace_back(i, j);
        }
    }

    vector<bool> used(pairs.size(), false);
    vector<pair<int, int>> answer;

    while (answer.size() < pairs.size()) {
        for (int i = 0; i < (int)pairs.size(); i++) {
            if (used[i]) {
                continue;
            }

            bool foundLessValue = false;

            for (int j = 0; j < (int)pairs.size(); j++) {
                if (i == j || used[j]) {
                    continue;
                }

                if (cmp(pairs[j].first, pairs[j].second, pairs[i].first, pairs[i].second)) {
                    foundLessValue = true;
                    break;
                }
            }

            if (!foundLessValue) {
                used[i] = true;
                //cerr << pairs[i].first << ' ' << pairs[i].second << endl;
                answer.emplace_back(pairs[i]);
                break;
            }
        }
    }

    return answer;
}
