#include <bits/stdc++.h>

#define int ll
#define endl '\n'
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
#define dbg(x) cerr << #x << " : " << x << endl
#define mp make_pair
#define pb emplace_back

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;
using pld = pair <ld, ld>;

template <class T>
istream& operator>> (istream &in, vector <T> &a)
{
    for (auto &i : a)
        in >> i;
    return in;
}
template <class T>
ostream& operator<< (ostream &out, const vector <T> &a)
{
    for (auto &i : a)
        out << i << " ";
    return out;
}
template <class T, class U>
istream& operator>> (istream &in, pair <T, U> &a)
{
    in >> a.first >> a.second;
    return in;
}
template <class T, class U>
ostream& operator<< (ostream &out, const pair <T, U> &a)
{
    out << a.first << " " << a.second;
    return out;
}

inline void Start()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen(".in", "r", stdin);
    //freopen(".out", "w", stdout);
}

int check(vector <vector <int>> a)
{
    int n = a.size(), m = a[0].size();
    vector <vector <int>> inrow(2, vector <int> (n)), incol(2, vector <int> (m));
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            inrow[a[i][j]][i]++;
            incol[a[i][j]][j]++;
        }
    }
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            if (inrow[a[i][j]][i] == 1 && incol[a[i][j]][j] == 1)
                return 0;
        }
    }
    return 1;
}

signed main()
{
    Start();
    int n, m;
    cin >> n >> m;
    int ans = 0;
    for (int mask = 0; mask < 1 << (n*m); ++mask)
    {
        vector <vector <int>> a(n, vector <int> (m));
        for (int i = 0; i < n; ++i)
        {
            for (int j = 0; j < m; ++j)
            {
                a[i][j] = mask >> (i * m + j) & 1;
            }
        }
        ans += check(a);
    }
    cout << ans;
    return 0;
}


