#include <bits/stdc++.h>
#include "sqsort.h"

#define int ll
#define endl '\n'
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
#define dbg(x) cerr << #x << " : " << x << endl
#define mp make_pair
#define pb emplace_back

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;
using pld = pair <ld, ld>;

template <class T>
istream& operator>> (istream &in, vector <T> &a)
{
    for (auto &i : a)
        in >> i;
    return in;
}
template <class T>
ostream& operator<< (ostream &out, const vector <T> &a)
{
    for (auto &i : a)
        out << i << " ";
    return out;
}
template <class T, class U>
istream& operator>> (istream &in, pair <T, U> &a)
{
    in >> a.first >> a.second;
    return in;
}
template <class T, class U>
ostream& operator<< (ostream &out, const pair <T, U> &a)
{
    out << a.first << " " << a.second;
    return out;
}

inline void Start()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen(".in", "r", stdin);
    //freopen(".out", "w", stdout);
}
void mergesorti(vector <int> &a)
{
    if (a.size() <= 1)
        return;
    vector <int> l(a.size() / 2), r(a.size() - a.size() / 2);
    for (int i = 0; i < a.size() / 2; ++i)
        l[i] = a[i];
    for (int i = 0; i < a.size() - a.size() / 2; ++i)
        r[i] = a[i + a.size() / 2];
    mergesorti(l);
    mergesorti(r);
    int i = 0, j = 0;
    while (i < l.size() && j < r.size())
    {
        if (cmp(l[i], l[i], r[j], r[j]))
        {
            a[i + j] = l[i];
            ++i;
        }
        else
        {
            a[i + j] = r[j];
            ++j;
        }
    }
    while (i < l.size())
    {
        a[i + j] = l[i];
        ++i;
    }
    while (j < r.size())
    {
        a[i + j] = r[j];
        ++j;
    }
}
vector <int> where;
bool cmpr(int a, int b, int c, int d)
{
    if (min(where[a], where[b]) <= min(where[c], where[d]) && max(where[a], where[b]) <= max(where[c], where[d]))
        return true;
    if (min(where[a], where[b]) >= min(where[c], where[d]) && max(where[a], where[b]) >= max(where[c], where[d]))
        return false;
    return cmp(a, b, c, d);
}
void mergesortp(vector <pii> &a)
{
    if (a.size() <= 1)
        return;
    vector <pii> l(a.size() / 2), r(a.size() - a.size() / 2);
    for (int i = 0; i < a.size() / 2; ++i)
        l[i] = a[i];
    for (int i = 0; i < a.size() - a.size() / 2; ++i)
        r[i] = a[i + a.size() / 2];
    mergesortp(l);
    mergesortp(r);
    int i = 0, j = 0;
    while (i < l.size() && j < r.size())
    {
        if (cmpr(l[i].first, l[i].second, r[j].first, r[j].second))
        {
            a[i + j] = l[i];
            ++i;
        }
        else
        {
            a[i + j] = r[j];
            ++j;
        }
    }
    while (i < l.size())
    {
        a[i + j] = l[i];
        ++i;
    }
    while (j < r.size())
    {
        a[i + j] = r[j];
        ++j;
    }
}
vector <pii> solve(int n)
{
    vector <int> inds(n);
    iota(all(inds), 0);
    mergesorti(inds);
    where.resize(n);
    for (int i = 0; i < n; ++i)
        where[inds[i]] = i;
    vector <pii> prs;
    for (int i = 0; i < n; ++i)
        for (int j = i; j < n; ++j)
            prs.pb(i, j);
    mergesortp(prs);
    return prs;
}



