#include "sqsort.h"

#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

vector<pair<int, int>> solve(int n) {
    vector<pair<int, int>> ans;
    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) {
            ans.push_back({i, j});
        }
    }
    auto mcmp = [&](pair<int, int> a, pair<int, int> b) {
        return cmp(a.first, a.second, b.first, b.second);
    };
    stable_sort(ans.begin(), ans.end(), mcmp);
    return ans;
}
