#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,abm,mmx,avx,avx2,popcnt,tune=native")
//#pragma GCC optimize("fast-math")
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <queue>
#include <deque>
#include <map>
#include <set>
#include <cassert>
#include <chrono>
#include <cmath>
#include <ctime>
#include <iomanip>
#include <cstdlib>
#include <unordered_map>
#include <unordered_set>
#include <numeric>
#include <random>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#define mp make_pair
#define endl '\n'
#define vin(v) for(int i =0 ; i< v.size();++i)cin>>v[i];
#define vout(v,c) for(auto i :v) cout<<i<<c;
#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()
#define sp system("pause")
#define pbc push_back
#define pob pop_back
/*
#define getchar_unlocked _getchar_nolock
inline int readInt()
{
char x;
while (x = getchar_unlocked())
{
if (x >= '0'&&x <= '9')
{
int ans = x - '0';
while (x = getchar_unlocked())
{
if (!(x >= '0' &&x <= '9')) return ans;
ans = ans * 10 + x - '0';
}
}
}
}*/
const int inf = 1e9;
const int MAXN = 7e2 + 1;
int dp[MAXN][MAXN*2][2];
int ppc[1 << 10];
signed main()
{
	int n, k;
	cin >> n >> k;
	vector<int> p(n);
	vector<int>l(n);
	for (int i = 0; i < n; ++i)
		cin >> p[i] >> l[i];
	if (n <= 10)
	{
		for (int i = 1; i < (1 << 10); ++i) ppc[i] = ppc[i >> 1] + (i & 1);
		int ans = 0;
		for (int mask1 = 0; mask1 < (1 << n); ++mask1)
		{
			vector<int> used(n);
			for (int j = 0; j < n; ++j)
			{
				if (mask1 & (1 << j)) used[j] = 1;
			}
			for (int mask2 = 0; mask2 < (1 << n); ++mask2)
			{
				vector<int> cnt = used;
				bool f = 1;
				int ntaken;
				for (int j = 0; j < n; ++j)
				{
					if (mask2 & (1 << j))
					{
						if (used[p[j]])
						{
							f = 0;
							break;
						}
						cnt[j]++;
					}
				}
				if (!f) continue;
				ntaken = n - ppc[mask1] - ppc[mask2];
				vector<int> ids(n);
				iota(all(ids), 0);
				sort(all(ids), [&](int a, int b) { return (cnt[a] == cnt[b] ? l[a] > l[b] :  cnt[a] > cnt[b]); });
				int now = 0;
				for (int j : ids)
				{
					if (cnt[j] == 2)
						now += l[j];
					else
					{
						int x = 2 - cnt[j];
						x *= k;
						if (x <= ntaken)
						{
							now += l[j];
							ntaken -= x;
						}
						else break;
					}
				}
				ans = max(ans, now);
			}
		}
		cout << ans;
		return 0;
	}
	vector<int> cycle;
	int now = 0;
	while (p[now] != 0)
	{
		cycle.pbc(now);
		now = p[now];
	}
	cycle.pbc(now);
	assert(cycle.size() == n);
	int ans = 0;
	if (l[cycle.back()] == 0)
	{
		vector<vector<int>> adp(n + 1, vector<int>(2, -inf));
		vector<vector<int>> aodp(n + 1, vector<int>(2));
		for (int j = 0; j <= n; ++j) for (int k = 0; k < 2; ++k) aodp[j][k] = -inf;
		aodp[0][0] = 0;
		for (int i = 0; i < n; ++i)
		{
			for (int left = 0; left <= n - i; ++left)
			{
				for (int flag = 0; flag < 2; ++flag)
				{
					if (aodp[left][flag] < 0) continue;
					if (flag)
					{
						if (left + k <= n)
							adp[left + k][1] = max(adp[left + k][1], aodp[left][flag] + l[cycle[i]]);
						adp[left][0] = max(adp[left][0], aodp[left][flag]);
						if (left + 2 * k <= n)
							adp[left + k * 2][0] = max(adp[left + k * 2][0], aodp[left][flag] + l[cycle[i]]);
					}
					else
					{
						int tleft = max(0, left - 1);
						adp[tleft][0] = max(adp[tleft][0], aodp[left][flag]);
						adp[left][1] = max(adp[left][1], aodp[left][flag] + l[cycle[i]]);
						if (tleft + k * 2 <= n)
							adp[tleft + k * 2][0] = max(adp[tleft + k * 2][0], aodp[left][flag] + l[cycle[i]]);
						if (left + k <= n)
							adp[left + k][0] = max(adp[left + k][0], aodp[left][flag] + l[cycle[i]]);
						if (tleft + k <= n)
							adp[tleft + k][1] = max(adp[tleft + k][1], aodp[left][flag] + l[cycle[i]]);
					}
				}
			}
			swap(adp, aodp);
			for (int j = 0; j <= n; ++j) for (int k = 0; k < 2; ++k) adp[j][k] = -inf;
		}
		ans = max(ans, aodp[0][0]);
		rotate(cycle.begin(), cycle.begin() + 1, cycle.end());
		for (int j = 0; j <= n; ++j) for (int k = 0; k < 2; ++k) aodp[j][k] = -inf;
		aodp[0][0] = 0;
		for (int i = 0; i < n; ++i)
		{
			for (int left = 0; left <= n - i; ++left)
			{
				for (int flag = 0; flag < 2; ++flag)
				{
					if (aodp[left][flag] < 0) continue;
					if (flag)
					{
						if (left + k <= n)
							adp[left + k][1] = max(adp[left + k][1], aodp[left][flag] + l[cycle[i]]);
						adp[left][0] = max(adp[left][0], aodp[left][flag]);
						if (left + 2 * k <= n)
							adp[left + k * 2][0] = max(adp[left + k * 2][0], aodp[left][flag] + l[cycle[i]]);
					}
					else
					{
						int tleft = max(0, left - 1);
						adp[tleft][0] = max(adp[tleft][0], aodp[left][flag]);
						adp[left][1] = max(adp[left][1], aodp[left][flag] + l[cycle[i]]);
						if (tleft + k * 2 <= n)
							adp[tleft + k * 2][0] = max(adp[tleft + k * 2][0], aodp[left][flag] + l[cycle[i]]);
						if (left + k <= n)
							adp[left + k][0] = max(adp[left + k][0], aodp[left][flag] + l[cycle[i]]);
						if (tleft + k <= n)
							adp[tleft + k][1] = max(adp[tleft + k][1], aodp[left][flag] + l[cycle[i]]);
					}
				}
			}
			swap(adp, aodp);
			for (int j = 0; j <= n; ++j) for (int k = 0; k < 2; ++k) adp[j][k] = -inf;
		}
		ans = max(ans, aodp[0][0]);
		cout << ans;
		return 0;
	}
	for (int jj = 0; jj < n; ++jj)
	{
		for (int i = 0; i <= n; ++i) for (int j = 0; j <= n - i; ++j) for (int k = 0; k < 2; ++k) dp[i][j][k] = -inf;
		dp[0][0][0] = 0;

		for (int i = 0; i < n; ++i)
		{
			for (int left = 0; left <= n - i; ++left)
			{
				for (int flag = 0; flag < 2; ++flag)
				{
					if (dp[i][left][flag] < 0) continue;
					if (flag)
					{
						if(left+k <=n)
						dp[i + 1][left + k][1] = max(dp[i + 1][left + k][1], dp[i][left][flag] + l[cycle[i]]);
						dp[i + 1][left][0] = max(dp[i + 1][left][0], dp[i][left][flag]);
						if(left + 2*k <=n)
						dp[i + 1][left + k * 2][0] = max(dp[i + 1][left + k * 2][0], dp[i][left][flag] + l[cycle[i]]);
					}
					else
					{
						int tleft = max(0, left - 1);
						dp[i + 1][tleft][0] = max(dp[i + 1][tleft][0], dp[i][left][flag]);
						dp[i + 1][left][1] = max(dp[i + 1][left][1], dp[i][left][flag] + l[cycle[i]]);
						if(tleft+k*2<=n)
						dp[i + 1][tleft + k * 2][0] = max(dp[i + 1][tleft + k * 2][0], dp[i][left][flag] + l[cycle[i]]);
						if(left+k<=n)
						dp[i + 1][left + k][0] = max(dp[i + 1][left + k][0], dp[i][left][flag] + l[cycle[i]]);
						if(tleft+k<=n)
						dp[i + 1][tleft + k][1] = max(dp[i + 1][tleft + k][1], dp[i][left][flag] + l[cycle[i]]);
					}
				}
			}
		}
		rotate(cycle.begin(), cycle.begin() + 1, cycle.end());
		ans = max(ans, dp[n][0][0]);
	}
	cout << ans;
//	sp;
}



/*
3 1 
1  4
2 3
0 0

*/