#include "sqsort.h"
#include <vector>
#include <algorithm>
#include <cassert>

bool compare(std::pair<int,int> f1, std::pair<int,int> f2) {
  return cmp(f1.first, f1.second, f2.first, f2.second);
}

std::vector<std::pair<int,int>> solve(int n) {
  std::vector<std::pair<int,int>> ans;
  for(int i = 0; i < n; i++)
    for(int j = i; j < n; j++)
      ans.push_back({i, j});
  std::sort(ans.begin(), ans.end(), compare);
  return ans;
}
