#include <iostream>
#include <vector>
using namespace std;

vector<bool> marked;
int k,N;
vector<int> t;
vector<int> l;
vector<vector<int>> dpT;
vector<vector<int>> dpF;
vector<int> solveCirc(int s){
    int n=0;
    int mn=s;
    int curr=s;
    do{
        marked[curr]=true;
        n++;
        if(l[curr]<l[mn]){
            mn=curr;
        }
        curr=t[curr];
    }while(curr!=s);
    dpT.assign(n,vector<int>(N+1,0));
    dpF.assign(n,vector<int>(N+1,0));
    curr=t[mn];
    for(int m=0; m<=N; m++){
        if(m>=2){
            dpT[0][m]=l[curr];
            if(m>=k+1){
                dpF[0][m]=l[curr];
            }
        }
    }
    curr=t[curr];
    for(int i=1; i<n; i++,curr=t[curr]) {
        for (int m = 0; m <= N; m++) {
            dpF[i][m] = dpT[i - 1][m];
            if (k + 1 <= m) {
                dpF[i][m] = max(dpF[i][m], dpF[i - 1][m - k - 1] + l[curr]);
            }
            if (2 * k <= m) {
                dpF[i][m] = max(dpF[i][m], dpT[i - 1][m - 2 * k] + l[curr]);
            }

            dpT[i][m] = dpF[i][m];
            if (2 <= m) {
                dpT[i][m]=max(dpT[i][m], dpF[i - 1][m - 2] + l[curr]);
            }
            if (k + 1 <= m) {
                dpT[i][m] = max(dpT[i][m], dpT[i - 1][m - k - 1] + l[curr]);
            }
        }
    }

    return dpF[n-1];
}
int main() {
    cin>>N>>k;
    t.resize(N);
    l.resize(N);
    marked.assign(N,false);
    for(int i=0; i<N; i++){
        cin>>t[i]>>l[i];
    }
    vector<vector<int>> cir;
    for(int i=0; i<N; i++){
        if(!marked[i]){
            cir.push_back(solveCirc(i));
        }
    }
    vector<vector<int>> suff(cir.size(),vector<int>(N+1,0));
    suff[0]=cir[0];

    for(int i=1; i<cir.size(); i++){
        for(int j=0; j<=N;j++){
            for(int l=0; l<=j; l++){
                suff[i][j]=max(suff[i][j],suff[i-1][j-l]+cir[i][l]);
            }
        }

    }

    cout<<suff[cir.size()-1][N];
    return 0;
}
