#include <bits/stdc++.h>

using namespace std;

const long long INF = 100000000000000LL;
const int MAXN = 700;
const int MAXK = 700;

int t[MAXN], l[MAXN], fr[MAXN];
long long dp[MAXN][MAXN][3];
bool vis[MAXN];

///dp[n][k][0/1] = suma maxima pe care o pot obtine daca am parcurs de la n la final si am k disponibili si am luat/nu am luat pe n

long long solve(int s, int n, int k) {
  for (int i = 0; i <= n; ++i)
    for (int j = 0; j <= n; ++j)
      dp[i][j][0] = dp[i][j][1] = -INF;
  dp[s][1][0] = 0;
  int f;
  for (int i = 1; i < n; ++i) {
    f = fr[s];
    for (int j = 0; j <= n; ++j) {
      if (j + 1 <= n && dp[s][j + 1][0] != -INF)
        dp[f][j][1] = dp[s][j + 1][0] + l[f];
    }
    for (int j = 0; j + 2 * k - 1 <= n; ++j)
      if (dp[f][j + 2 * k - 1][0] != -INF || dp[f][j + 2 * k - 1][1] != -INF)
        dp[f][j][0] = max(dp[f][j][0], max(dp[s][j + 2 * k - 1][0], dp[s][j + 2 * k - 1][1]) + l[f]);
    for (int j = 0; j + k <= n; ++j)
      if (dp[f][j + k][0] != -INF || dp[f][j + k][1] != -INF)
      dp[f][j][1] = max(dp[f][j][1], max(dp[s][j + k][0], dp[s][j + k][1]) + l[f]);
    for (int j = 0; j + 1 <= n; ++j)
      dp[f][j + 1][0] = max(dp[f][j + 1][0], max(dp[s][j][0], dp[s][j][1]));
    s = f;
  }
  long long ans = -INF;
  for (int i = 0; i <= n; ++i)
    ans = max(ans, max(dp[f][i][0], dp[f][i][1]));
  return ans;
}

int main() {
  //freopen("date.in", "r", stdin);
  //freopen("date.out", "w", stdout);

  int n, k;
  scanf("%d%d", &n, &k);
  for (int i = 1; i <= n; ++i) {
    scanf("%d%d", &t[i], &l[i]);
    t[i]++;
    fr[t[i]] = i;
  }

  long long ans = 0;
  for (int i = 1; i <= n; ++i)
    if (l[i] == 0) {
      ans = solve(i, n, k);
      break;
    }
  printf("%lld\n", ans);

  return 0;
}
