#include <bits/stdc++.h>
#include "sqsort.h"

using namespace std;

const int MAXN = 2005;

vector<pair<int, int> >G[MAXN];
int a[MAXN];
int p[MAXN];
int valori[MAXN];

int qry;

int bs(int l, int r, int pos) {
  int last = pos;
  while (l <= r) {
    int mid = (l + r) / 2;
    if (cmp(a[mid], a[mid], pos, pos)) {
      l = mid + 1;
    } else {
      last = mid;
      r = mid - 1;
    }
  }
  return last;
}

bool check(int a, int b, int c, int d) {
  if (min(p[a], p[b]) <= min(p[c], p[d]) && max(p[a], p[b]) <= max(p[c], p[d]))
    return 1;
  return 0;
}

vector<pair<int, int> >solve(int n) {
  srand(time(0));
  a[0] = 0;
  for (int i = 1; i < n; ++i) {
    int pos = bs(0, i - 1, i);
    for (int j = i; j > pos; --j)
      a[j] = a[j - 1];
    a[pos] = i;
  }
  for (int i = 0; i < n; ++i)
    p[a[i]] = i;
  //for (int i = 0; i < n; ++i)
    //printf("%d ", a[i]);
  priority_queue<pair<int, int> >pq;
  for (int i = 0; i < n; ++i) {
    for (int j = i; j < n - i; ++j)
      G[a[i]].push_back({a[i], a[j]});
    for (int j = i + 1; j <= n - i - 1; ++j)
      G[a[i]].push_back({a[j], a[n - i - 1]});
    pq.push({rand(), a[i]});
  }
  while (pq.size() > 1) {
    pair<int, int>p1 = pq.top();
    pq.pop();
    pair<int, int>p2 = pq.top();
    pq.pop();
    vector<pair<int, int> >aux;
    int x = p1.second;
    int y = p2.second;
    int i1 = 0, i2 = 0;
    while (i1 < G[x].size() || i2 < G[y].size()) {
      if (i1 == G[x].size()) {
        aux.push_back(G[y][i2]);
        i2++;
      } else if (i2 == G[y].size()) {
        aux.push_back(G[x][i1]);
        i1++;
      } else if (check(G[x][i1].first, G[x][i1].second, G[y][i2].first, G[y][i2].second)) {
        aux.push_back(G[x][i1]);
        i1++;
      } else if (check(G[y][i2].first, G[y][i2].second, G[x][i1].first, G[x][i1].second)) {
        aux.push_back(G[y][i2]);
        i2++;
      } else if (cmp(G[x][i1].first, G[x][i1].second, G[y][i2].first, G[y][i2].second)) {
        aux.push_back(G[x][i1]);
        i1++;
      } else {
        aux.push_back(G[y][i2]);
        i2++;
      }
    }
    G[x].clear();
    G[y].clear();
    swap(G[x], aux);
    pq.push({rand(), x});
  }
  vector<pair<int, int> >sol;
  int x = pq.top().second;
  for (auto& it:G[x])
    if (it.first > it.second)
      swap(it.first, it.second);
  return G[x];
}