#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/detail/standard_policies.hpp>
#include<ext/pb_ds/tree_policy.hpp>
#include<ext/rope>

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

template < typename T > using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define ll long long
#define endl '\n'
#define Endl '\n'
#define F first
#define S second
#define pb push_back
#define ld long double
#define pii pair < int, int >

#define int ll

vector < vector < int > > G;

vector < int > way;
vector < int > use;

void dfs(int v){
    use[v] = 1;
    way.pb(v);
    for (auto to : G[v]){
        if (!use[to])dfs(to);
    }
}

int32_t main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output1.txt", "w", stdout);
#else
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif
    int n, k;
    cin >> n >> k;
    if (n <= 10){
        vector < int > t(n);
        vector < int > a(n);
        for (int i = 0;i < n; ++i){
            cin >> t[i] >> a[i];
        }
        ll ans = 0;

        vector < int > nom(n, 0);
        for (int i = 0;i < n; ++i)nom[i] = i;
        do{
            ll tech = 0;
            vector < int > use(n, 0);
            for (int i = 0;i < n; ++i){
                int val = 0;
                if (!use[nom[i]])val += k;
                if (!use[t[nom[i]]])val += k;
                if (val == 2 * k){
                    use[nom[i]] = 1;
                    use[t[nom[i]]] = 1;
                    tech += a[nom[i]];
                    continue;
                }

                int need = -1;

                if (!use[nom[i]])use[nom[i]] = 1, need = nom[i];
                if (!use[t[nom[i]]])use[t[nom[i]]] = 1, need = t[nom[i]];

                int kol = 0;
                for (int j = n - 1;j >= 0; --j){
                    if (!use[nom[j]])kol++;
                }
                if (kol + val >= 2 * k){
                    for (int j = n - 1;j >= 0; --j){
                        if (!use[nom[j]]){
                            use[nom[j]] = 1;
                            val++;
                        }
                        if (val == 2 * k)break;
                    }
                    tech += a[nom[i]];

                }else{
                    if (need != -1)use[need] = 0;
                }
            }

            ans = max(ans, tech);
        }while(next_permutation(nom.begin(), nom.end()));
        cout << ans << endl;
        return 0;
    }

    vector < int > t(n);
    vector < int > a(n);
    G.resize(n);
    use.resize(n, 0);
    int start = 0;
    for (int i = 0;i < n; ++i){
        cin >> t[i] >> a[i];
        G[i].pb(t[i]);
        if (!a[i])start = i;
    }
    dfs(start);
    vector < ll > dp(n, 0);
    dp[0] = a[way[0]];
    dp[1] = a[way[1]];
    for (int i = 2;i < n; ++i){
        for (int j = 0;j < i - 1; ++j){
            dp[i] = max(dp[i], dp[j] + a[way[i]]);
        }
    }
    cout << *max_element(dp.begin(), dp.end());
    return 0;
}
