#include "sqsort.h"
#include<bits/stdc++.h>

#define f first
#define s second
#define pb push_back
#define ll long long

using namespace std;

const int N = 2e3 + 10, inf = 1e9 + 10, mod = 1e9 + 7;

unordered_map<ll, char> was;

bool my_cmp(pair<int, int> a, pair<int, int> b){
    int hashp = a.f * 2000 * 2000 * 2000 + a.s * 2000 * 2000 + b.f * 2000 + b.s;
    if(!was[hashp])
        was[hashp] = 2 - cmp(a.f, a.s, b.f, b.s);
    return was[hashp] == 1;
}

vector<pair<int, int>> solve(int n){
    vector<pair<int, int>> res;
    for(int i = 0; i < n; ++i)
        for(int j = i; j < n; ++j)
            res.pb({i, j});
    sort(res.begin(), res.end(), my_cmp);
    return res;
}
