#include <bits/stdc++.h>

using namespace std;

const int MOD = 1000000007;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    if(n > m) {
        swap(n, m);
    }

    if(m <= 3) {
        int ans = 0;
        for(int mask = 0; mask < (1 << (n * m)); mask++) {
            bool ok = true;
            vector<int> cntincol(m);
            vector<int> cntinrow(n);
            for(int i = 0; i < n; i++) {
                for(int j = 0; j < m; j++) {
                    if((mask >> (i * m + j)) & 1) {
                        cntincol[j]++;
                        cntinrow[i]++;
                    }
                }
            }
            for(int i = 0; i < n; i++) {
                for(int j = 0; j < m; j++) {
                    if((mask >> (i * m + j)) & 1) {
                        if(cntincol[j] == 1 && cntinrow[i] == 1) {
                            ok = false;
                            break;
                        }
                    } else {
                        if(cntincol[j] == n - 1 && cntinrow[i] == m - 1) {
                            ok = false;
                            break;
                        }
                    }
                }
            }
            if(ok) {
                ans++;
                ans %= MOD;
            }
        }
        cout << ans << endl;
        return 0;
    }

    vector< vector< vector<int> > > cntgoodabove(n + 1, vector< vector<int> >(m + 1, vector<int>(n + 1)));

    for(int h = 1; h <= n; h++) {
        for(int i = 0; i <= h; i++) {
            cntgoodabove[h][0][i] = 1;
        }
    }
    for(int w = 0; w <= m; w++) {
        cntgoodabove[0][w][0] = 1;
    }

    vector<int> pow2((n + 1) * (m + 1));
    pow2[0] = 1;
    for(int i = 1; i < pow2.size(); i++) {
        pow2[i] = pow2[i - 1] * 2 % MOD;
    }

    for(int h = 1; h <= n; h++) {
        for(int w = 1; w <= m; w++) {
            for(int y = 0; y <= h; y++) {
                int t = 0;
                for(int i = 0; i < y; i++) {
                    for(int j = 0; j < w; j++) {
                        t += cntgoodabove[h - 1][w - 1][i];
                        t %= MOD;
                    }
                }

                int cc = 1;
                for(int i = 0; i < (w * h); i++) {
                    cc = cc * 2 % MOD;
                }
                cntgoodabove[h][w][y] = (cc - t + MOD) % MOD;
            }
        }
    }

    int c = 1;
    for(int i = 0; i < (n * m); i++) {
        c = c * 2 % MOD;
    }

    int ans = (2 * cntgoodabove[n][m][n] % MOD - c + MOD) % MOD;
    cout << ans << endl;

    return 0;
}
