#include <bits/stdc++.h>

using namespace std;

const int MOD = 1000000007;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    if(n > m) {
        swap(n, m);
    }

    vector<int> pow2((n + 1) * (m + 1));
    pow2[0] = 1;
    for(int i = 1; i < pow2.size(); i++) {
        pow2[i] = pow2[i - 1] * 2 % MOD;
    }

    if(n == 1) {
        if(m == 1) {
            cout << 0 << endl;
            return 0;
        } else if(m == 2) {
            cout << 2 << endl;
            return 0;
        }
    } else if(n == 2) {
        if(m == 2) {
            cout << 6 << endl;
            return 0;
        }

        int ans = pow2[n * m];
        for(int i1 = 0; i1 < m; i1++) {
            ans -= 4 * i1 % MOD;
            ans = (ans + MOD) % MOD;
            ans += 2;
            ans %= MOD;
            ans -= 4 * pow2[m - 1] % MOD;
            ans = (ans + MOD) % MOD;
            ans += 4 * (m - 1) % MOD;
            ans %= MOD;
        }
        cout << ans << endl;
        return 0;
    }

    vector< vector< vector<int> > > cntgoodabove(n + 1, vector< vector<int> >(m + 1, vector<int>(n + 1)));

    for(int h = 1; h <= n; h++) {
        for(int i = 0; i <= h; i++) {
            cntgoodabove[h][0][i] = 1;
        }
    }
    for(int w = 0; w <= m; w++) {
        cntgoodabove[0][w][0] = 1;
    }

    for(int h = 1; h <= n; h++) {
        for(int w = 1; w <= m; w++) {
            for(int y = 0; y <= h; y++) {
                int t = 0;
                for(int i = 0; i < y; i++) {
                    for(int j = 0; j < w; j++) {
                        t += cntgoodabove[h - 1][w - 1][i];
                        t %= MOD;
                    }
                }

                int cc = 1;
                for(int i = 0; i < (w * h); i++) {
                    cc = cc * 2 % MOD;
                }
                cntgoodabove[h][w][y] = (cc - t + MOD) % MOD;
            }
        }
    }

    int c = 1;
    for(int i = 0; i < (n * m); i++) {
        c = c * 2 % MOD;
    }

    int ans = (2 * cntgoodabove[n][m][n] % MOD - c + MOD) % MOD;
    cout << ans << endl;

    return 0;
}
