#include <bits/stdc++.h>
#define IO ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0)
#define ll long long
#define pii pair<int,int>
#define pll pair<ll,ll>
#define F first
#define S second
#ifndef LOCALKL
#define endl '\n'
#endif 

using namespace std;

const ll m7 = 1000000007;

ll powmod(ll a,ll b)
{
	if(b==0) return 1;
	ll p = powmod(a,b>>1);
	if(b&1) return p*p%m7*a%m7;
	return p*p%m7;
}

ll lf(ll x,ll y,ll k)
{
	return (x*y-k*(x+y-k))%m7;
}

ll fact(ll k)
{
	ll res=1;
	do
	{
		res*=k;
		res%=m7;
	}while(--k);
	return res;
}

ll solve3(ll x, ll y)
{
	if(x>y) swap(x,y);
	ll ans=powmod(2,x*y);
	for(ll i=1;i<=x;i++)
	{
		ll res=2;
		for(ll j=0;j<i;j++)
		{
			res*=lf(x,y,j);
			res%=m7;
		}
		res*=powmod(2,lf(x,y,i));
		res%=m7;
		
		res*=powmod(fact(i),m7-2);
		res%=m7;
		
		//cerr<<i<<" : "<<res<<' '<<lf(x,y,i)<<' '<<((i&1)?'-':'+')<<endl;
		if(i&1) ans-=res;
		else ans+=res;
		ans+=m7;
		ans%=m7;
	}
	return ans;
}

ll n,m;
int main()
{
	IO;
	cin>>n>>m;
	if(3<=min(n,m)) cout<<solve3(n,m)<<endl;
	else
	{
		if(n>m) swap(n,m);
		if(n==1 and m==2) cout<<2;
		else if(n==1) cout<<(powmod(2,m)-2*m+m7)%m7<<endl;
		else
		{
			if(m==2)
			{
				cout<<6<<endl;
				return 0;
			}
			ll x1 = (powmod(2,m)-2*m+m7)%m7;
			cout<<((x1*x1%m7)+(2*m*m%m7)+(2*m*x1%m7))%m7<<endl;
		} 
	}
	return 0;
}