#include <iostream>
#include <bitset>
#include <random>
#include <chrono>
using namespace std;
using llong = long long;
#ifdef MANSON
#define BUGO(x) cerr << #x << " = " << (x) << '\n';
#define BUGOARR(a) {cerr << #a << ": "; for (auto i: a) cerr << i << ' '; cerr << '\n';}
ostream& operator<<(ostream& out, const pair<auto, auto>& p) {
	return out << "{" << p.first << ", " << p.second << "}";
}
#else
#define BUGO(x) {}
#define BUGOARR(x) {}
#endif
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
inline int rnd(int l, int r) { return uniform_int_distribution<int>(l, r)(rng); }
const int maxN = 10'005;

int next_[maxN], val[maxN], newVal_[maxN], stOf[maxN], nxt[maxN];
vector<int> st;

int NSmall(int n, int k)
{
    int ans = 0;
    for (int pit = 0; pit < (1 << n); ++pit)
    {
        int curans = 0;
        for (int i = 0; i < n; ++i)
            if (pit & (1 << i))
                curans += val[i];
        for (int mask = 0; mask < (1 << n); ++mask)
        {
            vector<int> sum(n, k), verc(n);
            for (int i = 0; i < n; ++i)
                if (mask & (1 << i)) {
                    int j = nxt[i];
                    verc[j] = true;
                    sum[j] -= k;
                    sum[i] += k;
                }
            int petq = 0, ka = 0;
            for (int i = 0; i < n; ++i)
                if (pit & (1 << i))
                {
                    petq += 2 * k - sum[i];
                }
                else
                    ka += sum[i] / k;
            if (ka >= petq) {
                ans = max(ans, curans);
            }
        }
    }
    return ans;
}
int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
    int n, k;
    cin >> n >> k;
    for (int i = 0; i < n; ++i)
        cin >> next_[i] >> val[i];
    {
        vector<int> used(n);
        int ind = 0;
        for (int curst = 0; curst < n; ++curst)
        {
            if (used[curst]) continue;
            st.push_back(ind);
            int i = curst;
            int stind = ind;
            while (true)
            {
                used[i] = true;
                stOf[i] = stind;
                nxt[i] = ind + 1;
                newVal_[ind++] = val[i];
                if (!used[next_[i]]) i = next_[i];
                else {
                    nxt[i] = stind;
                    break;
                }
            }
        }
        for (int j = 0; j < n; ++j)
            val[j] = newVal_[j];
    }
    #ifdef MANSON
    BUGOARR(st)
    for (int i=0;i<n;++i)cout<<nxt[i] << ' ';
    cout << '\n';
    #endif // MANSON
    if (n <= 10)
    {
        cout << NSmall(n, k) << '\n';
        exit(0);
    }
}
