#pragma GCC target("avx2");
#pragma GCC optimize("O3");
#pragma GGC optimize("unroll-loops");

#include<iostream>
#include<algorithm>
#include<vector>
#include<tuple>

using namespace std;

int get(int a, int ind) {
	return (a >> ind) & 1;
}

void rec(vector<int>& a, int& ans, int n, int m) {
	if (a.size() < n) {
		for (int i = 0; i < (1 << m); ++i) {
			a.push_back(i);
			rec(a, ans, n, m);
			a.pop_back();
		}
		return;
	}
	vector<vector<int>> check(n, vector<int>(m, false));
	for (int i = 0; i < n; ++i) {
		int ed = 0, zr = 0;
		for (int j = 0; j < m; ++j) {
			if (get(a[i], j))
				++ed;
			else
				++zr;
		}
		for (int j = 0; j < m; ++j) {
			if (get(a[i], j) && ed > 1)
				check[i][j] = true;
			else if (!get(a[i], j) && zr > 1)
				check[i][j] = true;
		}
	}
	for (int j = 0; j < m; ++j) {
		int ed = 0, zr = 0;
		for (int i = 0; i < n; ++i) {
			if (get(a[i], j))
				++ed;
			else
				++zr;
		}
		for (int i = 0; i < n; ++i) {
			if (get(a[i], j) && ed > 1)
				check[i][j] = true;
			else if (!get(a[i], j) && zr > 1)
				check[i][j] = true;
		}
	}
	bool yes = true;
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j)
			if (!check[i][j])
				yes = false;
	if (yes)
		++ans;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m;
	vector<int> a;
	a.reserve(n);
	int ans = 0;
	rec(a, ans, n, m);
	cout << ans;
}