#include<vector>
#include<algorithm>
#include<unordered_map>
#include "sqsort.h"

bool cmp(int a_, int b, int c, int d);

std::vector<std::pair<int, int>> solve(int n) {
	std::vector<std::pair<int, int>> ans;
	ans.reserve(n * (n + 1) / 2);
	for (int i = 0; i < n; ++i)
		for (int j = i; j < n; ++j)
			ans.emplace_back(i, j);
	std::vector<int> sorted(n);
	for (int i = 0; i < n; ++i)
		sorted[i] = i;
	sort(sorted.begin(), sorted.end(), [](int a, int b) {return cmp(0, a, 0, b); });
	std::unordered_map<int, int> check;
	for (int i = 0; i < n; ++i)
		check[sorted[i]] = i;
	sort(ans.begin(), ans.end(), [&check](std::pair<int, int> first, std::pair<int, int> second) {
		auto [a, b] = first;
		auto [c, d] = second;
		if (check[a] <= check[c] && check[b] <= check[d] || check[b] <= check[c] && check[a] <= check[d]) {
			return true;
		}
		if (check[a] >= check[c] && check[b] >= check[d] || check[b] >= check[c] && check[a] >= check[d])
			return false;
		return cmp(a, b, c, d);
		}
	);
	return ans;
}