#include "sqsort.h"
#include <bits/stdc++.h>

using namespace std;

void merge_sort(int l, int r, vector<pair<int, int>> &qs1) {
    if (l == r)
        return;
    int md = (l + r) / 2;
    merge_sort(l, md, qs1);
    merge_sort(md + 1, r, qs1);
    int l1 = l;
    int r1 = md + 1;
    vector<pair<int, int>> q1;
    while (l1 <= md && r1 <= r) {
        if (l1 > md) {
            q1.push_back(qs1[r1]);
            ++r1;
        } else if (r1 > r) {
            q1.push_back(qs1[l1]);
            ++l1;
        } else {

            if (cmp(qs1[l1].first, qs1[l1].second, qs1[r1].first, qs1[r1].second)) {
                q1.push_back(qs1[l1]);
                ++l1;
            } else {
                q1.push_back(qs1[r1]);
                ++r1;
            }
        }
    }
    for (int i = l; i <= r; ++i) {
        qs1[i] = q1[i - l];
    }
}

vector<pair<int, int>> solve(int n) {
    vector<pair<int, int>> qs1 (n * (n + 1) / 2);
    int last = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            qs1[last] = {i, j};
            ++last;
        }
    }
    merge_sort(0, last - 1, qs1);
    return qs1;
}