#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define pb push_back
#define pll pair<ll, ll>

const ll maxn = ll(1e2) + 5;
const ll mod = ll(1e9) + 7;

ll n, m;

void solve() {
    cin >> n >> m;
    ll ans = 0;
    for(ll msk = 0; msk < (ll(1) << (n * m)); msk++) {
        ll cur[n][m];
        for(ll i = 0; i < n; i++) {
            for(ll j = 0; j < m; j++) {
                cur[i][j] = 0;
                if(msk & (ll(1) << (i * m + j))) {
                    cur[i][j] = 1;
                }
            }
        }

        vector<ll> rows(n, 0);
        vector<ll> cols(m, 0);
        for(ll i = 0; i < n; i++) {
            for(ll j = 0; j < m; j++) {
                rows[i] += cur[i][j];
                cols[j] += cur[i][j];
            }
        }

        bool ok = true;
        for(ll i = 0; i < n; i++) {
            if(!ok) break;
            for(ll j = 0; j < m; j++) {
                if(cur[i][j] == 1 && rows[i] == 1 && cols[j] == 1) {
                    ok = false;
                    break;
                }
                if(cur[i][j] == 0 && rows[i] == m - 1 && cols[j] == n - 1) {
                    ok = false;
                    break;
                }
            }
        }

        if(ok) ans++;
    }
    cout << (ans % mod);
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
