#include "sqsort.h"
#include <bits/stdc++.h>

#define Tree int h,int l,int r
#define Left (h<<1),l,((l+r)>>1)
#define Right ((h<<1)|1),((l+r)>>1)+1,r
#define ll long long
#define pb push_back
#define F first
#define S second

using namespace std;

vector < int > v;

bool comp(pair < int , int > a, pair < int , int > b) {
	if (a==b) return false;
	if (min(a.F,a.S)<min(b.F,b.S) && max(a.F,a.S)<max(b.F,b.S)) return true;
	if (min(b.F,b.S)<min(a.F,a.S) && max(b.F,b.S)<max(a.F,a.S)) return false;
	return cmp(v[a.F],v[a.S],v[b.F],v[b.S]);
} 

vector < pair < int , int > > solve(int nn) {
	for (int i=0; i<nn; i++) 
		v.pb(i);
	
	bool s=true;
	while (s) {
		s=false;
		for (int i=1; i<v.size(); i++) {
			// true if v[i]<v[i-1]
			if (cmp(0,v[i],0,v[i-1]))
				swap(v[i],v[i-1]),s=true;
		}
	}
	
	vector < pair < int , int > > S;
	for (int i=0; i<v.size(); i++) {
		for (int j=i; j<v.size(); j++) {
			S.push_back({i,j});
		}
	}
	
	sort(S.begin(),S.end(),comp);
	
	for (int i=0; i<S.size(); i++) {
		S[i].F=v[S[i].F];
		S[i].S=v[S[i].S];
	}
	
	return S;
}

/*

5
1 0 0 4 0

*/