#include <iostream>
#include <vector>

using namespace std;

#define ll long long
#define MOD ((int)1e9+7)

ll n,m;
vector<vector<int>> board;

ll ok(ll k)
{
    for(int i=0; i<n; i++)
        for(int j=0; j<m; j++)
            board[i][j] = (k & (1<<(i*m)+j))?1:0;

    for(int i=0; i<n; i++)
    {
        for(int j=0; j<m; j++)
        {
            bool found = false;
            for(int x=0; x<m; x++)
                found = found || (board[i][j] == board[i][x] && x!=j);
            for(int x=0; x<n; x++)
                found = found || (board[i][j] == board[x][j] && x!=i);
            if(!found)
                return 0;
        }
    }
    return 1;
}

int main()
{

    cin>>n>>m;
    board = vector<vector<int>>(n, vector<int>(m, 0));
    ll cnt = 0;
    for(ll k=0; k<(1<<(n*m)); k++)
        cnt = (cnt+ok(k))%MOD;
    cout<<cnt<<endl;

}