#include "sqsort.h"
#include <algorithm>
using namespace std;
bool cmp1(pair<int,int> a, pair<int,int> b){
    return cmp(a.first, a.second, b.first, b.second);
}
bool cmp2(int a, int b){
    return cmp(0, a, 0, b);
}
vector < pair<int,int> > is;
int dix(int l, int r, pair<int,int> x){
    if(l == r) return l;
    int t = (l+r)/2;
    if(cmp(is[t].fi, is[t].se, x.fi, x.se)) l = t+1;
    else r = t;
    return dix(l, r, x);
}
vector < pair<int,int> > solve(int n){
    if(n > 400){
        vector < pair<int,int> > q;
        for(int i = 0; i < n; ++i){
            for(int j = i; j < n; ++j){
                q.push_back({i, j});
            }
        }
        sort(q.begin(), q.end(), cmp1);
        return q;
    }
    vec < int > w;
    for(int i = 0; i < n; ++i) w.push_back(i);
    sort(all(w), cmp2);
    for(int i = 0; i < n; ++i)
        is.pb({w[i], w[i]});
    pair<int,int> now = is[0];
    vector < pair<int,int> > otv;
    is.erase(is.begin());
    do{
        otv.pb(now);
        now.se++;
        if(now.se == n){
            if(is.size() == 0) break;
            now = is[0];
            is.erase(is.begin());
        }else{
            if(cmp(now.fi, now.se, is[0].fi, is[0].se)){
                int to = dix(0, n, now);
                is.insert(is.begin()+to-1, now);
                now = is[0];
                is.erase(is.begin());
            }
        }
    }while(true);
    return otv;
}
