//#include sqsort.h
#include <iostream>
#include <vector>
#include <stack>
#include <algorithm>
using namespace std;


vector <pair<int, int>> ans;
int order[2000];
stack<pair<int, int>> stacks[2000];

std::vector<std::pair<int, int>> solve(int n) {
	for (int i = 0; i < n - 1; i++) {
		for (int j = 0; j < n - 1 - i; j++) {
			if (cmp(order[i], order[i], order[i + 1], order[i + 1])) {
				int temp = order[i + 1];
				order[i + 1] = order[i];
				order[i] = temp;
			}
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = i; j < n; j++) {
			stacks[i].push({ order[i], order[j] });
		}
	}
	bool con = true;
	while (con) {
		int ms = -1;
		con = false;
		for (int i = 0; i < n; i++) {
			if (!stacks[i].empty()) {
				con = true;
				if (ms == -1)
					ms = i;
				else
					if (cmp(stacks[i].top().first, stacks[i].top().second, stacks[ms].top().first, stacks[ms].top().second))
						ms = i;
			}
		}
		if (con)
		{
			ans.push_back(stacks[ms].top());
			stacks[ms].pop();
		}
	}
	return ans;
}


int main() {


}