#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

//#define int long long
#define INF 1000000000
#define MAX_SZ 1000
int dp[2][MAX_SZ * 2];
int dpn[2][MAX_SZ * 2];

void init() {

    for (int i = 0; i < 2; ++i) {
        for (int j = 0; j < 2 * MAX_SZ; ++j) {
            dpn[i][j] = dp[i][j] = -INF;
        }
    }
    dp[0][MAX_SZ] = 0;
}

void reset() {
    for (int i = 0; i < 2; ++i) {
        for (int j = 0; j < 2 * MAX_SZ; ++j) {
            dp[i][j] = dpn[i][j];
            dpn[i][j] = -INF;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, k;
    cin >> n >> k;
    vector<int> nxt(n);
    vector<int> L(n);
    for (int i = 0; i < n; ++i) {
        cin >> nxt[i];
        cin >> L[i];
    }
    init();
    int cur = 0;
    for (int i = 0; i < n; ++i) {
        for (int l = 0; l < 2; l++) {
            for (int x = -n; x < n; ++x) {
                int v = dp[l][x + MAX_SZ];
                if (l == 1) {
                    dpn[0][x + MAX_SZ] = max(dpn[0][x + MAX_SZ], v);
                } else {
                    dpn[1][x + MAX_SZ] = max(dpn[1][x + MAX_SZ], v + L[i]);
                    dpn[0][x + 1 + MAX_SZ] = max(dpn[0][x + 1 + MAX_SZ], v);
                    dpn[0][x - k + MAX_SZ] = max(dpn[0][x - k + MAX_SZ], v + L[i]);

                }
            }
        }
        reset();
        //cout<<"------\n";

        cur = nxt[cur];
    }
    int ans = 0;
    if (cur != 0) {
        cout << 1 / 0;
    }
    int l = 0;
    for (int x = 0; x < n; ++x) {
        int v = dp[l][x + MAX_SZ];
        ans = max(ans, v);
    }
    cout << ans;

    return 0;
}/*
4 1
1 99
2 100
3 99
0 0

 6 1
 1 100
 2 100
 3 0
 4 0
 5 0
 0 0
*/