#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

//#define int long long
#define INF 1000000000
#define MAX_SZ 1000
int dp[2][MAX_SZ * 2];
int dpn[2][MAX_SZ * 2];


vector<int> nxt;
vector<int> L;
int n, k;
vector<int> cur;

int res = -INF;

void check() {
    int s = 0;
    int need = 0;
    int sum = 0;
    for (int i = 0; i < n; ++i) {
        s += 1 - cur[i];
        sum += cur[i] * L[i];
        if (cur[i]) {
            if (cur[nxt[i]]) {
                need += k;
            } else {
                s -= 1;
            }
        }
    }
    if (need <= s) {
        res = max(res, sum);
    }
}

void gen(int k) {
    if (k == n) {
        check();
    } else {
        for (int i = 0; i < 2; ++i) {
            cur[k] = i;
            gen(k + 1);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    //int n, k;
    cin >> n >> k;
    L.resize(n);
    nxt.resize(n);
    cur.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> nxt[i];
        cin >> L[i];
    }
    gen(0);
    cout << res;
    return 0;
}/*
4 1
1 99
2 100
3 99
0 0

 6 1
 1 100
 2 100
 3 0
 4 0
 5 0
 0 0

 8 2
 5 12
 6 111
 4 101
 0 13
 1 105
 7 14
 2 108
 3 9
*/