//
// Created by Dmitry Dubrovin on 11/20/20.
//

#include "sqsort.h"
#include <vector>
#include <algorithm>
using namespace std;

bool comp(pair<int, int> a, pair<int, int> b) {
    return cmp(a.first, a.second, b.first, b.second);
}

std::vector<std::pair<int, int>> solve(int n) {
    vector<pair<int, int>> res;
    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            res.push_back({i, j});
        }
    }
    sort(res.begin(), res.end(), comp);
    return res;
}
