#include <bits/stdc++.h>
#include "sqsort.h"
using namespace std;
#define app push_back
#define ii pair <int, int> 
#define f first
#define s second

const int N = 2007;
bool used[N][N];
int want[N][N];
int ord[N];

vector <ii> solve(int n) {

    assert(n > 20);

    vector <ii> ans;
    for (int i = 0; i < n; ++i)
        ord[i] = i;

    auto comp1 = [&] (int i, int j) {
        return cmp(i, i, j, j);
    };  
    sort(ord, ord + n, comp1);
    vector <int> num(n);
    for (int i = 0; i < n; ++i)
        num[ord[i]] = i;

    struct Pair {
        int i, j;
        bool operator < (Pair p) const {
            if (i <= p.i && j <= p.j && (i != p.i || j != p.j))
                return 0;
            if (i >= p.i && j >= p.j && (i != p.i || j != p.j))
                return 1;
            return cmp(ord[p.i], ord[p.j], ord[i], ord[j]);            
        }   
    };

    auto cell = [&] (int i, int j) {
        return i <= j && i < n && j < n && i >= 0 && j >= 0;
    };  

    for (int i = 0; i < n; ++i)
        for (int j = i; j < n; ++j)
            want[i][j] = cell(i - 1, j) + cell(i, j - 1);    

    priority_queue <Pair> q;
    auto add = [&] (int i, int j) {
        if (i <= j && i < n && j < n && !used[i][j]) {
            used[i][j] = 1;
            q.push({i, j});
        }   
    };  

    auto check = [&] (int i, int j) {
        if (i <= j && i < n && j < n) {
            assert(!used[i][j]);
            want[i][j]--;
            if (want[i][j] == 0)
                add(i, j);
        }   
    };

    add(0, 0);
    while (q.size()) {
        auto c = q.top(); q.pop();
        int i = c.i, j = c.j;
        ans.app({ord[i], ord[j]});
        check(i + 1, j);
        check(i, j + 1);
    }

    return ans;
}   