#include <bits/stdc++.h>
#define x first
#define y second
#define mp make_pair
#define mt make_tuple
#define all(x) x.begin(), x.end()
using namespace std;


bool cmp(int a, int b, int c, int d);

int K;

int check(int a, int b, int c, int d) {
	if (a > b) {
		assert(false);
	}
	if (c > d) {
		assert(false);
	}
	if (a == c && b == d) {
		return 0;
	}
	if (a <= c && b <= d) {
		return -1;
	}
	if (a >= c && b >= d) {
		return +1;
	}
	if (abs(a + b - c - d) > K) {
		return (a + b) < (c + d) ? -1 : +1;
	}
	return 0;
}

vector<int> per;
vector<int> inv;
map<tuple<int, int, int, int>, bool> mem;

bool query(int a, int b, int c, int d) {
	if (mp(a, b) < mp(c, d)) {
		return !query(c, d, a, b);
	}
	if (inv[a] > inv[b]) {
		swap(a, b);
	}
	if (inv[c] > inv[d]) {
		swap(c, d);
	}
	int x = check(inv[a], inv[b], inv[c], inv[d]);
	if (x < 0) {
		return true;
	}
	if (x > 0) {
		return false;
	}
	bool res = cmp(a, b, c, d);
	return res;
}
mt19937 rnd;

vector<pair<int, int>> solve(int n) {
	K = (int)(0.3 * n);
	per.assign(n, 0);
	iota(all(per), 0);
	sort(all(per), [&](int i, int j) {
		return cmp(i, i, j, j);
	});
	inv = per;
	for (int i = 0; i < n; ++i) {
		inv[per[i]] = i;
	}
	vector<pair<int, int>> a;
	if (n < 150) {
		for (int j = 0; j < n; ++j) {
			for (int i = 0; i <= j; ++i) {
				a.emplace_back(i, j);
			}
		}
	} else {
		for (int i = 0; i < n; ++i) {
			for (int j = i; j < n; ++j) {
				a.emplace_back(i, j);
			}
		}
	}
	// sort(all(a), [&](pair<int, int> p, pair<int, int> q) {
	// 	return inv[p.x] + inv[p.y] > inv[q.x] + inv[q.y];
	// });
	stable_sort(all(a), [&](pair<int, int> p, pair<int, int> q) {
		return query(p.x, p.y, q.x, q.y);
	});
	return a;
}

#ifdef LC
static const int HARD_LIMIT = 50000000;

static int n;
static bool valid_pos(int i) {
	return 0 <= i && i < n;
}
static bool check_valid(const std::vector<std::pair<int, int>> &a) {
	if(n * (n + 1) / 2 != (int)a.size()) {
		return false;
	}
	std::vector<std::vector<bool>> used(n, std::vector<bool>(n, false));
	for(int i = 0; i < (int)a.size(); i++) {
		if(!valid_pos(a[i].first) || !valid_pos(a[i].second) || used[a[i].first][a[i].second]) {
			return false;
		}

		used[a[i].first][a[i].second] = true;
		used[a[i].second][a[i].first] = true;
	}

	return true;
}

static std::vector<int> a;

static int Q;
bool cmp(int a_, int b, int c, int d) {
	if(!valid_pos(a_) || !valid_pos(b) || !valid_pos(c) || !valid_pos(d)) {
		std::cerr << "Invalid query." << std::endl;
		std::cout << -1 << std::endl;
		exit(0);
	}

	Q++;
	if(Q > HARD_LIMIT) {
		std::cerr << "Too many queries." << std::endl;
		std::cout << -1 << std::endl;
		exit(0);
	}

	return a[a_] + a[b] < a[c] + a[d];
}

int main() {
	std::cin >> n;
	a.resize(n);
	for(int i = 0; i < n; i++) {
		a[i] = (int)(rnd() % 10);
	}
	Q = 0;
	std::vector<std::pair<int, int>> ret = solve(n);	
	
	if(!check_valid(ret)) {
		std::cerr << "Invalid output." << std::endl;
		std::cout << -1 << std::endl;
		return 0;
	}

	for(int i = 1; i < (int) ret.size(); i++) { 
		if(a[ret[i].first] + a[ret[i].second] < a[ret[i - 1].first] + a[ret[i - 1].second]) {
			std::cerr << "Output not sorted." << std::endl;
			std::cout << -1 << std::endl;
			return 0;
		}
	}
	
	std::cout << "Correct!" << std::endl;
	std::cout << Q << std::endl;
	cout << round(100 * min(1.0, pow(double(2 * n * n + 1) / (Q + 1), 1.25))) << endl;
	return 0;
}
#endif