#include<bits/stdc++.h>
#include "sqsort.h"
using namespace std;

bool cmpSort( int a, int b ){
    return cmp( a, a, b, b );
}

vector < pair<int,int> > rv;

int findIdx( int x ){

    for(int i=0;i<rv.size();i++) if( rv[i] == pair<int,int>(x,x) ) return i;
    return 0;

}

vector < pair<int, int> > solve( int N ){

    int IDX[N];
    int A[N]; for(int i=0;i<N;i++) A[i] = i;

    sort( A, A+N, cmpSort );

    for(int i=0;i<N;i++) cout << A[i] << ' '; cout << endl;

    for(int i=0;i<N-1;i++){
        IDX[i] = rv.size();
        rv.push_back( { A[i], A[i] } );
        rv.push_back( { A[i], A[i+1] } );
    }
    IDX[N-1] = rv.size();
    rv.push_back( { A[N-1], A[N-1] } );

    for(int i=0;i<N;i++) {
        for(int j=i+2;j<N;j++){

            int L = findIdx( A[i] )+1;
            int R = findIdx( A[j] )-1;
            int mid;
            int target = 0;

            while( L <= R ){

                mid = (L+R) / 2;

                if( cmp( A[i], A[j], rv[mid].first, rv[mid].second ) ){
                    target = mid;
                    R = mid-1;
                }else L = mid+1;

            }

            rv.insert( rv.begin()+target, pair <int, int> ( A[i], A[j] ) );

        }
    }

    return rv;

}