#include "sqsort.h"
#include<bits/stdc++.h>

using namespace std;
//vector<int> c;

vector<pair<int, int>> a;
vector<pair<int, int>> b;

//bool cmp(int x, int y, int x2, int y2) {
//    return c[x] + c[y] < c[x2] + c[y2];
//}

void sort(int l, int r) {
    if (l >= r - 1) return;
    int m = (l + r) / 2;
    sort(l, m);
    sort(m, r);
    b.clear();
    int i = l, j = m;
    while (i < m || j < r) {
        if (i == m) {
            b.push_back(a[j]);
            j++;
        }
        else if (j == r) {
            b.push_back(a[i]);
            i++;
        }
        else if (cmp(a[i].first, a[i].second, a[j].first, a[j].second)) {
            b.push_back(a[i]);
            i++;
        }
        else {
            b.push_back(a[j]);
            j++;
        }
    }
    for (int i = l; i < r; i++) a[i] = b[i - l];
}

std::vector<std::pair<int, int>> solve(int n) {
    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) {
            a.push_back({i, j});
        }
    }
    sort(0, (n * (n + 1)) / 2);
    return a;
}