#include "sqsort.h"
#include<bits/stdc++.h>

using namespace std;
//vector<int> c;

vector<pair<int, int>> a;
vector<pair<int, int>> b;
vector<int> d;

//bool cmp(int x, int y, int x2, int y2) {
//    return c[x] + c[y] < c[x2] + c[y2];
//}

bool cmp2(int x, int y, int x2, int y2) {
    if (d.size() == 0) return cmp(x, y, x2, y2);
    if (d[x] <= d[x2] && d[y] <= d[y2]) return true;
    if (d[y] <= d[x2] && d[x] <= d[y2]) return true;
    if (d[x] >= d[x2] && d[y] >= d[y2]) return false;
    if (d[y] >= d[x2] && d[x] >= d[y2]) return false;
    return cmp(x, y, x2, y2);
}

void sort(int l, int r) {
    if (l >= r - 1) return;
    int m = (l + r) / 2;
    sort(l, m);
    sort(m, r);
    b.clear();
    int i = l, j = m;
    while (i < m || j < r) {
        if (i == m) {
            b.push_back(a[j]);
            j++;
        }
        else if (j == r) {
            b.push_back(a[i]);
            i++;
        }
        else if (cmp2(a[i].first, a[i].second, a[j].first, a[j].second)) {
            b.push_back(a[i]);
            i++;
        }
        else {
            b.push_back(a[j]);
            j++;
        }
    }
    for (int i = l; i < r; i++) a[i] = b[i - l];
}

std::vector<std::pair<int, int>> solve(int n) {
    d.clear();
    for (int i = 0; i < 1; i++) {
        for (int j = i; j < n; j++) {
            a.push_back({i, j});
        }
    }
    sort(0, n);
    d.resize(n);
    for (int i = 0; i < n; i++) {
        d[a[i].second] = i;
    }
    vector<pair<int, int>> A = a;
    vector<pair<int, int>> ans;
    for (int s = 0; s <= 2 * n - 2; s++) {
        a.clear();
        for (int i = 0; i < n; i++) {
            for (int j = i; j < n; j++) {
                if (i + j == s) {
                    int x = A[i].second;
                    int y = A[j].second;
                    a.push_back({min(x, y), max(x, y)});
                }
            }
        }
        sort(0, a.size());
        for (auto el : a) ans.push_back(el);
    }
    return ans;
}