#include<bits/stdc++.h>


#define int long long

using namespace std;

const int maxn = 51;
const int maxm = 7;
const int mod = 1e9 + 7;

int c[maxn][maxn];

int dp[maxm];

int twos[5000];
int fact[5000];

signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    if (n < m) {
        swap(n, m);
    }
    if (n * m <= 15) {
        int res[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
        for (int mask = 0; mask < 1 << (n * m); ++mask) {
            vector<vector<bool>> table(n, vector<bool>(m));
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    table[i][j] = (mask >> (i * m + j)) & 1;
                }
            }
            int sing = 0;
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    int cnt = 0;
                    for (int k = 0; k < n; ++k) {
                        if (table[i][j] == table[k][j]) {
                            ++cnt;
                        }
                    }
                    for (int k = 0; k < m; ++k) {
                        if (table[i][j] == table[i][k]) {
                            ++cnt;
                        }
                    }
                    if (cnt == 2) {
                        sing++;
                    }
                }
            }
            res[sing]++;
        }
        cout << res[0];
        cout << endl;
        exit(0);
    }
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= n; ++j) {
            if (i == 0) c[i][j] = 1;
            else if (i == j) c[i][j] = 1;
            else {
                c[i][j] = c[i][j - 1] + c[i - 1][j - 1];
                if (c[i][j] >= mod) c[i][j] -= mod;
            }
        }
    }
    twos[0] = 1;
    fact[0] = 1;
    for (int i = 1; i < 5000; ++i) {
        twos[i] = (twos[i - 1] * 2) % mod;
        fact[i] = (fact[i - 1] * i) % mod;
    }
    for (int cnt = 0; cnt <= m; ++cnt) {
        int last = (n * m);
        for (int i = 0; i < cnt; ++i) {
            last -= (n + m - 1 - i - i);
        }
        dp[cnt] = (((c[cnt][n] * twos[last]) % mod) * fact[cnt]) % mod;
        if (cnt != 0)
            dp[cnt] = (dp[cnt] * 2) % mod;
    }
    for (int cnt = m; cnt > 0; --cnt) {
        for (int uncnt = cnt - 1; uncnt >= 0; --uncnt) {
            dp[uncnt] -= (dp[cnt] * c[cnt - uncnt][m - uncnt]) % mod;
            dp[uncnt] = ((dp[uncnt] % mod) + mod) % mod;
        }
    }
    cout << dp[0];
}