#include "sqsort.h"
#include <bits/stdc++.h>

using namespace std;


vector<pair<int, int>> solve(int n) {
    vector<pair<int, int>> result;
    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            result.emplace_back(i, j);
        }
    }
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        a[i] = 3 * i % n;
    }
    auto cmpr = [&](const pair<int, int> &l, const pair<int, int> &r) -> bool {
        return a[l.first] + a[l.second] < a[r.first] + a[r.second];
    };
    sort(result.begin(), result.end(), cmpr);
    return result;
}