#include "sqsort.h"
#include <bits/stdc++.h>

using namespace std;


vector<pair<int, int>> solve(int n) {
    vector<pair<int, int>> result;
    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            result.emplace_back(i, j);
        }
    }
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i) {
        a[i] = {0, i};
    }
    auto cmpr = [&](const pair<int, int> &l, const pair<int, int> &r) -> bool {
        return cmp(l.first, l.second, r.first, r.second);
    };
    sort(a.begin(), a.end(), cmpr);
    vector<int> order(n);
    for (int i = 0; i < n; ++i) {
        order[a[i].second] = i;
    }
    auto cmprc = [&](const pair<int, int> &l, const pair<int, int> &r) -> bool {
        if (order[l.first] <= order[r.first] && order[l.second] <= order[r.second]) {
//            if (!cmpr(l, r)) {
//                cout << "Error " << l.first << " " << l.second << " " << r.first << " " << r.second << endl;
//            }
            if (l == r) return false;
            return true;
        }
        if (order[l.first] >= order[r.first] && order[l.second] >= order[r.second]) {
//            if (cmpr(l, r)) {
//                cout << "Error " << l.first << " " << l.second << " " << r.first << " " << r.second << endl;
//            }
            return false;
        }
        return cmpr(l, r);
    };
    sort(result.begin(), result.end(), cmprc);
    return result;
}