#include <bits/stdc++.h>

#include "sqsort.h"

using namespace std;

bool ccmp(int x, int y) {
    return cmp(x, x, y, y);
}
vector <int> d;

int pos[5001];

bool cmp2(int a, int b, int c, int d) {
    if (a == c) {
        return pos[b] <= pos[d];
    }
    if (b == d) {
        return pos[a] <= pos[c];
    }
    if (a == d) {
        return pos[b] <= pos[c];
    }
    if (b == c) {
        return pos[a] <= pos[d];
    }
    if (max(pos[b], pos[a]) <= min(pos[c], pos[d])) {
        return 1;
    }
    if (max(pos[c], pos[d]) <= min(pos[a], pos[b])) {
        return 0;
    }
    if (pos[a] <= pos[c] && pos[c] <= pos[b] && pos[b] <= pos[d]) return 1;
    if (pos[a] <= pos[d] && pos[d] <= pos[b] && pos[b] <= pos[c]) return 1;

    return cmp(a, b, c, d);
}

vector <pair <int, int> > sortt(int l, int r) {
    if (l + 1 == r) {
        vector <pair <int, int> > ans;
        for (int i = 0; i <= l; i++) {
            ans.push_back({d[i], d[l]});
        }
        return ans;
    }
    vector <pair <int, int>> ans, L, R;
    for (int i = r - 1; i >= 0; i--) {
        ans.clear();
        for (int j = 0; j <= i; j++) {
            L.push_back({d[j], d[i]});
        }
        reverse(L.begin(), L.end());
        reverse(R.begin(), R.end());
        ans.push_back(L.back());
        L.pop_back();
        while (!L.empty() && !R.empty()) {
            if (cmp2(L.back().first, L.back().second, R.back().first, R.back().second)) {
                ans.push_back(L.back());
                L.pop_back();
            }
            else {
                ans.push_back(R.back());
                R.pop_back();
            }
        }
        while (!L.empty()) {
            ans.push_back(L.back());
            L.pop_back();
        }
        while (!R.empty()) {
            ans.push_back(R.back());
            R.pop_back();
        }
        R = ans;
    }
    return R;
}



vector <pair <int, int> > solve(int n) {
    vector <pair <int, int> > v;

    for (int i = 0; i < n; i++) {
        d.push_back(i);
    }
    sort(d.begin(), d.end(), ccmp);
   /// d = sort2(0, n);
    for (int i = 0; i < n; i++) pos[d[i]] = i;
    return sortt(0, n);
}
