#include "sqsort.h"
#include <bits/stdc++.h>
using namespace std;

const int DIM = 2e3;

bool mycmp(int a, int b) {
	return !(cmp(0, b, 0, a));
}

vector <pair <int, int>> ans;
vector <int> elem;
int fsBig[DIM + 5][DIM + 5];

void solve(int ls, int ld, vector <int> &st, vector <int> &dr) {
	if (ls > ld) return ;
	if (st.empty() || dr.empty()) return ;
	if (ls == ld) {
		for (int i = st[0]; i <= dr[0] ; ++i) ans.push_back({elem[ls], elem[i]});
//		cerr << ls << " " << st[0] << " " << dr[0] << endl;
		return ;
	}

	vector <int> lst, rst, ldr, rdr;
	int lin = ls, col = dr[0], nr = 0, ll = ls, lr = ls, rl = ls + 1, rr = ls;

	if (st[0] <= dr[0] - 1) {
        lst.push_back(st[0]);
        ldr.push_back(dr[0] - 1);
	} else ++ll, ++lr;

    col = fsBig[lin][col];
    ++lin; ++nr;

    int caz = 0;
	while (lin <= ld) {
        if (caz == 0) {
            if (st[nr] < col && col <= dr[nr]) {
                lst.push_back(st[nr]);
                ldr.push_back(col - 1);

                rst.push_back(col);
                rdr.push_back(dr[nr]);
                ++lr; ++rr;
            } else if (col <= st[nr]) {
                caz = 1;
                rst.push_back(st[nr]);
                rdr.push_back(dr[nr]);
                ++rr;
            } else {
                caz = 2;
                lst.push_back(st[nr]);
                ldr.push_back(dr[nr]);
                ++lr;
            }
        } else if (caz == 1) {
            rst.push_back(st[nr]);
            rdr.push_back(dr[nr]);
            ++rr;
        } else {
            lst.push_back(st[nr]);
            ldr.push_back(dr[nr]);
            ++lr;
        }

        col = fsBig[lin][col];
        ++lin; ++nr;
	}

	solve(ll, lr, lst, ldr);
	ans.push_back({elem[ls], elem[dr[0]]});
	solve(rl, rr, rst, rdr);

}

vector <pair <int, int>> solve(int n) {
	///vad ordinea elementelor prima oara
	elem.clear();
	for (int i = 0; i < n ; ++i) elem.push_back(i);

	sort(elem.begin(), elem.end(), mycmp);
//	for (auto it : elem) cout << it << " ";
//	cout << endl;

	for (int i = 0; i < n - 1 ; ++i) {
		fsBig[i][i] = i;
		for (int j = i; j < n ; ++j) {
			fsBig[i][j] = fsBig[i][j - 1];
			while (cmp(elem[i + 1], elem[fsBig[i][j]], elem[i], elem[j])) ++fsBig[i][j];
		}
	}

//	for (int i = 0; i < n ; ++i) {
//        for (int j = 0; j < n ; ++j) {
//            cout << fsBig[i][j] << " ";
//        }
//        cout << endl;
//	}

	vector <int> st(n);
	vector <int> dr(n);

	for (int i = 0; i < n ; ++i) st[i] = i, dr[i] = n - 1;
	solve(0, n - 1, st, dr);

	for (auto &it : ans) if (it.first > it.second) swap(it.first, it.second);

//	for (auto it : ans) cerr << it.first << " " << it.second << endl;
	return ans;
}
