#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<map>

using namespace std;
const int INF = 1e9;

bool cmp(pair<int, int> a, pair<int, int> b) {
	return a.second < b.second;
}

int main() {
	int n, k;
	cin >> n >> k;
	vector<pair<int, int>> a(n);
	for (int i = 0; i < n; ++i) {
		int t, l;
		cin >> t >> l;
		a[i] = { t, l };
	}
	int ans = 0;
	for (int mask = 0; mask < (1 << n); ++mask) {
		set<int> hah;
		for (int i = 0; i < n; ++i) {
			if (mask & (1 << i))
				hah.insert(i);
		}
		int cur_res = 0;
		map<int, int> need_to_win;
		int cur_stolen = 0;
		for (auto i : hah) {
			need_to_win[i] += k;
			if (hah.find(a[i].first) == hah.end()) {
				need_to_win[i] -= k;
				++cur_stolen;
			}
			else {
				need_to_win[i] -= k;
				need_to_win[a[i].first] += k;
			}
			cur_res += a[i].second;
		}
		for (auto i: need_to_win){
			cur_stolen += i.second;
		}
		if (cur_stolen > n - hah.size()) {
			cur_res = 0;
		}
		ans = max(ans, cur_res);
	}
	cout << ans;
}