#include <iostream>
#include <cstdio>
#include <vector>
#include <utility>
#include <algorithm>

#include "sqsort.h"
//#include "sqsort.cpp"
using namespace std;

//bool cmp(int a, int b, int c, int d);

vector<pair<int, int>> v , w;

void sortare (int st , int dr){
   int mid = (st + dr)/2 , i , j , poz;

   //printf ("%d %d\n",st , dr);

   if (st == dr)
        return;

   sortare(st , mid);
   sortare(mid + 1 , dr);

   for (i = st ; i <= dr ; i++)
        w[i] = v[i];

   i = st;
   j = mid + 1;

   poz = st;
   while (i <= mid && j <= dr){
        if (cmp (w[i].first , w[i].second , w[j].first , w[j].second)){
            v[poz] = w[i];
            i++;
            poz++;
        }
        else {
            v[poz] = w[j];
            j++;
            poz++;
        }
   }

   while (i <= mid){
        v[poz] = w[i];
        poz++;
        i++;
   }

   while (j <= dr){
        v[poz] = w[j];
        poz++;
        j++;
   }



}


vector<pair<int, int>> solve(int n){
    int l , r , i;


    l = r = 0;
    for (i = 1 ; i <= n * (n + 1) / 2 ; i++){
        v.push_back(make_pair(l , r));
        w.push_back(make_pair(l , r));
        r++;
        if (r == n){
            l++;
            r = l;
        }
    }
    sortare (0 , n * (n + 1) / 2 - 1);
    return v;

}