#include <iostream>
#include <cstdio>
#include <vector>
#include <utility>
#include <algorithm>

#include "sqsort.h"
//#include "sqsort.cpp"
using namespace std;

//bool cmp(int a, int b, int c, int d);

vector<pair<int, int>> v , w , aux;
int poz[2010] , what[2010];



int fct (pair <int , int> x , pair <int , int> y){
    int minx , maxx , miny , maxy , d1 , d2 , d3;

    minx = min(poz[x.first] , poz[x.second]);
    maxx = max(poz[x.first] , poz[x.second]);

    miny = min(poz[y.first] , poz[y.second]);
    maxy = max(poz[y.first] , poz[y.second]);

    if (minx <= miny && maxx <= maxy)
        return 1;
    else if (minx >= miny && maxx >= maxy)
        return 0;

    d1 = max(maxy - miny , maxx - minx) / 900 - max(minx - miny , miny - minx);

    d2 = max(maxy - miny , maxx - minx) / 900 - max(maxx - maxy , maxy - maxx);

    d3 = max(maxy - miny , maxx - minx) / 900 - min(maxx - minx , maxy - miny);

    if (d1 > 0 && d2 < 0 && d3 > 0){
        if (minx < miny)
            return 0;
        else return 1;
    }
    else if (d1 < 0 && d2 > 0 && d3 > 0){
        if (maxx < maxy)
            return 0;
        else return 1;
    }
    return cmp(x.first , x.second , y.first , y.second);
}

int fct2 (pair <int , int> x , pair <int , int> y){
    return cmp(x.first , x.second , y.first , y.second);
}

void sortare (int st , int dr){
   int mid = (st + dr)/2 , i , j , poz;

   //printf ("%d %d\n",st , dr);

   if (st == dr)
        return;

   sortare(st , mid);
   sortare(mid + 1 , dr);

   for (i = st ; i <= dr ; i++)
        w[i] = v[i];

   i = st;
   j = mid + 1;

   poz = st;
   while (i <= mid && j <= dr){
        if (fct (w[i] , w[j])){
            v[poz] = w[i];
            i++;
            poz++;
        }
        else {
            v[poz] = w[j];
            j++;
            poz++;
        }
   }

   while (i <= mid){
        v[poz] = w[i];
        poz++;
        i++;
   }

   while (j <= dr){
        v[poz] = w[j];
        poz++;
        j++;
   }



}


void sortare2 (int st , int dr){
   int mid = (st + dr)/2 , i , j , poz;

   //printf ("%d %d\n",st , dr);

   if (st == dr)
        return;

   sortare2(st , mid);
   sortare2(mid + 1 , dr);

   for (i = st ; i <= dr ; i++)
        aux[i] = w[i];

   i = st;
   j = mid + 1;

   poz = st;
   while (i <= mid && j <= dr){
        if (fct2 (aux[i] , aux[j])){
            w[poz] = aux[i];
            i++;
            poz++;
        }
        else {
            w[poz] = aux[j];
            j++;
            poz++;
        }
   }

   while (i <= mid){
        w[poz] = aux[i];
        poz++;
        i++;
   }

   while (j <= dr){
        w[poz] = aux[j];
        poz++;
        j++;
   }



}

vector<pair<int, int>> solve(int n){
    int l , r , i;

    aux.resize(2 * n);

    for (i = 0 ; i < n ; i++)
        w.push_back(make_pair(i , i));

    sortare2 (0 , n - 1);
    //sort (w.begin() , w.end() , fct2);

    for (i = 0 ; i < n ; i++){
        poz[w[i].first] = i;
        what[i] = w[i].first;
    }

    l = r = 0;
    for (i = 1 ; i <= n * (n + 1) / 2 ; i++){
        v.push_back(make_pair(what[l] , what[r]));
        r++;
        if (r == n){
            l++;
            r = l;
        }
    }

    w.resize(v.size());

    sortare (0 , v.size() - 1);

    //for (i = 0 ; i < v.size() ; i++){
      //  printf ("%d %d\n",v[i].first , v[i].second);
    //}

    return v;

}