#include "sqsort.h"

using namespace std;
struct vec{int a,b;} v[2200005],vst[2200005],vdr[2200005];
int val[2005],stv[2005],drv[2005];
int ps,pd;
void cb1(int st, int dr)
{
    if(st>=dr) return ;
    int x=val[(st+dr)/2];
    int stl=0,drl=0;
    for(int i=st; i<=dr; i++)
    {
        if(val[i]==x)
        {
            x=x;
        }
        else
        {
            if(cmp(0,val[i],0,x))
            {
                stl++;
                stv[stl]=val[i];
            }
            else
            {
                drl++;
                drv[drl]=val[i];
            }
        }
    }
    for(int i=st; i<=st+stl-1; i++)
    {
        val[i]=stv[i-st+1];
        stv[i-st+1]=0;
    }
    val[st+stl]=x;
    for(int i=st+stl+1; i<=dr; i++)
    {
        val[i]=drv[i-st-stl];
        drv[i-st-stl]=0;
    }
    cb1(st,st+stl-1);
    cb1(st+stl+1,dr);
}
void cb2(int st, int dr)
{
    if(st>=dr) return ;
    vec x;
    if(ps&&pd)
    {
        int e=ps*st+pd*dr+ps+pd-1;
        e/=(ps+pd);
        x=v[e];
    }
    else x=v[(st+dr+1)/2];
    int lst=0,ldr=0,b1=st,b2=0,mij=0,p=st;
    for(int i=st+1; i<=dr; i++)
    {
        if(v[i].a!=v[i-1].a)
        {
            b2=i-1;
            while(v[b1].a<=x.a&&v[b1].b<=x.b&&(v[b1].a!=x.a||v[b1].b!=x.b)) b1++;
            while(v[b2].a>=x.a&&v[b2].b>=x.b) b2--;
            while(b1<=b2)
            {
                mij=(b1+b2)/2;
                if(cmp(val[v[mij].a],val[v[mij].b],val[x.a],val[x.b])) b1=mij+1;
                else b2=mij-1;
            }
            for(int j=p; j<=b2; j++)
            {
                lst++;
                vst[lst]=v[j];
            }
            for(int j=b1; j<=i-1; j++)
            {
                ldr++;
                vdr[ldr]=v[j];
            }
            b1=i;
            p=i;
        }
    }
    b2=dr;
    while(v[b1].a<=x.a&&v[b1].b<=x.b&&(v[b1].a!=x.a||v[b1].b!=x.b)) b1++;
    while(v[b2].a>=x.a&&v[b2].b>=x.b) b2--;
    while(b1<=b2)
    {
        mij=(b1+b2)/2;
        if(cmp(val[v[mij].a],val[v[mij].b],val[x.a],val[x.b])) b1=mij+1;
        else b2=mij-1;
    }
    for(int j=p; j<=b2; j++)
    {
        lst++;
        vst[lst]=v[j];
    }
    for(int j=b1; j<=dr; j++)
    {
        ldr++;
        vdr[ldr]=v[j];
    }
    for(int i=st; i<=st+lst-1; i++)
    {
        v[i]=vst[i-st+1];
        vst[i-st+1].a=0;
        vst[i-st+1].b=0;
    }
    for(int i=st+lst; i<=dr; i++)
    {
        v[i]=vdr[i-st-lst+1];
        vdr[i-st-lst+1].a=0;
        vdr[i-st-lst+1].b=0;
    }
    if(lst==0)
    {
        lst=0;
        ldr=0;
        for(int i=st; i<=dr; i++)
        {
            if(cmp(val[x.a],val[x.b],val[v[i].a],val[v[i].b])==0)
            {
                lst++;
                vst[lst]=v[i];
            }
            else
            {
                ldr++;
                vdr[ldr]=v[i];
            }
        }
        for(int i=st; i<=st+lst-1; i++)
        {
            v[i]=vst[i-st+1];
            vst[i-st+1].a=0;
            vst[i-st+1].b=0;
        }
        for(int i=st+lst; i<=dr; i++)
        {
            v[i]=vdr[i-st-lst+1];
            vdr[i-st-lst+1].a=0;
            vdr[i-st-lst+1].b=0;
        }
        cb2(st+lst,dr);
        return ;
    }
    if(ps==0&&pd==0)
    {
        ps=lst;
        pd=ldr;
    }
    cb2(st, st+lst-1);
    cb2(st+lst,dr);
}
std::vector<std::pair<int, int> > solve(int n)
{
    int m=0;
    for(int i=1; i<=n; i++)
    {
        val[i]=i-1;
    }
    cb1(1,n);
    for(int i=1; i<=n; i++)
    for(int j=i; j<=n; j++)
    {
        m++;
        v[m].a=i;
        v[m].b=j;
    }
    cb2(1,m);
    std::vector<std::pair<int, int> > sol;
    for(int i=1; i<=m; i++)
    {
        sol.push_back(make_pair(val[v[i].a],val[v[i].b]));
    }
    return sol;
}
