#include<bits/stdc++.h>
#include "sqsort.h"
using namespace std;
typedef int ll;
vector<pair<ll,ll> > mrg(vector<pair<ll,ll> > a)
{
    if(a.size()<=1)
        return a;
    vector<pair<ll,ll> > lft,rgt,ans;
    for(int i=0;i<a.size()/2;i++)
        lft.push_back(a[i]);
    for(int i=a.size()/2;i<a.size();i++)
        rgt.push_back(a[i]);
    random_shuffle(lft.begin(),lft.end());
    random_shuffle(rgt.begin(),rgt.end());
    lft=mrg(lft);
    rgt=mrg(rgt);
    ll i=0;
    ll j=0;
    while(i<lft.size()||j<rgt.size())
    {
        if(i==lft.size())
        {
            ans.push_back(rgt[j]);
            j++;
            continue;
        }
        if(j==rgt.size())
        {
            ans.push_back(lft[i]);
            i++;
            continue;
        }
        ll a=lft[i].first;
        ll b=lft[i].second;
        ll c=rgt[j].first;
        ll d=rgt[j].second;
        if(cmp(a,b,c,d))
        {
            ans.push_back(lft[i]);
            i++;
        }
        else
        {
            ans.push_back(rgt[j]);
            j++;
        }
    }
    return ans;
}
vector<pair<int,int> > solve(int n)
{
    srand(time(NULL));
    vector<pair<int,int> > ans;
    for(int i=0;i<n;i++)
        for(int j=i;j<n;j++)
            ans.push_back({i,j});
    random_shuffle(ans.begin(),ans.end());
    ans=mrg(ans);
    return ans;
}
