#include<bits/stdc++.h>
#include "sqsort.h"
using namespace std;
typedef int ll;
vector<pair<ll,ll> > mrg(vector<pair<ll,ll> > a)
{
    if(a.size()<=1)
        return a;
    vector<pair<ll,ll> > lft,rgt,ans;
    for(int i=0;i<a.size()/2;i++)
        lft.push_back(a[i]);
    for(int i=a.size()/2;i<a.size();i++)
        rgt.push_back(a[i]);
    lft=mrg(lft);
    rgt=mrg(rgt);
    ll i=0;
    ll j=0;
    while(i<lft.size()||j<rgt.size())
    {
        if(i==lft.size())
        {
            ans.push_back(rgt[j]);
            j++;
            continue;
        }
        if(j==rgt.size())
        {
            ans.push_back(lft[i]);
            i++;
            continue;
        }
        ll a=lft[i].first;
        ll b=lft[i].second;
        ll c=rgt[j].first;
        ll d=rgt[j].second;
        if(cmp(a,b,c,d))
        {
            ans.push_back(lft[i]);
            i++;
        }
        else
        {
            ans.push_back(rgt[j]);
            j++;
        }
    }
    return ans;
}
vector<pair<int,int> > solve1(int n)
{
    vector<pair<int,int> > ans,a;
    for(int i=0;i<n;i++)
    {
        a.push_back({i,i});
    }
    a=mrg(a);
    ll ptr[n];
    for(int i=0;i<n;i++)
    {
        ptr[i]=0;
    }
    for(int i=0;i<n;i++)
    {
        for(int j=0;j<=i;j++)
        {
            //cerr<<i<<' '<<j<<' '<<a[i].first<<' '<<a[j].second<<'\n';
            if(i==j)
                ptr[j]=ans.size();
            while(ptr[j]<ans.size())
            {
                if(cmp(ans[ptr[j]].first,ans[ptr[j]].second,a[j].first,a[i].first))
                    ptr[j]++;
                else
                    break;
            }
            ll cur=ptr[j];
            for(int k=0;k<n;k++)
            {
                if(ptr[k]>cur)
                    ptr[k]++;
                if(k>=j)
                    ptr[k]=max(ptr[k],cur+1);
                if(k&&ptr[k]<ptr[k-1])
                    ptr[k]=ptr[k-1]+1;
            }
            ans.insert(cur+ans.begin(),make_pair(min(a[j].first,a[i].first),max(a[i].first,a[j].first)));
        }
    }
    return ans;
}
vector<pair<ll,ll> > solve(ll n)
{
    return solve1(n);
}
