#include <bits/stdc++.h>
#include "sqsort.h"

using namespace std;

int alcomp[2005][2005];

bool tmpc(pair<int,int> x, pair<int,int> y)
{
    if(alcomp[x.first][y.first] == alcomp[x.second][y.second]) return alcomp[x.first][y.first];
    if(alcomp[x.first][y.second] == alcomp[x.second][y.first]) return alcomp[x.first][y.second];
    return cmp(x.first, x.second, y.first, y.second);
}

std::vector<std::pair<int, int>> solve(int n)
{
    for(int i = 0; i < n; i++)
    for(int j = i+1; j < n; j++) {
        alcomp[i][j] = cmp(0, i, 0, j);
        alcomp[j][i] = !alcomp[i][j];
    }
    vector<pair<int, int>> ret;
    for(int i = 0; i < n; i++)
    for(int j = i; j < n; j++)
        ret.push_back(make_pair(i, j));

    sort(ret.begin(), ret.end(), tmpc);

    return ret;
}
