#include <bits/stdc++.h>
#include "sqsort.h"

struct Pair {
	int i, j;

	bool operator<(const Pair x) const {
		return cmp(i, j, x.i, x.j);
	}
};

std::vector<std::pair<int, int> > solve(int n) {
	std::vector<Pair> elem;

	for(int i = 0; i < n; ++i)
		for(int j = i; j < n; ++j)
			elem.push_back({i, j});
	
	srand(time(NULL));
	std::random_shuffle(elem.begin(), elem.end());

	std::sort(elem.begin(), elem.end()); // N^2logN^2
	
	std::vector<std::pair<int, int> > ans;
	for(auto it: elem)
		ans.push_back({it.i, it.j});
	return ans;
}
