//#pragma GCC target("avx,avx2,sse3,ssse3,sse4.1,sse4.2,tune=native")
//#pragma GCC optimize(3)
//#pragma GCC optimize("O3")
//#pragma GCC optimize("inline")
//#pragma GCC optimize("-fgcse")
//#pragma GCC optimize("-fgcse-lm")
//#pragma GCC optimize("-fipa-sra")
//#pragma GCC optimize("-ftree-pre")
//#pragma GCC optimize("-ftree-vrp")
//#pragma GCC optimize("-fpeephole2")
//#pragma GCC optimize("-fsched-spec")
//#pragma GCC optimize("-falign-jumps")
//#pragma GCC optimize("-falign-loops")
//#pragma GCC optimize("-falign-labels")
//#pragma GCC optimize("-fdevirtualize")
//#pragma GCC optimize("-fcaller-saves")
//#pragma GCC optimize("-fcrossjumping")
//#pragma GCC optimize("-fthread-jumps")
//#pragma GCC optimize("-freorder-blocks")
//#pragma GCC optimize("-fschedule-insns")
//#pragma GCC optimize("inline-functions")
//#pragma GCC optimize("-ftree-tail-merge")
//#pragma GCC optimize("-fschedule-insns2")
//#pragma GCC optimize("-fstrict-aliasing")
//#pragma GCC optimize("-falign-functions")
//#pragma GCC optimize("-fcse-follow-jumps")
//#pragma GCC optimize("-fsched-interblock")
//#pragma GCC optimize("-fpartial-inlining")
//#pragma GCC optimize("no-stack-protector")
//#pragma GCC optimize("-freorder-functions")
//#pragma GCC optimize("-findirect-inlining")
//#pragma GCC optimize("-fhoist-adjacent-loads")
//#pragma GCC optimize("-frerun-cse-after-loop")
//#pragma GCC optimize("inline-small-functions")
//#pragma GCC optimize("-finline-small-functions")
//#pragma GCC optimize("-ftree-switch-conversion")
//#pragma GCC optimize("-foptimize-sibling-calls")
//#pragma GCC optimize("-fexpensive-optimizations")
//#pragma GCC optimize("inline-functions-called-once")
//#pragma GCC optimize("-fdelete-null-pointer-checks")

#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}

const int N = 1e4 + 10, MOD = 1e9 + 7, base = 131, INF = 1e9;

int n, k, dp[N][2][2], ans;
pair < int , int > a[N];
vector < int > b;

void f() {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < 2; j++) {
            for (int h = 0; h < 2; h++) {
                dp[i][j][h] = -INF;
            }
        }
    }
    dp[0][0][0] = 0;
    for (int i = 1; i < n; i++) {
        dp[0][1][0] = 0;
        for (int j = 1; j <= n; j++) {
            dp[j][1][1] = max(dp[j][0][0], dp[j][0][1]);
            if (j >= 2) {
                dp[j][1][1] = max(dp[j][1][1], dp[j - 2][0][0] + a[b[i - 1]].second);
            }
            if (j >= k + 1) {
                dp[j][1][1] = max(dp[j][1][1], max(dp[j - k - 1][0][1], dp[j - k - 1][0][0]) + a[b[i]].second);
            }
            dp[j][1][0] = max(dp[j][0][1], dp[j][0][0]);
            ans = max(ans, max(dp[j][1][0], dp[j][1][1]));
        }
        for (int j = 0; j <= n; j++) {
            dp[j][0][0] = dp[j][1][0];
            dp[j][0][1] = dp[j][1][1];
            dp[j][1][0] = -INF;
            dp[j][1][1] = -INF;
        }
    }
}

void solve() {
    cin >> n >> k;
    int e = 0, mn = INF;
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
        if (a[i].second < mn) {
            e = i;
            mn = a[i].second;
        }
    }

    int cur = a[e].first;
    while (cur != e) {
        b.push_back(cur);
        cur = a[cur].first;
    }
    b.push_back(e);
    f();
    
    cout << ans;
}