#include <bits/stdc++.h>
#ifndef ALEXPC
#include "sqsort.h"
#else
bool cmp(int a, int b, int c, int d);
std::vector<std::pair<int, int>> solve(int n);
#endif
using namespace std;

typedef long long ll;

#define FOR(i,n) for (int i=0;i<(n);++i)
#define FORT(i,a,b) for (int i=(a);i<=b;++i)
#define FORD(i,n) for (int i=(n)-1;i>=0;--i)
#define FORTD(i,a,b) for (int i=(a);i>=b;--i)
#define trav(to,v) for (auto to : v)
#define all(v) v.begin(),v.end()
#define fr first
#define sc second
#define ad push_back
#define pir pair<int,int> 
#define fastio ios_base::sync_with_stdio(false);cin.tie(0)

const signed N=2006;
const ll MOD=1e9+7;


int ind[N];
struct ban1{
	int x;
	ban1(int _i){
		x=_i;
	}
	bool operator < (ban1 other){
		return cmp(x,x,other.x,other.x);
	}
};
vector<ban1> b;

struct ban{
	int i,j;
	ban(int _i,int _j){
		i=_i;
		j=_j;
		if (ind[i]>ind[j]) swap(i,j);
	}
	bool operator <(ban other){
		if (ind[i]<=ind[other.i] && ind[j]<=ind[other.j])return true;
		if (ind[i]>=ind[other.i] && ind[j]>=ind[other.j])return false;
		return cmp(i,j,other.i,other.j);
	}
};

vector<pair<int, int> > solve(int n){
	FOR(i,n){
		b.ad({i});
	}
	sort(all(b));
	FOR(i,b.size()){
		ind[b[i].x]=i;
	}
	vector<ban> a;
	FOR(i,n){
		FORT(j,i,n-1){
			a.ad({i,j});
		}
	}
	sort(all(a));
	vector<pir> ans;
	trav(to,a)ans.ad({to.i,to.j});
	return ans;
}








#ifdef ALEXPC
static const int HARD_LIMIT = 50000000;
static int n;
static std::vector<int> a;

static bool valid_pos(int i) {
	return 0 <= i && i < n;
}

static int Q;
bool cmp(int a_, int b, int c, int d) {
	//cout<<a_<<" "<<b<<" "<<c<<" "<<d<<endl;
	if(!valid_pos(a_) || !valid_pos(b) || !valid_pos(c) || !valid_pos(d)) {
		std::cerr << "Invalid query." << std::endl;
		std::cout << -1 << std::endl;
		exit(0);
	}

	Q++;
	if(Q > HARD_LIMIT) {
		std::cerr << "Too many queries." << std::endl;
		std::cout << -1 << std::endl;
		exit(0);
	}

	return a[a_] + a[b] < a[c] + a[d];
}

static bool check_valid(const std::vector<std::pair<int, int>> &a) {
	if(n * (n + 1) / 2 != (int)a.size()) {
		return false;
	}

	std::vector<std::vector<bool>> used(n, std::vector<bool>(n, false));
	for(int i = 0; i < (int)a.size(); i++) {
		if(!valid_pos(a[i].first) || !valid_pos(a[i].second) || used[a[i].first][a[i].second]) {
			return false;
		}

		used[a[i].first][a[i].second] = true;
		used[a[i].second][a[i].first] = true;
	}

	return true;
}

int main() {
	std::cin >> n;
	a.resize(n);
	for(int i = 0; i < n; i++) {
		a[i] = 3 * i % n;
	}

	Q = 0;
	std::vector<std::pair<int, int>> ret = solve(n);	
	
	if(!check_valid(ret)) {
		std::cerr << "Invalid output." << std::endl;
		std::cout << -1 << std::endl;
		return 0;
	}

	for(int i = 1; i < (int) ret.size(); i++) { 
		if(a[ret[i].first] + a[ret[i].second] < a[ret[i - 1].first] + a[ret[i - 1].second]) {
			std::cerr << "Output not sorted." << std::endl;
			std::cout << -1 << std::endl;
			return 0;
		}
	}
	
	std::cerr << "Correct!" << std::endl;
	std::cout << Q << std::endl;
	return 0;
}

#endif