#include <iostream>

using namespace std;

const int NMAX = 1e4 + 5;

int N, K;
int T[NMAX], L[NMAX];

int sum[NMAX];

int ans = 0;

int n_op = 0;

int V[NMAX];

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N >> K;

    for(int i = 1; i <= N; ++i)
        cin >> T[i] >> L[i], ++T[i];

    return;
}

static inline int my_max (int a, int b)
{
    return ((a > b) ? a : b);
}

static inline void Back (int Level, int until_now)
{
    ++n_op;

    if(n_op > 2e7)
        return;

    if(Level == (N + 1))
    {
        ans = my_max(ans, until_now);

        return;
    }

    for(int j = 1; j <= N; ++j)
    {
        int i = V[j];

        if(n_op > 2e7)
            return;

        if(sum[i] < (K << 1))
        {
            if(Level == i || Level == T[i])
                sum[i] += K;
            else sum[i] += 1;

            if(sum[i] >= (K << 1))
                Back(Level + 1, until_now + L[i]);
            else Back(Level + 1, until_now);

            if(Level == i || Level == T[i])
                sum[i] -= K;
            else sum[i] -= 1;
        }
    }

    return;
}

int main()
{
    Read();

    for(int i = 1; i <= N; ++i)
        V[i] = i;

    for(int i = 1; i < N; ++i)
        for(int j = i + 1; j <= N; ++j)
            if(L[V[i]] < L[V[j]])
                swap(V[i], V[j]);

    Back(1, 0);

    cout << ans << '\n';

    return 0;
}
