#include <bits/stdc++.h>
#include "sqsort.h"
using namespace std;

typedef long long ll;
typedef long double ld;
/*
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unswitch-loops")
 
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target ("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,abm,mmx,avx,avx2,popcnt,tune=native")
*/

mt19937 gen;

#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()
#define chkmin(x, y) x = min(x, y)
#define chkmax(x, y) x = max(x, y)

vector<int> arr;

int cnt = 0;

/*
bool cmp(int a, int b, int c, int d) {
	cnt++;
	return arr[a] + arr[b] < arr[c] + arr[d];
}
*/

const int N = 2001;

vector<int> g[N * N];
vector<int> G[N * N];
int used[N * N];
int head = 0;
int pos[N * N];

void dfs(int v) {
	used[v] = 1;
	for(int to : G[v]) {
		if (!used[to]) dfs(to);
	}
	pos[v] = -(head++);
}

int p[N * N];
bool cm(pair<int, int> a, pair<int, int> b) {
	int x = p[a.first * N + a.second];
	int y = p[b.first * N + b.second];
	return pos[x] < pos[y];
}

int comp[N * N];
int timer = 0;


int pa(int x) {
	if (p[x] == x) return x;
	return p[x] = pa(p[x]);
}

void join(int x, int y) {
	x = pa(x);
	y = pa(y);
	p[x] = y;
}

inline int get(int x, int y) {
	if (x > y) swap(x, y);
	return x * N + y;
}

vector<pair<int, int>> solve(int n) {
	for(int i = 0; i < n; i++) {
		for(int j = i; j < n; j++) {
			if (i + 1 < n) {
				g[get(i, j)].push_back(get(i + 1, j));
			}
			if (j + 1 < n) {
				g[get(i, j)].push_back(get(i, j + 1));
			}
		}
	} 
	iota(p, p + N * N, 0);
	for(int i = 0; i < n; i++) {
		for(int j = i; j < n; j++) {
			if (i + 1 < n && j - 1 >= 0) {
				if (cmp(i, j, i + 1, j - 1)) {
					g[get(i, j)].push_back(get(i + 1, j - 1));
				} else if (cmp(i + 1, j - 1, i, j)) {
					g[get(i + 1, j - 1)].push_back(get(i, j));
				} else {
					join(get(i + 1, j - 1), get(i, j));
				}
			}
		}
	}
	for(int i = 0; i < N * N; i++) pa(i);
	for(int i = 0; i < N * N; i++) {
		for(int x : g[i]) {
			if (p[i] != p[x]) {
				G[p[i]].push_back(p[x]);
			}
		}
	}
	dfs(p[0]);
	vector<pair<int, int>> ret;
	for(int i = 0; i < n; i++) {
		for(int j = i; j < n; j++) {
			ret.emplace_back(i, j);
		}
	}
	sort(all(ret), cm);
	return ret;
}

/*

signed main() {
#ifdef LOCAL
	freopen("input", "r", stdin);
	freopen("output", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	cin.tie(0);
	arr.resize(2000);
	iota(all(arr), 0);
	sort(all(arr));
	//shuffle(all(arr), gen);
	auto get = solve(size(arr));

	/*
	for(int x : arr) cout << x << ' '; cout << endl;
	for(auto x : get) cout << x.first << ' ' << x.second << endl;
	for(int i = 0; i + 1 < size(get); i++) {
		assert(arr[get[i].first] + arr[get[i].second] <= arr[get[i + 1].first] + arr[get[i + 1].second]);
	}
}
	*/