#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = 10101;
const int INF = 1e9;

int N, k;
int dp[2][MAXN][2][2];

vector<int> solve(vector<int> a)
{
    for (int i = 0; i < MAXN; i++)
        for (int j = 0; j < 2; j++)
            for (int k = 0; k < 2; k++)
                for (int l = 0; l < 2; l++)
                    dp[j][i][k][l] = -INF;
    int n = a.size();
    dp[(n - 1) & 1][0][0][0] = 0;
    if (k + 1 <= N)
    {
        dp[(n - 1) & 1][k + 1][1][0] = a[n - 1];
        dp[(n - 1) & 1][k + 2][0][1] = a[n - 1];
    }
    if (2 <= N)
    {
        dp[(n - 1) & 1][2][1][1] = a[n - 1];
    }
    for (int person = n - 2; person >= 0; person--)
    {
        for (int badges = 0; badges <= N; badges++)
        {
            // do not take
            dp[person & 1][badges][0][0] = max(dp[person & 1][badges][0][0], dp[(person + 1) & 1][badges][0][0]);
            dp[person & 1][badges][0][0] = max(dp[person & 1][badges][0][0], dp[(person + 1) & 1][badges][1][0]);
            // take with i-th
            if (badges + k + 1 <= N)
            {
                dp[person & 1][badges + k + 1][1][0] = max(dp[person & 1][badges + k + 1][1][0], dp[(person + 1) & 1][badges][0][0] + a[person]);
                dp[person & 1][badges + k + 1][1][0] = max(dp[person & 1][badges + k + 1][1][0], dp[(person + 1) & 1][badges][1][0] + a[person]);
            }
            // take with (i+1)-th
            if (badges + k + 1 <= N)
            {
                dp[person & 1][badges + k + 1][0][0] = max(dp[person & 1][badges + k + 1][0][0], dp[(person + 1) & 1][badges][0][0] + a[person]);
            }
            // take both
            if (badges + 2 <= N)
            {
                dp[person & 1][badges + 2][1][0] = max(dp[person & 1][badges + 2][1][0], dp[(person + 1) & 1][badges][0][0] + a[person]);
            }

            // do not take
            dp[person & 1][badges][0][1] = max(dp[person & 1][badges][0][1], dp[(person + 1) & 1][badges][0][1]);
            dp[person & 1][badges][0][1] = max(dp[person & 1][badges][0][1], dp[(person + 1) & 1][badges][1][1]);
            // take with i-th
            if (badges + k + 1 <= N && person > 0)
            {
                dp[person & 1][badges + k + 1][1][1] = max(dp[person & 1][badges + k + 1][1][1], dp[(person + 1) & 1][badges][0][1] + a[person]);
                dp[person & 1][badges + k + 1][1][1] = max(dp[person & 1][badges + k + 1][1][1], dp[(person + 1) & 1][badges][1][1] + a[person]);
            }
            // take with (i+1)-th
            if (badges + k + 1 <= N)
            {
                dp[person & 1][badges + k + 1][0][1] = max(dp[person & 1][badges + k + 1][0][1], dp[(person + 1) & 1][badges][0][1] + a[person]);
            }
            // take both
            if (badges + 2 <= N && person > 0)
            {
                dp[person & 1][badges + 2][1][1] = max(dp[person & 1][badges + 2][1][1], dp[(person + 1) & 1][badges][0][1] + a[person]);
            }
        }
    }
    vector<int> ans(N + 1);
    for (int i = 0; i < N + 1; i++)
    {
        ans[i] = max(ans[i], dp[0][i][0][0]);
        ans[i] = max(ans[i], dp[0][i][0][1]);
        ans[i] = max(ans[i], dp[0][i][1][0]);
        ans[i] = max(ans[i], dp[0][i][1][1]);
    }
    return ans;
}

int dp2[2][MAXN];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n >> k, N = n;
    vector<int> t(n), l(n);
    for (int i = 0; i < n; i++)
    {
        cin >> t[i] >> l[i];
    }
    vector<int> vis(n);
    vector<vector<int> > costs;
    for (int i = 0; i < n; i++)
    {
        if (vis[i] == 0)
        {
            vector<int> a = {l[i]};
            vis[i] = 1;
            int fl = t[i];
            while (vis[fl] != 1)
            {
                vis[fl] = 1;
                a.push_back(l[fl]);
                fl = t[fl];
            }
            costs.push_back(solve(a));
        }
    }
    for (int g = 0; g < costs.size(); g++)
    {
        for (int bf = 0; bf <= n; bf++)
        {
            for (int h = 0; bf + h <= n; h++)
            {
                dp2[(g + 1) & 1][bf + h] = max(dp2[(g + 1) & 1][bf + h], dp2[g & 1][bf] + costs[g][h]);
            }
        }
    }
    int ans = 0;
    for (int i = 0; i <= n; i++)
        ans = max(ans, dp2[(costs.size()) & 1][i]);
    cout << ans;
}
