#include <bits/stdc++.h>

#ifdef LOCAL

#else
#include "sqsort.h"
#endif // LOCAL

using namespace std;

const int N = 2000;
int n;
int x[N];
int qu;

#ifdef LOCAL
bool cmp(int a, int b, int c, int d)
{
    qu++;
    return x[a] + x[b] < x[c] + x[d];
}
#endif // LOCAL

typedef pair<int, int> pii;
map<pair<pii, pii>, int> mm;

bool cmp_s(int a, int b, int c, int d)
{
    if (mm.find({{a, b}, {c, d}}) != mm.end())
        return mm[{{a, b}, {c, d}}];
    return mm[{{a, b}, {c, d}}] = cmp(a, b, c, d);
}

std::vector<std::pair<int, int> > solve(int n)
{
    vector<int> p(n);
    iota(p.begin(), p.end(), 0);
    sort(p.begin(), p.end(), [&](int x, int y){
         return cmp(x, x, y, y);
         });
    //for (int i = 0; i < p.size(); i++)
    //    cout << p[i] << " ";
    //cout << endl;
    vector<int> pos(n);
    for (int i = 0; i < p.size(); i++)
        pos[i] = p[i];
    vector<int> pointer(n);
    iota(pointer.begin(), pointer.end(), 0);
    vector<pair<int, int> > res;
    while (1)
    {
        pair<int, int> sm = {-1, -1};
        for (int select = 0; select < n; select++)
        {
            if (pointer[select] < n)
            {
                if (sm.first == -1) sm = {select, pointer[select]};
                else if (cmp_s(pos[select], pos[pointer[select]], pos[sm.first], pos[sm.second])) sm = {select, pointer[select]};
            }
        }
        if (sm.first == -1) break;
        pointer[sm.first]++;
        res.push_back({pos[sm.first], pos[sm.second]});
    }
    return res;
}

#ifdef LOCAL
int main()
{
    cin >> n;
    for (int i = 0; i < n; i++) cin >> x[i];
    vector<pair<int, int> > res = solve(n);
    cout << qu << endl;
    for (int i = 0; i < res.size(); i++)
    {
        cout << res[i].first << " " << res[i].second << " " << x[res[i].first] + x[res[i].second] << "\n";
    }
}
#endif // LOCAL
