#include <bits/stdc++.h>

using namespace std;

#include "sqsort.h"

#define fin(i, s, n) for(auto i = s; i < n; ++i)
#define pb push_back
#define all(x) (x).begin(),(x).end()
#define x first
#define y second
#define mp make_pair
using ii = pair<int, int>;
using vi = vector<int>;
using vii = vector<ii>;


vi rnk;

bool compare(const ii &a, const ii &b) {
    if ((rnk[a.x] <= rnk[b.x] && rnk[a.y] <= rnk[b.y]) || (rnk[a.y] <= rnk[b.x] && rnk[a.x] <= rnk[b.y])) return true;
    if ((rnk[a.x] >= rnk[b.x] && rnk[a.y] >= rnk[b.y]) || (rnk[a.y] >= rnk[b.x] && rnk[a.x] >= rnk[b.y])) return false;
    return cmp(a.x, a.y, b.x, b.y);
}


void merge(ii* a, ii* b, int n, int m, ii* out) {
    ii* res = new ii[n+m];
    int i = 0, j = 0;
    int K = 0;
    while (i < n && j < m) {
        if (compare(a[i], b[j])) res[K++] = a[i++];
        else res[K++] = b[j++];
    }
    if (i == n) while (j < m) res[K++] = b[j++];
    if (j == m) while (i < n) res[K++] = a[i++];
    n = n+m;
    fin(k,0,n) out[k] = res[k];
    delete[] res;
}

void srt(ii *a, int n) {
    if (n == 0) return;
    if (n == 1) return;
    if (n == 2) {
        if (!compare(a[0], a[1])) swap(a[0], a[1]);
        return;
    }
    int hn = (n + 1) / 2;
    ii *l = a, *r = a + hn;
//    fin(i, 0, hn) l.pb(a[i]);
//    fin(i, hn, n) r.pb(a[i]);
    srt(l,hn);
    srt(r,n-hn);
    merge(l, r, hn,n-hn,a);
}

std::vector<std::pair<int, int>> solve(int n) {

    vi idxs(n);
    iota(all(idxs), 0);
    sort(all(idxs), [](int i, int j) { return cmp(i, i, j, j); });
//    cout << "current score is " << score() << '\n';
    rnk = vi(n);
    fin(i, 0, n) rnk[idxs[i]] = i;
    vector<ii> ans;
    fin(i, 0, n) {
        fin(j, i, n) ans.pb({idxs[i], idxs[j]});
    }
    ii* aans = new ii[ans.size()];
    int N = ans.size();
    fin(i,0,N) aans[i] = ans[i];
    srt(aans,N);
    fin(i,0,N) ans[i] = aans[i];
//    stable_sort(all(ans),compare);
    return ans;
//    make_heap(all(ans),[rank](const ii& a, const ii& b) {
//        if((rank[a.x] <= rank[b.x] && rank[a.y] <= rank[b.y]) || (rank[a.y] <= rank[b.x] && rank[a.x] <= rank[b.y])) return true;
//        if((rank[a.x] >= rank[b.x] && rank[a.y] >= rank[b.y]) || (rank[a.y] >= rank[b.x] && rank[a.x] >= rank[b.y])) return false;
//        return cmp(a.x,a.y,b.x,b.y);
//    });
//    sort_heap(all(ans),[rank](const ii& a, const ii& b) {
//        if((rank[a.x] <= rank[b.x] && rank[a.y] <= rank[b.y]) || (rank[a.y] <= rank[b.x] && rank[a.x] <= rank[b.y])) return true;
//        if((rank[a.x] >= rank[b.x] && rank[a.y] >= rank[b.y]) || (rank[a.y] >= rank[b.x] && rank[a.x] >= rank[b.y])) return false;
//        return cmp(a.x,a.y,b.x,b.y);
//    });
//    return ans;
}