#include <iostream>
#include <string>
#include <vector>
#include <queue>
#include <deque>
#include <stack>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cstring>
#include <cmath>
#include <cstdlib>
#include <algorithm>
#include <random>
#include <iomanip>
#include <functional>
#include <cassert>
#include <bitset>
#include <chrono>
 
using namespace std;
 
typedef long long ll;

const int md = 1e9 + 7;

void add(int &a, int b) {
  a += b;
  if (a >= md) a -= md;
}
 
int main() {
  ios_base::sync_with_stdio(false); cin.tie(0);
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif
  int n, m;
  cin >> n >> m;
  if (n > m) swap(n, m);
  int ans = 0;
  for (int mask = 0; mask < (1 << (n * m)); ++mask) {
    vector <vector <int>> a(n, vector <int> (m));
    for (int i = 0; i < n; ++i) {
      for (int j = 0; j < m; ++j) {
        a[i][j] = (mask >> (i * m + j)) & 1;
      }
    }
    vector <int> cntr(n), cntc(m);
    for (int i = 0; i < n; ++i) {
      for (int j = 0; j < m; ++j) {
        if (a[i][j]) ++cntr[i];
        if (a[i][j]) ++cntc[j];
      }
    }
    bool ok = true;
    for (int i = 0; i < n; ++i) {
      for (int j = 0; j < m; ++j) {
        if (a[i][j]) {
          if (cntr[i] == 1 && cntc[j] == 1) ok = false;
        } 
        if (!a[i][j]) {
          if (cntr[i] == m - 1 && cntc[j] == n - 1) ok = false;
        }
      }
    }
    if (ok) ++ans;
  }
  cout << ans << '\n';
}
