#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;

//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define int long long

const int mod = 1e9 + 7;

int pw(int a, int n)
{
    if (n == 0)
    {
        return 1;
    }
    if (n == 1)
    {
        return a;
    }
    int cur = pw(a, n / 2);
    cur *= cur;
    cur %= mod;
    if (n % 2)
    {
        cur *= a;
        cur %= mod;
    }
    return cur;
}

int rev(int x)
{
    return pw(x, mod - 2);
}

int mul(int x, int y)
{
    return ((x * y) % mod + mod) % mod;
}

const int MAXN = 1e4 + 44;

int fact[MAXN];

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    if (m < n)
    {
        swap(n, m);
    }
    if (n == 1)
    {
        if (m == 1)
        {
            cout << 0 << endl;
            return 0;
        }
        if (m == 2)
        {
            cout << 2 << endl;
            return 0;
        }
        int ans = pw(2, n * m);
        ans -= 2 * m;
        ans %= mod;
        ans += mod;
        ans %= mod;
        cout << ans << endl;
        return 0;
    }
    if (n == 2)
    {
        if (m == 2)
        {
            cout << 6 << endl;
            return 0;
        }
        fact[0] = 1;
        for (int i = 1; i <= n * m; ++i)
        {
            fact[i] = mul(fact[i - 1], i);
        }
        int ans = pw(2, n * m);
        int sg = -1;
        int cur = 1;
        int x = n;
        int y = m;
        for (int i = 1; i <= min(n, m); ++i)
        {
            cur = mul(cur, (x * y));
            ans += mul(mul(mul(pw(2, (x - 1) * (y - 1) + 1), sg), cur), rev(fact[i]));
            ans %= mod;
            sg *= -1;
            --x;
            --y;
        }
        ans += 2 * m;
        ans %= mod;
        cout << ans << endl;
        return 0;
    }
    fact[0] = 1;
    for (int i = 1; i <= n * m; ++i)
    {
        fact[i] = mul(fact[i - 1], i);
    }
    int ans = pw(2, n * m);
    int sg = -1;
    int cur = 1;
    int x = n;
    int y = m;
    for (int i = 1; i <= min(n, m); ++i)
    {
        cur = mul(cur, (x * y));
        ans += mul(mul(mul(pw(2, (x - 1) * (y - 1) + 1), sg), cur), rev(fact[i]));
        ans %= mod;
        sg *= -1;
        --x;
        --y;
    }
    cout << ans << endl;
    return 0;
}
