#include <bits/stdc++.h>
#include "sqsort.h"

using namespace std;

const int MAXN = 1e5 + 7;

int pos[MAXN];

bool my_cmp(int a, int b)
{
    return cmp(0, a, 0, b);
}

bool my_cmp2(pair<int, int> a, pair<int, int> b)
{
    return cmp(a.first, a.second, b.first, b.second);
}

bool my_cmp3(pair<int, int> a, pair<int, int> b)
{
    return (pos[a.first] + pos[a.second] < pos[b.first] + pos[b.second]);
}

std::vector<std::pair<int, int>> solve(int n)
{
    vector<pair<int, int>> ans;
    vector<int> num;
    for (int i = 0; i < n; ++i)
    {
        num.push_back(i);
    }
    stable_sort(num.begin(), num.end(), my_cmp);
    for (int i = 0; i < n; ++i)
    {
        pos[num[i]] = i;
        for (int j = i; j < n; ++j)
        {
            ans.push_back({num[i], num[j]});
        }
    }
    stable_sort(ans.begin(), ans.end(), my_cmp3);
    stable_sort(ans.begin(), ans.end(), my_cmp2);
    return ans;
}
