#include <bits/stdc++.h>
#include "sqsort.h"

using namespace std;

const int MAXN = 1e5 + 7;

int pos[MAXN];

bool my_cmp(int a, int b)
{
    return cmp(0, a, 0, b);
}

bool my_cmp2(pair<int, int> a, pair<int, int> b)
{
    return cmp(a.first, a.second, b.first, b.second);
}

bool my_cmp3(pair<int, int> a, pair<int, int> b)
{
    return (pos[a.first] + pos[a.second] < pos[b.first] + pos[b.second]);
}

std::vector<std::pair<int, int>> solve(int n)
{
    vector<pair<int, int>> ans;
    vector<int> num;
    for (int i = 0; i < n; ++i)
    {
        num.push_back(i);
    }
    stable_sort(num.begin(), num.end(), my_cmp);
    for (int i = 0; i < n; ++i)
    {
        pos[num[i]] = i;
        for (int j = i; j < n; ++j)
        {
            ans.push_back({num[i], num[j]});
        }
    }
    vector<set<int>> t(n);
    t[0].insert(0);
    int cnt = 1;
    map<pair<int, int>, int> used;
    used[{0, 0}] = true;
    while (cnt)
    {
        int x = n;
        int y = n;
        for (int i = 0; i < n; ++i)
        {
            if (!t[i].empty())
            {
                if (cmp(i, num[*(t[i].begin())], x, y))
                {
                    x = i;
                    y = num[*(t[i].begin())];
                }
            }
        }
        ans.push_back({x, y});
        t[x].erase(y);
        if (x != n - 1 && !used[{x + 1, y}])
        {
            used[{x + 1, y}] = true;
            t[x + 1].insert(y);
        }
        if (y != n - 1 && !used[{x, y + 1}])
        {
            used[{x, y + 1}] = true;
            t[x].insert(y + 1);
        }
        --cnt;
    }
    return ans;
}
