#include <bits/stdc++.h>
#define DIM 2010
#define INF 2000000000
using namespace std;

int capacitate[DIM][DIM],flux[DIM][DIM],cst[DIM][DIM],v[DIM],w[DIM],dist[DIM],t[DIM],viz[DIM],f[DIM];
vector <int> L[DIM];
deque <int> c;
pair <int,int> d[DIM];
int n,i,j,sursa,dest,k;

int bellmanFord (){

    for (int i=sursa;i<=dest;i++){
        dist[i] = INF;
        t[i] = -1;
        viz[i] = 0;
    }

    c.push_back(sursa);
    viz[sursa] = 1;
    dist[sursa] = 0;

    while (!c.empty()){
        int nod = c.front();
        c.pop_front();
        viz[nod] = 0;
        for (auto vecin : L[nod]){
            if (flux[nod][vecin] < capacitate[nod][vecin] && dist[nod] + cst[nod][vecin] < dist[vecin]){
                dist[vecin] = dist[nod] + cst[nod][vecin];
                t[vecin] = nod;
                if (!viz[vecin]){
                    c.push_back(vecin);
                    viz[vecin] = 1;
                }
            }
        }
    }

    return dist[dest] != INF;

}

int fluxx (){

    int i,j;
    for (i=sursa;i<=dest;i++)
        L[i].clear();

    memset (capacitate,0,sizeof capacitate);
    memset (flux,0,sizeof flux);
    memset (cst,0,sizeof cst);

    for (i=1;i<=n;i++){
        L[sursa].push_back(i);
        L[i].push_back(sursa);
        capacitate[sursa][i] = 1;
    }

    int cnt = 0;
    for (i=1;i<=n;i++){
        if (!f[i])
            continue;
        cnt++;
        for (j=1;j<=n;j++){
            L[j].push_back(i+n);
            L[i+n].push_back(j);
            capacitate[j][i+n] = 1;

            if (i == j || j == v[i]){
                cst[j][i+n] = -k;
                cst[i+n][j] = k;
            } else {
                cst[j][i+n] = -1;
                cst[i+n][j] = 1;
            }

        }

        L[i+n].push_back(dest);
        L[dest].push_back(i+n);
        capacitate[i+n][dest] = n;
    }

    int sol = 0;
    while (bellmanFord()){
        int x = dest, dif = INF;
        while (x != sursa){
            dif = min (dif,capacitate[t[x]][x] - flux[t[x]][x]);
            x = t[x];
        }

        x = dest;
        while (x != sursa){

            sol += dif * cst[t[x]][x];

            flux[t[x]][x] += dif;
            flux[x][t[x]] -= dif;

            x = t[x];
        }

    }

    if (sol <= -2*k*cnt)
        return 1;

    return 0;

}


int main (){

    //ifstream cin ("date.in");
    //ofstream cout ("date.out");

    cin>>n>>k;

    for (i=1;i<=n;i++){
        cin>>v[i]>>w[i];
        v[i]++;
    }

    sursa = 0, dest = 2*n+1;

    /// ce multime de noduri vreau sa selectez din alea n

    int ans = 0;
   /* for (int mask=1;mask<(1<<n);mask++){

        memset (f,0,sizeof f);
        int sum = 0;
        for (int i=0;i<n;i++){
            if (mask&(1<<i)){
                f[i+1] = 1;
                sum += w[i+1];
            }
        }

        if (fluxx())
            ans = max (ans,sum);

    }*/

    for (i=1;i<=n;i++)
        d[i] = make_pair(w[i],i);
    sort (d+1,d+n+1);

    for (int i=1;i<=n;i++){

        memset (f,0,sizeof f);
        int sum = 0;
        for (j=n;j>=n-i+1;j--){
            f[d[j].second] = 1;
            sum += d[j].first;
        }

        if (fluxx())
            ans = max (ans,sum);

    }

    cout<<ans;

    return 0;
}
