﻿#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

const long long MOD = 1e9 + 7;

int n, m;

int table[50][50];

long long answer = 0;

long long gener(int i, int j) {
	long long answer = 0;
	if (i <= n - 1) {
		table[i][j] = 1;
		answer += gener(i + 1, j);
		answer %= MOD;
		table[i][j] = 0;
		answer += gener(i + 1, j);
		answer %= MOD;
	}
	else if (j < m - 1) {
		answer += gener(0, j + 1);
		answer %= MOD;
	}
	else {
		int count = 0;
		for (int i1 = 0; i1 < n; ++i1) {
			for (int j1 = 0; j1 < m; ++j1) {
				count = 0;
				for (int i2 = 0; i2 < n; ++i2) {
					if (table[i2][j1] == table[i1][j1])
						++count;
				}
				for (int j2 = 0; j2 < m; ++j2) {
					if (table[i1][j2] == table[i1][j1])
						++count;
				}
				if (count == 2)
					return 0;
			}
		}
		return 1;
	}
	return answer;
}

int main() {
	cin >> n >> m;
	cout << gener(0, 0);
}