﻿#include "sqsort.h"
#include <algorithm>
using namespace std;
bool comp1(pair <int, int> a, pair <int, int> b) {
	return cmp(a.first, a.second, b.first, b.second);
}
bool comp2(int a, int b) {
	return cmp(a, 0, b, 0);
}

std::vector<std::pair<int, int>> solve(int n) {
	vector <int> a1;
	for (int i = 0; i < n; ++i)
		a1[i] = i;
	sort(a1.begin(), a1.end(), comp2);
	vector <pair <int, int>> answer;
	for (int i = 0; i < n; ++i) {
		for (int j = i; j < n; ++j) {
			answer.push_back({ a1[i], a1[j] });
		}
	}
	sort(answer.begin(), answer.end(), comp1);
	return answer;
}