#include <iostream>
#include <algorithm>
#include <cmath>
using namespace std;
using ll = long long;
const ll mod = 1'000'000'007;
ll cm[52], cn[52], f[52];
int m, n;
ll md(ll a)
{
	if (a >= mod)a %= mod;
	if (a < 0)a += (abs(a) / mod) * mod;
	if (a < 0)a += mod;
	return a;
}
ll pw(int a)
{
	ll res = 1;
	while (a--)
	{
		res *= 2;
		md(res);
	}
	return res;
}
void Cm(int k)
{
	cm[1] = m;
	for (int i = 2; i < k; i++)
	{
		if (cm[i - 1] == 0)cm[i - 1] += mod;
		cm[i] = cm[i - 1] * (m - i + 1);
		cm[i - 1] %= mod;
		if (cm[i] < i)
			cm[i] += mod;
		cm[i] /= i;
		md(cm[i]);
	}
	if (k > 1) {
		if (m != k) {
			if (cm[k - 1] == 0)cm[k - 1] += mod;
			cm[k] = cm[k - 1] * (m - k + 1) / k;
			cm[k - 1] %= mod;
		}
		else cm[k] = 1;
		md(cm[k]);
	}
}
void Cn(int k)
{
	cn[1] = n;
	for (int i = 2; i < k; i++)
	{
		if (cn[i - 1] == 0)cn[i - 1] += mod;
		cn[i] = cn[i - 1] * (n - i + 1);
		cn[i - 1] %= mod;
		if (cn[i] < i)
			cn[i] += mod;
		cn[i] /= i;
		md(cn[i]);
	}
	cn[n] = 1;
}
ll fact(ll a)
{
	if (f[a])return f[a];
	return f[a] = md(a * fact(a - 1));
}
int main()
{
	cin >> n >> m;
	if (n > m)
		swap(n, m);
	//dp[i][j][0]=2^(i*j)-(gone 1 hat miaynak)+(gone 2 miaynak)-gone3miaynak....;
	ll ans = pw(m * n);
	//fact(n);
	f[0] = 1;
	Cn(n);
	Cm(n);
	if (n % 2 == 0 || m % 2 == 0)
	{
		while (1)
			cin >> n;
	}
	if (n == 2 && m == n)
	{
		cout << 6;
		return 0;
	}
	/*
	for (int i = 1; i <= n; i++)
	{
		cout << cn[i] << ' ';
	}
	cout << '\n';*/

	//for (int i = 1; i <= n; i++)
	//{
	//	cout << cm[i] << ' ';
	//}
	//cout << '\n';
	//cout << ans << '\n';
	for (int i = 1; i <= n; i++)
	{
		ll tmp = cm[i] * cn[i] * pw(md((m - i) * (n - i))) * fact(i);
		if (i*2 != (m*n))
			tmp *= 2;
		//cout << tmp << '\n';
		if (i % 2)
			ans -= md(tmp);
		else ans += md(tmp);
		ans = md(ans);

	}
	cout << ans%mod << '\n';
	return  0;
}