#include "sqsort.h"
#include <vector>
#include <stack>
#include <iostream>
std::stack <std::pair<int, int>> s;
std::vector <std::pair<int, int>> ans;
int used[2002][2002];
std::vector<std::pair<int, int>> solve(int n)
{
	ans.clear();
	while(!s.empty())s.pop();
	int ind[2002];
	for (int i = 0; i < n; i++)
		ind[i] = i;
	for (int i = 0; i < n; i++)
		for (int j = i + 1; j < n; j++)
		{
			if (!cmp(ind[i], ind[i], ind[j], ind[j]))
				std::swap(ind[i], ind[j]);
		}
	for (int i = n - 1; i >= 0; i--)
		for (int j = n - 1; j > i; j--)
			s.push({ ind[i],ind[j] });
	int p = 0;
	while (!s.empty() && p < n)
	{
		ans.push_back({ ind[p],ind[p] });
		while (!s.empty() && s.top().second < ind[p + 1])
		{
			ans.push_back(s.top());
			s.pop();
		}
		p++;
		while (!s.empty() && p<n && cmp(s.top().first, s.top().second,ind[p],ind[p]))
		{
			ans.push_back(s.top());
			s.pop();
		}
	}
	return ans;
}