#include <bits/stdc++.h>
using namespace std;

#define pb push_back
#define F first
#define S second
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define mp make_pair
#ifndef MY
    #define endl '\n'
#endif // MY

typedef long long ll;
typedef long double db;
typedef pair < int, int > pii;

const int mod = 1e9 + 7;

struct Int {
    ll x = 0;
    Int (ll x = 0) : x(x) {}
    Int operator + (Int a) {
        return Int((x + a.x) % mod);
    }
    Int operator += (Int a) {
        return Int(x = (x + a.x) % mod);
    }
    Int operator * (Int a) {
        return Int((x * a.x) % mod);
    }
    Int operator *= (Int a) {
        return Int(x = (x * a.x) % mod);
    }
    Int operator - (Int a) {
        return Int((x + mod - a.x) % mod);
    }
};

const int N = 55;
Int dp[N][N];
bool used[N][N];
Int deg[N * N];
int cur[N][N];
int oh[N];

Int cnt(int a, int b) {
    return deg[a * b];
}

Int solve(int n, int m) {
    if (m == 0 || n == 0) {
        return 1;
    }
    if (used[n][m]) {
        return dp[n][m];
    }
    used[n][m] = 1;
    for (int j = 1; j <= m; j++) {
        for (int i = 1; i <= n; i++) {
            int a = n - 1, b = j - 1;
            //cout << i << ' ' << j << ' ' << cnt(a, b).x << endl;
            dp[n][m] += cnt(a, b);
        }
    }
    return dp[n][m];
}

bool bad(int qi, int qj, int n, int m) {
    for (int i = 0; i < n; i++) {
        if (i == qi) {
            continue;
        }
        if (cur[i][qj] == cur[qi][qj]) {
            return 0;
        }
    }
    for (int j = 0; j < m; j++) {
        if (j == qj) {
            continue;
        }
        if (cur[qi][j] == cur[qi][qj]) {
            return 0;
        }
    }
    return 1;
}

void print(int n, int m) {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << cur[i][j];
        }
        cout << endl;
    }
    cout << endl;
}

void stupid(int n, int m) {
    int s = n * m;
    int ans = 0;
    int res = 0;
    for (int k = 0; k < (1 << s); k++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                int t = i * m + j;
                if ((1 << t) & k) {
                    cur[i][j] = 1;
                } else {
                    cur[i][j] = 0;
                }
            }
        }
        bool fl = 0;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (bad(i, j, n, m)) {
                    ans++;
//                    if (cur[i][j]) {
//                        print(n, m);
//                    }
                    fl = 1;
                    break;
                }
            }
            if (fl) {
                break;
            }
        }
//        bool a = (cur[n - 1][m - 1] != 1 && !bad(n - 1, m - 1, n, m));
//        bool b = (cur[n - 1][m - 1] == 1 && bad(n - 1, m - 1, n, m));
//        if (fl && (a || b)) {
//            res += b;
//            if (b)
//            print(n, m);
//        }
    }
//    cout << res << endl;
    cout << deg[s].x - ans << endl;
}

vector < vector < int > > kek = {
    {0, 2, 2, 8, 22},
    {2, 6, 34, 160, 754},
    {3, 34, 284, 2800, 25928},
    {8, 160, 2800, 51120, 898416},
    {22, 754, 25928, 898416, 30465392}
};

signed main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int P = 5;
//    deg[0] = 1;
//    for (int i = 1; i <= P * P; i++) {
//        deg[i] = deg[i - 1] * 2;
//    }
//    for (int i = 1; i <= P; i++) {
//        for (int j = i; j <= P; j++) {
//            cout << i << ' ' << j << ' ';
//            stupid(i, j);
//        }
//    }
    int n, m;
    cin >> n >> m;
    cout << kek[n - 1][m - 1];
//    int n, m;
//    cin >> n >> m;
//    cout << (512 - 284) / 3 << endl;
//    deg[0] = 1;
//    for (int i = 1; i <= (n * m); i++) {
//        deg[i] = deg[i - 1] * 2;
//    }
//    stupid(n, m);
//    Int ans = solve(n, m);
//    ans *= 2;
//    ans = deg[n * m] - ans;
//    cout << ans.x;
    return 0;
}
