#include <iostream>
#include <cstdio>
#include <sstream>
#include <iomanip>
#include <cstring>
#include <string.h>
#include <cmath>
#include <math.h>
#include <map>
#include <set>
#include <vector>
#include <unordered_map>
#include <algorithm>
#include <random>
#include "sqsort.h"
//#include <ext/container/c++.h>


using namespace std;
//using namespace __gnu_pbds;
template<class T1, class T2> inline bool chkmin(T1 &x, const T2 &y) {
	if (x > y) {
		x = y;
		return true;
	}
	return false;
}
template<class T1, class T2> inline bool chkmax(T1 &x, const T2 &y) {
	if (x < y) {
		x = y;
		return true;
	}
	return false;
}
#define rall(c) (c).rbegin(), (c).rend()
#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()
#define mp make_pair
#define pb push_back
using ll = long long;
using ld = long double;


int where[2005];

bool query(int a, int b, int c, int d) {
	return cmp(a, b, c, d);
}


bool comp(int a, int b) {
	return query(a, a, b, b);
}


bool comp1(pair<int, int> a, pair<int, int> b) {
	if (where[a.first] > where[a.second]) {
		swap(a.first, a.second);
	}
	if (where[b.first] > where[b.second]) {
		swap(b.first, b.second);
	}
	if (where[a.first] < where[b.first] && where[a.second] < where[b.second]) {
		return true;
	}
	if (where[a.first] > where[b.first] && where[a.second] > where[b.second]) {
		return false;
	}
	return cmp(a.first, a.second, b.first, b.second);
}



vector<pair<int, int> > d[2020];


vector<pair<int, int> > mergenubas(int l, int r) {
	if (l == r) {
		return d[l];
	}
	auto x = mergenubas(l, (l + r) / 2);
	auto y = mergenubas((l + r) / 2 + 1, r);
	vector<pair<int, int> > z;
	z.resize(sz(x) + sz(y));
	merge(all(x), all(y), z.begin(), comp1);
	return z;
}

vector<pair<int, int> > solve(int n) {
	vector<int> order;
	for (int i = 0; i < n; i++) {
		order.pb(i);
	}
	sort(all(order), comp);
	for (int i = 0; i < n; i++) {
		for (int j = i; j < n; j++) {
			d[i].pb(mp(order[j], order[i]));
		}
	}
	for (int i = 0; i < n / 2; i++) {
		vector<pair<int, int> > z, z1, z2;
		bool was = false;
		for (auto x: d[i]) {
			if (!was) {
				z1.pb(x);
			} else {
				z2.pb(x);
			}
			if (x.first == order[(n - 1) / 2 + i + 1]) {
				was = true;
			}
		}
		d[i] = z2; 
		z.resize(sz(d[i]) + sz(d[(n - 1) / 2 + i + 1]));
		merge(all(d[i]), all(d[(n - 1) / 2 + i + 1]), z.begin(), comp1);
		d[i] = z1;
		for (auto x: z) {
			d[i].pb(x);
		}
	}
	return mergenubas(0, (n - 1) / 2);
}