#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long
#define mp make_pair
#define pii pair<int, int>
#define pip pair<int, pii>
#define sz(a) (int) (a.size())
#define all(a) a.begin(), a.end()
#define chkmin(a, b) a = min(a, b)
#define chkmax(a, b) a = max(a, b)

mt19937 rnd(time(0));

const int inf = 1e15 + 7;
const int max_n = 702;
	
int K;
int T[max_n], L[max_n];
bool used[max_n];

vector<int> f(vector<int> a) {
	int n = sz(a);
	vector<vector<int>> dp(max_n, vector<int>(2));
	vector<vector<int>> dp1(max_n, vector<int>(2));

	for(int i = 1 + K;i < max_n;i++)
		dp1[i][1] = L[a[n - 1]];

	for(int v_id = n - 2;v_id >= 0;v_id--) {
		int v = a[v_id];
		for(int j = 0;j < max_n;j++) {
			dp[j][0] = max(dp1[j][1], dp1[j][0]);
			dp[j][1] = max((j >= 2 ? dp1[j - 2][0] : -inf),
				(j >= K + 1 ? dp1[j - K - 1][1] : -inf)) + L[v];
		}
		for(int j = 0;j < max_n;j++) {
			dp1[j][0] = dp[j][0];
			dp1[j][1] = dp[j][1];
		}
	}
	vector<int> res(max_n);
	for(int i = 0;i < max_n;i++)
		res[i] = max(dp[i][0], dp[i][1]);
	return res;
}

vector<int> g(vector<int> a) {
	int id = 0;
	for(int i = 0;i < sz(a);i++) {
		if (L[a[i]] < L[a[id]]) id = i;
	}
	id = (id + 1) % sz(a);

	vector<int> b;
	for(int i = id;i < sz(a);i++) 
		b.emplace_back(a[i]);
	for(int i = 0;i < id;i++)
		b.emplace_back(a[i]);

	return f(b);
}

int q(vector<vector<int>> a, int n) {

	/*cout << sz(a) << endl;
	for(int i = 0;i <= n;i++)
		cout << a[0][i] << " ";
	cout << endl;*/

	vector<int> res(max_n, -inf);
	res[0] = 0;

	for(vector<int> b : a) {
		//int max_b = max_n;
		/*for(int i = max_n - 1;i >= 0;i--) {
			if (b[i] > b[i - 1]) break;
			max_b--;
		}*/
		//cout << max_b << endl;

		for(int i = max_n - 1;i >= 0;i--) {
			for(int c = 0;c < max_n - i;c++) {
				chkmax(res[i + c], res[i] + b[c]);
			}
		}
	}

	int q = 0;
	for(int i = 0;i <= n;i++)
		chkmax(q, res[i]);

	return q;
}

void solve() {
	int n;
	cin >> n >> K;
	for(int i = 0;i < n;i++)
		cin >> T[i] >> L[i];

	vector<vector<int>> pack;

	vector<int> a;
	for(int i = 0;i < n;i++) {
		if (used[i]) continue;
		int v = i;
		while(!used[v]) {
			a.emplace_back(v);
			used[v] = true;
			v = T[v];
		}
		pack.emplace_back(g(a));
		a.clear();
	}

	cout << q(pack, n);
}


signed main() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);

	solve();
}