#include <bits/stdc++.h>
#include "sqsort.h"

//#include <ext/pb_ds/detail/standard_policies.hpp>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
//using namespace __gnu_pbds;

//template < typename T > using ordered_set = tree <T, null_type, less < T >, rb_tree_tag, tree_order_statistics_node_update>;

#define ll long long
#define ld long double
#define F first
#define S second
#define pb push_back
#define endl '\n'
#define TIME clock() * 1.0 / CLOCKS_PER_SEC
#define sz(a) a.size()
//#define inf long long

const int N = 1e5 + 100;
const int inf = 1e9 + 7;

bool ask(int i, int j, int x, int y)
{
    if (i == -1 && x == -1) return 1;
    if (x == -1) return 1;
    if (i == -1) return 0;
    return cmp(i, j, x, y);
}

struct DO
{
    vector < pair <int, int> > t;
    int pr = 2;
    
    void build(int n)
    {
        while (pr < n) pr *= 2;
        t.resize(2 * pr);
        for(int i = 1; i < 2 * pr; i++)
        {
            t[i] = {-1, -1};
        }
    }
    
    void upd(int v, int i, int j)
    {
        v += pr;
        t[v] = {i, j};
        v /= 2;
        while (v)
        {
            if (ask(t[v * 2].F, t[v * 2].S, t[v * 2 + 1].F, t[v * 2 + 1].S)) t[v] = t[v * 2];
            else t[v] = t[v * 2 + 1];
            v /= 2;
        }
    }
    
    int get_min(int v)
    {
        if (pr <= v) return v - pr;
        if (t[v] == t[v * 2]) return get_min(v * 2);
        else return get_min(v * 2 + 1);
    }
};

std::vector <std::pair <int, int> > solve(int n)
{
    DO t;
    int m = n * (n + 1) / 2;
    t.build(m);
    vector < pair <int, int> > zn(m + 5), ans;
    int uk = 0;
    for(int i = 0; i < n; i++)
    {
        for(int j = i; j < n; j++)
        {
            t.upd(uk, i, j);
            zn[uk++] = {i, j};
//            exit(0);
        }
    }
    while (m--)
    {
        int pos = t.get_min(1);
//        cerr << pos << " " << t.t[1].F << " " << t.t[1].S << endl;
        t.upd(pos, -1, -1);
        ans.pb(zn[pos]);
    }
    return ans;
}
