#include <bits/stdc++.h>
#include "sqsort.h"
using namespace std;

#define ll long long
#define ld long double
#define F first
#define S second
#define pb push_back

const int N = 1e4 + 10;
const int INF = 1e9;
const int MOD = 1e9 + 7;
const int rx[4] = {-1, 0, 1, 0};
const int ry[4] = {0, 1, 0, -1};
const int dx[8] = {-1, -1, -1, 0, 1, 1, 1, 0};
const int dy[8] = {-1, 0, 1, 1, 1, 0, -1, -1};

vector <int> v;

bool comp(int a, int b) {
    return cmp(0, b, 0, a);
}


bool comp2(pair <int, int> a, pair <int, int> b) {
    if (min(v[a.F], v[a.S]) <= min(v[b.F], v[b.S]) && max(v[a.F], v[a.S]) < max(v[b.F], v[b.S])) return true;
    else if (min(v[a.F], v[a.S]) < min(v[b.F], v[b.S]) && max(v[a.F], v[a.S]) <= max(v[b.F], v[b.S])) return true;
    else if (min(v[b.F], v[b.S]) <= min(v[a.F], v[a.S]) && max(v[b.F], v[b.S]) <= max(v[a.F], v[a.S])) return false;
    else return cmp(a.F, a.S, b.F, b.S);
}

vector <pair <int, int> > solve(int n) {
    for (int i = 1; i < n; i++) {
        v.pb(i);
    }
    sort(v.begin(), v.end(), comp);
    for (int i = 0; i < n - 1; i++) {
        v[i] = n - v[i];
    }
    int pr[n];
    for (int i = 0; i < n - 1; i++) {
        pr[v[i]] = i + 1;
    }
    int l = 1, r = n - 1, ans = 0;
//    cerr << "!!!" << endl;
    while (l <= r) {
        int mid = (l + r) / 2;
        if (cmp(0, pr[mid], 0, 0)) {
            ans = mid;
            l = mid + 1;
        } else r = mid - 1;
    }
//    cerr << ans << endl;
    for (int i = 0; i < n - 1; i++) {
        if (v[i] <= ans) v[i] --;
    }
    v.insert(v.begin(), ans);
//    for (int i = 0; i < n; i++) cerr << v[i] << " ";
//    cerr << endl;
    vector <pair <int, int> > g;
    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) g.pb({i, j});
    }
    sort(g.begin(), g.end(), comp2);
    return g;
}
