#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <map>
#include <set>
#include <unordered_set>
#include <unordered_map>



using namespace std;


template<typename T> void uin(T &a, T b) {
    if (b < a) a = b;
}
template<typename T> void uax(T &a, T b) {
    if (b > a) a = b;
}

#define left left228
#define right right228
#define move move228
#define prev prev228
#define next next228

const int MOD = 1e9 + 7;

int mod(int x) {
    x %= MOD;
    if (x < 0) x += MOD;
    return x;
}

void add(int &x, int y) {
    x += y;
    if (x >= MOD) x -= MOD;
    if (x < 0) x += MOD;
}

int dp[51][(1 << 7) + 1][(1 << 7) + 1];

int a[6][6];

int col[6][2];
int row[6][2];

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    if (n > m) {
        swap(n, m);
    }
    int ans = 0;
    for (int mask = 0; mask < (1 << (n * m)); ++mask) {
        int ptr = 0;
        for (int i = 1; i <= max(n,m); ++i) {
            row[i][0] = row[i][1] = col[i][0] = col[i][1] = 0;
        }
        for (int i = 1; i <= n; ++i) {
            for (int j = 1; j <= m; ++j) {
                a[i][j] = (mask >> ptr) & 1;
                row[i][a[i][j]]++;
                col[j][a[i][j]]++;
                ++ptr;
            }
        }
        bool bad = false;
        for (int i = 1; i <= n; ++i) {
            for (int j = 1; j <= m; ++j) {
                if (row[i][a[i][j]] == 1 && col[j][a[i][j]] == 1) {
                    bad = true;
                    break;
                }
            }
         
            if (bad) break;
        }
        if (!bad) ++ans;
    }
    cout << ans << endl;
    return 0;
}





/*
my login = A10180
my password = NJSTLGIT
*/