#include "sqsort.h"
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <map>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <random>


using namespace std;


template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}
template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

#define left left228
#define right right228
#define move move228
#define prev prev228
#define next next228

vector<int> pos;

map< pair< pair<int, int>, pair<int, int> > , bool> is;

bool mor(pair<int, int> a, pair<int, int> b) {
	int ax = a.first;
	int ay = a.second;
	int bx = b.first;
	int by = b.second;
	if (pos[ax] > pos[ay]) swap(ax, ay);
	if (pos[bx] > pos[by]) swap(bx, by);
	if (pos[ax] <= pos[bx] && pos[ay] <= pos[by]) {
		return false;
	}
	if (pos[ax] >= pos[bx] && pos[ay] >= pos[by]) {
		return true;
	}
	return cmp(b.first, b.second, a.first, a.second);
}

void merge(vector< pair<int, int> > &v) {
	if (v.size() == 1) {
		return ;
	}
	if (v.size() == 2) {
		if (mor(v[0], v[1])) {
			swap(v[0], v[1]);
		}
		return ;
	}
	vector< pair<int, int> > L, R;

	int m = (int)v.size() / 2;
	for (int i = 0; i < m; ++i) {
		L.emplace_back(v[i]);
	}
	for (int i = m; i < (int)v.size(); ++i) {
		R.emplace_back(v[i]);
	}
	merge(L);
	merge(R);
	v.clear();
	int i = 0;
	int szL = (int)L.size();
	int j = 0;
	int szR = (int)R.size();
	while (i < szL || j < szR) {
		if (i == szL) {
			v.emplace_back(R[j++]);
		} else if (j == szR) {
			v.emplace_back(L[i++]);
		} else {
			if (mor(L[i], R[j])) {
				v.emplace_back(R[j++]);
			} else {
				v.emplace_back(L[i++]);
			}
		}
	}
}

void meme(vector<int> &p) {
	if (p.size() == 1) {
		return;
	}
	if (p.size() == 2) {
		if (cmp(p[1], p[1], p[0], p[0])) {
			swap(p[0], p[1]);
		}
		return;
	}
	vector<int> L, R;
	int m = (int)p.size() / 2;
	for (int i = 0; i < m; ++i) {
		L.emplace_back(p[i]);
	}
	for (int i = m; i < (int)p.size(); ++i) {
		R.emplace_back(p[i]);
	}
	meme(L);
	meme(R);
	p.clear();
	int i = 0;
	int szL = (int)L.size();
	int j = 0;
	int szR = (int)R.size();
	while (i < szL || j < szR) {
		if (i == szL) {
			p.emplace_back(R[j++]);
		} else if (j == szR) {
			p.emplace_back(L[i++]);
		} else {
			if (cmp(R[j], R[j], L[i], L[i])) {
				p.emplace_back(R[j++]);
			} else {
				p.emplace_back(L[i++]);
			}
		}
	}
}

random_device rnd;

vector< pair<int, int> > solve(int n) {
	vector<int> p;
	for (int i = 0; i < n; ++i) {
		p.emplace_back(i);
	}
	meme(p);

	pos.resize(n);

	for (int i = 0; i < n; ++i) {
		pos[p[i]] = i;
	}

	vector< pair<int, int> > v;
	for (int i = 0; i < n; ++i) {
		for (int j = i; j < n; ++j) {
			v.emplace_back(i, j);
		}
	}


	int sz = (int)v.size();


	merge(v);

	return v;
}






// signed main() {
// 	ios_base::sync_with_stdio(false);
// 	cin.tie(0);
// 	return 0;
// }



/*

8 2
5 12
6 111
4 101
0 13
1 105
7 14
2 108
3 9


6 2
1 10
2 20
3 20
4 30
5 30
0 0






*/

