#include "sqsort.h"
#include <set>
#include <vector>
#include <algorithm>
#include <iostream>
#define pir pair<int, int>
#define ad push_back
#define MP make_pair
#define fr first
#define sc second
#define ld long double
using namespace std;
const int N = 2020;

int n;
int p[N];
vector<pir> pat;
bool col[N];
vector<pir> fp;
void srt()
{
	int mn = 0;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++) 
			if (!col[j]) mn = j;
		for (int j = 0; j < n; j++)
		{
			if (col[j] || mn == j) continue;
			if (cmp(mn, mn, j, j)) continue;
			mn = j;
		}
		col[mn] = 1;
		p[i] = mn;
	}
}
vector<pir> solve(int N)
{
	n = N;
	srt();
	//for (int i = 0; i < n; i++) cout << p[i] << " ";
	for (int i = n - 1; i >= 0; i--) fp.ad({ i,i });
	while (fp.size())
	{
		pir sm = fp.back();
		fp.pop_back();
		pat.ad(MP(p[sm.fr], p[sm.sc]));
		sm.sc++;
		if (sm.sc >= n) continue;
		int l = 0, r = (int)fp.size() - 1, ans = 0;
		while (l <= r)
		{
			int mid = (l + r) / 2;
			pir ss = fp[mid];
			if (ss.fr < sm.fr && ss.sc < sm.sc) r = mid - 1;
			if (ss.fr > sm.fr && ss.sc > sm.sc) ans = mid + 1, l = mid + 1;
			if (cmp(p[sm.fr], p[sm.sc], p[ss.fr], p[ss.sc])) ans = mid + 1, l = mid + 1;
			else r = mid - 1;
		}
		fp.insert(fp.begin() + ans, sm);
	}

	return pat;
}



