#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define ff first
#define ss second
#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef pair <int, int> pii;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int N = 10000 + 3;
int n, k, t[N], l[N], a[N];

int cost(int mask){
    int pos = -1, ans = 0;
    for (int i = 0; i < n; i++){
        pos++;
        int pt = 0;
        while (pos < 20 && !((mask>>pos)&1)){
            if (a[pos - i] == t[i]) pt += k;
            else pt++;
        }
        if (pt >= 2 * k)
            ans += l[i];
    }
    return ans;
}

void solve1(){
    int ans = 0;
    for (int mask = 0; mask < (1<<20); mask++){
        if (__builtin_popcount(mask) != n - 1) continue;
        ans = max(ans, cost(mask));
    }
    cout << ans;
}

void solve2(){
    vector <int> v;
    for (int i = 0; i < n; i++)
        v.pb(l[i]);
    sort(rall(v));
    int ans = 0;
    for (int i = 0; (i + 1) * (k + 1) <= v.size(); i++){
        ans += v[i];
    }
    cout << ans;
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> k;
    for (int i = 0; i < n; i++) cin >> t[i] >> l[i];
//    for (int i = 0; i < n; i++) a[i] = i;
    solve2();
    return 0;
}
