#include "sqsort.h"
#include<bits/stdc++.h>
typedef long long ll;
using namespace std;
const int N=2010;
int p[N];
vector<int>v;
bool my_cmp(pair<int,int>a, pair<int,int>b) {
    a.first=v[a.first];
    b.first=v[b.first];
    a.second=v[a.second];
    b.second=v[b.second];
    if (p[a.first]>p[a.second]) swap(a.first,a.second);
    if (p[b.first]>p[b.second]) swap(b.first,b.second);
    if (p[a.first]<=p[b.first] && p[a.second]<=p[b.second]) return true;
    if (p[a.first]>=p[b.first] && p[a.second]>=p[b.second]) return false;
	return cmp(a.first,a.second,b.first,b.second);
}
bool cmp1(int a,int b){
    return cmp(a,a,b,b);
}
int nn;
vector<pair<int,int> >Super_Sort(int l,int r){
    if (l>r) return {};
    if (l==r){
        vector<pair<int,int> >v;
        for (int i=l;i<nn;i++) v.push_back({l,i});
        return v;
    }
    int m=(l+r)/2;
    vector<pair<int,int> >A=Super_Sort(l,m);
    vector<pair<int,int> >B=Super_Sort(m+1,r);
    vector<pair<int,int> >C;
    int i=0,j=0;
    while (i<A.size() && j<B.size()){
        if (my_cmp(A[i],B[j])){
            C.push_back(A[i]);
            i++;
        } else {
            C.push_back(B[j]);
            j++;
        }
    }
    while (i<A.size()){
        C.push_back(A[i]);
        i++;
    }
    while (j<B.size()){
        C.push_back(B[j]);
        j++;
    }
    return C;
}
std::vector<std::pair<int, int>> solve(int n){
    nn=n;
    for (int i=0;i<n;i++) v.push_back(i);
    sort(v.begin(),v.end(),cmp1);
    for (int i=0;i<v.size();i++){
        p[v[i]]=i;
    }
    vector<pair<int,int> >u=Super_Sort(0,n-1);
    for (auto &cur:u) cur.first=v[cur.first],cur.second=v[cur.second];
    return u;

}
