#pragma GCC optimize("unroll-loops,fast-math,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,abm,mmx,popcnt")
#include  "sqsort.h"
#include <bits/stdc++.h>

using namespace std;

vector<int> arr;

bool cmp1(int a, int b) {
    return cmp(a, a, b, b);
}

struct Pair {
    int a, b;
    Pair(int a, int b) : a(a), b(b) {}
};

bool operator<(Pair a, Pair b) {
    if (max(a.a, a.b) < min(b.a, b.b))
        return true;
    if (min(a.a, a.b) > max(b.a, b.b))
        return false;

    return cmp(arr[a.a], arr[a.b], arr[b.a], arr[b.b]);
}

priority_queue<pair<Pair, int>, vector<pair<Pair, int>>, greater<pair<Pair, int>>> q;

vector<pair<int, int>> solve(int n) {
    arr.resize(n);
    iota(arr.begin(), arr.end(), 0);
    sort(arr.begin(), arr.end(), cmp1);
    vector<pair<int, int>> ans;
    ans.reserve(n * (n + 1) / 2);
    vector<vector<Pair>> lists(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j <= i; j++) {
            lists[i].push_back(Pair(i, j));
        }
    }
    vector<int> inds(n, 1);
    for (int i = 0; i < n; i++) {
        q.emplace(lists[i][0], i);
    }
    while (!q.empty()) {
        auto pp2 = q.top();
        q.pop();
        auto pp = pp2.first;
        int list_ind = pp2.second;
        ans.push_back({arr[pp.a], arr[pp.b]});
        if (inds[list_ind] == (int) lists[list_ind].size()) {
            continue;
        }
        q.emplace(lists[list_ind][inds[list_ind]++], list_ind);
    }
    return ans;
}
