#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <string>
#include <queue>
#include <deque>

#define peredayu_privet_andreyu_ivanovu ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define rep(i, n) for (int i = 0; i < n; ++i)
#define cod(x) static_cast<int>(x)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;

using ll = long long;
using vl = vector<ll>;
using vvl = vector<vl>;
using ld = long double;
using vd = vector<ld>;
using vvd = vector<vd>;
const ll INF = 1e18 + 7;
const ll MOD = 1e9 + 7;
const ld delta = 1 / 1e8;

// global variables;

ll n, m;
vl fact;

//

ll fp(ll x, ll deg) {
	if (deg == 0) return 1;
	ll cur_ans = (fp(x, deg / 2) * fp(x, deg / 2)) % MOD;
	if (deg % 2 == 1) {
		cur_ans = (cur_ans * x) % MOD;
	}
	return cur_ans;
}

pair<ll, ll> C(ll x, ll y) {
	return { fact[x], (fact[y] * fact[x - y]) % MOD };
}

int main() {
	peredayu_privet_andreyu_ivanovu;
	cin >> n >> m;
	if (n > m) swap(n, m); // n <= m;
	if (n == 1) {
		if (m == 1) {
			cout << 0;
		}
		else if (m == 2) {
			cout << 2;
		}
		else {
			cout << (fp(2, m) - 2 * m) % MOD;
		}
		return 0;
	}
	if (n == 2 && m == 2) {
		cout << 6;
		return 0;
	}
	fact.resize(m + 1);
	fact[0] = 1;
	for (int i = 1; i <= m; ++i) {
		fact[i] = (fact[i - 1] * i) % MOD;
	}
	pair<ll, ll> ans = { 0, 1 };
	for (int i = 1; i <= n; ++i) {
		if (i % 2 == 0) {
			// ans = (ans - () % MOD + MOD) % MOD;
			ll cur_sum = 1;
			for (int j = 1; j < i; ++j) {
				cur_sum = (((cur_sum * C(n, j).second) % MOD) * C(m, j).second) % MOD;
			}
			for (int j = i + 1; j <= n; ++j) {
				cur_sum = (((cur_sum * C(n, j).second) % MOD) * C(m, j).second) % MOD;
			}
			cur_sum = (((cur_sum * C(n, i).first) % MOD) * C(m, i).first) % MOD;
			cur_sum = (cur_sum * fact[i]) % MOD;
			cur_sum = (cur_sum * fp(2, n * m - i * (n + m - i))) % MOD;
			ans.first = (ans.first - cur_sum + MOD) % MOD;
		}
		else {
			ll cur_sum = 1;
			for (int j = 1; j < i; ++j) {
				cur_sum = (((cur_sum * C(n, j).second) % MOD) * C(m, j).second) % MOD;
			}
			for (int j = i + 1; j <= n; ++j) {
				cur_sum = (((cur_sum * C(n, j).second) % MOD) * C(m, j).second) % MOD;
			}
			cur_sum = (((cur_sum * C(n, i).first) % MOD) * C(m, i).first) % MOD;
			cur_sum = (cur_sum * fact[i]) % MOD;
			cur_sum = (cur_sum * fp(2, n * m - i * (n + m - i))) % MOD;
			ans.first = (ans.first + cur_sum + MOD) % MOD;
		}
		ans.second = (((ans.second * C(n, i).second) % MOD) * C(m, i).second) % MOD;
	}
	ans.first = (ans.first * 2) % MOD;
	ll x = ans.first;
	ll y = ans.second;
	ll y1 = fp(y, MOD - 2);
	ll cur_ans = (x * y1) % MOD;
	ll answer = (fp(2, n * m) - cur_ans + MOD) % MOD;
	if (n == 2) {
		answer = (answer + 2 * m + MOD) % MOD;
	}
	cout << answer;
	return 0;
}