#include <bits/stdc++.h>
using namespace std;

const int MAXN = 3e4;
int t[MAXN], l[MAXN];
int n, k;

void slow() {
    int ans = 0;
    for (int mask = 0; mask < (1 << n); ++mask) {
        vector<int> used(n, 0);
        int c = 0, sum = 0;
        for (int i = 0; i < n; ++i) {
            if (mask & (1 << i)) {
                c++;
                sum += l[i];
                used[i] = used[t[i]] = 1;
            }
        }
        int cnt = 0;
        for (int i = 0; i < n; ++i) {
            cnt += used[i];
        }
        if (c * 2 * k - cnt * k <= n - cnt) {
            ans = max(ans, sum);
        }
    }
    cout << ans;
    exit(0);
}

const int MAXS = 800;
int dp[MAXS][MAXS][2];

vector<int> get_p() {
    vector<int> p;
    int v = t[0];
    p.push_back(0);
    while (v != 0) {
        p.push_back(v);
        v = t[v];
    }
    return p;
}

main() {
    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        cin >> t[i] >> l[i];
    }
    /**if (n <= 10) {
        slow();
    }*/
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= n; ++j) {
            for (int t = 0; t < 2; ++t) {
                dp[i][j][t] = -1e9;
            }
        }
    }
    dp[0][n][0] = 0;
    vector<int> p = get_p();
    for (int i = 1; i < p.size(); ++i) {
        for (int j = 0; j <= n; ++j) {
            dp[i][j][0] = max(dp[i - 1][j][0], dp[i - 1][j][1]);
            if (j + 2 <= n) {
                dp[i][j][1] = max(dp[i][j][1], dp[i - 1][j + 2][0] + l[p[i - 1]]);
            }
            if (j + k + 1 <= n) {
                dp[i][j][1] = max(dp[i][j][1], dp[i - 1][j + k + 1][1] + l[p[i - 1]]);
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int t = 0; t < 2; ++i) {
            ans = max(ans, dp[n - 1][i][t]);
        }
    }
    cout << ans;
    return 0;
}
