#include <bits/stdc++.h>
using namespace std;

const int MAXN = 3e4, INF = 1e9;
int t[MAXN], l[MAXN];
int n, k;

void slow() {
    int ans = 0;
    for (int mask = 0; mask < (1 << n); ++mask) {
        vector<int> used(n, 0);
        int c = 0, sum = 0;
        for (int i = 0; i < n; ++i) {
            if (mask & (1 << i)) {
                c++;
                sum += l[i];
                used[i] = used[t[i]] = 1;
            }
        }
        int cnt = 0;
        for (int i = 0; i < n; ++i) {
            cnt += used[i];
        }
        if (c * 2 * k - cnt * k <= n - cnt) {
            ans = max(ans, sum);
        }
    }
    cout << ans;
    exit(0);
}

const int MAXS = 800;
int dp[MAXS][MAXS][2][2];

vector<int> get_p() {
    vector<int> p;
    int v = t[0];
    p.push_back(0);
    while (v != 0) {
        p.push_back(v);
        v = t[v];
    }
    return p;
}

main() {
    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        cin >> t[i] >> l[i];
    }
    if (n <= 10) {
        slow();
    }
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= n; ++j) {
            for (int st = 0; st < 2; ++st) {
                for (int t = 0; t < 2; ++t) {
                    dp[i][j][st][t] = -INF;
                }
            }
        }
    }
    dp[0][n][0][0] = 0;
    dp[0][n][1][0] = 0;
    vector<int> p = get_p();
    for (int i = 1; i < p.size(); ++i) {
        for (int j = 0; j <= n; ++j) {
            for (int st = 0; st < 2; ++st) {
                dp[i][j][st][0] = max(dp[i - 1][j][st][0], dp[i - 1][j][st][1]);
                if (st == 1 && i == 1) {
                    dp[i][j][st][0] = -INF;
                }
                if (j + 2 <= n) {
                    dp[i][j][st][1] = max(dp[i][j][st][1], dp[i - 1][j + 2][st][0] + l[p[i - 1]]);
                }
                if (j + k + 1 <= n) {
                    dp[i][j][st][1] = max(dp[i][j][st][1], dp[i - 1][j + k + 1][st][1] + l[p[i - 1]]);
                }
                if (st == 0 && i == 1) {
                    dp[i][j][st][1] = -INF;
                }
            }
        }
    }
    for (int j = 0; j <= n; ++j) {
        for (int st = 0; st < 2; ++st) {
            int w = l[p.back()];
            dp[n][j][st][0] = max(dp[n - 1][j][st][0], dp[n - 1][j][st][1]);
            if (j + 2 <= n) {
                dp[n][j][st][1] = max(dp[n][j][st][1], dp[n - 1][j + 2][0][0] + w);
            }
            if (j + k + 1 <= n) {
                dp[n][j][st][1] = max(dp[n][j][st][1], dp[n - 1][j + k + 1][1][0] + w);
                dp[n][j][st][1] = max(dp[n][j][st][1], dp[n - 1][j + k + 1][0][1] + w);
            }
            if (j + 2 * k <= n) {
                dp[n][j][st][1] = max(dp[n][j][st][1], dp[n - 1][j + 2 * k][1][1] + w);
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int st = 0; st < 2; ++st) {
            for (int t = 0; t < 2; ++t) {
                ans = max(ans, dp[n][i][st][t]);
            }
        }
    }
    cout << ans;
    return 0;
}
