#include "sqsort.h"
#include <bits/stdc++.h>
using namespace std;

bool cmp1(int i, int j) {
    return cmp(i, i, j, j);
}

const int MAXN = 3e3;
int w[MAXN];

bool ask(pair<int, int> x, pair<int, int> y) {
    int a = x.first, b = x.second;
    int c = y.first, d = y.second;
    if (w[a] > w[b]) {
        swap(a, b);
    }
    if (w[c] > w[d]) {
        swap(c, d);
    }
    if (w[c] >= w[a] && w[d] >= w[b]) {
        return w[a] + w[b] < w[c] + w[d];
    }
    if (w[c] <= w[a] && w[d] <= w[b]) {
        return false;
    }
    return cmp(a, b, c, d);
}

vector<pair<int, int>> solve(int n) {
    vector<int> arr(n);
    for (int i = 0; i < n; ++i) {
        arr[i] = i;
    }
    stable_sort(arr.begin(), arr.end(), cmp1);
    for (int i = 0; i < n; ++i) {
        w[arr[i]] = i;
    }
    vector<pair<int, int>> ans;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j <= i; ++j) {
            ans.push_back({i, j});
        }
    }
    sort(ans.begin(), ans.end(), ask);
    return ans;
}
