#include "sqsort.h"
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>
#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,sse4")
//#define int long long
#define pii pair<int, int>
#define x first
#define y second
#define all(a) (a.begin()), (a.end())

using namespace std;

bool mycmp(const pii &p1, const pii &p2)
{
	return cmp(p1.x, p1.y, p2.x, p2.y);
}

std::vector<std::pair<int, int>> solve(int n)
{
	vector<pii> rv;

	rv.reserve(n * (n + 1) / 2 + 10);

	for (int i = 0; i < n; ++i)
		for (int j = i; j < n; ++j)
			rv.emplace_back(i, j);

	stable_sort(all(rv), mycmp);

	return move(rv);
}