//#pragma GCC optimize ("O3")
//#pragma GCC optimize ("Ofast")
//#pragma GCC optimize ("unroll-loops")
#define COL 1
#if COL
#include "sqsort.h"
#endif
#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>
#define ff first
#define ss second
#define pb push_back
#define mp make_pair
#define ll long long
#define ld long double
#define all(a) a.begin(),a.end()
#define ull unsigned long long
#define y1 kjlshdfkljsa
#define ios ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);
#define iter set<int>::iterator
using namespace std;
using namespace __gnu_pbds;

const int N=2e5+7;
const int inf=1e9+1e9;
const int mod=1e9+7;
const ld eps=1e-9;

bool cmp(int a,int b,int c,int d);

#if !COL
static const int HARD_LIMIT = 50000000;

static int n;
static std::vector<int> a;

static bool valid_pos(int i) {
	return 0 <= i && i < n;
}

static int Q;
bool cmp(int a_, int b, int c, int d) {
	if(!valid_pos(a_) || !valid_pos(b) || !valid_pos(c) || !valid_pos(d)) {
		std::cerr << "Invalid query." << std::endl;
		std::cout << -1 << std::endl;
		exit(0);
	}

	Q++;
	if(Q > HARD_LIMIT) {
		std::cerr << "Too many queries." << std::endl;
		std::cout << -1 << std::endl;
		exit(0);
	}

	return a[a_] + a[b] < a[c] + a[d];
}

static bool check_valid(const std::vector<std::pair<int, int>> &a) {
	if(n * (n + 1) / 2 != (int)a.size()) {
		return false;
	}

	std::vector<std::vector<bool>> used(n, std::vector<bool>(n, false));
	for(int i = 0; i < (int)a.size(); i++) {
		if(!valid_pos(a[i].first) || !valid_pos(a[i].second) || used[a[i].first][a[i].second]) {
			return false;
		}

		used[a[i].first][a[i].second] = true;
		used[a[i].second][a[i].first] = true;
	}

	return true;
}
#endif

int num[N];

bool get_sm(pair<int,int>a1,pair<int,int>a2)
{
    if (num[a1.ff]>num[a1.ss])swap(a1.ff,a1.ss);
    if (num[a2.ff]>num[a2.ss])swap(a2.ff,a2.ss);
    if (num[a1.ff]<=num[a2.ff] && num[a1.ss]<num[a2.ss])return 1;
    if (num[a1.ff]<num[a2.ff] && num[a1.ss]<=num[a2.ss])return 1;
    return 0;
}

bool CMP(pair<int,int>a1,pair<int,int>a2)
{
    if (get_sm(a1,a2))return 1;
    if (get_sm(a2,a1))return 0;
    return cmp(a1.ff,a1.ss,a2.ff,a2.ss);
}

bool CMP1(int a1,int a2)
{
    return cmp(0,a1,0,a2);
}

vector<pair<int,int>>solve(int n)
{
    vector<int>c;
    for (int i=0;i<n;++i){
        c.pb(i);
    }
    sort(all(c),CMP1);
    for (int i=0;i<n;++i){
        num[c[i]]=i;
    }
    vector<pair<int,int>>res;
    for (int i=0;i<n;++i){
        for (int j=i;j<n;++j){
            res.pb(mp(i,j));
        }
    }
    sort(all(res),CMP);
    return res;
}

#if !COL
int main() {
	std::cin >> n;
	a.resize(n);
	for(int i = 0; i < n; i++) {
		a[i] = 3 * i % n;
	}

	Q = 0;
	std::vector<std::pair<int, int>> ret = solve(n);

	if(!check_valid(ret)) {
		std::cerr << "Invalid output." << std::endl;
		std::cout << -1 << std::endl;
		return 0;
	}

	for(int i = 1; i < (int) ret.size(); i++) {
		if(a[ret[i].first] + a[ret[i].second] < a[ret[i - 1].first] + a[ret[i - 1].second]) {
			std::cerr << "Output not sorted." << std::endl;
			std::cout << -1 << std::endl;
			return 0;
		}
	}

	std::cerr << "Correct!" << std::endl;
	std::cout << Q << std::endl;
	return 0;
}
#endif
