#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
typedef long long ll;
typedef long double ld;
using namespace std;
const int nax = 100006;
const ll MOD = 1000000007;
ll n, m;
ll fac[nax];

ll add(ll a, ll b) {
    return (a + b) % MOD;
}
ll sub(ll a, ll b) {
    return(a - b + MOD) % MOD;
}
ll mul(ll a, ll b) {
    return (a * b) % MOD;
}

ll pow(ll a, ll b) {
    ll ans = 1LL;
    while(b) {
        if(b & 1) {
            ans = mul(ans, a);
        }
        a = mul(a, a);
        b /= 2;
    }
    return ans;
}

ll inv(ll x) {
    return pow(x, MOD - 2LL);
}
ll aranj(ll n, ll m) {
    ll ans = mul(fac[n], inv(fac[n - m]));
    return ans;
}
ll choose(ll n, ll m) {
    ll ans = mul(fac[n], inv(fac[m]));
    ans = mul(ans, inv(fac[n-m]));
    return ans;
}

ll go(ll x) {

    ll remaining = min(n, m) - x;
    ll free = n * m, busy = x;
    ll cur = x, now = n + m - 2;
    //cout << now << '\n';
    while(cur--) {
        busy += now;
        now -= 2;
    }
    free -= busy;
    ll ans = mul(aranj(max(n, m), x), choose(min(n, m), remaining));
    ans = mul(ans, pow(2LL, free));
    //cout << x << ' ' << remaining << ' ' << busy << ' ' << free << '\n';
    //cout << mul(ans, 2) << '\n';
    //cout << mul(ans, 2) << '\n';
    return mul(ans, 2);

}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    fac[0] = 1LL;
    for(int i = 1; i < nax; i++) {
        fac[i] = mul(i, fac[i - 1]);
    }
    cin >> n >> m;
    if(n == m && n == 2) {
        cout << 6 << '\n';
        return 0;
    }

    ll ans = pow(2LL, n * m);
    for(int i = 1; i <= min(n, m); i++) {
        if(i & 1) {
            ans = sub(ans, go(i));
        } else {
            ans = add(ans, go(i));
        }
    }
    if(min(n, m) == 2) {
        ans = add(ans, max(n, m) * 2LL);
    }
    cout << ans << '\n';

    return 0;
}
