#include <bits/stdc++.h>
#include "sqsort.h"
#define pii pair <int, int>
#define x first
#define y second
#define ll long long
#define ld long double

using namespace std;

int n, cnt;

int v[2005];

/*bool cmp(int a, int b, int c, int d) {
  cnt++;
  return v[a] + v[b] < v[c] + v[d];
}*/

pii get_small(vector <pii> v) {
  pii p = v[0];
  for(int i = 1; i < v.size(); i++) {
    if(!cmp(p.x, p.y, v[i].x, v[i].y))
      p = v[i];
  }
  return p;
}

vector <pii> ans, p, can[4000005];
bool comp[2005][2005];

void merge_sort(int l, int r) {
  if(l == r)
    return;
  int mid = (l + r) >> 1;
  merge_sort(l, mid);
  merge_sort(mid + 1, r);
  int i = l, j = mid + 1;
  vector <pii> tmp;
  while(i <= mid && j <= r) {
    if(comp[p[i].x][p[j].x] == comp[p[i].y][p[j].y]) {
      if(comp[p[i].x][p[j].x])
        tmp.push_back(p[i]), i++;
      else
        tmp.push_back(p[j]), j++;
    } else {
      if(cmp(p[i].x, p[i].y, p[j].x, p[j].y)) {
        tmp.push_back(p[i]);
        i++;
      } else {
        tmp.push_back(p[j]);
        j++;
      }
    }
  }
  while(i <= mid)
    tmp.push_back(p[i]), i++;
  while(j <= r)
    tmp.push_back(p[j]), j++;
  for(int i = l; i <= r; i++)
    p[i] = tmp[i - l];
}

vector <pii> solve(int n) {
  vector <int> pz(n + 5);
  for(int i = 0; i < n; i++)
    pz[i] = i;
  for(int i = 0; i < n; i++) {
    for(int j = 0; j < n; j++) {
      comp[i][j] = cmp(i, i, j, j);
      if(i <= j)
        p.push_back({i, j});
    }
  }
  merge_sort(0, n * (n + 1) / 2 - 1);
  return p;
}

/*int main() {
  srand(time(0));
  cin >> n;
  for(int i = 0; i < n; i++) {
    v[i] = rand();
  }
  vector <pii> w = solve(n);
  cout << "Done in " << cnt << " queries\n";
  //for(auto &i : w)
  //  cout << i.x << " " << i.y << " " << v[i.x] + v[i.y] << "\n";
  return 0;
}
*/
