#include <bits/stdc++.h>
using namespace std;
const int N = 55;
const int MOD = 1000000007;
long long comb[N][N];
long long fact[N];
void add(long long &x, long long a){
	x+=a;
	if(x>=MOD)
		x-=MOD;
	if(x<0)
		x+=MOD;
}
long long lgcput(long long b, long long p){
	long long a = 1;
	while(p){
		if(p&1){
			a*=b;
			a%=MOD;
		}
		b*=b;
		b%=MOD;
		p/=2LL;
	}
	return a;
}
void prec(int n){
	comb[1][0] = comb[1][1] = 1;
	for(int i=2;i<=n;i++){
		for(int j = 0;j<=i;j++){
			comb[i][j] = 0;
			if(j > 0)
				add(comb[i][j], comb[i-1][j-1]);
			if(j<i)
				add(comb[i][j], comb[i-1][j]);
		}
	}
	fact[0] = 1;
	for(int i=1;i<=n;i++){
		fact[i] = (1LL* fact[i-1] * i)%MOD;
	}
}
int getpoz(int i,int j,int mask,int n){
	return (mask >> (i*n + j)) & 1;

}
bool check(int mask,int n,int m){
	for(int i=0;i<n;i++){
		for(int j = 0;j<m;j++){
			bool ok = false;
			for(int k = 0; k<m;k++){
				if(k!=j && getpoz(i,k,mask,n) == getpoz(i,j,mask,n))
					ok = true;
			}
			for(int k = 0; k<n;k++){
				if(k!=i && getpoz(k,j,mask,n) == getpoz(i,j,mask,n))
					ok = true;
			}
			if(ok == false)
				return false;
		}
	}
	return true;

}
void brut(int n,int m){
	int prod = n*m;
	int ans = 0;
	for(int mask = 0;mask < (1<<prod);mask++){
			if(check(mask, n, m))
				ans++;
	}
	cout<<ans;
}
int main()
{
	int n, m;
	cin>>n>>m;
	prec(max(n, m));
	if(n*m <= 22){
		brut(n,m);
		return 0;
	}
	long long ans = lgcput(2, n*m);
	for(int nr=1;nr<=min(n, m);nr++){
		long long deadg = 2LL*comb[n][nr] % MOD * comb[m][nr] % MOD * fact[nr] % MOD;
		int restul = (n-nr)*(m-nr);
		deadg = 1LL * deadg * lgcput(2, restul) % MOD;
		if(nr%2 == 1)
			add(ans, -deadg);
		else
			add(ans, deadg);
	}
	cout<<ans;
	return 0;
}
