#include <bits/stdc++.h>

using namespace std;

using ll = long long;
#define pb push_back
#define dbg(x) cerr << #x << " " << x << "\n"

const int N = 50, MOD = 1e9 + 7;



void add (int &a, int b) {
    a += b;
    if (a >= MOD)
        a -= MOD;
}
int mult (int a, int b) {
    return 1ll * a * b % MOD;
}


int a[1 + N][1 + N];
int row[2][1 + N], col[2][1 + N];

int main () {
    ios::sync_with_stdio (false);
    cin.tie (0); cout.tie (0);
    int n, m;
    cin >> n >> m;
    if (n > m)
        swap (n, m);

    int mx = n * m;
    int ans = 0;
    for (int mask = 0; mask < (1 << mx); mask++) {
        for (int i = 0; i < max (n, m); i++)
            for (int x = 0; x < 2; x++)
                row[x][i] = col[x][i] = 0;
        for (int i = 0; i < n; i++)
            for (int j = 0; j < m; j++) {
                int val = i * m + j;
                if (mask & (1 << val))
                    a[i][j] = 1;
                else
                    a[i][j] = 0;
                row[a[i][j]][i]++;
                col[a[i][j]][j]++;
            }
        bool ok = true;
        for (int i = 0; i < n; i++)
            for (int j = 0; j < m; j++) {
                int x = a[i][j];
                if (row[x][i] <= 1 && col[x][j] <= 1)
                    ok = false;
            }
        if (ok) ans++;
    }
    cout << ans << "\n";
    return 0;
}
