#include <iostream>
#include <deque>

using namespace std;

const int MAX_N = 1e4 + 1;
int t[MAX_N], l[MAX_N];
int dp[MAX_N], dp0[MAX_N], dp1[MAX_N];

int n, k;

int DP[MAX_N][MAX_N];

void solve(deque<int> p, int* dp0, int* ans) {
    for (int i = 0; i <= n; i++)
        DP[0][i] = dp0[i];

    for (int i = 1; i <= p.size(); i++) {
        for (int j = 0; j <= n; j++) {
            if (j >= 1)
                DP[i][j] = DP[i - 1][j - 1];
            else
                DP[i][j] = -1e9;

            if (j + k <= n)
                DP[i][j] = max(DP[i][j], DP[i - 1][j + k] + l[p[i-1]]);
            if (i >= 2)
                DP[i][j] = max(DP[i][j], DP[i - 2][j] + l[p[i-1]]);
        }
    }

    for (int i = 0; i <= n; i++)
        ans[i] = DP[p.size()][i];
}

int main() {
    cin >> n >> k;

    for (int i = 0; i < n; i++)
        cin >> t[i] >> l[i];

    for (int i = 1; i <= n; i++)
        dp[i] = -1e9;

    for (int i = 0; i < n; i++)
        if (t[i] != -1) {
            int cnt = 0;
            int j = i;
            deque<int> st;
            while (t[j] != -1) {
                st.push_front(j);
                int aux = j;
                j = t[j];
                t[aux] = -1;
            }

            solve(st, dp, dp0);
            st.push_back(st.front());
            st.pop_front();
            solve(st, dp, dp1);

            for (int j = 0; j <= n; j++)
                dp[j] = max(dp0[j], dp1[j]);
        }

    cout << dp[0];
    return 0;
}
