#include <iostream>
#include <cstdio>
#include <deque>

using namespace std;

const int MAX_N = 2e4 + 1;
int t[MAX_N], l[MAX_N];
int dp[MAX_N], dp0[MAX_N], dp1[MAX_N];

int n, k;

int DP[4][MAX_N];

void solve(deque<int> p, int* dp0, int* ans) {
    for (int i = 0; i <= n * 2; i++)
        DP[0][i] = dp0[i];

    for (int i = 1; i <= p.size(); i++) {
        for (int j = 0; j <= n * 2; j++) {
            if (j >= 1)
                DP[i & 3][j] = DP[(i + 3) & 3][j - 1];
            else
                DP[i & 3][j] = -1e9;

            if (j + k <= n * 2)
                DP[i & 3][j] = max(DP[i & 3][j], DP[(i + 3) & 3][j + k] + l[p[i-1]]);
            if (i >= 2)
                DP[i & 3][j] = max(DP[i & 3][j], DP[(i + 2) & 3][j] + l[p[i-1]]);
        }
    }

    for (int i = 0; i <= n * 2; i++)
        ans[i] = DP[p.size() & 3][i];
}

int main() {
//    freopen("input.txt", "r", stdin);

    cin >> n >> k;

    for (int i = 0; i < n; i++)
        cin >> t[i] >> l[i];

    for (int i = n + 1; i <= n * 2; i++)
        dp[i] = -1e9;

    for (int i = 0; i < n; i++)
        if (t[i] != -1) {
            int j = i;
            deque<int> st;
            while (t[j] != -1) {
                st.push_front(j);
                int aux = j;
                j = t[j];
                t[aux] = -1;
            }

//            solve(st, dp, dp0);
            int cnt = 0;
            while (cnt <= st.size() && l[st[0]]) {
                st.push_back(st.front());
                st.pop_front();
                cnt++;
            }
            solve(st, dp, dp);

//            for (int j = 0; j <= n * 2; j++)
//                dp[j] = max(dp0[j], dp1[j]);
        }

    cout << dp[n];
    return 0;
}
