#include <iostream>
#include <algorithm>
#define fi first
#define se second
using namespace std;

const int MAXN = 10004;

int n, k;
pair<int, int> tl[MAXN];

int check(int x)
{
    bool used[MAXN];
    int points[MAXN], sum = 0;
    for (int i = 0; i < n; ++ i)
    {
        if (x & (1 << i))
        {
            used[i] = 1;
            points[i] = k;
            sum += tl[i].se;
        }
        else
        {
            used[i] = 0;
            points[i] = 0;
        }
    }

    for (int i = 0; i < n; ++ i)
    {
        if (x & (1 << i))
        {
            if (used[tl[i].fi] == 0)
            {
                used[tl[i].fi] = 1;
                points[i] += k;
            }
        }
    }

    for (int i = 0; i < n; ++ i)
    {
        if (x & (1 << i))
        {
            if (points[i] == 2 * k) continue;

            for (int j = 0; j < n; ++ j)
            {
                if (points[i] == 2 * k) break;
                if (used[j] == 1) continue;
                if (used[j] == 0)
                {
                    used[j] = 1;
                    points[i]++;
                }
            }

            if (points[i] < 2 * k) return 0;
        }
    }

    return sum;
}

int main()
{
    cin >> n >> k;
    for (int i = 0; i < n; ++ i)
    {
        cin >> tl[i].fi >> tl[i].se;
    }

 /*   cout << check(82) << endl;
    return 0;*/

    int mask = (1 << n), ans = 0;
    for (int i = 0; i < mask; ++ i)
    {
        ans = max(ans, check(i));
    }

    cout << ans << endl;
    return 0;
}
