#include "sqsort.h"
//#include "Lgrader.cpp"
#include <vector>
#include <algorithm>
using namespace std;

const int MAXN = 2003;
int order[MAXN];

bool comp1(int a, int b)
{
    int x = 0;
    if (a == 0 or b == 0) x = 1;
    if (a == 1 or b == 1) x = 2;
    return cmp(a, x, b, x);
}

bool comp(pair<int, int> a, pair<int, int> b)
{
    if (order[a.first] > order[a.second]) swap(a.first, a.second);
    if (order[b.first] > order[b.second]) swap(b.first, b.second);
    if (order[a.first] < order[b.first] and order[a.second] < order[b.second]) return 1;
    return cmp(a.first, a.second, b.first, b.second);
}

std::vector<std::pair<int, int>> solve(int n)
{
    vector<int> v1;
    for (int i = 0; i < n; ++ i)
    {
        v1.push_back(i);
    }
    stable_sort(v1.begin(), v1.end(), comp1);
    for (int i = 0; i < n; ++ i)
    {
        order[v1[i]] = i;
    }


    vector<pair<int, int>> v;
    for (int i = 0; i < n; ++ i)
    {
        for (int j = i; j < n; ++ j)
        {
            v.emplace_back(i, j);
        }
    }

    sort(v.begin(), v.end(), comp);

    return v;
}
