#include<bits/stdc++.h>
using namespace std;

const int maxN = 51;
const unsigned long long mod = 1e9 + 7;
int n, m, maxi;
int amount;
int answer[maxN][maxN];

void first_row()
{
    maxi = max(m, n);
    answer[1][1] = 0;
    answer[1][2] = answer[2][1] = answer[1][3] = answer[3][1] = 2;
    for(int i = 4; i <= maxi; i++)
    {
        answer[1][i] = answer[i][1] = (2 * answer[1][i - 1] % mod + 2 * (i - 2)) % mod;
        //cout <<answer[1][i] <<endl;
    }
}

bool ans[maxN][maxN];
int ss = 0;
bool check_row(int row)
{
    int sum = 0;
    for(int j = 0; j < m; j++)
    {
        sum += ans[row][j];
    }
    return sum != 1 && sum != m - 1;
}

bool check_cols()
{
    bool ok = true;
    for(int j = 0; j < m; j++)
    {
        int sum = 0;
        for(int i = 0; i < n; i++)
        {
            sum += ans[i][j];
        }
        ok = ok && sum != 1 && sum != n - 1;
        if(!ok) return false;
    }

    return true;
}

void dfs(int pos = 0)
{
    if(pos != 0 && pos % m == 0 && !check_row(pos / m - 1))
    {
        return;
    }

    if(pos == amount)
    {
        if(check_cols())
        {
            ss++;
            ss %= mod;
        }
        return;
    }

    //cout <<pos <<endl;
    ans[pos / m][pos % m] = false;
    dfs(pos + 1);
    ans[pos / m][pos % m] = true;
    dfs(pos + 1);
}

/*
int pows[maxN * maxN];

void init()
{
    pows[0] = 1;
    for(int i = 1; i <= amount; i++)
    {
        pows[i] = 2 * pows[i - 1] % mod;
        //cout <<pows[i] <<endl;
    }
}

unsigned long long find_it()
{
    amount = m * n;
    unsigned long long a = pows[amount];
    //for(int i = 1; i <= n; i++)
    //{
    int i, j;
    i = 1;
    for(j = 1; j <= m; j++)
    {
        a = (a +  2LL * (mod - pows[(i - 1) * (j - 1)]) % mod *
                        (mod - pows[(n - i) * (j - 1)]) % mod *
                        (mod - pows[(i - 1) * (m - j)]) % mod *
                        (mod - pows[(n - i) * (m - j)]) % mod) % mod;
    }
    //}

    j = 1;
    for(i = 2; i <= n; i++)
    {
        a = (a +  2LL * (mod - pows[(i - 1) * (j - 1)]) % mod *
                        (mod - pows[(n - i) * (j - 1)]) % mod *
                        (mod - pows[(i - 1) * (m - j)]) % mod *
                        (mod - pows[(n - i) * (m - j)]) % mod) % mod;
    }
    return a;
}*/

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >>n >>m;
    if(n == 1 || m == 1)
    {
        first_row();
        cout <<answer[n][m] <<endl;
        return 0;
    }

    amount = m * n;
    dfs();
    //init();
    cout <<ss <<endl;

}
