#include <bits/stdc++.h>

using namespace std;
 
using ll = long long;
using ld = long double;
using db = double; 
using str = string; 

using pi = pair<int, int>;
using pll = pair<ll, ll>;
using pd = pair<double, double>;

#define f first
#define s second
#define mp(x, y) make_pair(x, y)

#define sz(X) x.size()
#define pb(x) push_back(x)
#define ins(x) insert(x)

const int MOD = 1e9+7;
const int mxN = 50;
const ll INF = 1e18; 
const ld PI = acos((ld)-1);
 
int add(int f, int s)
{
	f += s;
	if(f >= MOD) f %= MOD;
	return f;
}

int mul(long long f, int s)
{
	f *= s;
	if(f >= MOD) f %= MOD;
	return f;
}

int n, m;
int T[mxN][3][3][3][3][3][3][3][3][3][3][3][3][3][3];

int rec(int ind, bool R[7], bool B[7])
{
	if(ind == m)
	{
		for(int i = 0; i < n; i++)
		{
			if(R[i] == 1 || B[i] == 1) return 0;
		}
		return 1;
	}
	int& ans = T[ind][R[0]][R[1]][R[2]][R[3]][R[4]][R[5]][R[6]][B[0]][B[1]][B[2]][B[3]][B[4]][B[5]][B[6]];
	if(ans != -1) return ans;
	ans = 0;
	bool t_R[7], t_B[7];
	for(int i = 0; i < (1 << n); i++)
	{
		int br0 = 0, br1 = 0;
		
		for(int i = 0; i < 7; i++)
		{
			t_R[i] = R[i];
			t_B[i] = B[i];
		}
		for(int j = 0; j < n; j++)
		{
			if(i & (1 << j))
			{
				br1++;
			}
			else
			{
				br0++;
			}
		}
		for(int j = 0; j < n; j++)
		{
			if(i & (1 << j))
			{
				t_R[j] = min(t_R[j] + 1, 2);
				if(br1 >= 2)
				{
					t_R[j] = min(t_R[j] + 1, 2);
				}
			}
			else
			{
				t_B[j] = min(t_B[j] + 1, 2);
				if(br0 >= 2)
				{
					t_B[j] = min(t_B[j] + 1, 2);
				}
			}
		}
		ans = add(ans, rec(ind + 1, t_R, t_B));
	}
	return ans;
}

int solve()
{
	memset(T, -1, sizeof(T));
	bool a[7], b[7];
	for(int i = 0; i < 7; i++)
	{
		a[i] = b[i] = 0;
	}
	return rec(0, a, b);
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);

	cin >> n >> m;
	if(n > m) swap(n, m);
	cout << solve() << "\n";

	return 0;
}
 
 /* stuff you should look for
	* int overflow, array bounds
	* special cases (n=1?)
	* do smth instead of nothing and stay organized
	* WRITE STUFF DOWN
	* DON'T GET STUCK ON ONE APPROACH
*/

