#include <bits/stdc++.h>

using namespace std;
 
using ll = long long;
using ld = long double;
using db = double; 
using str = string; 

using pi = pair<int, int>;
using pll = pair<ll, ll>;
using pd = pair<double, double>;

#define f first
#define s second
#define mp(x, y) make_pair(x, y)

#define sz(X) x.size()
#define pb(x) push_back(x)
#define ins(x) insert(x)

const int MOD = 1e9+7;
const int mxN = 50;
const ll INF = 1e18; 
const ld PI = acos((ld)-1);
 
int add(int f, int s)
{
	f += s;
	if(f >= MOD) f %= MOD;
	return f;
}

int mul(long long f, int s)
{
	f *= s;
	if(f >= MOD) f %= MOD;
	return f;
}

int n, m;
int T[mxN][(1 << 10)][(1 << 10)];

int rec(int ind, int msk0, int msk1)
{
	//cout << bitset<10>(msk0) << " " << bitset<10>(msk1) << "\n";
	if(ind == m)
	{
		for(int i = 0; i < n; i++)
		{
			int b0 = !(msk0 & (1 << i));
			int b1 = !(msk0 & (1 << (n + i)));
			int a0 = !(msk1 & (1 << i));
			int a1 = !(msk1 & (1 << (n + i)));
			if((b0 != b1) || (a0 != a1)) return 0;
		}
		return 1;
	}
	int ans = T[ind][msk0][msk1];
	if(ans != -1) return ans;
	ans = 0;
	for(int i = 0; i < (1 << n); i++)
	{
		int br0 = 0, br1 = 0;
		int n_msk0 = msk0;
		int n_msk1 = msk1;
		for(int j = 0; j < n; j++)
		{
			if(i & (1 << j))
			{
				br1++;
			}
			else
			{
				br0++;
			}
		}
		//cout << br0 << " " << br1 << "\n";
		for(int j = 0; j < n; j++)
		{
			if(i & (1 << j))
			{
				n_msk1 |= (1 << j);
				//n_msk1 |= (msk1 & (1 << j));
				if((msk1 & (1 << j)) || br1 >= 2)
				{
					n_msk1 |= (1 << (j + n));
				}
				//br1++;
			}
			else
			{
				n_msk0 |= (1 << j);
				//n_msk1 |= (msk1 & (1 << j));
				if((msk0 & (1 << j)) || (br0 >= 2))
				{
					n_msk0 |= (1 << (j + n));
				}
				//br0++;
			}
		}
		ans += rec(ind + 1, n_msk0, n_msk1);
	}
	return ans;
}

int solve()
{
	memset(T, -1, sizeof(T));
	return rec(0, 0, 0);
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);

	cin >> n >> m;
	if(n > m) swap(n, m);
	cout << solve() << "\n";

	return 0;
}
 
 /* stuff you should look for
	* int overflow, array bounds
	* special cases (n=1?)
	* do smth instead of nothing and stay organized
	* WRITE STUFF DOWN
	* DON'T GET STUCK ON ONE APPROACH
*/

