#include<bits/stdc++.h>
using namespace std;

const int nmax=1e4+42,MX=11;

int n,k;

int target[nmax],gain[nmax];

int dp[MX][1<<MX];

int rec(int pos,int active)
{
    if(pos==n)return 0;
    if(dp[pos][active]!=-1)return dp[pos][active];

    int ret=rec(pos+1,active);

    for(int mask=active;mask;mask=(mask-1)&active)
    {
        int score=0;

        for(int j=0;j<n;j++)
            if((mask&(1<<j)))
            {
                if(j==pos||j==target[pos])score+=k;
                else score++;
            }
        if(score>=2*k)ret=max(ret,rec(pos+1,active-mask)+gain[pos]);
    }
    dp[pos][active]=ret;
    return ret;
}

void slow()
{
    memset(dp,-1,sizeof(dp));

    printf("%i\n",rec(0,(1<<n)-1));

    exit(0);
}

int last;
/*
10 2
1 2
2 7
3 6
4 4
5 6
6 5
7 0
8 4
9 0
0 0
*/

mt19937 rng(42);
void gen()
{
    n=10;
    k=2;
    for(int i=0;i<n;i++)
    {
        target[i]=(i+1)%n;
        gain[i]=rng()%30;
    }
    gain[n-1]=0;

    cout<<n<<" "<<k<<endl;
    for(int i=0;i<n;i++)cout<<target[i]<<" "<<gain[i]<<endl;
}

int order[nmax];

int help[nmax][2];

int dp_2[nmax][2];

int main()
{
    //gen();

    scanf("%i%i",&n,&k);
    for(int i=0;i<n;i++)scanf("%i%i",&target[i],&gain[i]);


    if(n<11)
    {
        slow();
        return 0;
    }

    for(int i=0;i<n;i++)
        if(target[i]==0)last=i;

    int cur=0;
    for(int i=0;i<n;i++)
    {
        order[i]=cur;
        cur=target[cur];
    }

    //cout<<"last= "<<last<<endl;

    for(int i=n-2;i>=0;i--)
    {
        memset(help,0,sizeof(help));

        int pos=order[i];

        for(int free=0;free<=n;free++)
            for(int taken=0;taken<2;taken++)
            {
            //cout<<"go "<<pos<<" "<<free<<" "<<taken<<endl;

            //ignore
            int ret=dp_2[free][0];

            //take as me+target
            if(taken==0&&free>=2)ret=max(ret,dp_2[free-2][1]+gain[pos]);

            //me+k free
            if(taken==0&&free>=k+1)ret=max(ret,dp_2[free-1-k][0]+gain[pos]);

            //target+k free
            if(free>=k+1)ret=max(ret,dp_2[free-1-k][1]+gain[pos]);

            //2k free
            if(free>=2*k)ret=max(ret,dp_2[free-2*k][0]+gain[pos]);

            help[free][taken]=ret;
            }

        for(int free=0;free<=n;free++)
            for(int taken=0;taken<2;taken++)
                dp_2[free][taken]=help[free][taken];
    }

    printf("%i\n",dp_2[n][0]);

    //slow();

    return 0;
}
/*
8 2
1 12
2 111
3 101
4 13
5 105
6 14
7 108
0 9

8 1
1 12
2 111
3 101
4 13
5 105
6 14
7 108
0 9



*/
