#include "sqsort.h"
#include<bits/stdc++.h>
using namespace std;
const int MAXN = 2048;
int it[MAXN *4];
vector< pair<int,int> >v;
vector< pair<int,int> >ans;
int id[MAXN*MAXN];
bool comp(pair<int,int>a,pair<int,int>b)
{
    return cmp(a.first,a.second,b.first,b.second);
}
void update(int k,int l,int r)
{
    if((it[k*2]==-1&&it[k*2+1]==-1)||(it[k*2]==it[k]&&it[k*2+1]==it[k]))
    {
        k/=2;
        if(k==0)return;
        if(it[k*2]==it[k])
        {
            it[k]=it[k*2+1];
        }
        else it[k]=it[k*2];
    }
    if(comp(v[it[k*2]],v[it[k*2+1]]))
    {
        it[k]=it[k*2];
    }else it[k] = it[k*2+1];
}
void init(int k,int l,int r)
{
    int mid=(l+r)/2;
    if(l==r)
    {
        it[k]=l;
        return;
    }
    init(k*2,l,mid);
    init(k*2+1,mid+1,r);
    if(comp(v[it[k*2]],v[it[k*2+1]]))
    {
        it[k]=it[k*2];
    }else it[k] = it[k*2+1];
}
std::vector<std::pair<int, int>> solve(int n)
{
    int i,j;
    for(i=0;i<n;i++)
    {
        for(j=i+1;j<n;j++)
        {
            v.push_back({i,j});
        }
    }
    init(1,0,v.size()-1);
    for(i=0;i<n;i++)
    {
        for(j=i+1;j<n;j++)
        {
            ans.push_back(v[it[1]]);
            update(1,0,v.size()-1);
        }
    }
    return ans;
}

