#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 1024
using namespace std;
int n, k;

struct st
{
    int id, target, l;
    st () {}
    st (int _id, int _target, int _l)
    {
        id = _id;
        target = _target;
        l = _l;
    }
    bool operator < (const st &p) const
    {
        return l > p.l;
    }
};

st hunters[MAXN];

void input()
{
    cin >> n >> k;
    for (int i = 0; i < n; ++i)
    {
        int t, l;
        hunters[i].id = i;
        cin >> hunters[i].target >> hunters[i].l;
    }
}

bool card[MAXN];
int rem;

void solve()
{
    sort(hunters, hunters + n);
    int cnt = 0;
    rem = n - 1;

    for (int i = 0; i < n; ++i)
    {
        if (i > rem)
            break;
        /// i-th hunter finds his target
        //cout << hunters[i].id << ": " << endl;
        if (!card[hunters[i].id])
        {
            //cout << "***" << endl;
            int target = hunters[i].target;
            if (!card[target])
            {
                cnt += hunters[i].l;
                card[target] = 1;
                --rem;
            }
            else if (rem - i >= k)
            {
                cnt += hunters[i].l;
                for (int j = 0; j < k; ++j)
                {
                    card[hunters[rem--].id] = 1;
                }
            }
            card[hunters[i].id] = 1;
            continue;
        }
        //cout << "---" << endl;
        if (rem - i >= 2 * k)
        {
            cnt += hunters[i].l;
            for (int j = 0; j < k; ++j)
            {
                card[rem--] = 1;
            }
        }
        card[hunters[i].id] = 1;
    }

    cout << cnt << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    solve();

    return 0;
}
