#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 1024
using namespace std;
int n, k;
int t[MAXN], l[MAXN];

struct st
{
    int id, target, l;
    st () {}
    st (int _id, int _target, int _l)
    {
        id = _id;
        target = _target;
        l = _l;
    }
    bool operator < (const st &p) const
    {
        return l > p.l;
    }
};

string convert(int x)
{
    string ret = "";
    while (x)
    {
        ret = char(x % 2 + '0') + ret;
        x /= 2;
    }

    return ret;
}


st hunters[MAXN];

void input()
{
    cin >> n >> k;
    for (int i = 0; i < n; ++i)
    {
        cin >> t[i] >> l[i];
        hunters[i].id = i;
        hunters[i].target = t[i];
        hunters[i].l = l[i];
    }
}

bool card[MAXN];

int check(int comb)
{
    //cout << convert(comb) << " ____ " << endl;
    int cnt = 0;
    for (int i = 0; i < n; ++i)
        card[i] = 0;

    vector <int> v;
    ///cout << "pass: ";
    string str = convert(comb);
    bool b = (str == "101101" || str == "111");
    b = false;

    for (int i = 0; i < n; ++i)
    {
        //cout << "* " << convert((1 << i)) << " " << convert(comb) << " " << ((1 << i) & comb) << " +" << convert((1 << i) & comb) << endl;
        if (((1 << i) & comb) != 0)
        {
            v.push_back(i);
            if (b)
                cout << hunters[i].id << "  ";
            //card[hunters[i].id] = 1;
            cnt += hunters[i].l;
        }

    }

    if (b)
        cout << endl;

    /*if (cnt == 336)
    {
        cout << endl << endl;
        for (int i = 0; i < v.size(); ++i)
            cout << "*- " << hunters[v[i]].id << " " << hunters[v[i]].target << " " << hunters[v[i]].l << endl;
        //cout << endl << endl;
    }*/


    b = (cnt == 336);
    b = false;

    int sz = v.size();
    int rem = n;
    int idx = n - 1;
    for (int i = 0; i < sz; ++i)
    {
        int id = hunters[v[i]].id;
        int target = hunters[v[i]].target;
        if (b)
        {
            cout << "id: " << id << " trg: " << target << " - " << endl;
        }
        if (!card[id])
        {
            if (b)
                cout << "has own card" << endl;
            card[id] = 1;
            rem--;

            if (!card[target])
            {
                //cnt += hunters[id].l;
                if (b)
                    cout << "gets targets card" << endl;
                card[target] = 1;
                card[id] = 1;
                rem--;
                continue;
            }

            if (rem < k)
                return -1;
            if (b)
                cout << "gets k other cards:" << endl;
            rem -= k;
            int take = k;

            for (int j = n - 1; j >= 0; --j)
            {
                if (take == 0)
                    break;

                if (card[hunters[j].id])
                    continue;

                if ((1 << j) ^ comb == 0)
                {
                    card[hunters[j].id] = 1;
                    if (b)
                        cout << "takes card of " << hunters[j].id << endl;
                     --take;
                }
            }

            if (take == 0)
            {
                continue;
            }

            for (int j = n - 1; j >= 0; --j)
            {
                if (take == 0)
                    break;

                if (card[hunters[j].id])
                    continue;

                if (b)
                    cout << "takes card of " << hunters[j].id << endl;
                card[hunters[j].id] = 1;
                --take;
            }
        }

        if (b)
            cout << "doesnt have own card" << endl;

        if (!card[target])
        {
            //cnt += hunters[id].l;
            if (b)
                cout << "gets targets card" << endl;
            card[target] = 1;
            card[id] = 1;
            rem--;

            if (rem < k)
                return -1;
            if (b)
                cout << "gets k other cards" << endl;
            rem -= k;
            int take = k;

            for (int j = n - 1; j >= 0; --j)
            {
                if (take == 0)
                    break;

                if (card[hunters[j].id])
                    continue;

                if ((1 << j) ^ comb == 0)
                {
                    card[hunters[j].id] = 1;
                    --take;
                }
            }

            if (take == 0)
            {
                continue;
            }

            for (int j = n - 1; j >= 0; --j)
            {
                if (take == 0)
                    break;

                if (card[hunters[j].id])
                    continue;

                card[hunters[j].id] = 1;
                --take;
            }

            continue;
        }

        if (b)
            cout << "gets 2*k other cards:" << endl;

        if (rem < 2 * k)
            return -1;

            rem -= 2 * k;
            int take = k;

            for (int j = n - 1; j >= 0; --j)
            {
                if (take == 0)
                    break;

                if (card[hunters[j].id])
                    continue;

                if ((1 << j) ^ comb == 0)
                {
                    card[hunters[j].id] = 1;
                    --take;
                }
            }

            if (take == 0)
            {
                continue;
            }

            for (int j = n - 1; j >= 0; --j)
            {
                if (take == 0)
                    break;

                if (card[hunters[j].id])
                    continue;

                card[hunters[j].id] = 1;
                --take;
            }
    }

    return cnt;
}

void solve()
{
    sort(hunters, hunters + n);
    int best = -1;
    for (int comb = 1; comb < (1 << n); ++comb)
    {
        //cout << " ------------------ " << endl << endl;
        //cout << convert(comb) << endl;
        int tmp = check(comb);
        //cout << tmp << endl;
        best = max(best, tmp);
    }

    cout << best << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    solve();

    return 0;
}
