#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 1024
using namespace std;

int n, k;

struct st
{
    int id, targetId, l;
    st () {}
    st (int _id, int _targetId, int _l)
    {
        id = _id;
        targetId = _targetId;
        l = _l;
    }
    bool operator < (const st &p) const
    {
        return l < p.l;
    }
};

st hunters[MAXN];

void input()
{
    cin >> n >> k;
    for (int i = 0; i < n; ++i)
    {
        hunters[i].id = i;
        cin >> hunters[i].targetId >> hunters[i].l;
    }
}

bool card[MAXN];
bool isHunter[MAXN];
bool isTarget[MAXN];

string convert(int x)
{
    string ret = "";
    while (x)
    {
        ret = char(x % 2 + '0') + ret;
        x /= 2;
    }

    return ret;
}

int check(int comb)
{
    vector <int> v;
    //cout << convert(comb) << endl;
    int cnt = 0;
    for (int i = 0; i < n; ++i)
    {
        card[i] = 0;
        isHunter[hunters[i].id] = 0;
        isTarget[hunters[i].targetId] = 0;
        if (((1 << i) & comb) != 0)
        {
            //cout << i << " - ";
            v.push_back(i);
            isHunter[hunters[i].id] = 1;
            isTarget[hunters[i].targetId] = 1;
            cnt += hunters[i].l;
        }
    }

    //cout << endl;
    //cout << cnt << endl;

    int rem = n;

    for (int i = 0; i < v.size(); ++i)
    {
        int id = hunters[v[i]].id;
        int targetId = hunters[v[i]].targetId;
        int goal = 2 * k;

        //cout << "tmp: " << id << " " << targetId << endl;

        if (!card[id])
        {
            card[id] = 1;
            --rem;
            goal -= k;
        }

        if (!card[targetId])
        {
            card[targetId] = 1;
            --rem;
            goal -= k;
        }

        if (goal == 0)
            continue;

        if (goal > rem)
            return -1;

        for (int j = n - 1; j >= 0; --j)
        {
            if (isHunter[hunters[j].id])
                continue;
            if (isTarget[hunters[j].id])
                continue;
            if (card[hunters[j].id])
                continue;
            --rem;
            --goal;
            card[hunters[j].id] = 1;
            if (goal == 0)
                break;
        }

        if (goal == 0)
            continue;

        for (int j = n - 1; j >= 0; --j)
        {
            if (card[hunters[j].id])
                continue;
            --rem;
            --goal;
            card[hunters[j].id] = 1;
            if (goal == 0)
                break;
        }
    }

    return cnt;
}

void solve()
{
    int best = -1;
    for (int i = 0; i < (1 << n); ++i)
    {
        int tmp = check(i);
        best = max(best, tmp);
    }

    cout << best << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    solve();

    return 0;
}
