#include <iostream>
#include <algorithm>
#include <utility>
#include <vector>
#include "sqsort.h"
using namespace std;
vector<pair<int, int>> indexes;
int createIndexConverters(int n)
{
	int current_index = 0;
	for(int i = 0; i < n; ++i)
	{
		for (int j = i; j < n; ++j)
		{
			indexes.push_back({ i,j });
			cout << indexes[current_index].first <<" "<< indexes[current_index].second<<endl;
			current_index++;
		}
	}
	return current_index;
}

bool compare(pair<int, int> a, pair<int, int> b)
{
	pair<int, int> ab = indexes[a.first];
	pair<int, int> cd = indexes[b.first];
	return cmp(ab.first, ab.second, cd.first, cd.second);
}

vector<pair<int, int>> solve(int n)
{
	int length = createIndexConverters(n);
	vector<pair<int, int>> numbers;
	for (int i = 0; i < length; ++i) numbers[i] = { i,0 };
	sort(numbers.begin(), numbers.end(), compare);
	return numbers;
}
