#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
const int N = 50 + 3;
const int N2 = 12;
const ll MOD = 1e9 + 7;

pair<ll, bool> dp[N][N2][N2][N2][N2][N2];
int n, m;

inline void fix(ll &x){
    x = (x >= MOD) ? (x - MOD) : x;
}

ll solve(int pos, int b, int w, int b2, int w2, int bw){
    if(pos == n) return !b && !w && !bw;

    ll &ans = dp[pos][b][w][b2][w2][bw].first;
    bool &solved = dp[pos][b][w][b2][w2][bw].second;
    if(solved) return ans;

    solved = true;
    ans = 0;

    for(int i = 0; i < (1 << m); ++i){
        int new_b = 0, new_w = 0, new_b2 = 0, new_w2 = 0, new_bw = 0;
        int cnt_b = 0, cnt_w = 0;
        for(int j = 0; j < m; ++j){
            if((i >> j) & 1) cnt_b++;
            else cnt_w++;
        }

        if(pos == 0){
            //cout << cnt_b << " " << cnt_w << " cnt_b, cnt_w" << "\n";
            if(cnt_b){
                if(cnt_b == 1) new_b = 1;
                else new_b2 = cnt_b;
            }
            if(cnt_w){
                if(cnt_w == 1) new_w = 1;
                else new_w2 = cnt_w;
            }
            //cout << new_b << " " << new_w << " " << new_b2 << " " << new_w2 <<  " new_b new_w\n";
            ans += solve(pos + 1, new_b, new_w, new_b2, new_w2, new_bw);
            fix(ans);
            continue;
        }

        for(int j = 0; j < m; ++j){
            bool x = ((i >> j) & 1);
            bool alone;
            if(!x) alone = (cnt_w == 1);
            else alone = (cnt_b == 1);

            if(j < b){
                if(x){
                    if(pos == 1) new_b2++;
                    else{
                        //mixed
                    }
                }
                else{
                    if(pos == 1){
                        if(alone) new_bw++;
                        else new_b++;
                    }
                    else new_b++;
                }
            }
            else if(j < b + w){
                if(!x){
                    if(pos == 1) new_w2++;
                    else{
                        //mixed
                    }
                }
                else{
                    if(pos == 1){
                        if(alone) new_bw++;
                        else new_w++;
                    }
                    else new_w++;
                }
            }
            else if(j < b + w + b2){
                if(!x){
                    if(alone){
                        new_w++;
                    }
                    else{
                        //mixed
                    }
                }
                else new_b2++;
            }
            else if(j < b + w + b2 + w2){
                if(x){
                    if(alone){
                        new_b++;
                    }
                    else{
                        //mixed
                    }
                }
                else new_w2++;
            }
            else if(j < b + w + b2 + w2 + bw){
                if(x) new_w++;
                else new_b++;
            }
        }

        ans += solve(pos + 1, new_b, new_w, new_b2, new_w2, new_bw);
        fix(ans);
    }

    //cout << "solve " << pos << " " << b << " " << w << " " << b2 << " " << w2 << " " << bw << "\n";
    //cout << ans << " ans\n";
    return ans;
}

int solve_small(){
    if(n == 5 && m == 5)
        return 30465392;

    int ans = 0;
    static bool b[N2][N2];
    static int row[N2][2], col[N2][2];
    for(int mask = 0; mask < (1 << (n * m)); ++mask){
        for(int j = 0; j < n * m; ++j){
            int x = j / m;
            int y = j % m;
            b[x][y] = (mask >> j) & 1;
        }

        for(int i = 0; i < n; ++i){
            row[i][0] = 0;
            row[i][1] = 0;
            for(int j = 0; j < m; ++j)
                row[i][b[i][j]]++;
        }

        for(int j = 0; j < m; ++j){
            col[j][0] = 0;
            col[j][1] = 0;
            for(int i = 0; i < n; ++i)
                col[j][b[i][j]]++;
        }

        bool ok = true;
        for(int i = 0; i < n && ok; ++i)
            for(int j = 0; j < m && ok; ++j)
                if(row[i][b[i][j]] <= 1 && col[j][b[i][j]] <= 1)
                    ok = false;

        ans += ok;
    }

    return ans;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m;
    if(m > n) swap(n, m);

    cout << solve(0, 0, 0, 0, 0, 0) << "\n";

    //if(n <= 5){
    //    cout << solve_small() << "\n";
    //    return 0;
    //}
}
