#include <vector>
#include <cstring>
#include <iostream>

using namespace std;

const int MAXN = 705;
const long long inf = 1e11 + 5;

int n, k;
int T[MAXN], L[MAXN];

long long memo[MAXN][2][MAXN*3+69];

long long rec(int ind, bool taken, int required)
{
    //cout << ind << " " << taken << " " << required << '\n';

    if(ind==n-1)
    {
        //TODO
        return rec(ind+1, false, required-((taken==false)?1:0));
    }
    if(ind==n)
    {
        if(required>0) return -inf;
        return 0;
    }

    if(required>(n-ind)+2) return -inf;
    if(memo[ind][taken][required+n]!=-1)
        return memo[ind][taken][required+n];

    long long ans = -inf;
    if(taken==false)
    {
        ans = max(ans, rec(ind+1, false, required-1));
        ans = max(ans, rec(ind+1, true, required) + L[ind]);
        ans = max(ans, rec(ind+1, false, required+k) + L[ind]);
    }
    else
    {
        ans = max(ans, rec(ind+1, false, required));
        ans = max(ans, rec(ind+1, true, required+k) + L[ind]);
        ans = max(ans, rec(ind+1, false, required+2*k) + L[ind]);
    }

    memo[ind][taken][required+n] = ans;
    return ans;
}

void rearrange()
{
    vector <int> p = {T[n-1]};
    for(int i = 0;i<n-1;i++) p.push_back(T[i]);

    vector <int> TData, LData;
    for(int i = 0;i<n;i++)
    {
        TData.push_back(T[i]);
        LData.push_back(L[i]);
    }

    for(int i = 0;i<n;i++)
    {
        T[p[i]] = TData[i];
        L[p[i]] = LData[i];
    }

    /*
    for(int i = 0;i<n;i++)
        cout << T[i] << ' ' << L[i] << '\n';

    for(int x: p) cout << x << " ";
    cout << '\n';
    */
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> k;
    for(int i = 0;i<n;i++) cin >> T[i] >> L[i];
    //cout << '\n';

    rearrange();

    memset(memo, -1, sizeof(memo));
    cout << rec(0, false, 0) << '\n';
}
/*
4 10
1 1
2 2
3 3
0 0

4 100
1 1
2 69
3 3
0 0
*/
