#include <vector>
#include <cstring>
#include <iostream>
#include <algorithm>

using namespace std;

const int MAXN = 705;
const long long inf = 1e11 + 5;

int n, k;
int T[MAXN], L[MAXN];

long long ans = 0;
int score[MAXN];

bool used[MAXN];

int rec(int ind)
{
    if(ind==n)
    {
        int available = 0;
        vector <int> v;

        for(int i = 0;i<n;i++)
        {
            if(used[i]==false)
            {
                available++;
                v.push_back(L[i]);
            }
        }
        sort(v.begin(), v.end(), greater<int>());

        int sum = 0;
        //for(int x: )

        return 0;
    }

    int ans = 0;
    if(used[ind]==false && used[T[ind]]==false)
    {
        used[ind] = true;
        used[T[ind]] = true;

        ans = max(ans, L[ind]+rec(ind+1));

        used[ind] = false;
        used[T[ind]] = false;
    }
    ans = max(ans, rec(ind+1));

    return ans;
}

void rec2(int ind)
{
    if(ind==n)
    {
        long long sum = 0;
        for(int i = 0;i<n;i++)
            if(score[i]>=2*k) sum += L[i];

        ans = max(ans, sum);
        return;
    }
    if(used[ind]==true)
    {
        rec2(ind+1);
        return;
    }

    for(int i = 0;i<n;i++)
    {
        if(score[i]>=2*k) continue;
        if(((i==ind || T[i]==ind)?k:1)!=1) continue;

        used[ind] = true;
        score[i] += ((i==ind || T[i]==ind)?k:1);

        rec2(ind+1);

        used[ind] = false;
        score[i] -= ((i==ind || T[i]==ind)?k:1);
    }
}

void rec1(int ind)
{
    if(ind==n)
    {
        rec2(0);
        return;
    }

    for(int i = 0;i<n;i++)
    {
        if(score[i]>=2*k) continue;
        if(((i==ind || T[i]==ind)?k:1)!=k) continue;

        used[ind] = true;
        score[i] += ((i==ind || T[i]==ind)?k:1);

        rec1(ind+1);

        used[ind] = false;
        score[i] -= ((i==ind || T[i]==ind)?k:1);
    }
    rec1(ind+1);
}

void rec4(int ind, int requested, long long sum)
{
    if(ind==n)
    {
        for(int i = 0;i<n;i++)
            requested -= used[i]^1;

        if(requested<=0) ans = max(ans, sum);
        return;
    }

    //1
    if(used[ind]==false && used[T[ind]]==false)
    {
        used[ind] = true;
        used[T[ind]] = true;

        rec4(ind+1, requested, sum+L[ind]);

        used[ind] = false;
        used[T[ind]] = false;
    }

    //2
    if(used[ind]==false)
    {
        used[ind] = true;

        rec4(ind+1, requested+k, sum+L[ind]);

        used[ind] = false;
    }

    //3
    if(used[T[ind]]==false)
    {
        used[T[ind]] = true;

        rec4(ind+1, requested+k, sum+L[ind]);

        used[T[ind]] = false;
    }

    //4
    rec4(ind+1, requested+2*k, sum+L[ind]);

    //5
    rec4(ind+1, requested, sum);
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> k;
    for(int i = 0;i<n;i++) cin >> T[i] >> L[i];

    rec4(0, 0, 0);
    cout << ans << '\n';
}
/*
4 10
1 1
2 2
3 3
0 0

4 100
1 1
2 69
3 3
0 0
*/
