#include <vector>
#include <cstring>
#include <iostream>
#include <algorithm>

using namespace std;

const int MAXN = 705;
const long long inf = 1e11 + 5;

int n, k;
int T[MAXN], L[MAXN];

long long memo[MAXN][2][MAXN*3+69];

long long rec(int ind, bool taken, int required)
{
    //cout << ind << " " << taken << " " << required << '\n';

    if(ind==n-1)
    {
        //TODO
        return rec(ind+1, false, required-((taken==false)?1:0));
    }
    if(ind==n)
    {
        if(required>0) return -inf;
        return 0;
    }

    if(required>(n-ind)+2) return -inf;
    if(memo[ind][taken][required+n]!=-1)
        return memo[ind][taken][required+n];

    long long ans = -inf;
    if(taken==false)
    {
        ans = max(ans, rec(ind+1, false, required-1));
        ans = max(ans, rec(ind+1, true, required) + L[ind]);
        ans = max(ans, rec(ind+1, false, required+k) + L[ind]);
    }
    else
    {
        ans = max(ans, rec(ind+1, false, required));
        ans = max(ans, rec(ind+1, true, required+k) + L[ind]);
        ans = max(ans, rec(ind+1, false, required+2*k) + L[ind]);
    }

    memo[ind][taken][required+n] = ans;
    return ans;
}

void rearrange()
{
    vector <int> p;
    for(int i = 0;i<n;i++) p.push_back(i);

    sort(p.begin(), p.end(),
    [](int x, int y){return T[x]<T[y];});

    vector <int> TData, LData;
    for(int i = 0;i<n;i++)
    {
        TData.push_back(T[i]);
        LData.push_back(L[i]);
    }

    for(int i = 1;i<n;i++)
    {
        T[i-1] = TData[p[i]];
        L[i-1] = LData[p[i]];
    }
    T[n-1] = TData[p[0]];
    L[n-1] = LData[p[0]];
}

bool used[MAXN];
long long ans = 0;

void rec4(int ind, int requested, long long sum)
{
    if(ind==n)
    {
        for(int i = 0;i<n;i++)
            requested -= used[i]^1;

        if(requested<=0) ans = max(ans, sum);
        return;
    }

    //1
    if(used[ind]==false && used[T[ind]]==false)
    {
        used[ind] = true;
        used[T[ind]] = true;

        rec4(ind+1, requested, sum+L[ind]);

        used[ind] = false;
        used[T[ind]] = false;
    }

    //2
    if(used[ind]==false)
    {
        used[ind] = true;

        rec4(ind+1, requested+k, sum+L[ind]);

        used[ind] = false;
    }

    //3
    if(used[T[ind]]==false)
    {
        used[T[ind]] = true;

        rec4(ind+1, requested+k, sum+L[ind]);

        used[T[ind]] = false;
    }

    //4
    rec4(ind+1, requested+2*k, sum+L[ind]);

    //5
    rec4(ind+1, requested, sum);
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> k;
    for(int i = 0;i<n;i++) cin >> T[i] >> L[i];
    //cout << '\n';


    if(n>10)
    {
    rearrange();
        memset(memo, -1, sizeof(memo));
        cout << rec(0, false, 0) << '\n';
    }
    else
    {
        rec4(0, 0, 0);
        cout << ans << '\n';
    }

}
/*
4 10
1 1
2 2
3 3
0 0

4 1
1 1
3 3
0 0
2 69
*/
