#include <iostream>
#include "sqsort.h"
#include <vector>
#include <utility>
using namespace std;

/*const int multiplier = 2000;

int coords2num(int i, int j) { /// Convert coordinates to number
	return i * multiplier + j;
}

int coords2num(pair<int, int> coords) {
	return coords2num(coords.first, coords.second);
}

pair<int, int> num2coords(int num) {
	return make_pair<int, int> (num / multiplier, num % multiplier);
}*/

vector<pair<int,int>> ans;

void merge_sort(int l, int r) {
	if(l == r) {
		return;
	}
	merge_sort(l, (r - l) / 2);
	merge_sort((r - l) / 2 + 1, r);

	int i = l;
	int max_i = (r - l) / 2;
	int j = (r - l) / 2 + 1;
	int max_j  = r;

	vector<pair<int, int>> new_ans;

	while(i < max_i || j < max_j) {
		/// If first pair is smaller than second pair
		if(cmp(ans[i].first, ans[i].second, ans[j].first, ans[j].second)) { 
			new_ans.push_back(ans[i]);
			++i;
		}
		else {
			new_ans.push_back(ans[j]);
			++j;
		}
	}

	ans = new_ans;
}

vector<pair<int,int>> solve(int n) {
	for(int i = 0; i < n; ++i) {
		for(int j = 0; j < n; ++j) {
			/*cout << i << " " << j << " " << coords2num(i, j) << " " << num2coords(coords2num(i, j)).first
			<< " " << num2coords(coords2num(i, j)).second << endl;*/
			ans.push_back(make_pair(i, j));
		}
	}

	merge_sort(0, n - 1);

	return ans;
}