
#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, k;
vector<pair<int, int>> a;

void read() {
    cin >> n >> k;

    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
}

void solve() {
    int maxSum = 0;

    for (int mask = 1; mask < (1 << n); mask++) {
        int requiredCards = 0;
        int numUsedCards = 0;

        for (int i = 0; i < n; i++) {
            if (mask & (1 << i)) {
                numUsedCards++;

                if (mask & (1 << a[i].first)) {
                    requiredCards += k;
                } else {
                    numUsedCards++;
                }
            }
        }

        if (requiredCards <= n - numUsedCards) {
            int sum = 0;

            for (int i = 0; i < n; i++) {
                if (mask & (1 << i)) {
                    sum += a[i].second;
                }
            }

            maxSum = max(maxSum, sum);
        }
    }

    cout << maxSum << endl;
}

int main() {
    setIO();

    read();

    solve();
}
