#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

const int MOD = 1e9 + 7;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, m;

void read() {
    cin >> n >> m;
}

void solve() {
    int numWays = 0;

    for (int grid = 0; grid < (1 << (n * m)); grid++) {
        vector<int> numBlueInRow(n, 0), numBlueInCol(m, 0);
        vector<int> numRedInRow(n, 0), numRedInCol(m, 0);

        /*
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                int cellColor = (grid >> (i * m + j)) & 1;

                cerr << cellColor;
            }

            cerr << endl;
        }
        */

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                int cellColor = (grid >> (i * m + j)) & 1;

                if (cellColor == 0) {
                    numBlueInRow[i]++;
                    numBlueInCol[j]++;
                } else {
                    numRedInRow[i]++;
                    numRedInCol[j]++;
                }
            }
        }

        bool valid = true;

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                int cellColor = (grid >> (i * m + j)) & 1;

                if (cellColor == 0 && max(numBlueInRow[i], numBlueInCol[j]) == 1) {
                    valid = false;
                    break;
                } else if (cellColor == 1 && max(numRedInRow[i], numRedInCol[j]) == 1) {
                    valid = false;
                    break;
                }
            }

            if (!valid) {
                break;
            }
        }

        //trace(valid);

        numWays += valid;
        if (numWays == MOD) {
            numWays = 0;
        }
    }

    cout << numWays << endl;
}

int main() {
    setIO();

    read();

    solve();
}
