#include <bits/stdc++.h>
#include "sqsort.h"

#pragma GCC optimize "-O3"

#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

vector<pair<int, int>> solve(int n) {
    vector<pair<pair<int, int>, int>> elements;

    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) {
            elements.emplace_back(make_pair(i, j), 0);
        }
    }

    for (int i = 0; i < (int)elements.size(); i++) {
        for (int j = 0; j < (int)elements.size(); j++) {
            if (i == j) {
                continue;
            }

            if (cmp(elements[j].first.first, elements[j].first.second
                    , elements[i].first.first, elements[i].first.second)) {
                elements[i].second++;
            }
        }
    }

    sort(elements.begin(), elements.end(), [&](const pair<pair<int, int>, int> &x, const pair<pair<int, int>, int> &y) {
        return (x.second < y.second);
    });

    vector<pair<int, int>> answer;

    for (int i = 0; i < (int)elements.size(); i++) {
        answer.emplace_back(elements[i].first);
    }

    return answer;
}
