#include <bits/stdc++.h>
#include "sqsort.h"

using namespace std;

bool cp(pair<int, int> l,pair<int, int> r)
{
	return cmp(l.first, l.second, r.first, r.second);
}

//----------------------------------------
/*

static const int HARD_LIMIT = 50000000;

static int n;
static std::vector<int> a;

static bool valid_pos(int i) {
	return 0 <= i && i < n;
}



static int Q;
bool cmp(int a_, int b, int c, int d) {
	if(!valid_pos(a_) || !valid_pos(b) || !valid_pos(c) || !valid_pos(d)) {
		std::cerr << "Invalid query." << std::endl;
		std::cout << -1 << std::endl;
		exit(0);
	}

	Q++;
	if(Q > HARD_LIMIT) {
		std::cerr << "Too many queries." << std::endl;
		std::cout << -1 << std::endl;
		exit(0);
	}

	return a[a_] + a[b] < a[c] + a[d];
}

static bool check_valid(const std::vector<std::pair<int, int> > &a) {
	if(n * (n + 1) / 2 != (int)a.size()) {
		return false;
	}

	std::vector<std::vector<bool> > used(n, std::vector<bool>(n, false));
	for(int i = 0; i < (int)a.size(); i++) {
		if(!valid_pos(a[i].first) || !valid_pos(a[i].second) || used[a[i].first][a[i].second]) {
			return false;
		}

		used[a[i].first][a[i].second] = true;
		used[a[i].second][a[i].first] = true;
	}

	return true;
}
*/
//------------------------------------------------------
vector<pair<int, int> > p;

vector<pair<int, int> > ans;

vector<pair<int, int> > srt(int l, int r)
{
	//cout << l  << " " << r << endl;
	vector<pair<int, int> >res, r1, r2;
	if(r - l <= 5)
	{
		int tmp;
		for(int i = l; i <= r; i++)
		{
			res.push_back(p[i]);
		}
		sort(res.begin(), res.end(),cp);
		return res;
	}
	int mid = (l + r) / 2;
	r1 = srt(l, mid);
	r2 = srt(mid + 1, r);
	int i1 = 0, i2 = 0;
	while(i1 < r1.size() && i2 < r2.size())
	{
		if(cmp(r1[i1].first,r1[i1].second, r2[i2].first, r2[i2].second) == 1)res.push_back(r1[i1++]);
		else res.push_back(r2[i2++]);
	}
	while(i1 < r1.size())res.push_back(r1[i1++]);
	while(i2 < r2.size())res.push_back(r2[i2++]);
	return res;
}



vector<std::pair<int, int> > solve(int n)
{
	
	for(int i = 0; i < n; i++)
	{
		for(int j = i; j < n; j++)
		{
			p.push_back({i, j});
		}
	}
	ans = srt(0, p.size() - 1);
	//sort(ans.begin(), ans.end(), cp);
	//for(int i = 0; i < ans.size(); i++)cout << ans[i].first << " " << ans[i].second << endl;
	return ans;
}
/*
int main() {
	std::cin >> n;
	a.resize(n);
	for(int i = 0; i < n; i++) {
		a[i] = (3 * i +n / (i +1))% n ;
	}

	Q = 0;
	std::vector<std::pair<int, int> > ret = solve(n);	
	
	if(!check_valid(ret)) {
		std::cerr << "Invalid output." << std::endl;
		std::cout << -1 << std::endl;
		return 0;
	}

	for(int i = 1; i < (int) ret.size(); i++) { 
		if(a[ret[i].first] + a[ret[i].second] < a[ret[i - 1].first] + a[ret[i - 1].second]) {
			std::cerr << "Output not sorted." << std::endl;
			std::cout << -1 << std::endl;
			return 0;
		}
	}
	
	std::cerr << "Correct!" << std::endl;
	std::cout << Q << std::endl;
	return 0;
}
*/

